create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop procedure if exists anp_base_set;^
	create procedure anp_base_set(
		in `$session` integer
	) begin 
		
		declare `$database` varchar(64) default settings_get('database_anp2', false);
		declare `$procedure` varchar(64) default 'anp_base_set';
		declare $procedure_id integer;
		declare $id integer;
		declare $has_database boolean default `$database` is not null;
		declare $session_id integer default sessions_get_id(`$session`);
		declare $ip_id integer;
		declare $user_agent_id integer;
	
		if $session_id is null then 
			set $session_id := sessions_get_machine();
		end if;

		select ip_id, user_agent_id into $ip_id, $user_agent_id from SessionsFullView where id = $session_id limit 1;
	
		if `$database` is null then 
			set `$database` := 'AnP';
		end if;
			
		call procedures_get(`$database`, `$procedure`, $procedure_id);
	
		if !$has_database then begin 
			insert into Settings values();
			set $id := last_insert_id();
			insert into SettingsData(`procedure`, `session`, entity, `type`, name, `range`, value) values 
				($procedure_id, $session_id, $id, 1, 'database_anp2', 1, 'AnP');
		end;end if;
	
		call logs_set($session_id, `$database`, `$procedure`, $ip_id, $user_agent_id, 0, '{}', 1 << 1);
		
	end;^
	
	call anp_base_set(null);^

delimiter ;