create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^
	
	drop procedure if exists users_data_update;^
	create procedure users_data_update(
		in $entity integer
	) begin 
		
		if (
			(select 1 from Users where id = $entity && date_out is null limit 1) is null || 
			(select 1 from UsersData where entity = $entity && date_out is null limit 1) is null 
		) then 
			delete from _Users where entity = $entity;
		else begin
			if (select 1 from _Users where entity = $entity limit 1) is null then 
				insert into _Users(`procedure`, `session`, entity, `data`, nick, `password`, `accessible`, deleted, date_in, date_created)
					select `procedure`, `session`, entity, id, nick, `password`, `accessible`, deleted, date_in, (select date_in from Users where id = $entity) from UsersData where id = (
						select max(id) from UsersData where entity = $entity && date_out is null 
					);
			else 
				update _Users plain 
				join (select `procedure`, `session`, entity, id, nick, `password`, `accessible`, deleted, date_in, (select date_in from Users where id = $entity) from UsersData where id = (
					select max(id) from UsersData where entity = $entity && date_out is null 
				)) `data` on plain.entity = `data`.entity
				set 
					plain.`procedure` := `data`.`procedure`,
					plain.`session` := `data`.`session`,
					plain.`data` := `data`.id,
					plain.nick := `data`.nick,
					plain.`password` := `data`.`password`,
					plain.`accessible` := `data`.`accessible`,
					plain.deleted := `data`.deleted,
					plain.date_in := `data`.date_in
				where plain.entity = $entity;
			end if;
		end;end if;
	
	end;^
	
	drop procedure if exists users_full_update;^
	create procedure users_full_update(
		in `$procedure` integer,
		in `$session` integer,
		in $entity integer,
		in `$data` integer,
		in $nick varchar(32),
		in `$password` varchar(256),
		in `$accessible` boolean,
		in $deleted datetime,
		in $date_in datetime
	) begin
		
		if (select 1 from Users where id = $entity && date_out is null limit 1) is null then 
			delete from _Users where entity = $entity;
		else begin 
			if (select 1 from _Users where entity = $entity limit 1) then 
				update _Users set 
					`procedure` := `$procedure`,
					`session` := `$session`,
					`data` := `$data`,
					nick := $nick,
					`password` := `$password`,
					`accessible` := `$accessible`,
					deleted := $deleted,
					date_in := $date_in
				where entity = $entity;
			else 
				insert into _Users(`procedure`, `session`, entity, `data`, nick, `password`, `accessible`, deleted, date_in, date_created) values 
					(`$procedure`, `$session`, $entity, `$data`, $nick, `$password`, `$accessible`, $deleted, $date_in, (select date_in from Users where id = $entity limit 1));
			end if;
		end;end if;
		
	end;^
	
	drop trigger if exists users_trigger_update_entity;^
	create trigger users_trigger_update_entity after update on Users for each row begin 
		call users_data_update(new.id);
	end;^
	
	drop trigger if exists users_trigger_insert;^
	create trigger users_trigger_insert after insert on UsersData for each row begin 
		if new.date_out is null then 
			call users_full_update(new.`procedure`, new.`session`, new.entity, new.id, new.nick, new.`password`, new.`accessible`, new.deleted, new.date_in);
		end if;
	end;^
	
	drop trigger if exists users_trigger_update;^
	create trigger users_trigger_update after update on UsersData for each row begin 
		if new.entity != old.entity then 
			call users_data_update(old.entity);
		end if;
		if new.date_out is null then 
			call users_full_update(new.`procedure`, new.`session`, new.entity, new.id, new.nick, new.`password`, new.`accessible`, new.deleted, new.date_in);
		else 
			call users_data_update(new.entity);
		end if;
	end;^
	
	drop trigger if exists users_trigger_delete;^
	create trigger users_trigger_delete after delete on UsersData for each row begin 
		call users_data_update(old.entity);
	end;^
	
delimiter ;