create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop view if exists UsersView;^
	create view UsersView as select 
		users.id as plain_id, 
		users.entity as id, 
		users.`data` as `data`, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		users.nick as user_nick, 
		-- users.`password` as `password`, 
		users.`accessible` as `accessible`, 
		users.deleted as deleted, 
		users.date_in as date_in, 
		users.date_created as date_created
	from _Users users
	join SessionsFullView sessions on users.`session` = sessions.id
	join ProceduresFullView procedures on users.`procedure` = procedures.id;^

	drop view if exists UsersSelectView;^
	create view UsersSelectView as select 
		users.entity as id, 
		users.nick as nick
	from _Users users
	;^

	drop view if exists UsersHistoryView;^
		create view UsersHistoryView as select 
		users.id as plain_id, 
		users.entity as id, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		users.nick as user_nick, 
		-- users.`password` as `password`, 
		users.`accessible` as `accessible`, 
		users.deleted as deleted, 
		users.date_in as date_in
	from UsersData users
	join SessionsFullView sessions on users.`session` = sessions.id
	join ProceduresFullView procedures on users.`procedure` = procedures.id
	where 
		users.date_out is null;^

	drop view if exists UsersLoadView;^
	create view UsersLoadView as select 
		users.entity as id,
		users.nick as nick,
		-- users.`password` as `password`,
		users.`accessible` as `accessible`
	from _Users users
	where 
		users.deleted is null;^

delimiter ;