create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^
	
	drop procedure if exists users_undelete;^
	create procedure users_undelete(
		in `$session` text,
		in $entity integer,
		out $error varchar(512)
	) begin 
		
		declare `$database` varchar(64) default settings_get('database_anp2', false);
		declare `$procedure` varchar(64) default 'users_undelete';
		declare $procedure_id integer;
		declare $data_id integer;
		declare $parameters text default json_set('{}', 
			'$.entity', $entity, 
			'$.id', 0
		);
		declare $session_id integer;
		declare $ip_id integer;
		declare $user_agent_id integer;
		declare exit handler for sqlexception begin
			get diagnostics condition 1
				@_status = returned_sqlstate,
				@_code = mysql_errno,
				@message = message_text;
			set $error := errors_set($error, 1 << 0, 0, 0);
			call exceptions_set($session_id, `$database`, `$procedure`, $ip_id, $user_agent_id, $error, $parameters, @message, @_status, @_code);
		end;
	
		call sessions_validate_full(`$session`, '["administrator"]', $error, $session_id, $ip_id, $user_agent_id);
		set $error := errors_set($error, users_validate($entity, false), 30, 0);
	
		if !errors_has($error) then begin 

			declare $nick varchar(32) default (select nick from _Users where entity = $entity limit 1);
			declare $group_id varchar(64) default users_get_entity_group($entity);

			set $error := errors_set($error, ifnull((select 1 << 0 from _Groups where 
				deleted is null && 
				($group_id is null || entity != $group_id) && 
				name = $nick 
			limit 1), 0), 34, 0);

			if !errors_has($error) then begin 
				
				call procedures_get(`$database`, `$procedure`, $procedure_id);
				set $data_id := (select `data` from _Users where entity = $entity limit 1);
			
				insert into UsersData(`procedure`, `session`, entity, nick, `password`, `accessible`, deleted) 
					select $procedure_id, $session_id, entity, nick, `password`, `accessible`, null from UsersData where id = $data_id limit 1;
				
				set $parameters := json_set($parameters, 
					'$.id', last_insert_id() 
				);

			end;end if;
		
		end;end if;
	
		call logs_set($session_id, `$database`, `$procedure`, $ip_id, $user_agent_id, $error, $parameters, 0);
		
	end;^

delimiter ;