create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop procedure if exists users_reset_password;^
	create procedure users_reset_password(
		in `$session` text, 
        in $entity integer, 
		out $error varchar(512)
	) begin 
		
		declare `$database` varchar(64) default settings_get('database_anp2', false);
		declare `$procedure` varchar(64) default 'users_reset_password';
		declare $procedure_id integer;
		declare $parameters text default json_set('{}', 
			'$.entity', $entity,
            '$.id', 0
		);
		declare $session_id integer;
		declare $ip_id integer;
		declare $user_agent_id integer;
		declare exit handler for sqlexception begin
			get diagnostics condition 1
				@_status = returned_sqlstate,
				@_code = mysql_errno,
				@message = message_text;
			set $error := errors_set($error, 1 << 0, 0, 0);
			call exceptions_set($session_id, `$database`, `$procedure`, $ip_id, $user_agent_id, $error, $parameters, @message, @_status, @_code);
		end;
	
		call sessions_validate_full(`$session`, '["administrator"]', $error, $session_id, $ip_id, $user_agent_id);
		set $error := errors_set($error, users_validate($entity, true), 30, 0);

		if !errors_has($error) then begin 

            set $error := errors_set($error, if(ifnull((
                select `password` from _Users where entity = $entity limit 1
            ), '') = '', 1 << 0, 0), 34, 0);

            if !errors_has($error) then begin 

                declare $nick varchar(32);
                declare `$accessible` bool;
                declare $deleted datetime;
                
			    call procedures_get(`$database`, `$procedure`, $procedure_id);

                select nick, `accessible`, deleted 
                into $nick, `$accessible`, $deleted 
                from _Users where entity = $entity limit 1;

                insert into UsersData(`procedure`, `session`, entity, nick, `password`, `accessible`, deleted) values 
                    ($procedure_id, $session_id, $entity, $nick, '', `$accessible`, $deleted);

                set $parameters := json_set($parameters, '$.id', last_insert_id());

            end;end if;

		end;end if;
	
		call logs_set($session_id, `$database`, `$procedure`, $ip_id, $user_agent_id, $error, $parameters, 0);

	end;^

delimiter ;