create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop view if exists GroupsView;^
	create view GroupsView as select 
		groups.id as plain_id, 
		groups.entity as id, 
		groups.`data` as `data`, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		groups.name as name, 
		groups.`default` as `default`, 
		groups.is_entity as is_entity, 
		groups.description as description, 
		groups.deleted as deleted, 
		groups.date_in as date_in, 
		groups.date_created as date_created
	from _Groups groups
	join SessionsFullView sessions on groups.`session` = sessions.id
	join ProceduresFullView procedures on groups.`procedure` = procedures.id;^

	drop view if exists GroupsSelectView;^
	create view GroupsSelectView as select 
		groups.entity as id, 
		groups.name as name
	from _Groups groups
	;^

	drop view if exists GroupsHistoryView;^
		create view GroupsHistoryView as select 
		groups.id as plain_id, 
		groups.entity as id, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		groups.name as name, 
		groups.`default` as `default`, 
		groups.is_entity as is_entity, 
		groups.description as description, 
		groups.deleted as deleted, 
		groups.date_in as date_in
	from GroupsData groups
	join SessionsFullView sessions on groups.`session` = sessions.id
	join ProceduresFullView procedures on groups.`procedure` = procedures.id
	where 
		groups.date_out is null;^

	drop view if exists GroupsLoadView;^
	create view GroupsLoadView as select 
		groups.entity as id,
		groups.name as name,
		groups.`default` as `default`,
		groups.is_entity as is_entity,
		groups.description as description
	from _Groups groups
	where 
		groups.deleted is null;^

delimiter ;