create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop procedure if exists emails_tables_delete;^
	create procedure emails_tables_delete(
		in `$session` text
	) begin
		
		drop table if exists Emails;
		
	end;^

	drop procedure if exists emails_tables_create;^
	create procedure emails_tables_create(
		in `$session` text
	) begin 
		
		create table if not exists Emails(
			id integer not null auto_increment,
			`procedure` integer not null,
			`session` integer not null,
			address varchar(256) not null,
			deleted datetime,
			date_in datetime not null default now(),
			date_out datetime,
			constraint emails_id primary key(id),
			constraint emails_procedure foreign key(`procedure`) references Procedures(id),
			constraint emails_session foreign key(`session`) references Sessions(id)
		);
		
	end;^

	drop procedure if exists emails_tables_update;^
	create procedure emails_tables_update(
		in `$session` text
	) begin 
		
		declare `$database` varchar(64) default settings_get('database_anp2', false);
		declare `$procedure` varchar(64) default 'emails_tables_update';
		declare $session_id integer default ifnull(sessions_get_id(`$session`), sessions_get_machine());
		declare $ip_id integer;
		declare $user_agent_id integer;
		
		select ip_id, user_agent_id into $ip_id, $user_agent_id from SessionsFullView where id = $session_id limit 1;

		if (select 1 from information_schema.columns where table_schema = `$database` && table_name = 'Emails' && column_name = 'address' limit 1) is null then begin 
			alter table Emails add column address varchar(256) not null after id;
		end;end if;
	
		call logs_set($session_id, `$database`, `$procedure`, $ip_id, $user_agent_id, 0, '{}', 1 << 1);
	
	end;^
	
	-- call emails_tables_delete(null);^
	call emails_tables_create(null);^
	call emails_tables_update(null);^
	
delimiter ;