create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop view if exists EmailsView;^
	create view EmailsView as select 
		emails.id as id, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		emails.address as address, 
		emails.deleted as deleted, 
		emails.date_in as date_in
	from Emails emails
	join SessionsFullView sessions on emails.`session` = sessions.id
	join ProceduresFullView procedures on emails.`procedure` = procedures.id
	where 
		emails.date_out is null;^

	drop view if exists EmailsSelectView;^
	create view EmailsSelectView as select 
		emails.id as id, 
		emails.address as address
	from Emails emails
	;^

delimiter ;