create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^
	
	drop procedure if exists ips_data_update;^
	create procedure ips_data_update(
		in $entity integer
	) begin 
		
		if (
			(select 1 from Ips where id = $entity && date_out is null limit 1) is null || 
			(select 1 from IpsData where entity = $entity && date_out is null limit 1) is null 
		) then 
			delete from _Ips where entity = $entity;
		else begin
			if (select 1 from _Ips where entity = $entity limit 1) is null then 
				insert into _Ips(`procedure`, `session`, entity, `data`, address, `accessible`, deleted, date_in, date_created)
					select `procedure`, `session`, entity, id, address, `accessible`, deleted, date_in, (select date_in from Ips where id = $entity) from IpsData where id = (
						select max(id) from IpsData where entity = $entity && date_out is null 
					);
			else 
				update _Ips plain 
				join (select `procedure`, `session`, entity, id, address, `accessible`, deleted, date_in, (select date_in from Ips where id = $entity) from IpsData where id = (
					select max(id) from IpsData where entity = $entity && date_out is null 
				)) `data` on plain.entity = `data`.entity
				set 
					plain.`procedure` := `data`.`procedure`,
					plain.`session` := `data`.`session`,
					plain.`data` := `data`.id,
					plain.address := `data`.address,
					plain.`accessible` := `data`.`accessible`,
					plain.deleted := `data`.deleted,
					plain.date_in := `data`.date_in
				where plain.entity = $entity;
			end if;
		end;end if;
	
	end;^
	
	drop procedure if exists ips_full_update;^
	create procedure ips_full_update(
		in `$procedure` integer,
		in `$session` integer,
		in $entity integer,
		in `$data` integer,
		in $address varchar(39),
		in `$accessible` boolean,
		in $deleted datetime,
		in $date_in datetime
	) begin
		
		if (select 1 from Ips where id = $entity && date_out is null limit 1) is null then 
			delete from _Ips where entity = $entity;
		else begin 
			if (select 1 from _Ips where entity = $entity limit 1) then 
				update _Ips set 
					`procedure` := `$procedure`,
					`session` := `$session`,
					`data` := `$data`,
					address := $address,
					`accessible` := `$accessible`,
					deleted := $deleted,
					date_in := $date_in
				where entity = $entity;
			else 
				insert into _Ips(`procedure`, `session`, entity, `data`, address, `accessible`, deleted, date_in, date_created) values 
					(`$procedure`, `$session`, $entity, `$data`, $address, `$accessible`, $deleted, $date_in, (select date_in from Ips where id = $entity limit 1));
			end if;
		end;end if;
		
	end;^
	
	drop trigger if exists ips_trigger_update_entity;^
	create trigger ips_trigger_update_entity after update on Ips for each row begin 
		call ips_data_update(new.id);
	end;^
	
	drop trigger if exists ips_trigger_insert;^
	create trigger ips_trigger_insert after insert on IpsData for each row begin 
		if new.date_out is null then 
			call ips_full_update(new.`procedure`, new.`session`, new.entity, new.id, new.address, new.`accessible`, new.deleted, new.date_in);
		end if;
	end;^
	
	drop trigger if exists ips_trigger_update;^
	create trigger ips_trigger_update after update on IpsData for each row begin 
		if new.entity != old.entity then 
			call ips_data_update(old.entity);
		end if;
		if new.date_out is null then 
			call ips_full_update(new.`procedure`, new.`session`, new.entity, new.id, new.address, new.`accessible`, new.deleted, new.date_in);
		else 
			call ips_data_update(new.entity);
		end if;
	end;^
	
	drop trigger if exists ips_trigger_delete;^
	create trigger ips_trigger_delete after delete on IpsData for each row begin 
		call ips_data_update(old.entity);
	end;^
	
delimiter ;