create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop view if exists IpsView;^
	create view IpsView as select 
		ips.id as plain_id, 
		ips.entity as id, 
		ips.`data` as `data`, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		ips.address as address, 
		ips.`accessible` as `accessible`, 
		ips.deleted as deleted, 
		ips.date_in as date_in, 
		ips.date_created as date_created
	from _Ips ips
	join SessionsFullView sessions on ips.`session` = sessions.id
	join ProceduresFullView procedures on ips.`procedure` = procedures.id;^

	drop view if exists IpsHistoryView;^
		create view IpsHistoryView as select 
		ips.id as plain_id, 
		ips.entity as id, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		ips.address as address, 
		ips.`accessible` as `accessible`, 
		ips.deleted as deleted, 
		ips.date_in as date_in
	from IpsData ips
	join SessionsFullView sessions on ips.`session` = sessions.id
	join ProceduresFullView procedures on ips.`procedure` = procedures.id
	where 
		ips.date_out is null;^

	drop view if exists IpsSelectView;^
	create view IpsSelectView as select 
		ips.entity as id, 
		ips.address as address
	from _Ips ips where deleted is null;^

delimiter ;