create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^
	
	drop procedure if exists ips_set_accessible;^
	create procedure ips_set_accessible(
        in `$session` text, 
		in $entity integer,
		in `$accessible` boolean, 
        out $error varchar(512) 
	) begin 
		
		declare `$database` varchar(64) default settings_get('database_anp2', false);
		declare `$procedure` varchar(64) default 'ips_set_accessible';
		declare $parameters text default json_set('{}',
			'$.entity', $entity,
			'$.accessible', `$accessible`, 
            '$.id', 0
		);
		declare $session_id integer;
		declare $ip_id integer;
		declare $user_agent_id integer;
		declare exit handler for sqlexception begin
			get diagnostics condition 1
				@_status = returned_sqlstate,
				@_code = mysql_errno,
				@message = message_text;
			set $error := errors_set($error, 1 << 0, 0, 0);
			call exceptions_set($session_id, `$database`, `$procedure`, $ip_id, $user_agent_id, $error, $parameters, @message, @_status, @_code);
		end;

        call sessions_validate_full(`$session`, 'administrator', $error, $session_id, $ip_id, $user_agent_id);
        set $error := errors_set($error, (
            (ips_validate($entity, true) << 0) | 
            ((case 
                when `$accessible` is null then 1 << 0
            else ifnull((
                select if(`accessible` = `$accessible`, 1 << 1, 0) from _Ips where entity = $entity limit 1
            ), 0) end) << 4) | 
        0), 30, 0);

        if !errors_has($error) then begin 

            declare $procedure_id integer;
            declare $data_id integer default (select `data` from _Ips where entity = $entity limit 1);

            call procedures_get(`$database`, `$procedure`, $procedure_id);

            insert into IpsData(`procedure`, `session`, entity, `address`, `accessible`, deleted) 
            select $procedure_id, $session_id, $entity, `address`, `$accessible`, deleted from IpsData where id = $data_id limit 1;

            set $parameters := json_set($parameters, '$.id', last_insert_id());

        end;end if;
	
		call logs_set($session_id, `$database`, `$procedure`, $ip_id, $user_agent_id, $error, $parameters, 0);

	end;^

delimiter ;