create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop view if exists PermissionsView;^
	create view PermissionsView as select 
		permissions.id as plain_id, 
		permissions.entity as id, 
		permissions.`data` as `data`, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		permissions.name as name, 
		permissions.description as description, 
		permissions.deleted as deleted, 
		permissions.date_in as date_in, 
		permissions.date_created as date_created
	from _Permissions permissions
	join SessionsFullView sessions on permissions.`session` = sessions.id
	join ProceduresFullView procedures on permissions.`procedure` = procedures.id;^

	drop view if exists PermissionsSelectView;^
	create view PermissionsSelectView as select 
		permissions.entity as id, 
		permissions.name as name
	from _Permissions permissions
	;^

	drop view if exists PermissionsHistoryView;^
		create view PermissionsHistoryView as select 
		permissions.id as plain_id, 
		permissions.entity as id, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		permissions.name as name, 
		permissions.description as description, 
		permissions.deleted as deleted, 
		permissions.date_in as date_in
	from PermissionsData permissions
	join SessionsFullView sessions on permissions.`session` = sessions.id
	join ProceduresFullView procedures on permissions.`procedure` = procedures.id
	where 
		permissions.date_out is null;^

	drop view if exists PermissionsLoadView;^
	create view PermissionsLoadView as select 
		permissions.entity as id,
		permissions.name as name,
		permissions.description as description
	from _Permissions permissions
	where 
		permissions.deleted is null;^

delimiter ;