create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop view if exists SettingsTypesView;^
	create view SettingsTypesView as select 
		settings_types.id as plain_id, 
		settings_types.entity as id, 
		settings_types.`data` as `data`, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		settings_types.name as name, 
		settings_types.description as description, 
		settings_types.deleted as deleted, 
		settings_types.date_in as date_in, 
		settings_types.date_created as date_created
	from _SettingsTypes settings_types
	join SessionsFullView sessions on settings_types.`session` = sessions.id
	join ProceduresFullView procedures on settings_types.`procedure` = procedures.id;^

	drop view if exists SettingsTypesSelectView;^
	create view SettingsTypesSelectView as select 
		settings_types.entity as id, 
		settings_types.name as name
	from _SettingsTypes settings_types
	;^

	drop view if exists SettingsTypesHistoryView;^
		create view SettingsTypesHistoryView as select 
		settings_types.id as plain_id, 
		settings_types.entity as id, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		settings_types.name as name, 
		settings_types.description as description, 
		settings_types.deleted as deleted, 
		settings_types.date_in as date_in
	from SettingsTypesData settings_types
	join SessionsFullView sessions on settings_types.`session` = sessions.id
	join ProceduresFullView procedures on settings_types.`procedure` = procedures.id
	where 
		settings_types.date_out is null;^

	drop view if exists SettingsTypesLoadView;^
	create view SettingsTypesLoadView as select 
		settings_types.entity as id,
		settings_types.name as name,
		settings_types.description as description
	from _SettingsTypes settings_types
	where 
		settings_types.deleted is null;^

delimiter ;