create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop procedure if exists hashes_tables_delete;^
	create procedure hashes_tables_delete(
		in `$session` text
	) begin
		
		drop table if exists Hashes;
		
	end;^

	drop procedure if exists hashes_tables_create;^
	create procedure hashes_tables_create(
		in `$session` text
	) begin 
		
		create table if not exists Hashes(
			id integer not null auto_increment,
			`procedure` integer not null,
			`session` integer not null,
			name varchar(16) not null,
			description varchar(512),
			deleted datetime,
			date_in datetime not null default now(),
			date_out datetime,
			constraint hashes_id primary key(id),
			constraint hashes_procedure foreign key(`procedure`) references Procedures(id),
			constraint hashes_session foreign key(`session`) references Sessions(id)
		);
		
	end;^

	drop procedure if exists hashes_tables_update;^
	create procedure hashes_tables_update(
		in `$session` text
	) begin 
		
		declare `$database` varchar(64) default settings_get('database_anp2', false);
		declare `$procedure` varchar(64) default 'hashes_tables_update';
		declare $session_id integer default ifnull(sessions_get_id(`$session`), sessions_get_machine());
		declare $ip_id integer;
		declare $user_agent_id integer;
		
		select ip_id, user_agent_id into $ip_id, $user_agent_id from SessionsFullView where id = $session_id limit 1;

		if (select 1 from information_schema.columns where table_schema = `$database` && table_name = 'Hashes' && column_name = 'name' limit 1) is null then begin 
			alter table Hashes add column name varchar(16) not null after id;
		end;end if;

		if (select 1 from information_schema.columns where table_schema = `$database` && table_name = 'Hashes' && column_name = 'description' limit 1) is null then begin 
			alter table Hashes add column description varchar(512) after name;
		end;end if;
	
		call logs_set($session_id, `$database`, `$procedure`, $ip_id, $user_agent_id, 0, '{}', 1 << 1);
	
	end;^
	
	-- call hashes_tables_delete(null);^
	call hashes_tables_create(null);^
	call hashes_tables_update(null);^
	
delimiter ;