create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop view if exists HashesView;^
	create view HashesView as select 
		hashes.id as id, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		hashes.name as name, 
		hashes.description as description, 
		hashes.deleted as deleted, 
		hashes.date_in as date_in
	from Hashes hashes
	join SessionsFullView sessions on hashes.`session` = sessions.id
	join ProceduresFullView procedures on hashes.`procedure` = procedures.id
	where 
		hashes.date_out is null;^

	drop view if exists HashesSelectView;^
	create view HashesSelectView as select 
		hashes.id as id, 
		hashes.name as name
	from Hashes hashes
	;^

delimiter ;