create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop view if exists FilesTypesView;^
	create view FilesTypesView as select 
		files_types.id as id, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		files_types.mime as mime, 
		files_types.description as description, 
		files_types.deleted as deleted, 
		files_types.date_in as date_in
	from FilesTypes files_types
	join SessionsFullView sessions on files_types.`session` = sessions.id
	join ProceduresFullView procedures on files_types.`procedure` = procedures.id
	where 
		files_types.date_out is null;^

	drop view if exists FilesTypesSelectView;^
	create view FilesTypesSelectView as select 
		files_types.id as id, 
		files_types.mime as mime
	from FilesTypes files_types
	;^

delimiter ;