create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop view if exists FilesGroupsView;^
	create view FilesGroupsView as select 
		files_groups.id as id, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		files_groups.name as name, 
		files_groups.description as description, 
		files_groups.deleted as deleted, 
		files_groups.date_in as date_in
	from FilesGroups files_groups
	join SessionsFullView sessions on files_groups.`session` = sessions.id
	join ProceduresFullView procedures on files_groups.`procedure` = procedures.id
	where 
		files_groups.date_out is null;^

	drop view if exists FilesGroupsSelectView;^
	create view FilesGroupsSelectView as select 
		files_groups.id as id, 
		files_groups.name as name
	from FilesGroups files_groups
	;^

delimiter ;