create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop view if exists LocatesGroupsView;^
	create view LocatesGroupsView as select 
		locates_groups.id as id, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		locates_groups.name as name, 
		locates_groups.description as description, 
		locates_groups.deleted as deleted, 
		locates_groups.date_in as date_in
	from LocatesGroups locates_groups
	join SessionsFullView sessions on locates_groups.`session` = sessions.id
	join ProceduresFullView procedures on locates_groups.`procedure` = procedures.id
	where 
		locates_groups.date_out is null;^

	drop view if exists LocatesGroupsSelectView;^
	create view LocatesGroupsSelectView as select 
		locates_groups.id as id, 
		locates_groups.name as name
	from LocatesGroups locates_groups
	;^

delimiter ;