create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^
	
	drop procedure if exists users_groups_data_update;^
	create procedure users_groups_data_update(
		in $entity integer
	) begin 
		
		if (
			(select 1 from UsersGroups where id = $entity && date_out is null limit 1) is null || 
			(select 1 from UsersGroupsData where entity = $entity && date_out is null limit 1) is null 
		) then 
			delete from _UsersGroups where entity = $entity;
		else begin
			if (select 1 from _UsersGroups where entity = $entity limit 1) is null then 
				insert into _UsersGroups(`procedure`, `session`, entity, `data`, `group`, `user`, belongs, date_in, date_created)
					select `procedure`, `session`, entity, id, `group`, `user`, belongs, date_in, (select date_in from UsersGroups where id = $entity) from UsersGroupsData where id = (
						select max(id) from UsersGroupsData where entity = $entity && date_out is null 
					);
			else 
				update _UsersGroups plain 
				join (select `procedure`, `session`, entity, id, `group`, `user`, belongs, date_in, (select date_in from UsersGroups where id = $entity) from UsersGroupsData where id = (
					select max(id) from UsersGroupsData where entity = $entity && date_out is null 
				)) `data` on plain.entity = `data`.entity
				set 
					plain.`procedure` := `data`.`procedure`,
					plain.`session` := `data`.`session`,
					plain.`data` := `data`.id,
					plain.`group` := `data`.`group`,
					plain.`user` := `data`.`user`,
					plain.belongs := `data`.belongs,
					plain.date_in := `data`.date_in
				where plain.entity = $entity;
			end if;
		end;end if;
	
	end;^
	
	drop procedure if exists users_groups_full_update;^
	create procedure users_groups_full_update(
		in `$procedure` integer,
		in `$session` integer,
		in $entity integer,
		in `$data` integer,
		in `$group` integer,
		in `$user` integer,
		in $belongs boolean,
		in $date_in datetime
	) begin
		
		if (select 1 from UsersGroups where id = $entity && date_out is null limit 1) is null then 
			delete from _UsersGroups where entity = $entity;
		else begin 
			if (select 1 from _UsersGroups where entity = $entity limit 1) then 
				update _UsersGroups set 
					`procedure` := `$procedure`,
					`session` := `$session`,
					`data` := `$data`,
					`group` := `$group`,
					`user` := `$user`,
					belongs := $belongs,
					date_in := $date_in
				where entity = $entity;
			else 
				insert into _UsersGroups(`procedure`, `session`, entity, `data`, `group`, `user`, belongs, date_in, date_created) values 
					(`$procedure`, `$session`, $entity, `$data`, `$group`, `$user`, $belongs, $date_in, (select date_in from UsersGroups where id = $entity limit 1));
			end if;
		end;end if;
		
	end;^
	
	drop trigger if exists users_groups_trigger_update_entity;^
	create trigger users_groups_trigger_update_entity after update on UsersGroups for each row begin 
		call users_groups_data_update(new.id);
	end;^
	
	drop trigger if exists users_groups_trigger_insert;^
	create trigger users_groups_trigger_insert after insert on UsersGroupsData for each row begin 
		if new.date_out is null then 
			call users_groups_full_update(new.`procedure`, new.`session`, new.entity, new.id, new.`group`, new.`user`, new.belongs, new.date_in);
		end if;
	end;^
	
	drop trigger if exists users_groups_trigger_update;^
	create trigger users_groups_trigger_update after update on UsersGroupsData for each row begin 
		if new.entity != old.entity then 
			call users_groups_data_update(old.entity);
		end if;
		if new.date_out is null then 
			call users_groups_full_update(new.`procedure`, new.`session`, new.entity, new.id, new.`group`, new.`user`, new.belongs, new.date_in);
		else 
			call users_groups_data_update(new.entity);
		end if;
	end;^
	
	drop trigger if exists users_groups_trigger_delete;^
	create trigger users_groups_trigger_delete after delete on UsersGroupsData for each row begin 
		call users_groups_data_update(old.entity);
	end;^
	
delimiter ;