create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop view if exists UsersGroupsView;^
	create view UsersGroupsView as select 
		users_groups.id as plain_id, 
		users_groups.entity as id, 
		users_groups.`data` as `data`, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		groups.entity as group_id, 
		groups.name as name, 
		users.entity as users_user_id, 
		users.nick as user_nick, 
		users_groups.belongs as belongs, 
		users_groups.date_in as date_in, 
		users_groups.date_created as date_created
	from _UsersGroups users_groups
	join SessionsFullView sessions on users_groups.`session` = sessions.id
	join ProceduresFullView procedures on users_groups.`procedure` = procedures.id
	join _Groups groups on users_groups.`group` = groups.entity
	join _Users users on users_groups.`user` = users.entity
	where 
		groups.deleted is null && 
		users.deleted is null;^

	drop view if exists UsersGroupsHistoryView;^
		create view UsersGroupsHistoryView as select 
		users_groups.id as plain_id, 
		users_groups.entity as id, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		groups.entity as group_id, 
		groups.name as name, 
		users.entity as users_user_id, 
		users.nick as user_nick, 
		users_groups.belongs as belongs, 
		users_groups.date_in as date_in
	from UsersGroupsData users_groups
	join SessionsFullView sessions on users_groups.`session` = sessions.id
	join ProceduresFullView procedures on users_groups.`procedure` = procedures.id
	join _Groups groups on users_groups.`group` = groups.entity
	join _Users users on users_groups.`user` = users.entity
	where 
		users_groups.date_out is null && 
		groups.deleted is null && 
		users.deleted is null;^

delimiter ;