create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop view if exists IpsGroupsView;^
	create view IpsGroupsView as select 
		ips_groups.id as plain_id, 
		ips_groups.entity as id, 
		ips_groups.`data` as `data`, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		groups.entity as group_id, 
		groups.name as name, 
		ips.entity as ips_ip_id, 
		ips.address as address, 
		ips_groups.belongs as belongs, 
		ips_groups.date_in as date_in, 
		ips_groups.date_created as date_created
	from _IpsGroups ips_groups
	join SessionsFullView sessions on ips_groups.`session` = sessions.id
	join ProceduresFullView procedures on ips_groups.`procedure` = procedures.id
	join _Groups groups on ips_groups.`group` = groups.entity
	join _Ips ips on ips_groups.ip = ips.entity
	where 
		groups.deleted is null && 
		ips.deleted is null;^

	drop view if exists IpsGroupsHistoryView;^
		create view IpsGroupsHistoryView as select 
		ips_groups.id as plain_id, 
		ips_groups.entity as id, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		groups.entity as group_id, 
		groups.name as name, 
		ips.entity as ips_ip_id, 
		ips.address as address, 
		ips_groups.belongs as belongs, 
		ips_groups.date_in as date_in
	from IpsGroupsData ips_groups
	join SessionsFullView sessions on ips_groups.`session` = sessions.id
	join ProceduresFullView procedures on ips_groups.`procedure` = procedures.id
	join _Groups groups on ips_groups.`group` = groups.entity
	join _Ips ips on ips_groups.ip = ips.entity
	where 
		ips_groups.date_out is null && 
		groups.deleted is null && 
		ips.deleted is null;^

delimiter ;