create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop view if exists PermissionsGroupsView;^
	create view PermissionsGroupsView as select 
		permissions_groups.id as plain_id, 
		permissions_groups.entity as id, 
		permissions_groups.`data` as `data`, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		groups.entity as group_id, 
		groups.name as name, 
		permissions.entity as permission_id, 
		permissions.name as permission_name, 
		permissions_groups.belongs as belongs, 
		permissions_groups.date_in as date_in, 
		permissions_groups.date_created as date_created
	from _PermissionsGroups permissions_groups
	join SessionsFullView sessions on permissions_groups.`session` = sessions.id
	join ProceduresFullView procedures on permissions_groups.`procedure` = procedures.id
	join _Groups groups on permissions_groups.`group` = groups.entity
	join _Permissions permissions on permissions_groups.permission = permissions.entity
	where 
		groups.deleted is null && 
		permissions.deleted is null;^

	drop view if exists PermissionsGroupsHistoryView;^
		create view PermissionsGroupsHistoryView as select 
		permissions_groups.id as plain_id, 
		permissions_groups.entity as id, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		groups.entity as group_id, 
		groups.name as name, 
		permissions.entity as permission_id, 
		permissions.name as permission_name, 
		permissions_groups.belongs as belongs, 
		permissions_groups.date_in as date_in
	from PermissionsGroupsData permissions_groups
	join SessionsFullView sessions on permissions_groups.`session` = sessions.id
	join ProceduresFullView procedures on permissions_groups.`procedure` = procedures.id
	join _Groups groups on permissions_groups.`group` = groups.entity
	join _Permissions permissions on permissions_groups.permission = permissions.entity
	where 
		permissions_groups.date_out is null && 
		groups.deleted is null && 
		permissions.deleted is null;^

delimiter ;