create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop view if exists SettingsView;^
	create view SettingsView as select 
		settings.id as plain_id, 
		settings.entity as id, 
		settings.`data` as `data`, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		settings_types.entity as type_id, 
		settings_types.name as name, 
		settings.name as settings_name, 
		settings.`range` as `range`, 
		settings.value as value, 
		settings.description as description, 
		settings.deleted as deleted, 
		settings.date_in as date_in, 
		settings.date_created as date_created
	from _Settings settings
	join SessionsFullView sessions on settings.`session` = sessions.id
	join ProceduresFullView procedures on settings.`procedure` = procedures.id
	join _SettingsTypes settings_types on settings.`type` = settings_types.entity
	where 
		settings_types.deleted is null;^

	drop view if exists SettingsSelectView;^
	create view SettingsSelectView as select 
		settings.entity as id, 
		settings_types.entity as type_id, 
		settings_types.name as name, 
		settings.name as settings_name
	from _Settings settings
	join _SettingsTypes settings_types on settings.`type` = settings_types.entity
	where settings_types.deleted is null;^

	drop view if exists SettingsHistoryView;^
		create view SettingsHistoryView as select 
		settings.id as plain_id, 
		settings.entity as id, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		settings_types.entity as type_id, 
		settings_types.name as name, 
		settings.name as settings_name, 
		settings.`range` as `range`, 
		settings.value as value, 
		settings.description as description, 
		settings.deleted as deleted, 
		settings.date_in as date_in
	from SettingsData settings
	join SessionsFullView sessions on settings.`session` = sessions.id
	join ProceduresFullView procedures on settings.`procedure` = procedures.id
	join _SettingsTypes settings_types on settings.`type` = settings_types.entity
	where 
		settings.date_out is null && 
		settings_types.deleted is null;^

	drop view if exists SettingsLoadView;^
	create view SettingsLoadView as select 
		settings.entity as id,
		settings.`type` as `type`,
		settings.name as name,
		settings.`range` as `range`,
		settings.value as value,
		settings.description as description
	from _Settings settings
	where 
		settings.deleted is null;^

delimiter ;