create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop procedure if exists files_tables_delete;^
	create procedure files_tables_delete(
		in `$session` text
	) begin
		
		drop table if exists Files;
		
	end;^

	drop procedure if exists files_tables_create;^
	create procedure files_tables_create(
		in `$session` text
	) begin 
		
		create table if not exists Files(
			id integer not null auto_increment,
			`procedure` integer not null,
			`session` integer not null,
			`group` integer not null,
			`type` integer not null,
			name varchar(256) not null,
			`path` varchar(512) not null,
			weight integer not null,
			date_modified bigint not null,
			description varchar(512),
			deleted datetime,
			date_in datetime not null default now(),
			date_out datetime,
			constraint files_id primary key(id),
			constraint files_procedure foreign key(`procedure`) references Procedures(id),
			constraint files_session foreign key(`session`) references Sessions(id),
			constraint files_group foreign key(`group`) references FilesGroups(id),
			constraint files_type foreign key(`type`) references FilesTypes(id)
		);
		
	end;^

	drop procedure if exists files_tables_update;^
	create procedure files_tables_update(
		in `$session` text
	) begin 
		
		declare `$database` varchar(64) default settings_get('database_anp2', false);
		declare `$procedure` varchar(64) default 'files_tables_update';
		declare $session_id integer default ifnull(sessions_get_id(`$session`), sessions_get_machine());
		declare $ip_id integer;
		declare $user_agent_id integer;
		
		select ip_id, user_agent_id into $ip_id, $user_agent_id from SessionsFullView where id = $session_id limit 1;

		if (select 1 from information_schema.columns where table_schema = `$database` && table_name = 'Files' && column_name = 'group' limit 1) is null then begin 
			alter table Files add column `group` integer not null after id;
			alter table Files add constraint files_group foreign key(`group`) references FilesGroups(id);
		end;end if;

		if (select 1 from information_schema.columns where table_schema = `$database` && table_name = 'Files' && column_name = 'type' limit 1) is null then begin 
			alter table Files add column `type` integer not null after `group`;
			alter table Files add constraint files_type foreign key(`type`) references FilesTypes(id);
		end;end if;

		if (select 1 from information_schema.columns where table_schema = `$database` && table_name = 'Files' && column_name = 'name' limit 1) is null then begin 
			alter table Files add column name varchar(256) not null after `type`;
		end;end if;

		if (select 1 from information_schema.columns where table_schema = `$database` && table_name = 'Files' && column_name = 'path' limit 1) is null then begin 
			alter table Files add column `path` varchar(512) not null after name;
		end;end if;

		if (select 1 from information_schema.columns where table_schema = `$database` && table_name = 'Files' && column_name = 'weight' limit 1) is null then begin 
			alter table Files add column weight integer not null after `path`;
		end;end if;

		if (select 1 from information_schema.columns where table_schema = `$database` && table_name = 'Files' && column_name = 'date_modified' limit 1) is null then begin 
			alter table Files add column date_modified bigint not null after weight;
		end;end if;

		if (select 1 from information_schema.columns where table_schema = `$database` && table_name = 'Files' && column_name = 'description' limit 1) is null then begin 
			alter table Files add column description varchar(512) after date_modified;
		end;end if;
	
		call logs_set($session_id, `$database`, `$procedure`, $ip_id, $user_agent_id, 0, '{}', 1 << 1);
	
	end;^
	
	-- call files_tables_delete(null);^
	call files_tables_create(null);^
	call files_tables_update(null);^
	
delimiter ;