create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop view if exists FilesView;^
	create view FilesView as select 
		files.id as id, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		files_groups.id as group_id, 
		files_groups.name as name, 
		files_types.id as type_id, 
		files_types.mime as mime, 
		files.name as file_name, 
		files.`path` as `path`, 
		files.weight as weight, 
		files.date_modified as date_modified, 
		files.description as description, 
		files.deleted as deleted, 
		files.date_in as date_in
	from Files files
	join SessionsFullView sessions on files.`session` = sessions.id
	join ProceduresFullView procedures on files.`procedure` = procedures.id
	join FilesGroups files_groups on files.`group` = files_groups.id
	join FilesTypes files_types on files.`type` = files_types.id
	where 
		files.date_out is null && 
		files_groups.date_out is null && 
		files_types.date_out is null;^

	drop view if exists FilesSelectView;^
	create view FilesSelectView as select 
		files.id as id, 
		files.name as name
	from Files files
	;^

delimiter ;