create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop procedure if exists locates_tables_delete;^
	create procedure locates_tables_delete(
		in `$session` text
	) begin
		
		drop table if exists Locates;
		
	end;^

	drop procedure if exists locates_tables_create;^
	create procedure locates_tables_create(
		in `$session` text
	) begin 
		
		create table if not exists Locates(
			id integer not null auto_increment,
			`procedure` integer not null,
			`session` integer not null,
			`group` integer not null,
			name varchar(256),
			latitude float not null,
			longitude float not null,
			altitude float not null,
			description varchar(512),
			deleted datetime,
			date_in datetime not null default now(),
			date_out datetime,
			constraint locates_id primary key(id),
			constraint locates_procedure foreign key(`procedure`) references Procedures(id),
			constraint locates_session foreign key(`session`) references Sessions(id),
			constraint locates_group foreign key(`group`) references LocatesGroups(id)
		);
		
	end;^

	drop procedure if exists locates_tables_update;^
	create procedure locates_tables_update(
		in `$session` text
	) begin 
		
		declare `$database` varchar(64) default settings_get('database_anp2', false);
		declare `$procedure` varchar(64) default 'locates_tables_update';
		declare $session_id integer default ifnull(sessions_get_id(`$session`), sessions_get_machine());
		declare $ip_id integer;
		declare $user_agent_id integer;
		
		select ip_id, user_agent_id into $ip_id, $user_agent_id from SessionsFullView where id = $session_id limit 1;

		if (select 1 from information_schema.columns where table_schema = `$database` && table_name = 'Locates' && column_name = 'group' limit 1) is null then begin 
			alter table Locates add column `group` integer not null after id;
			alter table Locates add constraint locates_group foreign key(`group`) references LocatesGroups(id);
		end;end if;

		if (select 1 from information_schema.columns where table_schema = `$database` && table_name = 'Locates' && column_name = 'name' limit 1) is null then begin 
			alter table Locates add column name varchar(256) after `group`;
		end;end if;

		if (select 1 from information_schema.columns where table_schema = `$database` && table_name = 'Locates' && column_name = 'latitude' limit 1) is null then begin 
			alter table Locates add column latitude float not null after name;
		end;end if;

		if (select 1 from information_schema.columns where table_schema = `$database` && table_name = 'Locates' && column_name = 'longitude' limit 1) is null then begin 
			alter table Locates add column longitude float not null after latitude;
		end;end if;

		if (select 1 from information_schema.columns where table_schema = `$database` && table_name = 'Locates' && column_name = 'altitude' limit 1) is null then begin 
			alter table Locates add column altitude float not null after longitude;
		end;end if;

		if (select 1 from information_schema.columns where table_schema = `$database` && table_name = 'Locates' && column_name = 'description' limit 1) is null then begin 
			alter table Locates add column description varchar(512) after altitude;
		end;end if;
	
		call logs_set($session_id, `$database`, `$procedure`, $ip_id, $user_agent_id, 0, '{}', 1 << 1);
	
	end;^
	
	-- call locates_tables_delete(null);^
	call locates_tables_create(null);^
	call locates_tables_update(null);^
	
delimiter ;