create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop view if exists LocatesView;^
	create view LocatesView as select 
		locates.id as id, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		locates_groups.id as group_id, 
		locates_groups.name as name, 
		locates.name as locate_name, 
		locates.latitude as latitude, 
		locates.longitude as longitude, 
		locates.altitude as altitude, 
		locates.description as description, 
		locates.deleted as deleted, 
		locates.date_in as date_in
	from Locates locates
	join SessionsFullView sessions on locates.`session` = sessions.id
	join ProceduresFullView procedures on locates.`procedure` = procedures.id
	join LocatesGroups locates_groups on locates.`group` = locates_groups.id
	where 
		locates.date_out is null && 
		locates_groups.date_out is null;^

	drop view if exists LocatesSelectView;^
	create view LocatesSelectView as select 
		locates.id as id, 
		locates.name as name
	from Locates locates
	;^

delimiter ;