create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop procedure if exists users_emails_tables_delete;^
	create procedure users_emails_tables_delete(
		in `$session` text
	) begin
		
		drop table if exists _UsersEmails;
		drop table if exists UsersEmailsData;
		drop table if exists UsersEmails;
		
	end;^

	drop procedure if exists users_emails_tables_create;^
	create procedure users_emails_tables_create(
		in `$session` text
	) begin 
		
		create table if not exists UsersEmails(
			id integer not null auto_increment,
			date_in datetime not null default now(),
			date_out datetime,
			constraint users_emails_id primary key(id)
		);
	
		create table if not exists UsersEmailsData(
			id integer not null auto_increment,
			`procedure` integer not null,
			`session` integer not null,
			entity integer not null,
			email integer not null,
			`user` integer not null,
			belongs boolean not null,
			date_in datetime not null default now(),
			date_out datetime,
			constraint users_emails_data_id primary key(id),
			constraint users_emails_data_procedure foreign key(`procedure`) references Procedures(id),
			constraint users_emails_data_session foreign key(`session`) references Sessions(id),
			constraint users_emails_data_entity foreign key(entity) references UsersEmails(id),
			constraint users_emails_data_email foreign key(email) references Emails(id),
			constraint users_emails_data_user foreign key(`user`) references Users(id)
		);
	
		create table if not exists _UsersEmails(
			id integer not null auto_increment,
			`procedure` integer not null,
			`session` integer not null,
			entity integer not null, 
			`data` integer not null,
			email integer not null,
			`user` integer not null,
			belongs boolean not null,
			date_in datetime not null,
			date_created datetime not null,
			constraint _users_emails_id primary key(id),
			constraint _users_emails_procedure foreign key(`procedure`) references Procedures(id),
			constraint _users_emails_session foreign key(`session`) references Sessions(id),
			constraint _users_emails_entity foreign key(entity) references UsersEmails(id),
			constraint _users_emails_email foreign key(email) references Emails(id),
			constraint _users_emails_user foreign key(`user`) references Users(id)
		);
		
	end;^

	drop procedure if exists users_emails_tables_update;^
	create procedure users_emails_tables_update(
		in `$session` text
	) begin 
		
		declare `$database` varchar(64) default settings_get('database_anp2', false);
		declare `$procedure` varchar(64) default 'users_emails_tables_update';
		declare $session_id integer default ifnull(sessions_get_id(`$session`), sessions_get_machine());
		declare $ip_id integer;
		declare $user_agent_id integer;
		
		select ip_id, user_agent_id into $ip_id, $user_agent_id from SessionsFullView where id = $session_id limit 1;

		if (select 1 from information_schema.columns where table_schema = `$database` && table_name = 'UsersEmailsData' && column_name = 'email' limit 1) is null then begin 
			alter table UsersEmailsData add column email integer not null after entity;
			alter table UsersEmailsData add constraint users_emails_data_email foreign key(email) references Emails(id);
			alter table _UsersEmails add column email integer not null after `data`;
			alter table _UsersEmails add constraint _users_emails_email foreign key(email) references Emails(id);
		end;end if;

		if (select 1 from information_schema.columns where table_schema = `$database` && table_name = 'UsersEmailsData' && column_name = 'user' limit 1) is null then begin 
			alter table UsersEmailsData add column `user` integer not null after email;
			alter table UsersEmailsData add constraint users_emails_data_user foreign key(`user`) references Users(id);
			alter table _UsersEmails add column `user` integer not null after email;
			alter table _UsersEmails add constraint _users_emails_user foreign key(`user`) references Users(id);
		end;end if;

		if (select 1 from information_schema.columns where table_schema = `$database` && table_name = 'UsersEmailsData' && column_name = 'belongs' limit 1) is null then begin 
			alter table UsersEmailsData add column belongs boolean not null after `user`;
			alter table _UsersEmails add column belongs boolean not null after `user`;
		end;end if;
	
		call logs_set($session_id, `$database`, `$procedure`, $ip_id, $user_agent_id, '', '{}', 2);
	
	end;^
	
	-- call users_emails_tables_delete(null);^
	call users_emails_tables_create(null);^
	call users_emails_tables_update(null);^
	
delimiter ;