create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^
	
	drop procedure if exists users_emails_data_update;^
	create procedure users_emails_data_update(
		in $entity integer
	) begin 
		
		if (
			(select 1 from UsersEmails where id = $entity && date_out is null limit 1) is null || 
			(select 1 from UsersEmailsData where entity = $entity && date_out is null limit 1) is null 
		) then 
			delete from _UsersEmails where entity = $entity;
		else begin
			if (select 1 from _UsersEmails where entity = $entity limit 1) is null then 
				insert into _UsersEmails(`procedure`, `session`, entity, `data`, email, `user`, belongs, date_in, date_created)
					select `procedure`, `session`, entity, id, email, `user`, belongs, date_in, (select date_in from UsersEmails where id = $entity) from UsersEmailsData where id = (
						select max(id) from UsersEmailsData where entity = $entity && date_out is null 
					);
			else 
				update _UsersEmails plain 
				join (select `procedure`, `session`, entity, id, email, `user`, belongs, date_in, (select date_in from UsersEmails where id = $entity) from UsersEmailsData where id = (
					select max(id) from UsersEmailsData where entity = $entity && date_out is null 
				)) `data` on plain.entity = `data`.entity
				set 
					plain.`procedure` := `data`.`procedure`,
					plain.`session` := `data`.`session`,
					plain.`data` := `data`.id,
					plain.email := `data`.email,
					plain.`user` := `data`.`user`,
					plain.belongs := `data`.belongs,
					plain.date_in := `data`.date_in
				where plain.entity = $entity;
			end if;
		end;end if;
	
	end;^
	
	drop procedure if exists users_emails_full_update;^
	create procedure users_emails_full_update(
		in `$procedure` integer,
		in `$session` integer,
		in $entity integer,
		in `$data` integer,
		in $email integer,
		in `$user` integer,
		in $belongs boolean,
		in $date_in datetime
	) begin
		
		if (select 1 from UsersEmails where id = $entity && date_out is null limit 1) is null then 
			delete from _UsersEmails where entity = $entity;
		else begin 
			if (select 1 from _UsersEmails where entity = $entity limit 1) then 
				update _UsersEmails set 
					`procedure` := `$procedure`,
					`session` := `$session`,
					`data` := `$data`,
					email := $email,
					`user` := `$user`,
					belongs := $belongs,
					date_in := $date_in
				where entity = $entity;
			else 
				insert into _UsersEmails(`procedure`, `session`, entity, `data`, email, `user`, belongs, date_in, date_created) values 
					(`$procedure`, `$session`, $entity, `$data`, $email, `$user`, $belongs, $date_in, (select date_in from UsersEmails where id = $entity limit 1));
			end if;
		end;end if;
		
	end;^
	
	drop trigger if exists users_emails_trigger_update_entity;^
	create trigger users_emails_trigger_update_entity after update on UsersEmails for each row begin 
		call users_emails_data_update(new.id);
	end;^
	
	drop trigger if exists users_emails_trigger_insert;^
	create trigger users_emails_trigger_insert after insert on UsersEmailsData for each row begin 
		if new.date_out is null then 
			call users_emails_full_update(new.`procedure`, new.`session`, new.entity, new.id, new.email, new.`user`, new.belongs, new.date_in);
		end if;
	end;^
	
	drop trigger if exists users_emails_trigger_update;^
	create trigger users_emails_trigger_update after update on UsersEmailsData for each row begin 
		if new.entity != old.entity then 
			call users_emails_data_update(old.entity);
		end if;
		if new.date_out is null then 
			call users_emails_full_update(new.`procedure`, new.`session`, new.entity, new.id, new.email, new.`user`, new.belongs, new.date_in);
		else 
			call users_emails_data_update(new.entity);
		end if;
	end;^
	
	drop trigger if exists users_emails_trigger_delete;^
	create trigger users_emails_trigger_delete after delete on UsersEmailsData for each row begin 
		call users_emails_data_update(old.entity);
	end;^
	
delimiter ;