create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop view if exists UsersEmailsView;^
	create view UsersEmailsView as select 
		users_emails.id as plain_id, 
		users_emails.entity as id, 
		users_emails.`data` as `data`, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		emails.id as email_id, 
		emails.address as address, 
		users.entity as users_user_id, 
		users.nick as user_nick, 
		users_emails.belongs as belongs, 
		users_emails.date_in as date_in, 
		users_emails.date_created as date_created
	from _UsersEmails users_emails
	join SessionsFullView sessions on users_emails.`session` = sessions.id
	join ProceduresFullView procedures on users_emails.`procedure` = procedures.id
	join Emails emails on users_emails.email = emails.id
	join _Users users on users_emails.`user` = users.entity
	where 
		emails.date_out is null && 
		users.deleted is null;^

	drop view if exists UsersEmailsHistoryView;^
		create view UsersEmailsHistoryView as select 
		users_emails.id as plain_id, 
		users_emails.entity as id, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		emails.id as email_id, 
		emails.address as address, 
		users.entity as users_user_id, 
		users.nick as user_nick, 
		users_emails.belongs as belongs, 
		users_emails.date_in as date_in
	from UsersEmailsData users_emails
	join SessionsFullView sessions on users_emails.`session` = sessions.id
	join ProceduresFullView procedures on users_emails.`procedure` = procedures.id
	join Emails emails on users_emails.email = emails.id
	join _Users users on users_emails.`user` = users.entity
	where 
		users_emails.date_out is null && 
		emails.date_out is null && 
		users.deleted is null;^

delimiter ;