create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop view if exists FilesHashesView;^
	create view FilesHashesView as select 
		files_hashes.id as id, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		files.id as file_id, 
		files.name as name, 
		hashes.id as algorithm_id, 
		hashes.name as algorithm_name, 
		files_hashes.`hash` as `hash`, 
		files_hashes.deleted as deleted, 
		files_hashes.date_in as date_in
	from FilesHashes files_hashes
	join SessionsFullView sessions on files_hashes.`session` = sessions.id
	join ProceduresFullView procedures on files_hashes.`procedure` = procedures.id
	join Files files on files_hashes.file = files.id
	join Hashes hashes on files_hashes.`algorithm` = hashes.id
	where 
		files_hashes.date_out is null && 
		files.date_out is null && 
		hashes.date_out is null;^

delimiter ;