create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop view if exists CountriesView;^
	create view CountriesView as select 
		countries.id as plain_id, 
		countries.entity as id, 
		countries.`data` as `data`, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		countries.name as name, 
		countries.`key` as `key`, 
		countries.code as code, 
		countries_flag.id as flag_id, 
		countries_flag.group_id as flag_group_id, 
		countries_flag.`group` as flag_group, 
		countries_flag.name as flag_name, 
		countries_flag.type_id as flag_type_id, 
		countries_flag.mime as flag_mime, 
		countries_flag.`size` as flag_size, 
		countries_flag.last_modified as flag_last_modified, 
		concat('/app/countries/flag/', countries_flag.id, '/', countries_flag.name) as flag_url, 
		countries.description as description, 
		countries.deleted as deleted, 
		countries.date_in as date_in, 
		countries.date_created as date_created
	from _Countries countries
	join SessionsFullView sessions on countries.`session` = sessions.id
	join ProceduresFullView procedures on countries.`procedure` = procedures.id
	left join FilesLoadItemView countries_flag on countries_flag.id = countries.flag;^

	drop view if exists CountriesSelectView;^
	create view CountriesSelectView as select 
		countries.entity as id, 
		countries.name as name, 
		countries.code as code
	from _Countries countries
	;^

	drop view if exists CountriesHistoryView;^
		create view CountriesHistoryView as select 
		countries.id as plain_id, 
		countries.entity as id, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		countries.name as name, 
		countries.`key` as `key`, 
		countries.code as code, 
		countries_flag.id as flag_id, 
		countries_flag.group_id as flag_group_id, 
		countries_flag.`group` as flag_group, 
		countries_flag.name as flag_name, 
		countries_flag.type_id as flag_type_id, 
		countries_flag.mime as flag_mime, 
		countries_flag.`size` as flag_size, 
		countries_flag.last_modified as flag_last_modified, 
		concat('/app/countries/flag/', countries_flag.id, '/', countries_flag.name) as flag_url, 
		countries.description as description, 
		countries.deleted as deleted, 
		countries.date_in as date_in
	from CountriesData countries
	join SessionsFullView sessions on countries.`session` = sessions.id
	join ProceduresFullView procedures on countries.`procedure` = procedures.id
	left join FilesLoadItemView countries_flag on countries_flag.id = countries.flag
	where 
		countries.date_out is null;^

	drop view if exists CountriesLoadView;^
	create view CountriesLoadView as select 
		countries.entity as id,
		countries.name as name,
		countries.`key` as `key`,
		countries.code as code,
		files_flag.id as flag_id,
		files_flag.name as flag_name,
		files_flag.mime as flag_mime,
		files_flag.size as flag_size,
		files_flag.last_modified as flag_last_modified,
		concat('/app/countries/flag/', files_flag.id, '/', files_flag.name) as flag_url,
		countries.description as description
	from _Countries countries
	left join FilesLoadItemView files_flag on countries.flag = files_flag.id
	where 
		countries.deleted is null;^

delimiter ;