create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^
	
	drop procedure if exists countries_undelete;^
	create procedure countries_undelete(
		in `$session` text,
		in $entity integer,
		out $error varchar(512)
	) begin 
		
		declare `$database` varchar(64) default settings_get('database_anp2', false);
		declare `$procedure` varchar(64) default 'countries_undelete';
		declare $procedure_id integer;
		declare $data_id integer;
		declare $parameters text default json_set('{}', 
			'$.entity', $entity, 
			'$.id', 0
		);
		declare $session_id integer;
		declare $ip_id integer;
		declare $user_agent_id integer;
		declare exit handler for sqlexception begin
			get diagnostics condition 1
				@_status = returned_sqlstate,
				@_code = mysql_errno,
				@message = message_text;
			set $error := errors_set($error, 1 << 0, 0, 0);
			call exceptions_set($session_id, `$database`, `$procedure`, $ip_id, $user_agent_id, $error, $parameters, @message, @_status, @_code);
		end;
	
		call sessions_validate_full(`$session`, '["administrador"]', $error, $session_id, $ip_id, $user_agent_id);
		set $error := errors_set($error, countries_validate($entity, false), 30, 0);
	
		if !errors_has($error) then begin 
			
			call procedures_get(`$database`, `$procedure`, $procedure_id);
			set $data_id := (select `data` from _Countries where entity = $entity limit 1);
		
			insert into CountriesData(`procedure`, `session`, entity, name, `key`, code, flag, description, deleted) 
				select $procedure_id, $session_id, entity, name, `key`, code, flag, description, null from CountriesData where id = $data_id limit 1;
			
			set $parameters := json_set($parameters, 
				'$.id', last_insert_id() 
			);
		
		end;end if;
	
		call logs_set($session_id, `$database`, `$procedure`, $ip_id, $user_agent_id, $error, $parameters, 0);
		
	end;^

delimiter ;