create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^
	
	drop procedure if exists settings_groups_data_update;^
	create procedure settings_groups_data_update(
		in $entity integer
	) begin 
		
		if (
			(select 1 from SettingsGroups where id = $entity && date_out is null limit 1) is null || 
			(select 1 from SettingsGroupsData where entity = $entity && date_out is null limit 1) is null 
		) then 
			delete from _SettingsGroups where entity = $entity;
		else begin
			if (select 1 from _SettingsGroups where entity = $entity limit 1) is null then 
				insert into _SettingsGroups(`procedure`, `session`, entity, `data`, `group`, settings, value, belongs, date_in, date_created)
					select `procedure`, `session`, entity, id, `group`, settings, value, belongs, date_in, (select date_in from SettingsGroups where id = $entity) from SettingsGroupsData where id = (
						select max(id) from SettingsGroupsData where entity = $entity && date_out is null 
					);
			else 
				update _SettingsGroups plain 
				join (select `procedure`, `session`, entity, id, `group`, settings, value, belongs, date_in, (select date_in from SettingsGroups where id = $entity) from SettingsGroupsData where id = (
					select max(id) from SettingsGroupsData where entity = $entity && date_out is null 
				)) `data` on plain.entity = `data`.entity
				set 
					plain.`procedure` := `data`.`procedure`,
					plain.`session` := `data`.`session`,
					plain.`data` := `data`.id,
					plain.`group` := `data`.`group`,
					plain.settings := `data`.settings,
					plain.value := `data`.value,
					plain.belongs := `data`.belongs,
					plain.date_in := `data`.date_in
				where plain.entity = $entity;
			end if;
		end;end if;
	
	end;^
	
	drop procedure if exists settings_groups_full_update;^
	create procedure settings_groups_full_update(
		in `$procedure` integer,
		in `$session` integer,
		in $entity integer,
		in `$data` integer,
		in `$group` integer,
		in $settings integer,
		in $value text,
		in $belongs boolean,
		in $date_in datetime
	) begin
		
		if (select 1 from SettingsGroups where id = $entity && date_out is null limit 1) is null then 
			delete from _SettingsGroups where entity = $entity;
		else begin 
			if (select 1 from _SettingsGroups where entity = $entity limit 1) then 
				update _SettingsGroups set 
					`procedure` := `$procedure`,
					`session` := `$session`,
					`data` := `$data`,
					`group` := `$group`,
					settings := $settings,
					value := $value,
					belongs := $belongs,
					date_in := $date_in
				where entity = $entity;
			else 
				insert into _SettingsGroups(`procedure`, `session`, entity, `data`, `group`, settings, value, belongs, date_in, date_created) values 
					(`$procedure`, `$session`, $entity, `$data`, `$group`, $settings, $value, $belongs, $date_in, (select date_in from SettingsGroups where id = $entity limit 1));
			end if;
		end;end if;
		
	end;^
	
	drop trigger if exists settings_groups_trigger_update_entity;^
	create trigger settings_groups_trigger_update_entity after update on SettingsGroups for each row begin 
		call settings_groups_data_update(new.id);
	end;^
	
	drop trigger if exists settings_groups_trigger_insert;^
	create trigger settings_groups_trigger_insert after insert on SettingsGroupsData for each row begin 
		if new.date_out is null then 
			call settings_groups_full_update(new.`procedure`, new.`session`, new.entity, new.id, new.`group`, new.settings, new.value, new.belongs, new.date_in);
		end if;
	end;^
	
	drop trigger if exists settings_groups_trigger_update;^
	create trigger settings_groups_trigger_update after update on SettingsGroupsData for each row begin 
		if new.entity != old.entity then 
			call settings_groups_data_update(old.entity);
		end if;
		if new.date_out is null then 
			call settings_groups_full_update(new.`procedure`, new.`session`, new.entity, new.id, new.`group`, new.settings, new.value, new.belongs, new.date_in);
		else 
			call settings_groups_data_update(new.entity);
		end if;
	end;^
	
	drop trigger if exists settings_groups_trigger_delete;^
	create trigger settings_groups_trigger_delete after delete on SettingsGroupsData for each row begin 
		call settings_groups_data_update(old.entity);
	end;^
	
delimiter ;