create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop view if exists SettingsGroupsView;^
	create view SettingsGroupsView as select 
		settings_groups.id as plain_id, 
		settings_groups.entity as id, 
		settings_groups.`data` as `data`, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		groups.entity as group_id, 
		groups.name as name, 
		settings.entity as settings_id, 
		settings_types.entity as type_id, 
		settings_types.name as type_name, 
		settings.name as settings_name, 
		settings_groups.value as value, 
		settings_groups.belongs as belongs, 
		settings_groups.date_in as date_in, 
		settings_groups.date_created as date_created
	from _SettingsGroups settings_groups
	join SessionsFullView sessions on settings_groups.`session` = sessions.id
	join ProceduresFullView procedures on settings_groups.`procedure` = procedures.id
	join _Groups groups on settings_groups.`group` = groups.entity
	join _Settings settings on settings_groups.settings = settings.entity
	join _SettingsTypes settings_types on settings.`type` = settings_types.entity
	where 
		groups.deleted is null && 
		settings.deleted is null && 
		settings_types.deleted is null;^

	drop view if exists SettingsGroupsHistoryView;^
		create view SettingsGroupsHistoryView as select 
		settings_groups.id as plain_id, 
		settings_groups.entity as id, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		groups.entity as group_id, 
		groups.name as name, 
		settings.entity as settings_id, 
		settings_types.entity as type_id, 
		settings_types.name as type_name, 
		settings.name as settings_name, 
		settings_groups.value as value, 
		settings_groups.belongs as belongs, 
		settings_groups.date_in as date_in
	from SettingsGroupsData settings_groups
	join SessionsFullView sessions on settings_groups.`session` = sessions.id
	join ProceduresFullView procedures on settings_groups.`procedure` = procedures.id
	join _Groups groups on settings_groups.`group` = groups.entity
	join _Settings settings on settings_groups.settings = settings.entity
	join _SettingsTypes settings_types on settings.`type` = settings_types.entity
	where 
		settings_groups.date_out is null && 
		groups.deleted is null && 
		settings.deleted is null && 
		settings_types.deleted is null;^

	drop view if exists SettingsGroupsLoadView;^
	create view SettingsGroupsLoadView as select 
		settings_groups.entity as id,
		settings_groups.`group` as `group`,
		settings_groups.settings as settings,
		settings_groups.value as value,
		settings_groups.belongs as belongs
	from _SettingsGroups settings_groups;^

delimiter ;