create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

    drop procedure if exists settings_groups_get_basics;^
    create procedure settings_groups_get_basics(
        in `$session` text,
        out $error varchar(512)
    ) begin 

        declare `$database` varchar(64) default settings_get('database_anp2', false);
        declare `$procedure` varchar(64) default 'settings_groups_get_basics';
        declare $has_errors bool;
        declare $session_id integer;
        declare $ip_id integer;
        declare $user_agent_id integer;
		declare exit handler for sqlexception begin
			get diagnostics condition 1
				@_status = returned_sqlstate,
				@_code = mysql_errno,
				@message = message_text;
			set $error := errors_set($error, 1 << 0, 0, 0);
			call exceptions_set($session_id, `$database`, `$procedure`, $ip_id, $user_agent_id, $error, '{}', @message, @_status, @_code);
		end;
            
        call sessions_validate_full(`$session`, '["administrator"]', $error, $session_id, $ip_id, $user_agent_id);
        set $has_errors := errors_has($error);

		select * from GroupsSelectView where !$has_errors;
		select * from SettingsSelectView where !$has_errors;
        
        call logs_set($session_id, `$database`, `$procedure`, $ip_id, $user_agent_id, $error, '{}', 2);

    end;^

delimiter ;