create database if not exists AnP character set utf8mb4 collate utf8mb4_general_ci;
use AnP;

delimiter ;^

	drop view if exists LanguagesView;^
	create view LanguagesView as select 
		languages_2.id as plain_id, 
		languages_2.entity as id, 
		languages_2.`data` as `data`, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		countries.entity as country_id, 
		countries.name as name, 
		countries.code as code, 
		languages_2.name as language_name_2, 
		languages_2.`key` as `key`, 
		languages_2.code as language_code, 
		languages_flag.id as flag_id, 
		languages_flag.group_id as flag_group_id, 
		languages_flag.`group` as flag_group, 
		languages_flag.name as flag_name, 
		languages_flag.type_id as flag_type_id, 
		languages_flag.mime as flag_mime, 
		languages_flag.`size` as flag_size, 
		languages_flag.last_modified as flag_last_modified, 
		concat('/app/languages/flag/', languages_flag.id, '/', languages_flag.name) as flag_url, 
		languages_2.description as description, 
		languages_2.deleted as deleted, 
		languages_2.date_in as date_in, 
		languages_2.date_created as date_created
	from _Languages languages_2
	join SessionsFullView sessions on languages_2.`session` = sessions.id
	join ProceduresFullView procedures on languages_2.`procedure` = procedures.id
	join _Countries countries on languages_2.country = countries.entity
	left join FilesLoadItemView languages_flag on languages_flag.id = languages_2.flag
	where 
		countries.deleted is null;^

	drop view if exists LanguagesSelectView;^
	create view LanguagesSelectView as select 
		languages.entity as id, 
		languages.name as name, 
		languages.code as code
	from _Languages languages
	;^

	drop view if exists LanguagesHistoryView;^
		create view LanguagesHistoryView as select 
		languages_2.id as plain_id, 
		languages_2.entity as id, 
		procedures.database_id as database_id, 
		procedures.id as procedure_id, 
		procedures.`database` as `database`, 
		procedures.`procedure` as `procedure`, 
		sessions.id as session_id, 
		sessions.user_id as user_id, 
		sessions.nick as nick, 
		sessions.ip_id as ip_id, 
		sessions.ip as ip, 
		countries.entity as country_id, 
		countries.name as name, 
		countries.code as code, 
		languages_2.name as language_name_2, 
		languages_2.`key` as `key`, 
		languages_2.code as language_code, 
		languages_flag.id as flag_id, 
		languages_flag.group_id as flag_group_id, 
		languages_flag.`group` as flag_group, 
		languages_flag.name as flag_name, 
		languages_flag.type_id as flag_type_id, 
		languages_flag.mime as flag_mime, 
		languages_flag.`size` as flag_size, 
		languages_flag.last_modified as flag_last_modified, 
		concat('/app/languages/flag/', languages_flag.id, '/', languages_flag.name) as flag_url, 
		languages_2.description as description, 
		languages_2.deleted as deleted, 
		languages_2.date_in as date_in
	from LanguagesData languages_2
	join SessionsFullView sessions on languages_2.`session` = sessions.id
	join ProceduresFullView procedures on languages_2.`procedure` = procedures.id
	join _Countries countries on languages_2.country = countries.entity
	left join FilesLoadItemView languages_flag on languages_flag.id = languages_2.flag
	where 
		languages_2.date_out is null && 
		countries.deleted is null;^

	drop view if exists LanguagesLoadView;^
	create view LanguagesLoadView as select 
		languages.entity as id,
		languages.country as country,
		languages.name as name,
		languages.`key` as `key`,
		languages.code as code,
		files_flag.id as flag_id,
		files_flag.name as flag_name,
		files_flag.mime as flag_mime,
		files_flag.size as flag_size,
		files_flag.last_modified as flag_last_modified,
		concat('/app/languages/flag/', files_flag.id, '/', files_flag.name) as flag_url,
		languages.description as description
	from _Languages languages
	left join FilesLoadItemView files_flag on languages.flag = files_flag.id
	where 
		languages.deleted is null;^

delimiter ;