﻿use AnP;

delimiter ;^

	drop procedure if exists kyman_language_set;^
	create procedure kyman_language_set(
		in $country_name varchar(64),
		in $country_key varchar(64),
		in $country_code varchar(4),
		in $language_name varchar(64),
		in $language_key varchar(64),
		in $language_code varchar(4)
	) begin
		
		declare $session_id integer default sessions_get_machine();
		declare `$database` varchar(64) default settings_get('database_anp', false);
		declare `$procedure` varchar(64) default 'kyman_language_set';
		declare $procedure_id integer;
		declare $country_id integer default (select id from _Countries where `key` = $country_key limit 1);
	
		call procedures_get(`$procedure`, `$database`, $procedure_id);
	
		if $country_id is null then begin 
			insert into Countries values();
			set $country_id := last_insert_id();
			insert CountriesData(`procedure`, `session`, entity, name, `key`, code) values 
				($procedure_id, $session_id, $country_id, $country_name, $country_key, $country_code);
		end;end if;
	
		if (select 1 from _Languages where country = $country_id && `key` = $language_key limit 1) is null then begin 
			insert into Languages values();
			insert LanguagesData(`procedure`, `session`, entity, country, name, `key`, code) values 
				($procedure_id, $session_id, last_insert_id(), $country_id, $language_name, $language_key, $language_code);
		end;end if;
		
	end;^
	
	call kyman_language_set('España', 'espana', 'es', 'Español', 'espanol', 'es');^
	call kyman_language_set('España', 'espana', 'es', 'Galego', 'galego', 'gal');^
	call kyman_language_set('United Kingdom', 'united_kingdom', 'uk', 'English', 'english', 'en');^
	call kyman_language_set('Россия', 'Rossiya', 'ru', 'Русский', 'russkiy', 'ru');^
	call kyman_language_set('日本', 'nihon', 'jp', '日本語', 'nihongo', 'jp');^
	
	drop procedure kyman_language_set;^

delimiter ;