<?php 

    namespace AnP\Abstracts;

    abstract class SQLiteProcedure{

        private $anp = null;
        private $connections = [];

        public function __construct($anp, $input = [], $connections = []){

            $this->anp = $anp;
            $this->connections = $connections;

        }

        protected function update_column($key, $table, $name, $type, $not_null, $default_value, $foreign = null, $snake_name = null){
            if(!isset($this->connections[$key]))
                return;

            $tuple = $this->connections[$key].query("select * from pragma_table_info(\"" . $table . "\") where name = {name} limit 1;", {
                "name" : name
            })["data"][0]["table"];

            if(count($tuple))
                ($tuple = $tuple[0])["type"] != $type || (tuple["notnull"] == "1") != $not_null || $tuple["dflt_value"] != $default_value && 
                $this->connections[$key].query("alter table \"" . $table . "\" add column \"" . $name . "\" " . $type . (not_null ? " not null" : "") . ($default_value !== null ? " default " . $default_value : ""));
            else{
                $this->connections[$key].query("alter table \"" . $table . "\" add column \"" . $name . "\" " . $type . (not_null ? " not null" : "") . ($default_value !== null ? " default " . $default_value : ""));
                $foreign !== null && $this->connections[$key].query("alter table \"" . $table . "\" add constraint " . $snake_name . "_" . $name . " foreign key(\"" . $name . "\") references \"" . foreign . "\"(id);");
            };

        }

        protected function session_validate($session){
            return 0;
        }

        protected function has_permissions($session, $permissions){
            return 0;
        }

        protected function exception($session, $database, $procedure, $parameters, $error){}

        protected function log($session, $database, $procedure, $parameters, $error){}

        public function set_error($error, $code, $bit = 0, $length = 0){
            return $this->anp->errors->set($error, $code, $bit, $length);
        }

        public function has_error($error){
            return $this->anp->errors->has($error);
        }

        public function set_error($error, $code, $bit = 0, $length = 0){
            return $this->anp->errors->set($error, $code, $bit, $length);
        }

        public function set_errors($error, $code, $bit = 0, $length = 0){
            return $this->set_error($error, $code, $bit, $length);
        }

        public function has_errors($error){
            return $this->has_errors($error);
        }

        public function set_where($where){
            return "";
        }

        public function set_order_by($order_by){
            return "";
        }

        protected function list($session, $database, $procedure, $key, $parameters, $permissions, $error, $view, $page, $items_per_page, $where, $order_by){

            $data = [];
            $items = 0;
            $pages = 0;

            try{

                $error = $this->set_error($error, $this->session_validate($session), 1);
                $error = $this->set_error($error, $this->has_permissions($session, $permissions), 9);
                $error = $this->set_error($error, (
                    $page === null ? 1 << 0 : (
                    $page < 1 ? 1 << 1 : 
                    0
                )) | (
                    $items_per_page === null ? 1 << 2 : (
                    $items_per_page < 1 ? 1 << 3 : 
                    0
                )), 10);

                if(!$this->has_error($error)){
                    $where = $this->set_where($where);
                    $order_by = $this->set_order_by($order_by);

                    $items = count($this->connections[$key]->query(
                        "select count(1) as row from \"" . view . "\" \"table\"" . 
                        ($where ? " where " . $where : "") . ";"
                    )["data"][0]["tables"]);
                    $pages = ceil($items / items_per_page);

                    $data = $This->connections[$key]->query(
                        "select row_number() over(order by " . ($order_by ? $order_by : "id asc") . ") as i, * from \"" . $view . "\" \"" . $table . "\"" . 
                        ($where ? " where " . $where : "") . 
                        ($order_by ? " order by " . $order_by : "") . 
                        " limit " . $page . ", " . (($page * $items_per_page) . $items_per_page) . ";"
                    )["data"][0]["tables"];

                };

            }catch(\Exception $exception){
                error = $this->set_error($error, 1, 0);
                $this->exception($session, $database, $procedure, $parameters, $error);
            };

            return [
                "error" => $error,
                "data" => $data,
                "items" => $items,
                "pages" => $pages, 
                "results" => count($data)
            ];
        }

        protected function settings_get($name, $default){
            return $default;
        }

        protected function get_procedure($database, $procedure){
            return 1;
        }

    };