<?php

    namespace AnP;

    class Connections{

        private $anp;
        private $started = false;
        private $drivers = [];
        private $connections = [];

        public function __construct($anp, $input = []){

            $this->anp = $anp;
            $this->drivers = \AnP\Secrets::drivers;

        }

        public function add($data, $overwrite = null){

            !is_bool($overwrite) && ($overwrite = $this->anp->settings->get(["connection_overwrite", "overwrite"]));

            if(is_string($data)){
                if(!($json = $this->anp->json_decode($data)) && !($json = $this->anp->load_json($data)))
                    return;
                $data = $json;
            };

            if(is_array($data)){
                if(\AnP::is_dictionary($data))
                    foreach($data as $key => $connection)
                        \AnP::is_dictionary($connection) &&
                        isset($this->drivers[$type = $this->anp->settings->get(["connection_type", "type"], $connection)]) &&
                        ($overwrite || !isset($this->connections[$key])) &&
                        ($this->connections[$key] = new $this->drivers[$type]($this->anp, $connection));
                else
                    foreach($data as $set)
                        $this->add($set, $overwrite);
            };

        }

        public function start(){

            if($this->started)
                return;
            $this->started = true;

            foreach(["default_connections", "connections"] as $key){
                // $this->anp->print(["key" => $key, "data" => $this->anp->settings->get($key)]);
                $this->add($this->anp->settings->get($key), true);
            };

        }

        public function get($key){
            return isset($this->connections[$key]) ? $this->connections[$key] : null;
        }

    };
