<?php

    namespace AnP;

    class Controllers{

        private $anp = null;
        private $started = false;
        private $roots = [""];
        private $controllers = [];
        private $paths = [""];

        public function __construct($anp, $input = []){

            $this->anp = $anp;

        }

        public function add($inputs, $overwrite = null){
            if(!$inputs)
                return;

            !is_bool($overwrite) && ($overwrite = $this->anp->settings->get(["controllers_overwrite", "overwrite"]));

            if(\AnP::is_dictionary($inputs)){
                foreach($inputs as $key => $controller)
                    if($controller){
                        if(is_string($controller)){
                            foreach($this->roots as $root){
                                class_exists($class = $root . $controller) && ($controller = new $class($this->anp));
                                break;
                            };
                        };
                        (is_object($controller) || (is_string($controller))) && ($overwrite || !isset($this->controllers[$key])) && ($this->controllers[$key] = $controller);
                    };
            }elseif(is_array($inputs))
                foreach($inputs as $input){
                    is_string($input) && (($json = $this->anp->json_decode($input)) || ($json = $this->anp->load_json($input))) && ($input = $json);
                    is_array($input) && $this->add($input);
                };

        }

        public function add_roots($roots){
            foreach($roots ? (is_array($roots) ? $roots : [$roots]) : [] as $root)
                $root && is_string($root) && !in_array($root, $this->roots) && ($this->roots[] = $root);
        }

        public function add_paths($paths){
            foreach($paths ? (is_array($paths) ? $paths : [$paths]) : [] as $path)
                $path && is_string($path) && !in_array($path, $this->paths) && ($this->paths[] = preg_replace('/\/$/', '', $path) . "/");
        }

        public function start(){

            if($this->started)
                return;
            $this->started = true;

            foreach(["default_controllers_paths", "controllers_paths"] as $key)
                $this->add_paths($this->anp->settings->get($key));
            foreach(["default_controllers_roots", "controllers_roots"] as $key)
                $this->add_roots($this->anp->settings->get($key));
            foreach(["default_controllers_files", "controllers_files"] as $key)
                $this->add($this->anp->settings->get($key), true);

        }

        public function get($key){

            if(is_string($this->controllers[$key])){

                $file = "/" . preg_replace('/\\\\/', ".", substr($this->controllers[$key], 1)) . ".php";
                $ok = false;

                foreach($this->paths as $path){
                    if($ok)
                        break;
                    elseif(($path = $this->anp->get_absolute_path($path . $file)) !== null){

                        include $path;

                        foreach($this->roots as $root){
                            if(class_exists($class = $root . $this->controllers[$key])){
                                $this->controllers[$key] = new $class($this->anp);
                                $ok = true;
                                break;
                            };
                        };

                    };
                };

            };

            return isset($this->controllers[$key]) && is_object($this->controllers[$key]) ? $this->controllers[$key] : null;
        }

    };
