<?php 

    namespace AnP\Controllers;

    class Languages extends \AnP\Controller{

        public function __construct($anp){
            parent::__construct($anp, $this);

            $this->entity = "Languages";
            $this->class = get_class($this);

        }

        public function list(){

            try{
                $this->execute()->list();
            }catch(\Exception $exception){
                $this->set_traces($exception);
            };

        }

        public function basics(){

            try{
                $this->execute()->basics();
            }catch(\Exception $exception){
                $this->set_traces($exception);
            };

        }

        public function add(){

            try{
                $this->execute()->add();
            }catch(\Exception $exception){
                $this->set_traces($exception);
            };

        }

        public function load(){

            try{
                $this->execute()->load();
            }catch(\Exception $exception){
                $this->set_traces($exception);
            };

        }

        public function edit(){

            try{
                $this->execute()->edit();
            }catch(\Exception $exception){
                $this->set_traces($exception);
            };

        }

        public function delete(){

            try{
                $this->execute()->delete();
            }catch(\Exception $exception){
                $this->set_traces($exception);
            };

        }

        public function deleted(){

            try{
                $this->execute()->deleted();
            }catch(\Exception $exception){
                $this->set_traces($exception);
            };

        }

        public function undelete(){

            try{
                $this->execute()->undelete();
            }catch(\Exception $exception){
                $this->set_traces($exception);
            };

        }

        public function history(){

            try{
                $this->execute()->history();
            }catch(\Exception $exception){
                $this->set_traces($exception);
            };

        }

        public function restore(){

            try{
                $this->execute()->restore();
            }catch(\Exception $exception){
                $this->set_traces($exception);
            };

        }

        public function get_flag_file(){

            try{

                $response = $this->execute()->get_flag_file();

                if($this->anp->errors->has($response["error"])){
                    $this->json_response([
                        "error" => $response["error"],
                        "message" => "load_file_error"
                    ]);
                    return;
                };

                header("Content-type: " . $response["type"]);
                echo file_get_contents($response["path"]);

            }catch(\Exception $exception){
                $this->set_traces($exception);
            };

        }

    };
