<?php 

    namespace AnP\Controllers\Groups;

    class MariaDB extends \AnP\Controller{

        protected $key = "AnP_MariaDB";

        public function list(){
            
            $this->json_response($this->list_query((
                "call groups_list({session}, {page}, {items_per_page}, {where}, {order_by}, @items, @pages, @results, @error);"
            )));

        }

        public function select(){
            
            $this->json_response($this->list_query((
                "call groups_select_list({session}, {page}, {items_per_page}, {where}, {order_by}, @items, @pages, @results, @error);"
            )));

        }

        public function add(){ 

            $this->json_response($this->anp->connections->get($this->key)->query((
                "call groups_add({session}, {name}, {default}, {is_entity}, {description}, @error, @id);"
            ), [
                "name" => $this->request("name"),
                "default" => $this->request("default"),
                "is_entity" => $this->request("is_entity"),
                "description" => $this->request("description")
            ])); 

        }

        public function load(){

            $results = $this->anp->connections->get($this->key)->query((
                "call groups_load({session}, {id}, @error);"
            ), ["id" => $this->request("id")]);

            if(!$results["error"] && !$results["driver_error"] && $this->anp->errors->has($results["variables"]["error"]))
                $results["data"] = null;
            else{
                $results["data"] = $results["tables"][0][0]; 
            };
            
            if(isset($results["tables"]))
                unset($results["tables"]);
            
            $this->json_response($results);

        }

        public function edit(){ 

            $this->json_response($this->anp->connections->get($this->key)->query((
                "call groups_edit({session}, {id}, {name}, {default}, {is_entity}, {description}, @error);"
            ), [
                "id" => $this->request("id"),
                "name" => $this->request("name"),
                "default" => $this->request("default"),
                "is_entity" => $this->request("is_entity"),
                "description" => $this->request("description")
            ])); 

        }

        public function delete(){
            
            $this->json_response($this->anp->connections->get($this->key)->query((
                "call groups_delete({session}, {id}, @error);"
            ), ["id" => $this->request("id")]));

        }

        public function deleted(){
            
            $this->json_response($this->list_query((
                "call groups_deleted_list({session}, {page}, {items_per_page}, {where}, {order_by}, @items, @pages, @results, @error);"
            )));

        }

        public function undelete(){
            
            $this->json_response($this->anp->connections->get($this->key)->query((
                "call groups_undelete({session}, {id}, @error);"
            ), ["id" => $this->request("id")]));

        }

        public function history(){
            
            $this->json_response($this->list_query((
                "call groups_history({session}, {id}, {page}, {items_per_page}, {where}, {order_by}, @items, @pages, @results, @error);"
            ), ["id" => $this->request("id")]));

        }

        public function restore(){
            
            $this->json_response($this->anp->connections->get($this->key)->query((
                "call groups_restore({session}, {id}, @error);"
            ), ["id" => $this->request("id")]));

        }

    };
