<?php 

    namespace AnP\Controllers\Sessions;

    class MariaDB extends \AnP\Controller{

        protected $key = "AnP_MariaDB";
        
        public function guest(){
            return $this->anp->connections->get($this->key)->query((
                "call sessions_get_guest({session}, @error, @id, @user, @timeout);"
            ), [
                "ip" => \AnP::get_ip()
            ]);
        }
        
        public function update(){
            return $this->anp->connections->get($this->key)->query((
                "call sessions_update({session}, @error, @user, @timeout, @reset_password);"
            ));
        }
        
        public function close(){
            return $this->anp->connections->get($this->key)->query((
                "call sessions_close({session}, @error);"
            ));
        }

        public function register(){
            return $this->anp->connections->get($this->key)->query((
                "call sessions_register({session}, {nick}, {email}, {password}, @error, @id);"
            ), [
                "nick" => $this->request("nick"),
                "email" => $this->request("email"),
                "password" => $this->request("password")
            ]);
        }

        public function login(){
            return $this->anp->connections->get($this->key)->query((
                "call sessions_login({session}, {user}, {password}, @error, @id, @user, @timeout, @reset_password);"
            ), [
                "user" => $this->request("user"),
                "password" => $this->request("password")
            ]);
        }

        public function reset_password(){
            
            // $this->json_response($this->anp->connections->get($this->key)->query((
            //     "call sessions_reset_password({session}, {password}, @error);"
            // ), [
            //     "password" => $this->request("password")
            // ]));

            $this->json_response($this->anp->connections->get($this->key)->query((
                "call sessions_reset_password({session}, {password}, @error);"
            ), ["password" => $this->request("password")]));


        }

        public function logs(){
            
            $this->json_response($this->list_query((
                "call logs_list({session}, {page}, {items_per_page}, {where}, {order_by}, @items, @pages, @results, @error);"
            )));

        }

        public function exceptions(){
            
            $this->json_response($this->list_query((
                "call exceptions_list({session}, {page}, {items_per_page}, {where}, {order_by}, @items, @pages, @results, @error);"
            )));

        }

        public function traces(){
            
            $this->json_response($this->list_query((
                "call traces_list({session}, {page}, {items_per_page}, {where}, {order_by}, @items, @pages, @results, @error);"
            )));

        }

    };
