<?php 

    namespace AnP\Controllers\Settings;

    class MariaDB extends \AnP\Controller{

        protected $key = "AnP_MariaDB";

        public function list(){
            
            $this->json_response($this->list_query((
                "call settings_list({session}, {page}, {items_per_page}, {where}, {order_by}, @items, @pages, @results, @error);"
            )));

        }

        public function select(){
            
            $this->json_response($this->list_query((
                "call settings_select_list({session}, {page}, {items_per_page}, {where}, {order_by}, @items, @pages, @results, @error);"
            )));

        }

        public function basics(){
            
            $this->json_response($this->list_query((
                "call settings_get_basics({session}, @error);"
            )));

        }

        public function add(){ 

            $this->json_response($this->anp->connections->get($this->key)->query((
                "call settings_add({session}, {type}, {name}, {range}, {value}, {description}, @error, @id);"
            ), [
                "type" => $this->request("type"),
                "name" => $this->request("name"),
                "range" => $this->request("range"),
                "value" => $this->request("value"),
                "description" => $this->request("description")
            ])); 

        }

        public function load(){

            $results = $this->anp->connections->get($this->key)->query((
                "call settings_load({session}, {id}, @error);"
            ), ["id" => $this->request("id")]);

            if(!$results["error"] && !$results["driver_error"] && $this->anp->errors->has($results["variables"]["error"]))
                $results["data"] = null;
            else{
                $results["data"] = $results["tables"][0][0]; 
            };
            
            if(isset($results["tables"]))
                unset($results["tables"]);
            
            $this->json_response($results);

        }

        public function edit(){ 

            $this->json_response($this->anp->connections->get($this->key)->query((
                "call settings_edit({session}, {id}, {type}, {name}, {range}, {value}, {description}, @error);"
            ), [
                "id" => $this->request("id"),
                "type" => $this->request("type"),
                "name" => $this->request("name"),
                "range" => $this->request("range"),
                "value" => $this->request("value"),
                "description" => $this->request("description")
            ])); 

        }

        public function delete(){
            
            $this->json_response($this->anp->connections->get($this->key)->query((
                "call settings_delete({session}, {id}, @error);"
            ), ["id" => $this->request("id")]));

        }

        public function deleted(){
            
            $this->json_response($this->list_query((
                "call settings_deleted_list({session}, {page}, {items_per_page}, {where}, {order_by}, @items, @pages, @results, @error);"
            )));

        }

        public function undelete(){
            
            $this->json_response($this->anp->connections->get($this->key)->query((
                "call settings_undelete({session}, {id}, @error);"
            ), ["id" => $this->request("id")]));

        }

        public function history(){
            
            $this->json_response($this->list_query((
                "call settings_history({session}, {id}, {page}, {items_per_page}, {where}, {order_by}, @items, @pages, @results, @error);"
            ), ["id" => $this->request("id")]));

        }

        public function restore(){
            
            $this->json_response($this->anp->connections->get($this->key)->query((
                "call settings_restore({session}, {id}, @error);"
            ), ["id" => $this->request("id")]));

        }

    };
