<?php 

    namespace AnP\Controllers\SettingsGroups;

    class MariaDB extends \AnP\Controller{

        protected $key = "AnP_MariaDB";

        public function list(){
            
            $this->json_response($this->list_query((
                "call settings_groups_list({session}, {page}, {items_per_page}, {where}, {order_by}, @items, @pages, @results, @error);"
            )));

        }

        public function select(){
            
            $this->json_response($this->list_query((
                "call settings_groups_select_list({session}, {page}, {items_per_page}, {where}, {order_by}, @items, @pages, @results, @error);"
            )));

        }

        public function basics(){
            
            $this->json_response($this->list_query((
                "call settings_groups_get_basics({session}, @error);"
            )));

        }

        public function load(){

            $results = $this->anp->connections->get($this->key)->query((
                "call settings_groups_load({session}, {id}, @error);"
            ), ["id" => $this->request("id")]);

            if(!$results["error"] && !$results["driver_error"] && $this->anp->errors->has($results["variables"]["error"]))
                $results["data"] = null;
            else{
                $results["data"] = $results["tables"][0][0]; 
            };
            
            if(isset($results["tables"]))
                unset($results["tables"]);
            
            $this->json_response($results);

        }

        public function history(){
            
            $this->json_response($this->list_query((
                "call settings_groups_history({session}, {id}, {page}, {items_per_page}, {where}, {order_by}, @items, @pages, @results, @error);"
            ), ["id" => $this->request("id")]));

        }

        public function restore(){
            
            $this->json_response($this->anp->connections->get($this->key)->query((
                "call settings_groups_restore({session}, {id}, @error);"
            ), ["id" => $this->request("id")]));

        }

    };
