<?php 

    namespace AnP\Controllers\Groups;

    class SQLServer extends \AnP\Controller{

        protected $key = "AnP_SQLServer";

        public function list(){
            
            $this->json_response($this->list_query((
                "execute dbo.groups_list {session}, {page}, {items_per_page}, {where}, {order_by}, @pages output, @items output, @results output, @error output"
            )));
            
        }

        public function select(){
            
            $this->json_response($this->list_query((
                "execute dbo.groups_select_list {session}, {page}, {items_per_page}, {where}, {order_by}, @pages output, @items output, @results output, @error output"
            )));
            
        }

        public function add(){ 

            $this->json_response($this->anp->connections->get($this->key)->query((
                "execute dbo.groups_add {session}, {name}, {default}, {is_entity}, {description}, @error output, @id output"
            ), [
                "name" => $this->request("name"),
                "default" => $this->request("default"),
                "is_entity" => $this->request("is_entity"),
                "description" => $this->request("description")
            ])); 

        }

        public function load(){

            $results = $this->anp->connections->get($this->key)->query((
                "execute dbo.groups_load {session}, {id}, @error output"
            ), ["id" => $this->request("id")]);

            if(!$results["error"] && !$results["driver_error"] && $this->anp->errors->has($results["variables"]["error"]))
                $results["data"] = null;
            else{
                $results["data"] = $results["tables"][0][0]; 
            };
            
            if(isset($results["tables"]))
                unset($results["tables"]);
            
            $this->json_response($results);

        }

        public function edit(){ 

            $this->json_response($this->anp->connections->get($this->key)->query((
                "execute dbo.groups_edit {session}, {id}, {name}, {default}, {is_entity}, {description}, @error output"
            ), [
                "id" => $this->request("id"),
                "name" => $this->request("name"),
                "default" => $this->request("default"),
                "is_entity" => $this->request("is_entity"),
                "description" => $this->request("description")
            ])); 

        }

        public function delete(){
            
            $this->json_response($this->anp->connections->get($this->key)->query((
                "execute dbo.groups_delete {session}, {id}, @error output"
            ), ["id" => $this->request("id")]));

        }

        public function deleted(){
            
            $this->json_response($this->list_query((
                "execute dbo.groups_deleted_list {session}, {page}, {items_per_page}, {where}, {order_by}, @pages output, @items output, @results output, @error output"
            )));

        }

        public function undelete(){
            
            $this->json_response($this->anp->connections->get($this->key)->query((
                "execute dbo.groups_undelete {session}, {id}, @error output"
            ), ["id" => $this->request("id")]));

        }

        public function history(){
            
            $this->json_response($this->list_query((
                "execute dbo.groups_history {session}, {id}, {page}, {items_per_page}, {where}, {order_by}, @pages output, @items output, @results output, @error output"
            ), ["id" => $this->request("id")]));

        }

        public function restore(){
            
            $this->json_response($this->anp->connections->get($this->key)->query((
                "execute dbo.groups_restore {session}, {id}, @error output"
            ), ["id" => $this->request("id")]));

        }

    };
