<?php 

    namespace AnP\Controllers\Sessions;

    class SQLServer extends \AnP\Controller{

        protected $key = "AnP_SQLServer";
        
        public function guest(){
            return $this->anp->connections->get($this->key)->query((
                "execute dbo.sessions_get_guest {session}, @error output, @id output, @user output, @timeout output"
            ), [
                "ip" => \AnP::get_ip()
            ]);
        }
        
        public function update(){
            return $this->anp->connections->get($this->key)->query((
                "execute dbo.sessions_update {session}, @error output, @user output, @timeout output, @reset_password output"
            ));
        }
        
        public function close(){
            return $this->anp->connections->get($this->key)->query((
                "execute dbo.sessions_close {session}, @error output"
            ));
        }

        public function register(){
            return $this->anp->connections->get($this->key)->query((
                "execute dbo.sessions_register {session}, {nick}, {email}, {password}, @error output, @id output"
            ), [
                "nick" => $this->request("nick"),
                "email" => $this->request("email"),
                "password" => $this->request("password")
            ]);
        }

        public function login(){
            return $this->anp->connections->get($this->key)->query((
                "execute dbo.sessions_login {session}, {user}, {password}, @error output, @id output, @user output, @timeout output, @reset_password output"
            ), [
                "user" => $this->request("user"),
                "password" => $this->request("password")
            ]);
        }

        public function reset_password(){
            
            $this->json_response($this->anp->connections->get($this->key)->query((
                "execute dbo.sessions_reset_password {session}, {password}, @error output"
            ), [
                "password" => $this->request("password")
            ]));

        }

        public function logs(){
            
            $this->json_response($this->list_query((
                "execute dbo.logs_list {session}, {page}, {items_per_page}, {where}, {order_by}, @pages output, @items output, @results output, @error output"
            )));
            
        }

        public function exceptions(){
            
            $this->json_response($this->list_query((
                "execute dbo.exceptions_list {session}, {page}, {items_per_page}, {where}, {order_by}, @pages output, @items output, @results output, @error output"
            )));
            
        }

        public function traces(){
            
            $this->json_response($this->list_query((
                "execute dbo.traces_list {session}, {page}, {items_per_page}, {where}, {order_by}, @pages output, @items output, @results output, @error output"
            )));
            
        }

    };
