<?php 

    namespace AnP\Controllers\Settings;

    class SQLServer extends \AnP\Controller{

        protected $key = "AnP_SQLServer";

        public function list(){
            
            $this->json_response($this->list_query((
                "execute dbo.settings_list {session}, {page}, {items_per_page}, {where}, {order_by}, @pages output, @items output, @results output, @error output"
            )));
            
        }

        public function select(){
            
            $this->json_response($this->list_query((
                "execute dbo.settings_select_list {session}, {page}, {items_per_page}, {where}, {order_by}, @pages output, @items output, @results output, @error output"
            )));
            
        }

        public function basics(){
            
            $this->json_response($this->anp->connections->get($this->key)->query((
                "execute dbo.settings_get_basics {session}, @error output"
            )));

        }

        public function add(){ 

            $this->json_response($this->anp->connections->get($this->key)->query((
                "execute dbo.settings_add {session}, {type}, {name}, {range}, {value}, {description}, @error output, @id output"
            ), [
                "type" => $this->request("type"),
                "name" => $this->request("name"),
                "range" => $this->request("range"),
                "value" => $this->request("value"),
                "description" => $this->request("description")
            ])); 

        }

        public function load(){

            $results = $this->anp->connections->get($this->key)->query((
                "execute dbo.settings_load {session}, {id}, @error output"
            ), ["id" => $this->request("id")]);

            if(!$results["error"] && !$results["driver_error"] && $this->anp->errors->has($results["variables"]["error"]))
                $results["data"] = null;
            else{
                $results["data"] = $results["tables"][0][0]; 
            };
            
            if(isset($results["tables"]))
                unset($results["tables"]);
            
            $this->json_response($results);

        }

        public function edit(){ 

            $this->json_response($this->anp->connections->get($this->key)->query((
                "execute dbo.settings_edit {session}, {id}, {type}, {name}, {range}, {value}, {description}, @error output"
            ), [
                "id" => $this->request("id"),
                "type" => $this->request("type"),
                "name" => $this->request("name"),
                "range" => $this->request("range"),
                "value" => $this->request("value"),
                "description" => $this->request("description")
            ])); 

        }

        public function delete(){
            
            $this->json_response($this->anp->connections->get($this->key)->query((
                "execute dbo.settings_delete {session}, {id}, @error output"
            ), ["id" => $this->request("id")]));

        }

        public function deleted(){
            
            $this->json_response($this->list_query((
                "execute dbo.settings_deleted_list {session}, {page}, {items_per_page}, {where}, {order_by}, @pages output, @items output, @results output, @error output"
            )));

        }

        public function undelete(){
            
            $this->json_response($this->anp->connections->get($this->key)->query((
                "execute dbo.settings_undelete {session}, {id}, @error output"
            ), ["id" => $this->request("id")]));

        }

        public function history(){
            
            $this->json_response($this->list_query((
                "execute dbo.settings_history {session}, {id}, {page}, {items_per_page}, {where}, {order_by}, @pages output, @items output, @results output, @error output"
            ), ["id" => $this->request("id")]));

        }

        public function restore(){
            
            $this->json_response($this->anp->connections->get($this->key)->query((
                "execute dbo.settings_restore {session}, {id}, @error output"
            ), ["id" => $this->request("id")]));

        }

    };
