<?php 

    namespace AnP\Controllers\Users;

    class SQLServer extends \AnP\Controller{

        protected $key = "AnP_SQLServer";

        public function list(){
            
            $this->json_response($this->list_query((
                "execute dbo.users_list {session}, {page}, {items_per_page}, {where}, {order_by}, @pages output, @items output, @results output, @error output"
            )));
            
        }

        public function select(){
            
            $this->json_response($this->list_query((
                "execute dbo.users_select_list {session}, {page}, {items_per_page}, {where}, {order_by}, @pages output, @items output, @results output, @error output"
            )));
            
        }

        public function add(){ 

            $this->json_response($this->anp->connections->get($this->key)->query((
                "execute dbo.users_add {session}, {nick}, {password}, {accessible}, @error output, @id output"
            ), [
                "nick" => $this->request("nick"),
                "password" => $this->request("password"),
                "accessible" => $this->request("accessible")
            ])); 

        }

        public function load(){

            $results = $this->anp->connections->get($this->key)->query((
                "execute dbo.users_load {session}, {id}, @error output"
            ), ["id" => $this->request("id")]);

            if(!$results["error"] && !$results["driver_error"] && $this->anp->errors->has($results["variables"]["error"]))
                $results["data"] = null;
            else{
                $results["data"] = $results["tables"][0][0]; 
            };
            
            if(isset($results["tables"]))
                unset($results["tables"]);
            
            $this->json_response($results);

        }

        public function edit(){ 

            $this->json_response($this->anp->connections->get($this->key)->query((
                "execute dbo.users_edit {session}, {id}, {nick}, {password}, {accessible}, @error output"
            ), [
                "id" => $this->request("id"),
                "nick" => $this->request("nick"),
                "password" => $this->request("password"),
                "accessible" => $this->request("accessible")
            ])); 

        }

        public function delete(){
            
            $this->json_response($this->anp->connections->get($this->key)->query((
                "execute dbo.users_delete {session}, {id}, @error output"
            ), ["id" => $this->request("id")]));

        }

        public function deleted(){
            
            $this->json_response($this->list_query((
                "execute dbo.users_deleted_list {session}, {page}, {items_per_page}, {where}, {order_by}, @pages output, @items output, @results output, @error output"
            )));

        }

        public function undelete(){
            
            $this->json_response($this->anp->connections->get($this->key)->query((
                "execute dbo.users_undelete {session}, {id}, @error output"
            ), ["id" => $this->request("id")]));

        }

        public function history(){
            
            $this->json_response($this->list_query((
                "execute dbo.users_history {session}, {id}, {page}, {items_per_page}, {where}, {order_by}, @pages output, @items output, @results output, @error output"
            ), ["id" => $this->request("id")]));

        }

        public function restore(){
            
            $this->json_response($this->anp->connections->get($this->key)->query((
                "execute dbo.users_restore {session}, {id}, @error output"
            ), ["id" => $this->request("id")]));

        }

        public function reset_password(){
            
            $this->json_response($this->anp->connections->get($this->key)->query((
                "execute dbo.users_reset_password {session}, {id}, @error output"
            ), ["id" => $this->request("id")]));

        }

    };
