<?php

    namespace AnP\PDO;

    class TransactSQL{

        private $anp;
        private $connection_string = null;
        private $connection = null;
        private $error = 0;
        private $input = null;

        private function close(){

            if($this->connection){
                // try{
                //     $this->connection->commit();
                // }catch(\Exception $exception){
                //     $this->error |= 1 << 0;
                    try{
                        $this->connection->rollback();
                    }catch(\Exception $exception){
                        $this->error |= 1 << 1;
                    };
                // };
            }else
                $this->error |= 1 << 2;

            $this->connection = null;

        }

        private function connect(){
            if($this->connection)
                return;

            try{

                $string = \AnP::string_variables($this->anp->settings->get(["transact_sql_pdo_connection_string", "transact_sql_pdo_string_connection", "sql_server_pdo_connection_string", "sql_server_pdo_string_connection", "transact_sql_connection_string", "transact_sql_string_connection", "sql_server_connection_string", "sql_server_string_connection", "connection_string", "string_connection"], $this->input), [
                    "engine" => $this->anp->settings->get(["transact_sql_pdo_engine", "sql_server_pdo_engine", "transact_sql_engine", "sql_server_engine", "engine"], $this->input),
                    "database" => $this->anp->settings->get(["transact_sql_pdo_database", "sql_server_pdo_database", "transact_sql_database", "sql_server_database", "database"], $this->input),
                    "host" => $this->anp->settings->get(["transact_sql_pdo_host", "sql_server_pdo_host", "transact_sql_host", "sql_server_host", "host"], $this->input),
                    "port" => $this->anp->settings->get(["transact_sql_pdo_port", "sql_server_pdo_port", "transact_sql_port", "sql_server_port", "port"], $this->input),
                    "library" => $this->anp->settings->get(["transact_sql_pdo_library", "sql_server_pdo_library", "transact_sql_library", "sql_server_library", "library"], $this->input),
                    "user" => $user = $this->anp->settings->get(["transact_sql_pdo_user", "sql_server_pdo_user", "transact_sql_user", "sql_server_user", "user"], $this->input),
                    "password" => $password = $this->anp->settings->get(["transact_sql_pdo_password", "sql_server_pdo_password", "transact_sql_password", "sql_server_password", "password"], $this->input)
                ]);

                // $this->anp->print($string);

                $this->connection = new \PDO($string, $user, $password);

                $this->connection->setAttribute(\PDO::ATTR_ERRMODE, \PDO::ERRMODE_EXCEPTION);

                // $this->connection->beginTransaction();

            }catch(\Exception $exception){
                print_r($exception);
                $this->error |= 1 << 3;
                $this->close();
            };

        }

        public function __construct($anp, $input = null){

            $this->anp = $anp;
            $this->input = $input;

            $this->anp->settings->get(["transact_sql_autoconnect", "sql_server_autoconnect", "autoconnect"], $this->input) && $this->connect();

        }

        public function __destruct(){

            $this->close();

        }

        public static function variable_value($variable){

            $declare_variable = false;

            if(is_array($variable))
                // $variable = json_encode($variable);
                $variable = null;

            if(is_string($variable)){
                $declare_variable = preg_match('/[\r\n]/', $variable);
                $variable = "'" . preg_replace_callback('/(\')|(\r)|(\n)/', function($values){
                    return $values[1] ? "''" : "' + char(1" . ($values[2] ? 0 : 3) . ") + '";
                }, $variable) . "'";
            };

            if($variable === null)
                $variable = "null";
            elseif(is_bool($variable))
                $variable = $variable ? 1 : 0;

            return [$variable, $declare_variable];
        }

        public function query_variables($query, $variables = []){

            $outs = "";
            $names = [];
            $declares = "";
            $declares_i = 0;

            !is_array($variables) && ($variables = []);

            if(isset($variables["page"]) && isset($variables["items_per_page"]) && isset($variables["where"]) && isset($variables["order_by"])){

                if(!empty($variables["where"])){

                    $where = "";

                    // foreach($variables["where"])

                    // $variables["where"] = $where ? json_encode($where) : null;
                    $variables["where"] = null;

                }else 
                    $variables["where"] = null;

                if(!empty($variables["order_by"])){

                    $order_by = "";

                    // foreach($variables["order_by"])

                    // $variables["order_by"] = $order_by ? json_encode($where) : null;
                    $variables["order_by"] = null;

                }else 
                    $variables["order_by"] = null;

            };

            preg_replace_callback('/@([a-z_\d]+)/i', function($values) use(&$outs, &$names, &$declares){
                if(in_array($values[1], $names))
                    return;
                $declares .= "declare @" . $values[1] . " varchar(max)\r\n";
                $outs .= ($outs ? ", " : "") . "@" . $values[1] . " as '" . $values[1] . "'";
                $names[] = $values[1];
            }, $query);
            $outs && ($outs = "\r\nselect " . $outs);

            $query = preg_replace_callback('/\{([^\{\}]+)\}/', function($values) use($variables, &$declares, &$declares_i){

                list($data, $declare_variable) = self::variable_value(
                    !$variables || !isset($variables[$values[1]]) ? $this->anp->routes->get($values[1]) : $variables[$values[1]]
                );

                if($declare_variable){
                    $declares .= "declare @variable" . (++ $declares_i) . " varchar(max) = " . $data;
                    return "@variable" . $declares_i;
                };
                return $data;
            }, $query);

            return $declares . $query . $outs;
        }

        private function variable_type($value, $decode = true){
            if($value === null || strtolower($value) == "null")
                return null;
            if(($trimmed = trim($value)) && in_array($trimmed[0], ["[", "{"])){
                $json = null;
                try{
                    $json = $this->anp->json_decode($this->anp->utf8_encode($value));
                }catch(\Exception $exception){};
                if($json)
                    return $json;
            };
            if(preg_match('/^([0-9]+(\.([0-9]+)?)?|\.[0-9]+)$/', $value))
                return (float)$value;
            return $decode ? $this->anp->utf8_encode($value) : $value;
        }

        public function query($query, $input = null){

            //print_r($input);

            $this->connect();

            if(($results = [
                "tables" => [],
                "variables" => [],
                "error" => 0,
                "driver_error" => (
                    $this->error |
                    ($query ? 0 : 1 << 4) |
                    ($this->connection ? 0 : 1 << 5)
                )
            ])["driver_error"])
                return $results;
            
            $this->connection->beginTransaction();

            // print_r([$this->query_variables($query, $input), $query, $input]);

            // try{

                $query_processed = $this->query_variables($query, array_merge([
                    "session" => (($session = $this->anp->sessions->get()) ? $session : "null") . "," . (\AnP::get_ip() ?? "null") . "," . ($_SERVER["HTTP_USER_AGENT"] ?? "null")
                    // "session" => $this->anp->session_get()
                ], is_array($input) ? $input : []));
                // print_r([$this->anp->sessions->get(), $query_processed]);
                // $results["query"] = $query_processed;
                ($statement = $this->connection->prepare($query_processed))->execute();

                do{
                    try{
                        $table = [];
                        foreach($statement->rowCount() == 0 ? [] : $statement->fetchAll(\PDO::FETCH_ASSOC) as $new_row){
                            $row = [];
                            foreach($new_row as $key => $value){
                                // if(in_array($value[0], ["[", "{"])){
                                //     try{
                                //         $row[$key] = $this->anp->json_decode($this->anp->utf8_encode($value));
                                //     }catch(\Exception $exception){}
                                //     !$row[$key] && ($row[$key] = $this->anp->utf8_encode($value));
                                // }else
                                //     $row[$key] = $value;
                                $row[$key] = $this->variable_type($value, false);
                            };
                            $table[] = $row;
                        };
                        $results["tables"][] = $table;
                    }catch(\Exception $exception){};
                }while($statement->nextRowset());
                
                try{
                    $this->connection->commit();
                }catch(\Exception $exception){};

            // }catch(\Exception $exception){
            //     try{
            //         $this->connection->rollback();
            //     }catch(\Exception $exception){};
            // };

            if(preg_match('/(,\s+?|\()\@/', $query)){
                $l = count($results["tables"]) - 1;
                foreach($results["tables"][$l][0] as $key => $value)
                    $results["variables"][$key] = $this->variable_type($value);
                unset($results["tables"][$l]);
            };

            return $results;
        }

    };
