<?php

    include __DIR__ . "/../../PHP/AnPBuilder.php";

    $anp_builder = new AnPBuilder([
        "language" => "es",
        "language_code" => "es_ES",
        "url" => AnPBuilder::get_host(),
        "description" => "Entorno de pruebas del AnP.",
        "since" => 20220426,
        "version" => 20221109,
        "kstats" => "uCDY3brWxEJrJywm2sFcKo1d8oaUdmxTTrv3VGuhpyRDpPYXyKeHWeknh", 
        "domain" => in_array(($domain = preg_replace('/^.+\.(test|local|k3y.pw|[\.]+)$/', "$1", $_SERVER["HTTP_HOST"])), ["test"]) ? "local" : $domain,
        "script" => AnPBuilder::get_cache(function(){ ?><script data-type="text/javascript" data-language="ECMAScript 2015" charset="utf-8">

            (() => {

                const anp_domain = "https://anp." + window.location.href.match(/\/anp\.(local|k3y\.pw)(\/|$)/)[1];

                console.log(anp_domain);

                new AnPBuilder({
                    //domain : anp_domain,
                    domain : "",
                    scripts : [[
                        ["https://cdn.k3y.pw/js/jszip.min.js", "js"],
                        ["https://cdn.k3y.pw/js/Leaflet/1.9.3/leaflet.js", "js"]
                    ], [
                        "/app/ecma/AnPApp.ecma.js"
                    ], [
                        "/app/ecma/AnPApp.SQL.ecma.js",
                        "/app/ecma/AnPApp.ErrorsTests.ecma.js"
                    ]],
                    css : [
                        "/app/css/AnPApp.icons.css",
                        "https://cdn.k3y.pw/css/Leaflet/1.9.3/leaflet.css"
                    ],
                    scss : "/app/scss/AnPApp.css",
                    callback : () => {
                        anp_app = new AnP({
                            object_name : "anp_app",
                            anp_root : anp_domain, 
                            settings_files : [
                                "/app/json/AnPApp.settings.json"
                            ],
                            anp_autostart : false
                        }, AnPApp);
                        anp_app.start(() => {
                            // console.log(anp_app.routes.get_object());
                            // console.log(anp_app.views.get_object());
                        });
                    }
                });

            })();

        </script><?php }),
        "callback" => function(){

            foreach([
                __DIR__ . "/php/AnPApp.Controllers.ErrorsTests.php"
            ] as $file)
                if(file_exists($file))
                    include $file;

            $anp_app = new AnP([
                "settings_files" => __DIR__ . "/json/AnPApp.php.settings.json",
                // "secrets" => \AnP\Secrets::settings
            ]);

        }
    ]);
