<?php

    namespace AnPApp\Controllers;

    class ErrorsTests extends \AnP\Controller{

        private function get_code($key = "code"){
            return preg_replace('/ /', "+", $this->request($key));
        }

        private function bitwise($direction){

            $results = [];
            $l = $this->request("positions");
            $code = $this->get_code();

            for($i = 0; $i < $l; $i ++)
                $results[] = [
                    "error" => $code,
                    "i" => $i,
                    "string" => $result = $this->anp->errors->bitwise($code, $i * $direction),
                    "array" => $this->anp->errors->to_array($result),
                    "integer" => $this->anp->errors->to_integer($result)
                ];

            return $results;
        }

        public function php_bitwise_left(){

            $this->json($this->bitwise(1));

        }

        public function php_bitwise_right(){

            $this->json($this->bitwise(-1));

        }

        private function python($command){
            return json_decode(shell_exec("python3 python/AnP.ErrorsTests.py " . $command), true);
        }

        private function python_bitwise($direction){

            $code = $this->get_code();
            $positions = $this->request("positions");

            return $this->python("bitwise_" . ($direction == 1 ? "left" : "right") . " " . ($code ? '"' . $code . '"' : "null") . " " . ($positions ? $positions : "null"));
        }

        public function python_bitwise_left(){

            $this->json($this->python_bitwise(1));

        }

        public function python_bitwise_right(){

            $this->json($this->python_bitwise(-1));

        }

        public function sqlite_bitwise_left(){

            $this->json($this->bitwise(1));

        }

        public function sqlite_bitwise_right(){

            $this->json($this->bitwise(-1));

        }

        private function sql_bitwise($connection, $query, $direction){

            $results = count($results = $this->anp->connections->get("anp_" . $connection)->query($query, [
                "code" => $this->get_code(),
                "positions" => (integer)$this->request("positions"),
                "direction" => $direction
            ])["tables"]) ? $results[0] : [];

            // foreach($results as $i => $row)
            //     $results[$i]["array"] = $this->anp->errors->to_array($row["string"]);

            return $results;
        }

        public function mysql_bitwise_left(){

            $this->json($this->sql_bitwise("mysql", "call errors_tests_bitwise({code}, {positions}, {direction});", 1), 200);

        }

        public function mysql_bitwise_right(){

            $this->json($this->sql_bitwise("mysql", "call errors_tests_bitwise({code}, {positions}, {direction});", -1), 200);

        }

        public function transact_sql_bitwise_left(){

            $this->json($this->sql_bitwise("transact_sql", "execute errors_tests_bitwise {code}, {positions}, {direction}", 1), 200);

        }

        public function transact_sql_bitwise_right(){

            $this->json($this->sql_bitwise("transact_sql", "execute errors_tests_bitwise {code}, {positions}, {direction}", -1), 200);

        }

        public function php_format(){

            $string = $this->get_code();
            $integer = $this->anp->errors->to_integer($string);
            $array = $this->anp->errors->to_array($string);

            $this->json([
                "integer" => [
                    "integer" => $this->anp->errors->to_integer($integer),
                    "string" => $this->anp->errors->to_string($integer),
                    "array" => $this->anp->errors->to_array($integer)
                ],
                "string" => [
                    "integer" => $this->anp->errors->to_integer($string),
                    "string" => $this->anp->errors->to_string($string),
                    "array" => $array
                ],
                "array" => [
                    "integer" => $this->anp->errors->to_integer($array),
                    "string" => $this->anp->errors->to_string($array),
                    "array" => $this->anp->errors->to_array($array)
                ]
            ]);

        }

        public function python_format($direction){

            $code = $this->get_code();
            $this->json($this->python("format " . ($code ? '"' . $code . '"' : "null")));

        }

        public function sqlite_format(){

            $this->php_format();

        }

        private function sql_format($key_connection, $query){

            $results = count($results = $this->anp->connections->get("anp_" . $key_connection)->query($query, [
                "code" => $this->get_code()
            ])["tables"]) ? $results[0] : [];

            count($results) && ($results = [
                "integer" => $results[0]["json_values"],
                "string" => $results[1]["json_values"],
                "array" => $results[2]["json_values"]
            ]);

            return $results;
        }

        public function mysql_format(){

            $this->json($this->sql_format("mysql", "call errors_tests_format({code});"));

        }

        public function transact_sql_format(){

            $this->json($this->sql_format("transact_sql", "execute dbo.errors_tests_format {code}"));

        }

        public function php_binary(){

            $this->json([
                "string" => str_split($code = $this->request("code")),
                "array" => $this->anp->errors->to_array($code),
                "binary" => $this->anp->errors->to_array_binary($code)
            ]);

        }

        public function python_binary($direction){

            $code = $this->get_code();
            $this->json($this->python("binary " . ($code ? '"' . $code . '"' : "null")));

        }

        public function sqlite_binary(){

            $this->php_binary();

        }

        private function sql_binary($key_connection, $query){
            return count($results = $this->anp->connections->get("anp_" . $key_connection)->query($query, [
                "code" => $this->get_code()
            ])["tables"]) ? $results[0] : [];
        }

        public function mysql_binary(){

            $this->json($this->sql_binary("mysql", "call errors_tests_binary({code});")[0]);

        }

        public function transact_sql_binary(){

            $this->json($this->sql_binary("transact_sql", "execute dbo.errors_tests_binary {code}")[0]);

        }

        private function sql_join($key_connection, $query){
            return count($results = $this->anp->connections->get("anp_" . $key_connection)->query($query, [
                "code" => $this->get_code(),
                "joiner" => $this->get_code("joiner"),
                "position" => $this->request("position")
            ])["tables"]) ? $results[0] : [];
        }

        public function php_join(){

            $code = $this->get_code();
            $joiner = $this->get_code("joiner");
            $position = $this->request("position");
            $bitwise = $this->anp->errors->bitwise($joiner, $position);
            $results = $this->anp->errors->set($code, $joiner, $position);

            $this->json([[
                "code" => $code,
                "joiner" => $joiner,
                "bitwise" => $bitwise,
                "results" => $results
            ], [
                "code" => str_split($code),
                "joiner" => str_split($joiner),
                "bitwise" => str_split($bitwise),
                "results" => str_split($results)
            ], [
                "code" => $this->anp->errors->to_array($code),
                "joiner" => $this->anp->errors->to_array($joiner),
                "bitwise" => $this->anp->errors->to_array($bitwise),
                "results" => $this->anp->errors->to_array($results)
            ], [
                "code" => $this->anp->errors->to_array_binary($code),
                "joiner" => $this->anp->errors->to_array_binary($joiner),
                "bitwise" => $this->anp->errors->to_array_binary($bitwise),
                "results" => $this->anp->errors->to_array_binary($results)
            ], [
                "code" => $this->anp->errors->to_integer($code),
                "joiner" => $this->anp->errors->to_integer($joiner),
                "bitwise" => $this->anp->errors->to_integer($bitwise),
                "results" => $this->anp->errors->to_integer($results)
            ]]);

        }

        public function python_join(){

            $code = $this->get_code();
            $joiner = $this->get_code("joiner");
            $position = $this->request("position");

            $this->json($this->python("set " . ($code ? '"' . $code . '"' : "null") . " " . ($joiner ? '"' . $joiner . '"' : "null") . " " . ($position ? $position : "null")));

        }

        public function sqlite_join(){

            $this->php_join();

        }

        public function mysql_join(){

            $this->json($this->sql_join("mysql", "call errors_tests_join({code}, {joiner}, {position});"));

        }

        public function transact_sql_join(){

            $this->json($this->sql_join("transact_sql", "execute dbo.errors_tests_join {code}, {joiner}, {position}"));

        }

        public function php_set(){

            $code = $this->get_code();
            $joiner = $this->get_code("joiner");
            $position = $this->request("position");
            $length = $this->request("length");
            $bitwise = $this->anp->errors->bitwise($joiner, $position);
            $reset = $this->anp->errors->set($code, 0, $position, $length);
            $results = $this->anp->errors->set($code, $joiner, $position, $length);

            $this->json([[
                "code" => $code,
                "joiner" => $joiner,
                "bitwise" => $bitwise,
                "reset" => $reset,
                "results" => $results
            ], [
                "code" => str_split($code),
                "joiner" => str_split($joiner),
                "bitwise" => str_split($bitwise),
                "reset" => str_split($reset),
                "results" => str_split($results)
            ], [
                "code" => $this->anp->errors->to_array($code),
                "joiner" => $this->anp->errors->to_array($joiner),
                "bitwise" => $this->anp->errors->to_array($bitwise),
                "reset" => $this->anp->errors->to_array($reset),
                "results" => $this->anp->errors->to_array($results)
            ], [
                "code" => $this->anp->errors->to_array_binary($code),
                "joiner" => $this->anp->errors->to_array_binary($joiner),
                "bitwise" => $this->anp->errors->to_array_binary($bitwise),
                "reset" => $this->anp->errors->to_array_binary($reset),
                "results" => $this->anp->errors->to_array_binary($results)
            ], [
                "code" => $this->anp->errors->to_integer($code),
                "joiner" => $this->anp->errors->to_integer($joiner),
                "bitwise" => $this->anp->errors->to_integer($bitwise),
                "reset" => $this->anp->errors->to_integer($reset),
                "results" => $this->anp->errors->to_integer($results)
            ]]);

        }

        public function python_set(){

            $code = $this->get_code();
            $joiner = $this->get_code("joiner");
            $position = $this->request("position");
            $length = $this->request("length");

            $this->json($this->python("set " . ($code ? '"' . $code . '"' : "null") . " " . ($joiner ? '"' . $joiner . '"' : "null") . " " . ($position ? $position : "null") . " " . ($length ? $length : "null")));

        }

        public function sqlite_set(){

            $this->php_set();

        }

        private function sql_set($key_connection, $query){
            return count($results = $this->anp->connections->get("anp_" . $key_connection)->query($query, [
                "code" => $this->get_code(),
                "joiner" => $this->get_code("joiner"),
                "position" => $this->request("position"),
                "length" => $this->request("length")
            ])["tables"]) ? $results[0] : [];
        }

        public function mysql_set(){

            $this->json($this->sql_set("mysql", "call errors_tests_set({code}, {joiner}, {position}, {length});"));

        }

        public function transact_sql_set(){

            $this->json($this->sql_set("transact_sql", "execute dbo.errors_tests_set {code}, {joiner}, {position}, {length}"));

        }

    };
