AnP.Attributes = function(anp, input){

    const self = this,
          no_data = [],
          no_value = [];
    let started = false;

    const construct = () => {};

    this.start = callback => {

        if(started)
            return;
        started = true;

        ["_default", ""].forEach(key => {

            const without_data = anp.settings_get("attributes" + key + "_without_data"),
                  without_value = anp.settings_get("attributes" + key + "_without_value");

            anp.is_array(without_data) && without_data.forEach(attribute => !no_data.includes(attribute) && no_data.push(attribute));

            anp.is_array(without_value) && without_value.forEach(attribute => !no_value.includes(attribute) && no_value.push(attribute));

        });

        anp.is_function(callback) && callback();

    };

    const as_html = name => name.replace(/(_)|([A-Z])/g, (...arguments) => "-" + (arguments[1] ? "" : arguments[2].toLowerCase()));
    const as_snake = name => name.replace(/(\-)|([A-Z])/g, (...arguments) => "_" + (arguments[1] ? "" : arguments[2].toLowerCase()));
    const as_camel = name => name.replace(/[\-_](.)/g, (...arguments) => arguments[1].toUpperCase());

    const get_names = name => [name, as_html(name), as_snake(name), as_camel(name)];

    const has_no_data = name => get_names(name).some(key => no_data.includes(key));

    const has_no_value = (name, real) => get_names(name).some(key => no_value.includes(key)) || (real && get_names(real).some(key => no_value.includes(key)));

    const get = name => as_html(/^data[_\-A-Z]/.test(name) || has_no_data(name) ? name : "data-" + name);

    const set_list = list => list ? anp.is_string(list) ? [list] : anp.is_array(list) ? list : null : null;

    const set_input = (arguments, i, callback) => {

        let attributes = arguments[0 + i];

        if(anp.is_array(attributes)){
            const results = {};

            attributes.forEach(group => anp.is_dictionary(group) && Object.assign(results, group));
            attributes = results;

        };

        if(!anp.is_dictionary(attributes) || !Object.keys(attributes).length)
            return;

        const excluded = set_list(arguments[1 + i]),
              included = set_list(arguments[2 + i]);

        for(const name in attributes){
            if((excluded && excluded.includes(name)) || (included && !included.includes(name)))
                continue;

            const without_value = has_no_value(name);

            if(without_value && !attributes[name])
                continue;

            if(name == "permissions" && attributes[name])
                callback("data-permissions", anp.base64_encode(anp.json_encode(anp.is_array(attributes[name]) ? attributes[name] : [attributes[name]])), false);
            else
                callback(get(name), without_value || anp.set_globals(attributes[name]), without_value);

        };

    };

    this.set = (...arguments) => {
        if(!arguments[0])
            return;

        if(!anp.is_html_object(arguments[0])){

            let html = ``;

            set_input(arguments, 0, (real, value, without_value) => html += ` ` + real + (without_value ? `` : `="` + ("" + value).replace(/"/g, "&quot;") + `"`));

            return html;
        };

        const item = arguments[0];

        set_input(arguments, 1, (real, value, without_value) => item.setAttribute(real, value));

        return item;
    };

    this.is = (item, attribute) => item.hasAttribute(attribute) && item.getAttribute(attribute) == "true";

    this.get_values = (inputs, names, _default) => {
        if(!names || !anp.is_object(inputs))
            return _default || null;

        let has = false;
        const attributes = {};

        !anp.is_array(names) && (names = []);

        (anp.is_array(inputs) ? inputs : [inputs]).forEach(input => {
            if(anp.is_dictionary(input))
                names.forEach(name => {if(!anp.null_or_undefined(input[name])){
                    attributes[name] = input[name];
                    !has && (has = true);
                }});
        });

        return has ? attributes : _default || null;
    };

    construct();

};
