AnP.I18N = function(anp, input){

    const self = this,
          sentences = {}, 
          data = {};
    let started = false,
        selected = null,
        default_language = null,
        ids = {}, 
        overwrite_add, overwrite_add_data;

    const construct = () => {};

    this.start = callback => {

        if(started)
            return;
        started = false;

        (default_language = anp.settings_get(["default_language", "language"])) && (selected = default_language);
        change_globals = anp.settings_get(["i18n_change_globals", "change_globals"]);
        overwrite_add = anp.settings_get(["i18n_overwrite", "overwrite"]);
        overwrite_add_data = anp.settings_get(["i18n_overwrite_data", "i18n_overwrite", "overwrite"]);

        self.add(anp.settings_get("default_i18n_files"), true, () => {
            self.add(anp.settings_get("i18n_files"), true, () => {
                self.add_data(anp.settings_get("default_i18n_data"), true, () => {
                    self.add_data(anp.settings_get("i18n_data"), true, () => {
                        self.update_ids(callback);
                    });
                });
            });
        });

    };

    /**
        @deprecated
    */
    const add_items = (items, overwrite) => {
        for(const language in items){
            if(["ok", "code"].includes(language))
                continue;
            !selected && (selected = language);
            !sentences[language] && (sentences[language] = {});
            for(const key in items[language])
                anp.null_or_undefined(sentences[language][key]) && (sentences[language][key] = items[language][key]);
        };
    };

    const add = (items, overwrite, callback, i) => {

        if(i >= items.length){
            anp.is_function(callback) && callback();
            return;
        };

        const end = () => add(items, overwrite, callback, i + 1);

        if(!items[i])
            end();
        else if(anp.is_string(items[i])){

            let data = anp.json_decode(items[i]);

            if(data)
                add(anp.is_array(data) ? data : [data], overwrite, end, 0);
            else if(/^[a-z0-9_]+$/.test(items[i]))
                end();
            else 
                anp.ajax.load(items[i], response => response && (data = anp.json_decode(response, true)) && data.code != 404 ? add(anp.is_array(data) ? data : [data], overwrite, end, 0) : end());

        }else if(anp.is_array(items[i]))
            add(items[i], overwrite, end, 0);
        else if(anp.is_dictionary(items[i])){
            for(const language in items[i]){
                if(["ok", "code"].includes(language))
                    continue;
                !selected && (selected = language);
                !sentences[language] && (sentences[language] = {});
                for(const key in items[i][language])
                    !anp.is_refrence_key(key) && 
                    anp.null_or_undefined(sentences[language][key]) && 
                    (sentences[language][key] = items[i][language][key]);
            };
            end();
        };

    };

    this.add = (items, overwrite, callback) => add(items ? anp.is_array(items) ? items : [items] : [], anp.is_bool(overwrite) ? overwrite : overwrite_add, callback, 0);

    const get = (names, _default, nulls) => {
        if(names){

            const l = (anp.is_array(names) ? names : names = [names]).length;

            for(let i = l - 1; i >= 0; i --)
                !anp.is_string(names[i]) && names.splice(i, 1);

            if(names.length){

                const languages = [selected, default_language],
                      m = languages.length;

                for(let j = 0; j < m; j ++)
                    if(languages[j] && sentences[languages[j]])
                        for(let i = 0; i < l; i ++)
                            if(sentences[languages[j]][names[i]] !== undefined)
                                return sentences[languages[j]][names[i]];
                for(const language in sentences)
                    if(!languages.includes(language))
                        for(let i = 0; i < l; i ++)
                            if(sentences[language][names[i]] !== undefined)
                                return sentences[language][names[i]];
                return names[0];
            };
        };
        return _default !== undefined && (nulls || _default !== null) ? _default : anp.settings_get("default_text");
    };

    this.get = (names, variables, _default, nulls) => {

        const text = get(names, _default, anp.is_bool(nulls) ? nulls : anp.settings_get("nulls", null, false, false));

        return anp.string_variables(anp.is_array(text) ? text.join(" ") : text, variables);
    };

    this.update = () => {

        if(change_globals){

            const global_item = document.querySelector("html[lang]");

            if(global_item && selected && sentences[selected]){

                const code = sentences[selected].language_code || sentences[selected].__language_code__;

                code && global_item.setAttribute("lang", code);

            };

        };

        anp.item_self.querySelectorAll("[data-i18n]").forEach(item => {

            const variables = item.getAttribute("data-i18n-variables"),
                  text = self.get(item.getAttribute("data-i18n"), variables ? anp.json_decode(anp.base64_decode(variables)) : null),
                  dotted = anp.attr.is(item, "data-dotted") ? "..." : "";

            !anp.attr.is(item, "data-i18n-without") && !["input", "br", "hr", "select", "table", "thead", "tbody", "tfoot", "tr"].includes(item.tagName.toLowerCase()) && (item.innerHTML = text + dotted);
            ["title", "alt"].forEach(attribute => item.hasAttribute(attribute) && item.setAttribute(attribute, text + dotted));
            ["placeholder"].forEach(attribute => item.hasAttribute(attribute) && item.setAttribute(attribute, text + "..."));

        });

    };

    this.create = input => {

        if(!input)
            input = {};
        else if(anp.is_string(input))
            input = {format : input};
        else if(!anp.is_dictionary(input))
            input = {};

        let languages = ``;
        const format = anp.settings_get(["i18n_format", "format"], input);

        for(const language in data)
            languages += `<li` + anp.attr.set({
                data_language : language,
                data_selected : language == selected,
                onclick : anp.object_name + ".i18n.change('" + language + "');"
            }) + `>` + format.replace(/\{([^\{\}]+)\}/g, (...arguments) => {
                switch(arguments[1]){
                    case "flag":
                        return anp.comp.images.create({src : anp.settings_get(["flag", "__flag__", "default_flag"], [data[language], input]), alt : language, class : "flag"});
                    case "language":
                    case "country":
                    case "language_code":
                    case "country_code":
                        return `<span` + anp.attr.set({class : arguments[1].replace(/_/g, "-")}) + `>` + anp.settings_get(["__" + arguments[1] + "__", arguments[1], "default_" + arguments[1]], [data[language], input]) + `</span>`;
                    case "name":
                        return `<span` + anp.attr.set({class : "name"}) + `>` + language + `</span>`;
                };
                if(anp.null_or_undefined(input[arguments[1]]))
                    return arguments[0];
                return input[arguments[1]];
            }) + `</li>`;

        return `<ul` + anp.attr.set([input, {class : "i18n" + (input.class ? " " + input.class : "")}], ["i18n_format", "format"]) + `>` + languages + `</ul>`;
    };

    this.change = language => {

        if(!language || language == selected || !sentences[language])
            return;

        anp.item_self.querySelectorAll(".i18n").forEach(i18n => {
            i18n.querySelectorAll("[data-selected=true]").forEach(item => item.setAttribute("data-selected", false));
            i18n.querySelector("[data-language=" + language + "]").setAttribute("data-selected", true);
        });
        selected = language;
        self.update();

    };

    this.update_ids = callback => {
        if(anp.settings_get("allow_users"))
            anp.ajax.post(anp.anp_route() + "/sessions/languages", {}, response => {
                try{

                    const json = anp.json_decode(response);

                    json && 
                    json.content && 
                    json.content.tables && 
                    json.content.tables.length && 
                    anp.is_array(json.content.tables[0]) && 
                    json.content.tables[0].forEach(language => ids[language.key] = language.id);

                }catch(exception){
                    console.error(exception);
                };
                anp.is_function(callback) && callback();
            });
        else 
            anp.is_function(callback) && callback();
    };

    this.get_id = () => ids[selected] || null;

    const add_data = (inputs, overwrite, callback, i) => {

        if(i >= inputs.length){
            anp.is_function(callback) && callback();
            return;
        };

        const end = () => add_data(inputs, overwrite, callback, i + 1);

        if(anp.is_array(inputs[i]))
            add_data(inputs[i], overwrite, end, 0);
        else if(anp.is_dictionary(inputs[i])){
            for(const language in inputs[i])
                if(anp.is_dictionary(inputs[i][language])){
                    !data[language] && (data[language] = {});
                    for(const key in inputs[i][language])
                        if(overwrite || data[language][key] === undefined)
                            data[language][key] = inputs[i][language][key];
                };
            end();
        }else if(anp.is_string(inputs[i])){
            
            let json = anp.json_decode(json);

            if(json){
                add_data(anp.is_array(json) ? json : [json], overwrite, end, 0);
                return;
            };

            anp.ajax.get(inputs[i], response => {
                if(json = anp.json_decode(response))
                    add_data(anp.is_array(json) ? json : [json], overwrite, end, 0);
                else 
                    end();
            });

        }else 
            end();

    };

    this.add_data = (inputs, overwrite, callback) => add_data(
        anp.is_array(inputs) ? inputs : anp.is_dictionary(inputs) ? [inputs] : [], 
        anp.is_bool(overwrite) ? overwrite : overwrite_add_data, 
        callback, 
        0
    );

    construct();

};
