AnP.Settings = function(anp, custom, default_settings){

    const self = this,
          settings = {};

    let started = false;

    const construct = () => {};

    this.start = callback => {

        const end = status => anp.is_function(callback) && callback(status);

        if(started){
            end(false);
            return;
        };
        started = true;

        self.add(self.get("default_settings_files"), true, () => self.add(self.get("settings_files"), true, end));

    };

    /**
        @deprecated
    */
    const add_items = (data, overwrite) => {
        for(const key in data)
            (overwrite || !settings[key]) && (settings[key] = data[key]);
    };

    const filter = data => (
        anp.is_array(data) ? data.filter(item => typeof item != "string" || !/^[A-Z_]+$/.test(item)) : 
        anp.is_object(data) ? [data] : 
        []
    );

    const add = (items, overwrite, callback, i) => {
        // console.log([items, i]);

        if(i >= items.length){
            anp.is_function(callback) && callback();
            return;
        };

        const end = () => add(items, overwrite, callback, i + 1);

        if(!items[i])
            end();
        else if(anp.is_string(items[i])){

            let data = anp.json_decode(items[i]);

            if(data)
                add(filter(data), overwrite, end, 0);
            else if(/^[a-z0-9_]+$/i.test(items[i]))
                end();
            else 
                anp.ajax.load(items[i], response => {
                    if(response && (data = anp.json_decode(response, true)) && data.code != 404)
                        add(filter(data), overwrite, end, 0);
                    else
                        end();
                });

        }else if(anp.is_array(items[i]))
            add(filter(items[i]), overwrite, end, 0);
        else if(anp.is_dictionary(items[i])){
            for(const key in items[i])
                !anp.is_refrence_key(key) && (overwrite || !settings[key]) && (settings[key] = items[i][key]);
            end();
        };

    };

    this.add = (items, overwrite, callback) => add(items ? anp.is_array(items) ? items : [items] : [], anp.is_bool(overwrite) ? overwrite : self.get(["settings_overwrite", "overwrite"]), callback, 0);

    this.get = (names, inputs, _default, nulls) => {

        !anp.is_bool(nulls) && (nulls = self.get("nulls", null, false, false));

        if(names){

            const l = (anp.is_array(names) ? names : names = [names]).length,
                  m = (inputs = (inputs ? anp.is_array(inputs) ? inputs : [inputs] : []).concat([custom, settings, default_settings])).length;

            for(let j = 0; j < m; j ++)
                if(anp.is_dictionary(inputs[j]))
                    for(let i = 0; i < l; i ++)
                        if(anp.is_string(names[i]) && inputs[j][names[i]] !== undefined && (nulls || inputs[j][names[i]] !== null))
                            return inputs[j][names[i]];
        };
        return nulls || _default !== null ? _default : self.get("default_value", null, null, true);
    };

    construct();

};
