AnP.Stores = function(anp, input){

    const self = this;
    let started = false,
        data = [],
        search = "",
        filter = [],
        order = [],
        page = 0,
        items_per_page = 30,
        results = [],
        json_parameters = "";

    this.on_change = null;

    this.start = () => {

        if(started)
            return;
        started = true;

    };

    const update = (custom, search, filter, order) => {

        const l = order.length;
        let results = [].concat(custom instanceof Array ? custom : data);

        filter.length && (results = results.filter(item => filter.every(subitem => {

            const [key, condition] = subitem;

            return item[key] !== undefined && (item[key] === condition || ( // null && boolean && exactly value.
                typeof condition == "function" ? condition(item[key], item, key) :
                condition instanceof Array ? !isNaN(item[key]) || item[key] instanceof Date ? (anp.null_or_undefined(condition[0]) || item[key] >= condition[0]) && (anp.null_or_undefined(condition[1]) || item[key] <= condition[1]) : false :
                condition instanceof RegExp ? item[key].match(condition) :
                !anp.null_or_undefined(condition) && item[key] !== null && ("" + item[key]).includes(condition)
            ));
        })));

        search && (results = results.filter(item => Object.values(item).some(value => !anp.null_or_undefined(value) && ("" + value).includes(search))));

        l && results.sort((a, b) => {
            for(let i = 0; i < l; i ++)
                if(a[order[i][0]] !== undefined && a[order[i][0]] !== b[order[i][0]])
                    return (order[i][1] == 1 && a[order[i][0]] > b[order[i][0]]) || order[i][1] == 2 && a[order[i][0]] < b[order[i][0]] ? 1 : -1;
            return 0;
        });

        return results;
    };

    this.update = custom => {
        json_parameter = JSON.stringify([search, filter, order]);
        self.on_change.execute(results = update(data, search, filter, order));
    };

    this.set = new_data => {
        if(!(new_data instanceof Array))
            return;

        data = new_data.filter(item => typeof item == "object");
        self.update();

    };

    this.add = new_data => {
        if(!(new_data instanceof Array))
            return;

        new_data.forEach(item => typeof item == "object" && data.push(item));
        data.forEach((item, i) => item.__i = i);
        self.update();

    };

    this.remove = this.clean = () => {

        data = [];
        self.update();

    };

    this.reset_search = () => search = "";
    this.reset_filter = () => filter = [];
    this.reset_order = () => order = [];
    this.reset_page = () => page = 0;

    this.reset = () => {

        self.reset_search();
        self.reset_filter();
        self.reset_order();
        self.reset_page();

    };

    this.search = new_search => {
        if(typeof new_search != "string")
            return;

        search = new_search;
        self.update();

    };

    const build_filter = filter => filter instanceof Array ? (filter.length ? typeof filter[0] == "string" ? [filter] : filter : []).filter(item => item instanceof Array && item.length >= 2 && typeof item[0] == "string") : [];

    const set_filter = new_filter =>  filter = build_filter(new_filter || []);

    this.set_filter = new_filter => {

        !new_filter && (filter = []);

        if(!(new_filter instanceof Array))
            return;

        set_filter(new_filter);
        self.update();

    };

    this.add_filter = new_filter => {
        if(!(new_filter instanceof Array))
            return;

        build_filter(new_filter).forEach(item => filter.push(item));
        self.update();

    };

    const format_order = order => (order.length ? typeof order[0] == "string" ? [order] : order : []).filter(item => item instanceof Array && item.length && typeof item[0] == "string" && (item.length == 1 || [false, null, 0, 1, 2, "asc", "ascendent", "desc", "descendent"].includes(item[1]))).map(item => [item[0], !item[1] ? 0 : [1, "asc", "ascendent"].includes(item[1]) ? 1 : 2]);

    const set_order = new_order => order = format_order(new_order || []).filter(item => item[0]);

    this.set_order = new_order => {

        !new_order && (new_order = []);

        if(!(new_order instanceof Array))
            return;

        set_order(new_order);
        self.update();

    };

    this.add_order = new_order => {
        if(!(new_order instanceof Array))
            return;

        format_order(new_order).forEach(item => {
            order.some((subitem, i) => subitem[0] == item[0] && order.splice(i, 1));
            item[0] && order.push(item);
        });
        self.update();

    };

    this.set_page = new_page => !isNaN(new_page) && new_page >= 0 && (page = new_page);

    this.set_items_per_page = new_items_per_page => !isNaN(new_items_per_page) && new_items_per_page > 0 && (items_per_page = new_items_per_page);

    const construct = () => {

        self.on_change = new AnP.Events(anp);

        data = anp.settings_get("data", input, []);

        search = anp.settings_get("search", input, "") || "";
        set_filter(anp.settings_get("filter", input, []));
        set_order(anp.settings_get("order", input, []));
        self.set_page(anp.settings_get("page", input, 0));
        self.set_items_per_page(anp.settings_get("items_per_page", input, 30));

        self.update();

    };

    const get = this.get = (from, items, custom) => {

        from = (isNaN(from) ? page : from) * (isNaN(items) ? items = items_per_page : items);

        return (custom instanceof Array ? custom : custom = results).slice(from < 0 ? from = 0 : from > custom.length ? from = (custom.length / items >> 0) * items : from, from + items);
    };

    this.get_results = (custom, from, items, search, filter, order) => get(from, items, update(custom, search, filter, order));

    this.set_parameters = (new_search, new_filter, new_order) => {
        if(JSON.stringify([new_search, new_filter, new_order]) == json_parameters)
            return;

        search = new_search;
        set_filter(new_filter);
        set_order(new_order);

        self.update();

    };

    this.get_results_pages = custom_items_per_page => Math.ceil(results.length / (custom_items_per_page || items_per_page));

    this.get_results_count = () => results.length;

    this.get_all = () => [].concat(data);

    construct();

};
