AnP.Threads = function(anp, input){

    const self = this,
          threads = [];
    let thread = null,
        started = false;

    const construct = () => {};

    const thread_function = () => threads.forEach(thread => thread && thread());

    this.start = frames_per_second => thread === null && (thread = setInterval(thread_function, 1000 / (!isNaN(frames_per_second) && frames_per_second > 0 ? frames_per_second : anp.settings_get(["frames_per_second", "fps"]))));

    this.init = callback => {

        if(started)
            return;
        started = true;

        self.start();
        anp.is_function(callback) && callback();

    };

    this.stop = () => {

        if(thread === null)
            return;

        clearInterval(thread);
        thread = null;

    };

    this.restart = frames_per_second => {

        self.stop();
        self.start(frames_per_second);

    };

    this.add = method => {
        if(!anp.is_function(method))
            return null;

        const l = threads.length
        let i = 0;

        for(; i < l; i ++)
            if(!threads[i])
                break;

        threads[i] = method;

        return i;
    };

    this.remove = i => !isNaN(i) && threads[i] && (threads[i] = null);

    construct();

};
