AnP.Views = function(anp, input){

    const self = this,
          views = {};
    let started = false,
        show_add_json_decode_value, show_add_load_json_value;

    const construct = () => {};

    const show_add_json_decode = () => (
        anp.is_bool(show_add_json_decode_value) ? show_add_json_decode_value : 
        show_add_json_decode_value = anp.settings_get("views_add_json_decode_error")
    );

    const show_add_load_json = () => (
        anp.is_bool(show_add_load_json_value) ? show_add_load_json_value : 
        show_add_load_json_value = anp.settings_get("views_add_load_json_error")
    );

    /**
        @deprecated
    */
    const add_views = (object, overwrite, callback) => {
        if(anp.is_dictionary(object)){
            for(const key in object)
                object[key] && (overwrite || !views[key]) && (views[key] = object[key]);
            callback();
        }else if(anp.is_array(object))
            add(object, overwrite, callback);
        else
            callback();
    };

    const add = (items, overwrite, callback, i) => {

        if(!items || i >= items.length){
            anp.is_function(callback) && callback();
            return;
        };

        const end = () => add(items, overwrite, callback, i + 1);

        if(anp.is_string(items[i])){

            let data = anp.json_decode(items[i], show_add_json_decode());

            if(data)
                add(data ? anp.is_array(data) ? data : [data] : [], overwrite, end, 0);
            else
                anp.ajax.load(items[i], data => {
                    if(data)
                        add((data = anp.json_decode(data, show_add_load_json())) ? anp.is_array(data) ? data : [data] : [], overwrite, end, 0);
                    else
                        end();
                });

        }else if(anp.is_array(items[i]))
            add(items[i], overwrite, end);
        else if(anp.is_dictionary(items[i])){
            for(const key in items[i])
                items[i][key] && (overwrite || !views[key]) && (views[key] = items[i][key]);
            end();
        }else
            end();

    };

    this.add = (views, overwrite, callback) => add(views ? anp.is_array(views) ? views : [views] : [], anp.is_bool(overwrite) ? overwrite : anp.settings_get(["views_overwrite", "overwrite"]), callback, 0);

    this.start = callback => {

        if(started)
            return;
        started = true;

        self.add(anp.settings_get("default_views_files"), true, () => self.add(anp.settings_get("views_files"), true, callback));

    };

    const get = view => {
        if(!view.type)
            return anp.comp.error(206);
        if(views[view.type])
            return self.get(views[view.type]);

        let method = anp.comp[view.type];

        if(!method || !anp.is_function(method) && !anp.is_function(method = method.create))
            return anp.comp.error(501);
        return method(view) || anp.comp.error(204);
    };

    const with_permissions = view => {

        const hash = anp.hash(),
              on_load = view.on_load || view.onload;

        new AnP.Preload(anp, "[data-preload=" + hash + "]", preloader => {
            if(!preloader)
                return;

            const item = preloader.parentNode;

            item.removeChild(preloader);
            anp.sessions.set_permissions_views();
            anp.update_url_pointers();
            if(on_load && view.type != "form")
                try{
                    eval(anp.set_globals(on_load))(item, view);
                }catch(exception){console.error(exception);};

        });

        return !view.permissions || !view.permissions.length || (anp.sessions && anp.sessions.has_permissions(view.permissions)) ? (`<div` + anp.attr.set({
            data_view : view.name || view.type,
            permissions : view.permissions || null
        }) + `>
            ` + get(view) + `
            <div` + anp.attr.set({data_preload : hash}) + `></div>
        </div>`) : anp.comp.error(403);
    };

    this.get_raw = key => views[key] || null;

    this.get = input => {
        if(!input)
            return anp.comp.error(400);
        if(anp.is_dictionary(input))
            return with_permissions(input);

        const l = (anp.is_array(input) ? input : input = [input]).length;

        for(let i = 0; i < l; i ++)
            if(input[i] && anp.is_string(input[i])){
                if(views[input[i]]){
                    !views[input[i]].name && (views[input[i]].name = input[i]);
                    return with_permissions(views[input[i]]);
                }else if(anp.comp[input[i]])
                    return anp.comp[input[i]]();
            };
        return `<div` + anp.attr.set({data_view : "unknown"}) + `>` + anp.comp.error(404) + `</div>`;
    };

    const get_data = (key, views) => {
        if(views[key])
            return views[key];
        for(const name in views){
            if(views[name].name == key)
                return views[name];
            if(views[name].type == "multiview" && views[name].views){

                const result = get_data(key, views[name].views);

                if(result)
                    return result;
            };
        };
        return null;
    };

    this.get_data = key => get_data(key, views);

    this.get_object = () => {
        if(anp.settings_get("allow_get_views"))
            return views;

        anp.toast("warning", "get_views_not_allowed");

        return null;
    };

    construct();

};
