AnP = function(custom, object){

    const self = this,
          default_settings = {
              autostart : true,
              nulls : false,
              default_value : null,
              default_settings_files : "{anp_root}/json/AnP.settings.json",
              overwrite : false,
              object_name : "anp",
              initiate_order : ["init", "initiate", "start", "launch"]
          },
          hashes = [],
          re_special = {
              " " : "s",
              "\t" : "t",
              "\r" : "r",
              "\n" : "n"
          },
          globals = {},
          data_for_set = {},
          toast_to_console = {
              info : "log",
              error : "error",
              warn : "warn"
          },
          cache = {}, 
          // http://detectmobilebrowsers.com/
          is_mobile = ((a) => (
              /(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(a) || 
              /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0,4))
          ))(navigator.userAgent || navigator.vendor || window.opera), 
          // https://stackoverflow.com/questions/56393880/how-do-i-detect-dark-mode-using-javascript#answer-57795495
          is_dark_mode = window.matchMedia && window.matchMedia('(prefers-color-scheme: dark)').matches;
    let started = false,
        with_toasts = null,
        toast_types = [],
        toasts_to_console = null,
        last_z_index = 200,
        was_back = false,
        anp_route = null, 
        device_mode = "default", 
        gui_mode = "default", 
        console_ok_dark_style, console_ok_light_style, 
        console_info_dark_style, console_info_light_style, 
        print_format = "[{type}] {yyyy}{mm}{dd} {hh}{ii}{ss} [{line}]{file}({method}): {message}";

    const re_stack_trace = new RegExp("^(" + [
        /\s*at\s+(([^\s]+)\s+\()?(([^\(\)\:]+\:)?[^\(\)\:]+)(\:([0-9]+)\:[0-9]+)?\)?/.source, // Webkit
        /([^\@]+)\@([^:]+\:[^\:]+)\:([0-9]+)\:[0-9]+/.source, // Gecko
    ].join("|") + ")$");

    let settings = this.settings;
    let ajax = this.ajax;
    let i18n = this.i18n;
    let threads = this.threads;
    let attributes = this.attributes;
    let components = this.components;
    let errors = this.errors;
    let sessions = this.sessions;
    let views = this.views;
    let routes = this.routes;

    let logs = this.logs;
    let exceptions = this.exceptions;
    let traces = this.traces;
    let users = this.users;
    let ips = this.ips;
    let groups = this.groups;
    let permissions = this.permissions;

    let attr = this.attr;
    let comp = this.comp;

    let base = this.base;
    let object_name = this.object_name;
    let item_self = this.item_self = document;
    let hash_self = this.hash_self;

    const construct = () => {

        // Implements for compatibility.
        !Array.isArray && (Array.isArray = item => Object.prototype.toString.call(item) == "[object Array]");

        AnP.Settings && (settings = self.settings = new AnP.Settings(self, custom, default_settings));
        AnP.Ajax && (ajax = self.ajax = new AnP.Ajax(self, custom));
        AnP.I18N && (i18n = self.i18n = new AnP.I18N(self, custom));
        AnP.Threads && (threads = self.threads = new AnP.Threads(self, custom));
        AnP.Attributes && (attributes = self.attributes = attr = self.attr = new AnP.Attributes(self, custom));
        AnP.Components && (components = self.components = comp = self.comp = new AnP.Components(self, custom));
        AnP.Errors && (errors = self.errors = new AnP.Errors(self, custom));
        AnP.Sessions && (sessions = self.sessions = new AnP.Sessions(self, custom));
        AnP.Views && (views = self.views = new AnP.Views(self, custom));
        AnP.Routes && (routes = self.routes = new AnP.Routes(self, custom));
        
        AnP.Logs && (logs = self.logs = new AnP.Logs(self, custom));
        AnP.Exceptions && (exceptions = self.exceptions = new AnP.Exceptions(self, custom));
        AnP.Traces && (traces = self.traces = new AnP.Traces(self, custom));
        AnP.Users && (users = self.users = new AnP.Users(self, custom));
        AnP.Ips && (ips = self.ips = new AnP.Ips(self, custom));
        AnP.Groups && (groups = self.groups = new AnP.Groups(self, custom));
        AnP.Permissions && (permissions = self.permissions = new AnP.Permissions(self, custom));

        self.set_globals("object_name", object_name = self.object_name = settings_get("object_name"), true);

        object && self.extends(typeof object == "function" ? object = new object(self, custom) : object);

        (is_bool(object) ? object : true) && settings_get(["anp_autostart", "autostart"]) && self.start();

    };

    this.start = callback => {

        if(started)
            return;
        started = true;

        const start_go = subcallback => {

                  const construct_callback = settings_get(["callback", "on_built", "on_construct", "on_started"]);

                  routes && routes.autostart_go();
                  if(is_function(callback))
                      callback(subcallback);
                  else
                      is_function(subcallback) && subcallback();

                  is_function(construct_callback) && construct_callback();

              },
              end = () => {
                if(object && is_function(object.start)){
                    object.item_self = item_self;
                    object.start(start_go);
                }else 
                    start_go();
              };

        self.launch(self, ["settings", "i18n", "ajax", "threads", "attr", "comp"], () => {
            gui_mode = self.settings_get("gui_mode");
            device_mode = self.settings_get("device_mode");
            console_ok_dark_style = self.settings_get("console_ok_dark_style");
            console_ok_light_style = self.settings_get("console_ok_light_style");
            console_info_dark_style = self.settings_get("console_info_dark_style");
            console_info_light_style = self.settings_get("console_info_light_style");
            if(settings_get("gui_on") && AnP.Base){
                with_toasts = settings_get("toasts_enabled");
                toast_types = settings_get("toasts_types");
                toasts_to_console = settings_get("toasts_to_console");
                last_z_index = settings_get("start_z_index");
                base = self.base = new AnP.Base(self, {...custom, base_autobuild : false}, () => self.launch(self, [
                    "routes", "views", "logs", "exceptions", "traces", "groups", "permissions", "users", "ips"
                ], () => {
                    if(settings_get(["base_autobuild", "autobuild"]))
                        base.build(() => {
                            // sessions && sessions.start();
                            // routes.launch();
                            if(base.hash_self){
                                item_self = this.item_self = base.item_self;
                                hash_self = this.hash_self = base.hash_self;
                            };
                            end();
                        });
                    else 
                        end();
                }));
            }else 
                end();
        });

    };

    const is_function = this.is_function = item => typeof item == "function";
    const is_array = this.is_array = item => Array.isArray(item);
    const is_object = this.is_object = item => item !== null && typeof item == "object";
    const is_dictionary = this.is_dictionary = item => is_object(item) && !is_array(item);
    const is_bool = this.is_bool = item => typeof item == "boolean";
    const is_string = this.is_string = item => typeof item == "string";
    const is_html_object = this.is_html_object = item => item && !!(item.tagName || item.nodeName);
    const is_number = this.is_number = item => !isNaN(item) && typeof item == "number";
    const is_date = this.is_date = item => item instanceof Date;
    const is_integer = this.is_integer = item => is_number(item) && item == item >> 0;

    const settings_get = this.settings_get = (names, inputs, _default, nulls) => {
        if(settings)
            return settings.get(names, inputs, _default, nulls);

        if(names){

            const l = (is_array(names) ? names : names = [names]).length,
                  m = (inputs = (inputs ? is_array(inputs) ? inputs : [inputs] : []).concat([custom, default_settings])).length;

            is_bool(nulls) && (nulls = settings_get("nulls", null, false, false));

            for(let j = 0; j < m; j ++)
                if(is_dictionary(inputs[j]))
                    for(let i = 0; i < l; i ++)
                        if(is_string(names[i]) && inputs[j][names[i]] !== undefined && (nulls || inputs[j][names[i]] !== null))
                            return inputs[j][names[i]];
        };
        return _default !== undefined && (nulls || _default !== null) ? _default : settings_get("default_value", null, null, true);
    };

    const json_encode = this.json_encode = (object, show_errors) => {try{return JSON.stringify(object);}catch(exception){show_errors && console.error(exception);};return null;};
    const json_decode = this.json_decode = (json, show_errors) => {try{return JSON.parse(json);}catch(exception){show_errors && console.error([exception, json]);};return null;};
    const base64_encode = this.base64_encode = (string, show_errors) => {try{return btoa(encodeURIComponent(string));}catch(exception){show_errors && console.error(exception);};return null;};
    const base64_decode = this.base64_decode = (base64, show_errors) => {try{return decodeURIComponent(atob(base64));}catch(exception){show_errors && console.error(exception);};return null;};
    const base64_encode_raw = this.base64_encode_raw = (string, show_errors) => {try{return btoa(string);}catch(exception){show_errors && console.error(exception);};return null;};
    const base64_decode_raw = this.base64_decode_raw = (base64, show_errors) => {try{return atob(base64);}catch(exception){show_errors && console.error(exception);};return null;};

    const null_or_undefined = this.null_or_undefined = item => item === undefined || item === null;

    const get_variable = this.get_variable = (names, variables, nulls) => {
        if(names && variables){

            const l = (is_array(names) ? names : names = [names]).length,
                  m = (is_array(variables) ? variables : variables = [variables]).length;

            !is_bool(nulls) && (nulls = settings_get("nulls"));

            for(let j = 0; j < m; j ++)
                if(is_dictionary(variables[j]))
                    for(let i = 0; i < l; i ++)
                        if(is_string(names[i]) && variables[j][names[i]] !== undefined && (nulls || variables[j][names[i]] !== null))
                            return variables[j][names[i]];
        };
        return settings_get("default_value");
    };

    const string_variables = this.string_variables = (string, variables, _default) => {

        if(variables){
            is_dictionary(variables) && (variables = [variables]);
            if(is_array(variables)){
                for(let i = variables.length - 1; i >= 0; i --)
                    !is_dictionary(variables[i]) && variables.splice(i, 1);
            }else
                variables = null;
        };

        return is_string(string) ? string.replace(/\{([^\{\}]+)\}/g, (...arguments) => {
            if(variables)
                for(let i = 0, l = variables.length; i < l; i ++)
                    if(variables[i][arguments[1]] !== undefined){
                        if(is_function(variables[i][arguments[1]]))
                            return variables[i][arguments[1]](arguments[1], variables, _default);
                        return variables[i][arguments[1]];
                    };
            if(_default !== undefined)
                return _default;
            return arguments[0];
        }) : string;
    };

    const start_settings = callback => settings ? settings.start(callback) : callback();
    const start_i18n = callback => i18n ? i18n.start(callback) : callback();

    const hash = this.hash = input => {

        let alphabet = settings_get(["hash_alphabet", "alphabet"], input),
            hash;
        const length = settings_get(["hash_length", "length"], input),
              l = (is_array(alphabet) ? alphabet : alphabet = ("" + alphabet).split("")).length;

        do{
            hash = "";
            while((hash += alphabet[Math.random() * l >> 0]).length < length);
        }while(
            hashes.includes(hash) ||
            /^[0-9]/.test(hash) ||
            document.querySelector("." + hash + ",#" + hash + ",[name=" + hash + "]")
        );
        hashes.push(hash);

        return hash;
    };

    this.extends = (object, overwrite) => {
        if(is_function(object))
            object = new object(self, custom);
        else if(!is_object(object))
            return;

        const keys = Object.keys(object);

        !is_bool(overwrite) && (overwrite = settings_get(["extends_overwrite", "overwrite"]));

        Object.keys(self).forEach(key => (overwrite || object[key] === undefined) && (object[key] = self[key]));
        keys.forEach(key => self[key] === undefined && (self[key] = object[key]));

        // keys.includes("start") && is_function(object.start) && object.start();

        return object;
    };

    const initiate = (object, items, callback, i) => {

        if(i >= items.length){
            is_function(callback) && callback();
            return;
        };

        const end = () => initiate(object, items, callback, i + 1);

        items[i] && object[items[i]] && settings_get("initiate_order").some(method => is_function(object[items[i]][method]) && (!!object[items[i]][method](end) || true)) || end();

    };

    this.launch = (object, items, callback) => is_object(object) && items && initiate(object, is_array(items) ? items : [items], callback, 0);

    this.string_to_re = string => string.replace(/[\s\r\n\t\\\/\(\)\{\}\[\]\!\?\.\-\*\+\^\$\|]/g, (...arguments) => "\\" + (re_special[arguments[0]] || arguments[0]));

    this.get_globals = names => {
        if(!names)
            return Object.assign({}, globals);
        if(!is_array(names))
            return globals[names];
        
        const results = {};

        names.forEach(name => globals[name] !== undefined && (results[name] = globals[name]));

        return results;
    };

    this.set_global = (name, value, overwrite) => {
        if(!name)
            return;

        !is_bool(overwrite) && (overwrite = settings_get(["globals_overwrite", "overwrite"]));

        (overwrite || globals[name] === undefined) && (globals[name] = value);

    };

    this.remove_globals = name => {
        if(globals[name] !== undefined)
            delete globals[name];
    };

    this.go = (url, _new) => {

        url.substring(0, 1) == "#" && 
        (url = self.string_variables(url, {
            current_path : window.location.hash.replace(/\#\/([^\/]+)(\/([0-9]+|add|deleted)(\/(history|edit|set)(\/i18n)?)?)?$/, (...arguments) => {
                console.log([url.replace(/^\#(\{[^\{\}]+\})?\/([^\/]+)(\/.*)?$/, "$2"), arguments[1]]);
                return arguments[2] || url.replace(/^\#(\{[^\{\}]+\})?\/([^\/]+)(\/.*)?$/, "$2") == arguments[1] ? "" : arguments[1];
            })
        }));

        _new ? window.open(url, "_blank") : window.location.href = url;

    };

    const i18n_get = this.i18n_get = (names, variables, _default) => {
        if(i18n)
            return i18n.get(names, variables, _default)
        return self.string_variables(self.null_or_undefined(names) && !self.null_or_undefined(_default) ? _default : is_array(names) && names.length ? names[0] : "" + names, variables);
    };

    this.html_to_text = html => html.replace(/[\t\r\n]/g, "").replace(/<(br|hr)([ >])|<(li|ul)([ >])|<\/(p)>/gi, (...arguments) => {

        const tag = (arguments[1] || arguments[3] || arguments[5]).toLowerCase();
        let string = "";

        switch(tag){
            case "p":
                string = "\n\n";
            break;
            case "br":
            case "ul":
                string = "\n";
            break;
            case "li":
                string = "\n - ";
            break;
            case "hr":
                string = "\n----------------------------------\n";
            break;
        };

        return string + arguments[0];
    }).replace(/<(([^<>]+|[\r\n]+)+)>/g, "");

    this.print = (type, message, variables, _default, i) => {

        const date = new Date(), 
              own = {
                  type : type.toLowerCase() == "ok" ? " OK " : type.trim().toUpperCase().substr(0, 4), 
                  raw_type : type, 
                  message : self.i18n_get(message, variables, _default), 
                  ...self.get_trace()[1 + (i || 0)]
              };

        [
            ["year", "y", "getFullYear"], 
            ["month", "m", "getMonth"], 
            ["day", "d", "getDate"], 
            ["hour", "h", "getHours"], 
            ["minute", "i", "getMinutes"], 
            ["second", "s", "getSeconds"]
        ].forEach(([key, character, method]) => {
            own[character + character] = ("00" + (own[character] = own[key] = date[method]())).slice(-2);
        });
        own["yyyy"] = ("0000" + own.year).slice(-4);

        const plain_message = self.string_variables(print_format, [].concat(
            [own], 
            self.is_dictionary(variables) ? [variables] : self.is_array(variables) ? variables : []
        ));

        switch(type.trim().toLowerCase()){
            case "info":
            case "information":
                console.log("%c" + plain_message, self.gui_is_dark() ? console_info_dark_style : console_info_light_style);
            break;
            case "ok":
                console.log("%c" + plain_message, self.gui_is_dark() ? console_ok_dark_style : console_ok_light_style);
            break;
            case "warn":
            case "warning":
                console.warn(plain_message);
            break;
            case "error":
            case "exce":
            case "except":
            case "exception":
                console.error(plain_message);
            break;
            default:
                console.log(plain_message);
            break;
        };

    };

    this.get_trace = i => (new Error()).stack.replace(/^Error\s*?[\r\n]+/, "").trim().split(/[\r\n]+/).slice(1 + (i || 0)).map(line => {

        const matches = line.match(re_stack_trace);

        return matches ? {
            file : matches[4] || matches[9], 
            method : matches[3] || matches[8] || "", 
            line : Number(matches[7] || matches[10])
        } : null;
    });

    this.toast = (type, sentence, variables, _default, i) => {

        let kind = toast_types[type = type.toLowerCase()] || null

        if(kind)
            kind = type;
        else
            for(const key in toast_types)
                if(toast_types[key].includes(type)){
                    kind = key;
                    break;
                };

        const base = {
            kind : kind,
            type : type
        };

        if(is_array(variables))
            variables.unshift(base);
        else
            variables = [base, variables];

        const message = i18n_get(sentence, variables, _default),
              plain_message = self.html_to_text(message.replace(/<span class="i">([0-9])<\/span>/g, "[$1] "));

        with_toasts && item_self && (attr.set(item_self.querySelector(".toasts").appendChild(document.createElement("li")), {
            class : "toast",
            data_i18n : sentence,
            data_i18n_without : true,
            title : plain_message,
            data_date : Date.now(),
            data_type : type == "ok" ? "ok" : kind,
            data_type_custom : type
        }).innerHTML = message);

        toast_to_console && self.print(type, plain_message, null, null, 1 + (i || 0));

    };

    this.with_toasts = () => !!with_toasts;

    this.download = (data, type, name) => {

        const anchor = item_self.appendChild(document.createElement("a"));

        anchor.setAttribute("href", "data:" + type + ";base64," + base64_encode(is_object(data) ? json_encode(data) : "" + data));
        anchor.setAttribute("download", name);

        anchor.click();
        anchor.remove();

    };

    this.utf8_encode = string => unescape(encodeURIComponent(string));
    this.utf8_decode = string => decodeURIComponent(escape(string));

    this.next_z_index = () => last_z_index ++;

    this.set_globals = (string, variables) => string_variables(string, (variables ? variables.push ? variables : [variables] : []).concat([{
        object_name : self.object_name
    }, routes ? routes.get_variables() : null]));

    this.remove_was_back = () => was_back = false;

    this.was_back = () => !!was_back;

    this.back = (item, event) => {
        if(routes){
            routes.back();
            return;
        };

        if(window.history.length){
            self.routes.set_was_back();
            was_back = true;
            window.history.back();
        }else if(anp.is_string(item))
            self.go(item);

    };

    this.has_permissions = (permissions, reject) => sessions.has_permissions(permissions, reject);

    this.cookie_set = (name, value, expire, path) => document.cookie = name + "=" + value + ";expires=" + new Date(Date.now() + (expire || settings_get("cookies_expire"))).toUTCString() + ";path=" + (path || settings_get("cookies_path"));

    this.cookie_get = name => {
        if(!name || !document.cookie)
            return null;

        const items = decodeURIComponent(document.cookie).split(";"),
              l = items.length;

        for(let i = 0; i < l; i ++){

            const matches = items[i].match(/^([^=]+)=(.+)?$/);

            if(!matches)
                continue;

            if(matches[1].trim() == name)
                return matches[2];
        };
        return null;
    };

    this.cookie_delete = name => document.cookie = name + "=;expires=" + new Date(0).toUTCString() + ";path=/";

    this.alert = (text, callback, variables) => {

        alert(i18n_get(text, variables));
        is_function(callback) && callback();

    };

    this.confirm = (text, accept, reject, variables) => confirm(i18n_get(text, variables)) ? is_function(accept) && accept() : is_function(reject) && reject();

    this.prompt = (text, callback, variables) => {
        if(!is_function(callback))
            return;

        const response = prompt(i18n_get(text, variables));

        callback(response, response !== null);

    };

    this.to_html = value => null_or_undefined(value) ? "-" : ("" + value).replace(/\r\n|[<>\n\r]/g, (...arguments) => {
        switch(arguments[0]){
            case "<":
                return "&lt;";
            case ">":
                return "&gt;";
            case "\n":
            case "\r":
            case "\r\n":
                return "<br />";
        };
        return arguments[0];
    });

    this.to_date = value => {
        if(null_or_undefined(value))
            return null;
        if(value instanceof Date)
            return value;
        if(is_number(value))
            return new Date(value);
        if(is_string(value)){
            if(!value)
                return null;

            if(value == "now")
                return new Date();

            const matches = value.match(/^(\d{4})[\/\-\\]?(\d{1,2})[\/\-\\]?(\d{1,2})([\st]?(\d{1,2})\:?(\d{1,2})\:?(\d{1,2})([\:\.](\d{1,3})z?)?)?$/i);

            if(matches)
                return new Date(new Date(Number(matches[1]), Number(matches[2]) - 1, Number(matches[3]), Number(matches[5]) || 0, Number(matches[6]) || 0, Number(matches[7]) || 0).getTime() + (Number(matches[9]) || 0));
            try{
                return new Date(value);
            }catch(exception){};
        };
        return null;
    };

    this.date_format = (date, format) => {
        if(!(date = self.to_date(date)))
            return null;

        const year = date.getFullYear(),
              month = date.getMonth(),
              day = date.getDate(),
              hour = date.getHours(),
              minute = date.getMinutes(),
              second = date.getSeconds();

        return string_variables(format || settings_get(["default_date_format", "date_format"]), {
            yyyy : year,
            yy : year % 100,
            y : year,
            m : month,
            mm : (month < 9 ? "0" : "") + (month + 1),
            d : day,
            dd : (day < 10 ? "0" : "") + day,
            h : hour,
            hh : (hour < 10 ? "0" : "") + hour,
            i : minute,
            ii : (minute < 10 ? "0" : "") + minute,
            s : second,
            ss : (second < 10 ? "0" : "") + second
        });
    };

    this.set_cache = (name, value) => cache[name] = value;

    this.get_cache = name => {

        const value = cache[name];

        if(cache[name] === undefined)
            delete cache[name];

        return value;
    };

    const load_local_file = (files, callback, results, i) => {

        if(i >= files.length){
            callback(results);
            return;
        };

        const reader = new FileReader();

        reader.onload = reader.onerror = event => {
            results.push({
                name : files[i].name,
                last_modified : files[i].lastModified,
                data : event.target && event.target.result ? event.target.result : null,
                size : files[i].size,
                type : files[i].type
            });
            load_local_file(files, callback, results, i + 1);
        };
        reader.readAsDataURL(files[i]);

    };

    this.open_local_files = (input, callback) => {
        if(!is_function(callback)){
            if(!is_function(input))
                return;

            const temporary = is_object(callback) ? callback : null;

            callback = input;
            input = temporary;

        };

        const button = item_self.appendChild(document.createElement("input")),
              on_load = event => load_local_file(event.target.files, results => {
                  button.removeEventListener("change", on_load);
                  button.remove();
                  callback(results);
              }, [], 0);

        attr.set(button, {
            ...(is_object(input) ? input : {}),
            visible : false,
            type : "file"
        });

        button.addEventListener("change", on_load);

        button.click();

    };

    this.get_uri_data = data => {
        try{
            data = base64_decode(decodeURIComponent(data.match(/^[^,]+,(.*)$/)[1]));
            try{
                data = self.utf8_decode(data);
            }catch(error){};
        }catch(exception){
            console.error(exception);
        };
        return data;
    };

    this.get_url_app = () => window.location.hash.substr(1);
    this.get_url_pointer = url_pointer => new RegExp(url_pointer).test(self.get_url_app());
    this.update_url_pointers = () => item_self.querySelectorAll("[data-url-pointer]").forEach(item => item.setAttribute("data-url-pointer-here", self.get_url_pointer(item.getAttribute("data-url-pointer"))));

    this.anp_route = () => anp_route !== null ? anp_route : anp_route = settings_get("anp_route") || "";

    this.jszip_download = (zip, name, callback) => {

        is_function(name) && ([name, callback] = [callback, name]);

        zip.generateAsync({type : "blob"}).then(content => {

            const anchor = item_self.appendChild(document.createElement("a"));

            anchor.setAttribute("data-visible", false);
            is_string(name) && anchor.setAttribute("download", name);
            anchor.setAttribute("href", window.URL.createObjectURL(content));

            anchor.click();
            anchor.remove();

            is_function(callback) && callback();

        });

    };

    this.url_encode = string => encodeURIComponent(string.replace(/[\\\+ ]/g, (...arguments) => "\\" + {
        "\\" : "\\",
        "+" : "p",
        " " : "s"
    }[arguments[0]]));

    this.url_decode = string => decodeURIComponent(string).replace(/\\([\\ps])/g, (...arguments) => "\\" + {
        "\\" : "\\",
        "p" : "+",
        "s" : " "
    }[arguments[1]]);

    this.back_edit = () => {
        if(routes){
            routes.back();
            return;
        };

        const history = routes.get_history(),
              url_base = window.location.hash.replace(/^\#(.+)(\/[0-9]+\/texts\/[0-9]+\/edit)$/, "$1").replace(/^\#?(.+)(\/add|\/[0-9]+(\/edit)?)$/, "$1");

        for(let i = history.length - 1; i >= 0; i --){

            const be = history[i].indexOf(url_base);

            if(be == -1 || (!be && history[i].length - url_base.length < 2)){
                self.go("#" + history[i]);
                return;
            };

            const view_name = routes.get_view_name(history[i]);
            
            if(view_name && !/_edit(_view)?$/.test(view_name)){
                self.go("#" + history[i]);
                return;
            };

        };

        self.go("#" + url_base);

    };

    this.set_data_for_set = (key, data) => data_for_set[key] = data;

    this.get_data_for_set = key => data_for_set[key];

    this.remove_data_for_set = key => {
        if(data_for_set[key] !== undefined)
            delete data_for_set[key];
    };

    this.encode_set = set => self.base64_encode(JSON.stringify(set));
    this.decode_set = set => JSON.parse(self.base64_decode(set));

    this.is_refrence_key = key => key.match(/^(AnP_.+_(end|start)|AnP_(end|start))$/);

    this.is_mobile = () => !!is_mobile;
    this.is_dark_mode = () => !!is_dark_mode;
    this.get_gui_mode_forced = () => "" + gui_mode;
    this.get_device_mode_forced = () => "" + device_mode;
    this.gui_is_dark = () => gui_mode == "dark" || (gui_mode != "light" && is_dark_mode);
    this.devide_is_mobile = () => device_mode == "mobile" || (device_mode != "desktop" && is_mobile);

    construct();

};
