AnPBuilder = function(input){

    const self = this,
          default_settings = {
              nulls : false,
              default_value : null,
              autostart : true,
              callback : null,
              domain : "https://anp.k3y.pw",
              default_scripts : [[
                  "{domain}/ecma/AnP.ecma.js"
              ], [
                  "{domain}/ecma/AnP.Events.ecma.js",
                  "{domain}/ecma/AnP.Ajax.ecma.js",
                  "{domain}/ecma/AnP.Settings.ecma.js",
                  "{domain}/ecma/AnP.Stores.ecma.js",
                  "{domain}/ecma/AnP.I18N.ecma.js",
                  "{domain}/ecma/AnP.Threads.ecma.js",
                  "{domain}/ecma/AnP.Preload.ecma.js",
                  "{domain}/ecma/AnP.Attributes.ecma.js",
                  "{domain}/ecma/AnP.Components.ecma.js",
                  "{domain}/ecma/AnP.Sessions.ecma.js",
                  "{domain}/ecma/AnP.Base.ecma.js",
                  "{domain}/ecma/AnP.Errors.ecma.js",
                  "{domain}/ecma/AnP.Views.ecma.js",
                  "{domain}/ecma/AnP.Routes.ecma.js",
                  "{domain}/ecma/views/AnP.Logs.ecma.js",
                  "{domain}/ecma/views/AnP.Exceptions.ecma.js",
                  "{domain}/ecma/views/AnP.Traces.ecma.js",
                  "{domain}/ecma/views/AnP.Users.ecma.js",
                  "{domain}/ecma/views/AnP.Ips.ecma.js",
                  "{domain}/ecma/views/AnP.UsersAgents.ecma.js",
                  "{domain}/ecma/views/AnP.Groups.ecma.js",
                  "{domain}/ecma/views/AnP.Permissions.ecma.js"
              ], [
                  "{domain}/ecma/comp/AnP.Components.Images.ecma.js",
                  "{domain}/ecma/comp/AnP.Components.Files.ecma.js",
                  "{domain}/ecma/comp/AnP.Components.Selectors.ecma.js",
                  "{domain}/ecma/comp/AnP.Components.Forms.ecma.js",
                  "{domain}/ecma/comp/AnP.Components.Tables.ecma.js",
                  "{domain}/ecma/comp/AnP.Components.Calendars.ecma.js",
                  "{domain}/ecma/comp/AnP.Components.Maps.ecma.js",
                  "{domain}/ecma/comp/AnP.Components.Colors.ecma.js",
                  "{domain}/ecma/comp/AnP.Components.SelectsLists.ecma.js",
                  "{domain}/ecma/comp/AnP.Components.SyntaxHighlighter.ecma.js"
              ]],
              default_css : [
                  "https://cdn.k3y.pw/css/fonts/local/Roboto.css",
                  "https://cdn.k3y.pw/css/fonts/local/RobotoMono.css",
                  "https://cdn.k3y.pw/css/fonts/local/FontAwesome5Free.css",
                  "{domain}/css/AnP.icons.css"
              ],
              default_scss : ["{domain}/scss/AnP.css"],
              default_script_type : "ecma"
          },
          url_variables = {};
    let started = false;

    const default_value = this.default_value = (_default, nulls) => _default !== undefined && (_default !== null || (typeof nulls == "boolean" ? nulls : settings("nulls", null, false, false))) ? _default : settings(["default_value", "value"], null, null, true);

    const settings = this.settings = (names, inputs, _default, nulls) => {

        if(names){

            const l = (names instanceof Array ? names : names = [names]).length,
                  m = (inputs = (inputs ? inputs instanceof Array ? inputs : [inputs] : []).concat([input, default_settings])).length;

            typeof nulls != "boolean" && (nulls = settings("nulls", null, false, false));

            for(let j = 0; j < m; j ++)
                if(typeof inputs[j] == "object")
                    for(let i = 0; i < l; i ++)
                        if(names[i] && inputs[j][names[i]] !== undefined && (nulls || inputs[j][names[i]] !== nulls))
                            return inputs[j][names[i]];
        };
        return default_value(_default, nulls);
    };

    const string_variables = this.string_variables = (string, variables, _default) => {

        const l = (variables = (typeof variables == "object" ? variables instanceof Array ? variables : [variables] : []).filter(item => typeof item == "object")).length;

        return ("" + string).replace(/\{([^\{\}]+)\}/g, (...arguments) => {
            for(let i = 0; i < l; i ++)
                if(variables[i][arguments[1]] !== undefined)
                    return variables[i][arguments[1]];
            return _default !== undefined ? _default : arguments[0];
        });
    };

    const build_url = file => {

        const variables = Object.assign({}, url_variables, {file : file});

        return string_variables(string_variables(file, variables), variables);
    };

    const load_scripts = (domain, files, callback, i) => {

        if(i >= files.length){
            typeof callback == "function" && callback();
            return;
        };

        let ended = false,
            loaded = 0;
        const l = files[i].length,
              head = document.querySelector("head"),
              end = () => {
                  if(!ended && ++ loaded < l)
                      return;
                  ended = true;
                  load_scripts(domain, files, callback, i + 1);
              },
              default_type = settings("default_script_type");

        l ? files[i].forEach(file => {

            let type = default_type,
                attributes = null;

            if(file instanceof Array){
                file[1] && (type = file[1]);
                attributes = file[2];
                file = file[0];
            };

            const script = head.appendChild(document.createElement("script"));

            script.onload = end;

            script.setAttribute("data-type", "text/javascript");
            script.setAttribute("data-language", {
                "ecma" : "ECMAScript 2015",
                "js" : "JavaScript 1.8.5"
            }[type] || type);
            script.setAttribute("src", build_url(file));
            attributes instanceof Array && attributes.forEach(attribute => attribute instanceof Array && attribute.length == 2 && script.setAttribute(attribute[0].replace(/[^a-z0-9\-]+/ig, "-"), attribute[1]));
            script.setAttribute("data-crossorigin", "anonymous");
            script.setAttribute("charset", "utf-8");

        }) : end();

    };

    this.start = callback => {

        if(started)
            return;
        started = true;

        const head = document.querySelector("head"),
              scripts = [],
              scss = [],
              css = [];
        let value;

        ["default_scripts", "scripts"].forEach(key => {

            const set = settings(key) || [];

            (set ? set.length && typeof set[0] == "string" ? [set] : set : []).forEach(item => scripts.push(item));

        });
        ["default_scss", "scss"].forEach(key => ((value = settings(key) || []).push ? value : [value]).forEach(item => scss.push(item)));
        ["default_css", "css"].forEach(key => ((value = settings(key) || []).push ? value : [value]).forEach(item => css.push(item)));

        typeof callback != "function" && (callback = settings("callback"));
        load_scripts(settings("domain").replace(new RegExp("\\/\\*$"), ""), scripts, () => {
            scss.forEach(file => {

                const scss = head.appendChild(document.createElement("link")),
                      url = build_url(file);

                scss.setAttribute("type", "text/css");
                scss.setAttribute("rel", "stylesheet");
                scss.setAttribute("data-language", "SASS/CSS3");
                scss.setAttribute("href", url);
                scss.setAttribute("data-css-map", url + ".map");
                scss.setAttribute("data-scss", url.replace(/\.css$/, ".scss"));
                scss.setAttribute("data-crossorigin", "anonymous");
                scss.setAttribute("charset", "utf-8");

            });
            css.forEach(file => {

                const css = head.appendChild(document.createElement("link"));

                css.setAttribute("type", "text/css");
                css.setAttribute("rel", "stylesheet");
                css.setAttribute("data-language", "CSS3");
                css.setAttribute("href", build_url(file));
                css.setAttribute("data-crossorigin", "anonymous");
                css.setAttribute("charset", "utf-8");

            });
            typeof callback == "function" && callback();
        }, 0);

    };

    const construct = () => {

        if(typeof input == "function")
            input = {callback : input};
        else if(typeof input != "object")
            input = {};

        const custom_url_variables = settings(["url_variables", "custom_url_variables"]);

        if(typeof custom_url_variables == "object")
            for(const key in custom_url_variables)
                url_variables[key] = custom_url_variables[key];
        [
            "domain", "js_path", "js_comp_path", "ecma_path", "ecma_comp_path", "css_path",
            "sass_path", "scss_path"
        ].forEach(key => url_variables[key] = string_variables(settings(key), url_variables));

        settings("autostart") && self.start();

    };

    construct();

};
