AnP.Components.Files = function(anp, input){

    const self = this,
          cache = {};
    let started = false,
        thread = null,
        size_mode;

    const construct = () => {};

    const thread_function = () => {

        for(const key in cache)
            if(!anp.item_self.querySelector(".files [type=file][name=" + key + "]"))
                delete cache[key];

    };

    this.start = callback => {

        if(started)
            return;
        started = true;

        anp.comp.file = self.create;
        anp.comp.urlfile = self.url_field;

        size_mode = anp.settings_get(["files_size_mode", "size_mode"]);
        thread = anp.threads.add(thread_function);

        anp.is_function(callback) && callback();

    };

    this.select = (item, event) => item.parentNode.parentNode.querySelector("[type=file]").click();

    const field = (name, html) => (`
        <span` + anp.attr.set({
            class : "file-field",
            data_i18n : name,
            data_i18n_without : true,
            title : anp.i18n_get(name)
        }) + `>
            ` + anp.comp.i18n(name, "span") + `
            ` + html + `
        </span>
    `);

    // const draw_size = size => {

    //     let i = 0,
    //         simply = size;

    //     for(; simply > 1024; i ++)
    //         simply /= 1024;

    //     return (`
    //         <span` + anp.attr.set({
    //             class : "size",
    //             data_size : size
    //         }) + `>
    //             <span` + anp.attr.set({class : "value"}) + `>` + simply.toFixed(2) + `</span>
    //             <span data-icon="bytes_level_` + i + `"></span>
    //         </span>
    //     `);
    // };

    const get_icon_source = (name, url, type) => (type ? /^image\//.test(type) : is_image_extension(url)) ? url : [
        "https://raw.githubusercontent.com/redbooth/free-file-icons/master/512px/" + name.replace(/^.+\.([^\.\/\\]+)$/, "$1").toLowerCase() + ".png",
        "https://raw.githubusercontent.com/redbooth/free-file-icons/master/512px/_blank.png"
    ];

    const icon = (name, type, url) => field("thumbnail", anp.comp.images.create({src : get_icon_source(name, url, type)}));

    this.size_calculate = (size, mode) => {

        let i = 0;

        switch((mode || size_mode).toLowerCase()){
            case "bit":
                for(; size >= 1024; i ++)
                    size /= 1024;
            break;
            case "decimal":
                for(; size >= 1000; i ++)
                    size /= 1000;
            case "raw":
            break;
        };

        return [size, i];
    };

    this.size_build = (size, mode) => {

        const [results, i] = self.size_calculate(size, mode);

        return (`<span` + anp.attr.set({
            class : "size-submodule", 
            data_i : i,
            data_size : size,
            data_results : results,
            data_mode : (mode || (mode = size_mode)).toLowerCase()
        }) + `>
            <span` + anp.attr.set({class : "mode"}) + `>` + mode + `</span>
            <span` + anp.attr.set({class : "size"}) + `>` + size + `</span>
            <span` + anp.attr.set({class : "results"}) + `>` + results.toFixed(2).replace(/(\.0+|0+)$/, "") + `</span>
            ` + anp.comp.icon("size_" + i) + `
        </span>`);
    };

    const draw_file = (item, id, name, type, size, last_modified, data, i) => {

        const date = new Date(last_modified),
              on_change_event = get_module(item).getAttribute("data-on-change"),
              key = item.querySelector("input").getAttribute("name"),
              is_url = /^(\/|[a-z]{2,5}\:\/{2})/.test(data);

        anp.attr.set(item.querySelector(".data").appendChild(document.createElement("li")), {
            class : "file-data",
            data_size : size,
            data_type : type,
            data_name : name,
            data_last_modified : last_modified,
            data_i : i || 0,
            data_id : id || null
        }).innerHTML = (`
            ` + anp.comp.checkbox({
                i18n : "select",
                value : i || 0,
                data_name : name
            }) + `
            ` + anp.comp.buttons({data_direction : "vertical", buttons : [
                {i18n : "download", icon : "download", onclick : is_url ? anp.object_name + ".go('" + data + "', true);" : anp.object_name + ".comp.files.download(this, event);"},
                {i18n : "remove", icon : "remove", onclick : on_change_event ? on_change_event.replace("this", anp.object_name + ".comp.files.remove(this, event)") : anp.object_name + ".comp.files.remove(this, event)"}
            ]}) + `
            ` + field("name", name) + `
            ` + field("type", type) + `
            ` + field("size", self.size_build(size)) + `
            ` + field("date", (
                ("0000" + date.getFullYear()).slice(-4) + "/" +
                ("00" + date.getMonth()).slice(-2) + "/" +
                ("00" + date.getDate()).slice(-2) + " " +
                ("00" + date.getHours()).slice(-2) + ":" +
                ("00" + date.getMinutes()).slice(-2) + ":" +
                ("00" + date.getSeconds()).slice(-2)
            )) + `
            ` + icon(name, type, data) + `
        `);

        (cache[key] || (cache[key] = []))[i || (i = 0)] = {
            mime : type,
            data : is_url ? data : data.match(/^[^,]+,(.+)/)[1],
            size : size,
            name : name,
            reader_size : size,
            last_modified : last_modified,
            id : id
        };

    };

    const add = (item, event, callback, i) => {

        if(!event.target || i >= event.target.files.length){
            anp.is_function(callback) && callback();
            return;
        };

        const reader = new FileReader(),
              is_multiple = item.querySelector("[type=file]").hasAttribute("multiple");

        reader.onload = subevent => {

            const matches = subevent.target.result.match(/^data\:([^;,]+)(;[^,]+)?,(.+)$/),
                  name = item.querySelector("input").getAttribute("name"),
                  size = matches[3].length * .75 >> 0,
                  type = event.target.files[i].type || matches[1];
            let j = null;

            (cache[name] || (cache[name] = []))[j = cache[name].length] = null;

            !is_multiple && remove_all(item);

            draw_file(item, null, event.target.files[i].name, type, size, event.target.files[i].lastModified, subevent.target.result, j);

            add(item, event, callback, i + 1);

        };
        reader.readAsDataURL(event.target.files[i]);

    };

    const get_module = this.get_module = item => {

        if(item)
            while(item.hasAttribute && !item.hasAttribute("data-module") && !item.classList.contains("files") && (item = item.parentNode));

        return item || null;
    };

    this.add = (item, event, callback) => add(get_module(item), event, callback, 0);

    this.create = input => {

        let on_change;

        !anp.is_object(input) && (input = {});

        input.onchange = anp.object_name + ".comp.files.add(this, event, " + ((on_change = input.onchange || "") ? "() => {" + on_change + "}" : "null") + ");";

        return (`
            <div` + anp.attr.set({
                class : "files" + (input.class ? " " + input.class : ""),
                data_module : "files",
                data_reset : true,
                ...(on_change ? {data_on_change : on_change} : {})
            }) + `>
                <span` + anp.attr.set({class : "input"}) + `><input` + anp.attr.set([{
                    type : "file",
                    data_module_name : "files"
                }, input], ["class", "i18n"]) + ` /></span>
                ` + anp.comp.buttons({buttons : [
                    {i18n : "select_files", icon : "select_files", onclick : anp.object_name + ".comp.files.select(this, event);"},
                    {i18n : "remove_selected", icon : "remove", onclick : anp.object_name + ".comp.files.remove_select(this, event);" + (on_change || "")}
                ]}) + `
                <ul` + anp.attr.set({class : "data"}) + `></ul>
            </div>
        `);
    };

    const get_item = item => {

        if(item){
            anp.is_string(item) && (item = anp.item_self.querySelector(item) || anp.item_self.querySelector("#" + item));
            while(item.tagName && item.tagName.toLowerCase() != "li" && (item = item.parentNode));
        };

        return item || null;
    };

    this.download = (item, event) => anp.download(
        cache[get_module((item = get_item(item))).querySelector("input").getAttribute("name")][Number(item.getAttribute("data-i"))].data,
        item.getAttribute("data-type"),
        item.getAttribute("data-name")
    );

    this.remove = (item, event) => {

        const module = get_module(item),
              input = module.querySelector("input"),
              cache_block = cache[input.getAttribute("name")];

        item = get_item(item);
        cache_block && (cache_block[Number(item.getAttribute("data-i"))] = null);
        anp.attr.is(module, "data-reset") && (input.value = "");
        item.remove();

        return module;
    };

    const remove_all = item => {

        const module = get_module(item);

        module.querySelectorAll("[type=checkbox]").forEach(checkbox => checkbox.checked = true);
        module.setAttribute("data-reset", false);
        self.remove_select(item);
        module.setAttribute("data-reset", true);

    };

    this.remove_select = (item, event) => get_module(item).querySelectorAll("[type=checkbox]:checked").forEach(element => self.remove(element));

    this.get = item => cache[get_module(item).querySelector("[name]").getAttribute("name")];

    this.set = (item, files) => {

        (item = get_module(item)).querySelector("[type=file]").hasAttribute("multiple") && remove_all(item);

        (files ? anp.is_array(files) ? files : [files] : []).forEach(file => {
            draw_file(item, file.id, file.name, file.mime, file.size, file.last_modified, file.url);
        });

    };

    this.table_build = (key, data) => {
        
        return (data[key + "_url"] ? `<a` + anp.attr.set({
            class : "size-table-submodule",
            href : data[key + "_url"], 
            target : "_blank", 
            data_id : data[key + "_id"],
            data_name : data[key + "_name"],
            data_size : data[key + "_size"],
            data_type : data[key + "_mime"]
        }) + `>
            <span` + anp.attr.set({class : "icon"}) + `>` + icon(data[key + "_name"], data[key + "_mime"], data[key + "_url"]) + `</span>
            <span` + anp.attr.set({class : "name"}) + `>` + data[key + "_name"] + `</span>
            <span` + anp.attr.set({class : "type"}) + `>` + data[key + "_mime"] + `</span>
            <span` + anp.attr.set({class : "size"}) + `>` + self.size_build(data[key + "_size"], data.mode) + `</span>
        </a>` : "-");
    };

    const is_image_extension = this.is_image_extension = url => ["jpg", "jpge", "jpeg", "png", "bmp", "gif", "pcx", "webp", "tif", "tiff", "png"].includes(url.match(/([^\.\/]*)$/)[1]);

    this.url_sample = input => {
        if(anp.null_or_undefined(input) || !((anp.is_string(input) ? input = {url : input} : input).url))
            return "-";

        let text;

        return (`<a` + anp.attr.set([{
            class : "files-url-sample",
            href : input.url,
            target : anp.settings_get(["url_target", "target"], input)
        }, input.i18n ? {
            data_i18n : input.i18n,
            data_i18n_without : true, 
            title : text = anp.i18n.get(input.i18n, input.text)
        } : {title : text = input.text || input.url}]) + `>
            ` + anp.comp.images.create({src : get_icon_source(input.url, input.url, input.type == "image" || is_image_extension(input.url) ? "image/" : "")}) + `
            <span` + anp.attr.set([{class : "text"}, input.i18n ? {data_i18n : input.i18n} : {}]) + `>` + text + `</span>
        </a>`);
    };

    this.url_field = input => {

        let on_change;

        !anp.is_object(input) && (input = {});

        return (`
            <div` + anp.attr.set({
                class : "url-file group" + (input.class ? " " + input.class : ""),
                data_module : "url_file",
                ...(on_change ? {data_on_change : on_change} : {})
            }) + `>
                ` + anp.comp.text({
                    name : input.name || input.i18n,
                    data_on_change : anp.object_name + ".comp.files.url_change(this, event, " + ((on_change = input.onchange || "") ? "() => {" + on_change + "}" : "null") + ");",
                    maxlength : 256,
                    multiline : true
                }) + `
                <!--<span` + anp.attr.set({class : "image-box"}) + `>
                    <span` + anp.attr.set({class : "image"}) + `></span>
                    <img />
                </span>-->
                ` + anp.comp.images.create({
                    class : "image-box",
                    src : "https://raw.githubusercontent.com/redbooth/free-file-icons/master/512px/_blank.png"
                }) + `
            </div>
        `);
    };

    this.url_change = (input, event, callback) => {

        const url = get_icon_source(input.value, input.value),
              root = input.parentNode.parentNode;
        
        anp.comp.images.reset(root.querySelector(".image"), url);

    };

    construct();

};
