AnP.Components.Images = function(anp, input){

    const self = this;
    let started = false,
        thread = null;

    const construct = () => {};

    this.start = callback => {

        if(started)
            return;
        started = true;

        anp.comp.image = self.create;

        anp.is_function(callback) && callback();

    };

    this.load = (item, event) => {

        const i = Number(item.parentNode.getAttribute("data-i")),
              sources = anp.json_decode(anp.base64_decode(item.parentNode.getAttribute("data-sources")));

        if(sources[i]){
            item.setAttribute("src", sources[i]);
            item.parentNode.querySelector("span").style.backgroundImage = "url('" + sources[i] + "')";
            item.parentNode.setAttribute("data-i", i + 1);
        }else
            item.parentNode.setAttribute("data-status", "error");

    };

    this.loaded_ok = (item, event) => item.parentNode.setAttribute("data-status", "ok");

    this.create = input => {

        !anp.is_dictionary(input) && (input = {});

        const default_source = anp.settings_get("image_default_source"),
              sources = input.sources || input.src,
              _class = anp.get_variable("class", input),
              i18n = anp.settings_get("i18n", input);
        let text = null;

        if(i18n)
            text = anp.i18n_get(i18n);
        else
            ["text", "alt", "title"].forEach(key => {

                const value = anp.settings_get(key, input);

                if(!anp.null_or_undefined(value)){
                    text = value;
                    return true;
                };

            });

        return (`
            <span` + anp.attr.set([{
                class : "image" + (_class ? " " + _class : ""),
                data_status : "unloaded",
                data_sources : anp.base64_encode(anp.json_encode(sources ? anp.is_array(sources) ? sources : [sources] : [])),
                data_i18n_without : true,
                data_i : 0,
                data_mode : anp.settings_get(["image_mode", "data_mode", "mode"], input)
            }, input.i18n ? {
                data_i18n : input.i18n,
                title : text
            } : null]) + `>
                <img` + anp.attr.set([{
                    src : default_source,
                    onerror : anp.object_name + ".comp.images.load(this, event);",
                    onload : anp.object_name + ".comp.images.loaded_ok(this, event);"
                }, text !== null ? {alt : text} : null]) + ` />
                <span` + anp.attr.set({style : "background-image:url('" + default_source + "');"}) + `></span>
                ` + anp.comp.icon("image_status") + `
            </span>
        `);
    };

    this.reset = (image, sources) => {

        anp.is_string(image) && (image = anp.item_self.querySelector(image));

        if(!image)
            return;

        const item = image.querySelector("img");

        image.setAttribute("data-sources", anp.base64_encode(anp.json_encode(anp.is_array(sources) ? sources : anp.is_string(sources) ? [sources] : [])));
        image.setAttribute("data-i", 0);
        image.setAttribute("data-status", "unloaded");
        
        self.load(item);

    };

    construct();

};
