AnP.Components.Marks = function(anp, input){

    const self = this,
          cache = {},
          origin = {},
          list_cache = {};
    let started = false,
        thread = null;

    const construct = () => {};

    const thread_method = () => {

        for(const hash in cache)
            if(!anp.item_self.querySelector("[data-hash=" + hash + "]")){
                if(cache[hash])
                    delete cache[hash];
                if(origin[hash])
                    delete origin[hash];
            };

    };

    this.start = callback => {

        if(started)
            return;
        started = true;

        anp.comp.marks = self.create;
        anp.comp.marks_selector = self.create_selector;
        thread = anp.threads.add(thread_method);

        anp.is_function(callback) && callback();

    };

    const get = this.get = item => {

        if(item.substr){
            try{
                return anp.item_self.querySelector(item) || null;
            }catch(exception){};
            return null;
        };

        if(item)
            while(item.hasAttribute && (!item.hasAttribute("data-module") || item.getAttribute("data-module") != "marks") && (item = item.parentNode));

        return item || null;
    };

    this.back = (item, event) => {

        const marks = get(item);

        if(!marks)
            return;

        const hash = marks.getAttribute("data-hash");

        if(cache[hash] && cache[hash] != origin[hash])
            anp.confirm("marks_changed_verify_back", anp.back);
        else
            anp.back();

    };

    this.show_deleted = (item, event) => {

        const marks = get(item);

        marks && marks.setAttribute("data-show-deleted", item.getAttribute("data-toggle") == "true");

    };

    this.set_autocheck = (item, event) => {

        const marks = get(item),
              check = item.parentNode.querySelector("button[data-i18n=check]"),
              disabled = check.hasAttribute("disabled"),
              autocheck = item.getAttribute("data-toggle") == "true";

        marks.setAttribute("data-autocheck", autocheck);
        if(autocheck)
            !disabled && check.setAttribute("disabled", true);
        else
            disabled && check.removeAttribute("disabled");

    };

    const summatory = (values, points, weight) => {

        let value = 0;

        values.forEach(item => value += item.value * item.weight / weight / points);

        return value;
    };

    this.check = (item, event) => {

        const module = get(item);

        if(!module)
            return;

        const marks = [],
              each_side = [],
              weight = {
                  header : [],
                  side : []
              },
              average_items = module.querySelectorAll(".info>.average>span"),
              points = Number(module.getAttribute("data-points")),
              sides_items = module.querySelectorAll(".footer>.totals>span"),
              total_values = [];
        let total_weight = 0,
            total_value;


        module.querySelectorAll(".header-items>span").forEach(header => {
            weight.header.push(Number(header.getAttribute("data-weight")));
            each_side.push({
                values : [],
                weight : 0
            });
        });
        module.querySelectorAll(".info>.side>span").forEach(side => weight.side.push(Number(side.getAttribute("data-weight"))));

        module.querySelectorAll(".marks-block").forEach((block, i) => {

            const items = block.querySelectorAll(".mark"),
                  average = [];
            let current_weight = 0;

            items.forEach((mark, j) => {

                const value = Number(mark.getAttribute("data-value")) || null;

                marks.push(value);
                if(value){
                    average.push({
                        value : value,
                        weight : weight.header[j]
                    });
                    current_weight += weight.header[j];
                    each_side[j].values.push({
                        value : value,
                        weight : weight.side[j]
                    });
                    each_side[j].weight += weight.side[j];
                };

            });

            if(current_weight){

                const value = summatory(average, points, current_weight);

                average_items[i].innerText = value ? value.toFixed(3) : "-";

            }else
                average_items[i].innerText = "-";

        });

        each_side.forEach((side, i) => {

            if(side.weight){

                const value = summatory(side.values, points, side.weight);

                sides_items[i].innerText = value ? value.toFixed(3) : "-";

                total_values.push({
                    value : value,
                    weight : weight.header[i]
                });
                total_weight += weight.header[i];

            }else
                sides_items[i].innerText = "-";

        });

        total_value = summatory(total_values, 1, total_weight);
        module.querySelector(".footer>.total").innerText = total_value ? (total_value * 5).toFixed(3) : "-";

        cache[module.getAttribute("data-hash")] = JSON.stringify(marks);

    };

    this.data_scroll = (item, event) => get(item).querySelectorAll(".side,.average").forEach(fields => fields.scrollTop = item.scrollTop);

    this.create = (input, callback) => {

        const hash = anp.hash(),
              autocheck = anp.settings_get(["marks_autocheck", "autocheck"], input),
              deleted = anp.settings_get(["marks_deleted", "show_deleted", "deleted"], input);

        new AnP.Preload(anp, "[data-hash=" + hash + "]>.preloader", preloader => {

            anp.is_function(callback) && callback(preloader.parentNode);

            if(input.on_load){
                try{
                    anp.is_function(input.on_load = eval(anp.set_globals(input.on_load))) && input.on_load(preloader.parentNode, input);
                }catch(exception){};
            };

            if(anp.settings_get(["marks_autoload", "autoload"], input)){

                const loader = preloader.parentNode.querySelector("button[data-i18n=load]");

                loader && loader.click();

            };

            preloader.remove();

        });

        return (`
            <form` + anp.attr.set({
                class : "marks",
                method : "post",
                action : input.save || null,
                data_module : "marks",
                data_hash : hash,
                data_loaded : false,
                data_show_deleted : deleted,
                data_autocheck : autocheck,
                data_points : anp.settings_get(["marks_points", "points"], input),
                data_headers : 0,
                onsubmit : "return false;"
            }) + `>
                <fieldset>
                    ` + anp.comp.i18n(input.i18n, "legend") + `
                    ` + anp.comp.i18n(input.i18n + "_text", "p") + `
                    <div` + anp.attr.set({
                        class : "box",
                        data_side_selected : 0,
                        data_header_selected : 0,
                        onmouseout : anp.object_name + ".comp.marks_module.mark_selected(this, event, -1, -1);"
                    }) + `>
                        <div` + anp.attr.set({class : "header"}) + `>
                            ` + anp.comp.i18n("side", "div") + `
                            <div` + anp.attr.set({class : "header-items"}) + `></div>
                            ` + anp.comp.i18n("average", "div") + `
                        </div>
                        <div` + anp.attr.set({class : "info"}) + `>
                            <div` + anp.attr.set({class : "side"}) + `></div>
                            <div` + anp.attr.set({
                                class : "data",
                                onscroll : anp.object_name + ".comp.marks_module.data_scroll(this, event);"
                            }) + `></div>
                            <div` + anp.attr.set({class : "average"}) + `></div>
                        </div>
                        <div` + anp.attr.set({class : "footer"}) + `>
                            ` + anp.comp.i18n("total", "div") + `
                            <div` + anp.attr.set({class : "totals"}) + `></div>
                            <div` + anp.attr.set({class : "total"}) + `>-</div>
                        </div>
                    </div>
                    <div` + anp.attr.set({class : "actions"}) + `>
                        ` + anp.comp.buttons({buttons : [
                            {type : "button", i18n : "back", onclick : anp.object_name + ".comp.marks_module.back(this, event);", icon : "back"},
                            {type : "button", i18n : "deleted", onclick : anp.object_name + ".comp.marks_module.show_deleted(this, event);", icon : "deleted", toggle : deleted},
                            {type : "button", i18n : "autocheck", onclick : anp.object_name + ".comp.marks_module.set_autocheck(this, event);", icon : "autocheck", toggle : autocheck},
                            {type : "button", i18n : "check", onclick : anp.object_name + ".comp.marks_module.check(this, event);", icon : "check", disabled : autocheck}
                        ].concat(
                            input.save ? [{type : "submit", i18n : "save", onclick : anp.set_globals(input.save), icon : "save"}] : [],
                            input.load ? [{type : "button", i18n : "load", onclick : anp.set_globals(input.load), icon : "load"}] : []
                        )}) + `
                    </div>
                </fieldset>
                <div` + anp.attr.set({class : "preloader"}) + `></div>
            </form>
        `);
    };

    this.set_mark = (item, event) => {

        const marks = get(item),
              value = ((Number(item.getAttribute("data-value")) || 0) + 1) % (Number(marks.getAttribute("data-points")) + 1) || "-";

        item.setAttribute("data-value", value);
        item.setAttribute("title", value);
        item.querySelector(".mark-value").innerText = value;

        marks.getAttribute("data-autocheck") == "true" && self.check(item, event);

    };

    this.mark_selected = (item, event, i, j) => {
        with(get(item).querySelector(".box")){
            setAttribute("data-side-selected", i + 1);
            setAttribute("data-header-selected", j + 1);
        };
    };

    this.set_data = (item, map, marks, texts, points) => {

        const marks_item = get(item);

        if(!marks_item)
            return;

        const hash = marks_item.getAttribute("data-hash");
        let i = 0;

        marks_item.setAttribute("data-points", points);

        if(texts){

            const l = texts[0].length,
                  m = texts[1].length;
            let cells = ``;

            marks_item.setAttribute("data-headers", m);

            marks_item.setAttribute("data-loaded", false);
            ["side", "header"].forEach((level, i) => {

                let html = ``,
                    averages = ``;

                texts[i].forEach((field, j) => {

                    const on_mouse_over_event = anp.object_name + ".comp.marks_module.mark_selected(this, event, " + (i ? "-1, " + j : j + ", -1")+ ");";

                    averages += `<span` + anp.attr.set(Object.assign({
                        data_weight : field.weight,
                        onmouseover : on_mouse_over_event
                    }, i ? {} : {data_minimum : !!field.minimum})) + `>-</span>`;
                    html += (`
                        <span` + anp.attr.set(Object.assign({
                            data_id : field.id,
                            data_deleted : !!field.deleted,
                            data_weight : field.weight,
                            onmouseover : on_mouse_over_event
                        }, i ? {} : {data_minimum : !!field.minimum})) + `>
                            <span` + anp.attr.set({class : "text"}) + `>` + field.text + `</span>
                        </span>
                    `);

                });
                marks_item.querySelector("." + level + (level == "header" ? "-items" : "")).innerHTML = html + `<span class="preloader-` + level + `"></span>`;
                marks_item.querySelector(level == "side" ? ".info .average" : ".footer .totals").innerHTML = averages;

                new AnP.Preload(anp, "[data-hash=" + hash + "] .preloader-" + level, preloader => {
                    preloader.remove();
                    ++ i == 2 && marks_item.setAttribute("data-loaded", true);
                });

            });

            for(let i = 0; i < l; i ++){
                cells += `<div` + anp.attr.set({
                    class : "marks-block",
                    data_side : i,
                    data_id : texts[0][i].id,
                    data_minimum : !!texts[0][i].minimum
                }) + `>`;
                for(let j = 0; j < m; j ++)
                    cells += (`
                        <span` + anp.attr.set({
                            class : "mark",
                            onclick : anp.object_name + ".comp.marks_module.set_mark(this, event);",
                            data_value : "-",
                            data_header : j,
                            data_id : texts[1][j].id,
                            title : "-",
                            onmouseover : anp.object_name + ".comp.marks_module.mark_selected(this, event, " + i + ", " + j + ");"
                        }) + `>
                            <span` + anp.attr.set({data_icon : "mark_status"}) + `></span>
                            <span` + anp.attr.set({class : "mark-value"}) + `>-</span>
                        </span>
                    `);
                cells += `</div>`;
            };
            cells += `<div class="preloader-marks"></div>`;
            marks_item.querySelector(".box .data").innerHTML = cells;

            origin[hash] = JSON.stringify(marks);

            new AnP.Preload(anp, ".preloader-marks", preloader => {

                if(map && map[0] && map[1]){

                    const l = map[1].length;

                    marks_item.querySelectorAll(".marks-block").forEach(side => {

                        const side_id = Number(side.getAttribute("data-id")),
                              i = map[0].indexOf(side_id);

                        if(isNaN(i))
                            side.querySelectorAll(".mark").forEach(mark => {
                                mark.setAttribute("data-value", "-");
                                mark.setAttribute("title", "-");
                                mark.querySelector(".mark-value").innerText = "-";
                            });
                        else
                            side.querySelectorAll(".mark").forEach(mark => {

                                const header_id = Number(mark.getAttribute("data-id")),
                                      j = map[1].indexOf(header_id);

                                if(!isNaN(j)){

                                    const value = marks[(i * l) + j];

                                    if(value){
                                        mark.setAttribute("data-value", value);
                                        mark.setAttribute("title", value);
                                        mark.querySelector(".mark-value").innerText = value;
                                        return;
                                    };

                                };

                                mark.setAttribute("data-value", "-");
                                mark.setAttribute("title", "-");
                                mark.querySelector(".mark-value").innerText = "-";

                            });

                    });

                    setTimeout(() => self.check(item, event), 20);

                };

                preloader.remove();

            });

        };

    };

    this.get_data = item => {

        const module = get(item);

        if(!module)
            return null;

        const map = [[], []],
              hash = module.getAttribute("data-hash");

        module.querySelectorAll(".side>span").forEach(side => map[0].push(Number(side.getAttribute("data-id"))));
        module.querySelectorAll(".header-items>span").forEach(header => map[1].push(Number(header.getAttribute("data-id"))));

        return [map, cache[hash] || null, origin[hash] || null];
    };

    const get_selector = item => {

        if(item)
            while(item.hasAttribute && (!item.hasAttribute("data-module") || item.getAttribute("data-module") != "marks_selector") && (item = item.parentNode));

        return item || null;
    };

    this.set_autoselect = (item, event) => {

        const form = get_selector(item),
              select_button = form.querySelector("button[data-i18n=select]");

        if(form.querySelector("[data-i18n=autoselect]").getAttribute("data-toggle") == "true"){
            !select_button.hasAttribute("disabled") && select_button.setAttribute("disabled", true);
        }else
            select_button.hasAttribute("disabled") && select_button.removeAttribute("disabled");

    };

    this.autoselect = (item, event) => {
        with(get_selector(item))
            querySelector("button[data-i18n=autoselect]").getAttribute("data-toggle") == "true" && onsubmit(item, event);
    };

    this.load_selector = (item, event) => get_selector(item).querySelector("button[data-i18n=reload]").click(item, event);

    this.select = (item, event) => {

        const [values, selector] = anp.comp.forms.get_values(item),
              list = selector.parentNode.parentNode.querySelector("form.table");

        selector.hasAttribute("data-cache") && selector.getAttribute("data-cache") == "true" && (list_cache[window.location.hash] = values);

        for(const key in values)
            list.querySelectorAll("tr.searcher>[data-field=" + key + "_id] input").forEach(input => input.value = values[key] || "");

        anp.comp.tables.refresh(list, event);

    };

    this.on_loaded = (item, event) => {

        const selector = get_selector(item);

        if(selector.hasAttribute("data-cache") && selector.getAttribute("data-cache") == "true" && list_cache[window.location.hash]){
            anp.comp.forms.set(selector, list_cache[window.location.hash]);
            setTimeout(() => self.select(item, event), 20);
        }else
            self.select(item, event);

    };

    this.create_selector = input => {

        let html = {
            header : ``,
            body : ``
        };
        const hash = anp.hash(),
              autoselect = anp.settings_get(["marks_autoselect", "autoselect"], input);

        anp.settings_get(["marks_fields", "fields"], input).forEach((field, i) => {
            console.log(i18n_get);

            const text = anp.i18n_get(field),
                  _class = "option-" + i + " " + field.replace(/[^a-z\d\-]+/g, "-");

            html.header += `<span` + anp.attr.set({
                class : _class,
                data_field : field,
                data_i18n : field,
                title : text
            }) + `>` + text + `</span>`;
            html.body += `<span` + anp.attr.set({
                class : _class,
                data_field : field,
                data_i18n : field,
                title : text,
                data_i18n_without : true
            }) + `>` + anp.comp.selector({
                name : field,
                onchange : anp.object_name + ".comp.marks_module.autoselect(this, event);"
            }) + `</span>`;

        });

        new AnP.Preload(anp, "[data-preloader=" + hash + "]", preloader => {
            preloader.parentNode.querySelector("button[data-i18n=reload]").click(preloader.parentNode, null);
            preloader.remove();
        });

        return (`
            <form` + anp.attr.set({
                class : "marks-selector",
                data_module : "marks_selector",
                method : "get",
                action : "#",
                data_cache : anp.settings_get(["marks_cache", "cache"], input),
                onsubmit : (input.select ? input.select.replace(/;$/, "") + ";" : "") + anp.object_name + ".comp.marks_module.select(this, event);return false;"
            }) + `>
                <fieldset>
                    ` + anp.comp.i18n(input.i18n + "_selector", "legend") + `
                    ` + anp.comp.i18n(input.i18n + "_selector_text", "p") + `
                    <div` + anp.attr.set({class : "options"}) + `>
                        <div` + anp.attr.set({class : "header"}) + `>` + html.header + `</div>
                        <div` + anp.attr.set({class : "body"}) + `>` + html.body + `</div>
                    </div>
                    ` + anp.comp.buttons({buttons : [
                        {type : "button", i18n : "reload", onclick : input.load.replace(/,\s*callback\)/, ", () => " + anp.object_name + ".comp.marks_module.on_loaded(this, event))"), icon : "reload"},
                        {type : "button", i18n : "autoselect", onclick : anp.object_name + ".comp.marks_module.set_autoselect(this, event);", icon : "autoselect", toggle : autoselect},
                        {type : "submit", i18n : "select", icon : "select", disabled : autoselect}
                    ]}) + `
                </fieldset>
                <div` + anp.attr.set({data_preloader : hash}) + `></div>
            </form>
        `);
    };

    this.fill_selector = (block, data) => {

        const selector = get_selector(block);

        for(const key in data){
            if(key == "error")
                continue;

            const options = [{
                      name : "all",
                      value : 0,
                      selected : true
                  }],
                  field = selector.querySelector("[name=" + key + "]");

            data[key] && data[key].forEach(item => {

                let text = item.text || item.name;

                if(anp.null_or_undefined(text)){
                    text = "";
                    Object.values(item).forEach(value => text += (text ? " - " : "") + value);
                };

                options.push({
                    name : text,
                    value : item.id
                });

            });
            anp.comp.selectors.set(field, options);

        };

    };

    this.set_origin = item => {

        const hash = get(item).getAttribute("data-hash");

        origin[hash] = cache[hash];

    };

    construct();

};
