AnP.Components.SelectsLists = function(anp, input){

    const self = this;
    let started = false;

    const construct = () => {};

    this.start = callback => {

        const end = status => anp.is_function(callback) && callback(status);

        if(started){
            end(false);
            return false;
        };
        started = true;

        end(true);

        return true;
    };

    this.build = input => anp.comp.group({
        class : "submodule-foreign submodule-foreign-list",
        data_visible : !!input.visible,
        items : [
            `<span` + anp.attr.set({
                class : "value",
                data_type : "html",
                data_name : input.name, 
                data_has_content : false
            }) + `>
                ` + anp.comp.i18n(input.name, "span", null, null, true) + `
                <span` + anp.attr.set({class : "content"}) + `>` + (input.content || "") + `</span>
            </span>`,
            {type : "number", i18n : input.name, name : input.name, min : 1, data_subdata : input.subdata ? anp.base64_encode(anp.json_encode(input.subdata)) : null, data_module_name : "select_list"},
            {type : "button", i18n : "select", onclick : "{object_name}.comp.forms.go_save(null, '#" + input.url + "', false);", icon : "select"}
        ]
    });

    this.set = (item, value, subdata) => {

        item.value = value;
        item.setAttribute("data-subdata", subdata ? anp.base64_encode(anp.json_encode(subdata)) : null);
        with(item.parentNode.parentNode.querySelector("[data-has-content]")){
            setAttribute("data-has-content", !!subdata);
            querySelector(".content").innerHTML = subdata ? anp.json_encode(subdata) : "";
        };

    };

    this.get_value = item => Number(item.value) || null;

    this.get_subdata = item => {
        
        const subdata = item.getAttribute("data-subdata");
        
        return subdata ? anp.json_decode(anp.base64_decode(subdata)) : null;
    };

    construct();

};