AnP.Ips = function(anp, input){

    const self = this,
          for_wait = {};
    let started = false,
        cache = null;

    const construct = () => {};

    this.start = callback => {

        const end = status => anp.is_function(callback) && callback(status);

        if(started){
            end(false);
            return false;
        };
        started = true;

        end(true);

        return true;
    };

    this.refresh = (item, event) => anp.comp.tables.fill(
        item, 
        anp.anp_route() + "/administration/ips/list", 
        {}, 
        null, // callback
        "ips_refresh_error", 
        anp.sessions.get_errors_list().concat([])
    );

    this.refresh_history = (item, event) => anp.comp.tables.fill(
        item, 
        anp.anp_route() + "/administration/ips/history", 
        {id : Number(anp.get_globals("ip"))}, 
        null, // callback
        "ips_history_error", 
        anp.sessions.get_errors_list().concat([
            anp.sessions.get_errors_list(), [
                "ip_null",
                "ip_not_id",
                "ip_not_exists",
                "ip_deleted"
            ]
        ])
    );

    this.restore = (item, event) => {
        
        const variables = {
            ...anp.comp.forms.get_variables(item), 
            ...anp.comp.tables.get_row_data(item)
        };
        
        anp.confirm("ip_restore_confirm", () => {
            anp.ajax.send("post", anp.anp_route() + "/administration/ips/restore", {
                id : anp.comp.tables.get_row_field(item, "plain_id")
            }, (response, ok) => {
                anp.errors.validate(
                    response.variables.error, 
                    [].concat(
                        anp.sessions.get_errors_list(), [
                            "ip_null",
                            "ip_not_id",
                            "ip_not_exists",
                            "ip_date_out"
                        ]
                    ), 
                    variables, 
                    "ip_restore_error", 
                    "ip_restore_ok"
                ) && 
                self.refresh_history(item, event);
            });
        }, null, variables);

    };

    this.set_accessible = (item, event) => anp.confirm("ip_set_accessible_confirm", () => {

        anp.ajax.send("post", anp.anp_route() + "/administration/ips/set_accessible", {
            id : anp.comp.tables.get_id(item),
            accessible : item.checked
        }, (response, ok) => {
            console.log(response);
            (
                !response || 
                !response.variables || 
                !anp.errors.validate(
                    response.variables.error, 
                    [].concat(
                        anp.sessions.get_errors_list(), 
                        [
                            "ip_null",
                            "ip_not_id",
                            "ip_not_exists",
                            "ip_deleted",
                            "accessible_null",
                            "accessible_same_value"
                        ]
                    ), 
                    {}, 
                    "ip_set_accessible_error", 
                    "ip_set_accessible_ok"
                )
            ) && (item.checked = !item.checked)
        });

    }, () => item.checked = !item.checked);

    construct();

};