AnP.UsersEmails = function(anp, input){

    const self = this,
          for_wait = {};
    let started = false,
        cache = null;

    const construct = () => {};

    this.start = callback => {

        const end = status => anp.is_function(callback) && callback(status);

        if(started){
            end(false);
            return false;
        };
        started = true;

        end(true);

        return true;
    };

    const has_changes = (item) => JSON.stringify(anp.comp.forms.get_values(item)[0]).replace(/"language":[0-9]+/, "") != cache.replace(/"language":[0-9]+/, "");

    this.refresh = (item, event) => anp.comp.tables.fill(
        item, 
        "/app/sessions/users/emails/list", 
        {}, 
        null, // callback
        "users_emails_refresh_error", 
        anp.sessions.get_errors_list().concat([])
    );

    this.delete = (item, event) => anp.confirm("user_email_delete_confirm", () => {
        anp.ajax.send("post", "/app/sessions/users/emails/delete", {
            id : anp.comp.tables.get_id(item)
        }, (response, ok) => {
            anp.errors.validate(response.variables.error, "user_email_delete_error", [].concat(
                anp.sessions.get_errors_list(), [
                    "user_email_null",
                    "user_email_not_id",
                    "user_email_not_exists",
                    "user_email_deleted"
                ]
            ), "user_email_delete_ok") && 
            self.refresh(item, event);
        });
    });

    const set_wait_values = item => {
        
        for(const key in for_wait)
            if((wait_data = anp.get_data_for_set(for_wait[key])) && wait_data.id){

                const form = anp.comp.forms.get(item);

                anp.comp.selects_lists.set(form.querySelector("[name=" + key + "]"), wait_data.id, wait_data);
                anp.remove_data_for_set(for_wait[key]);

                break;
            };

    };

    this.load = (item, event) => anp.ajax.send("post", "/app/sessions/users/emails/basics", {}, data => {
        if(anp.errors.validate(data.variables.error, [].concat(
            anp.sessions.get_errors_list()
        ), "users_emails_basics_error")){

            const id = Number(anp.get_globals("user_email")); 

            anp.comp.selectors.set("[data-view=users_emails_edit] [name=email]", anp.format_selector_values(data.tables[0]));
            anp.comp.selectors.set("[data-view=users_emails_edit] [name=user]", anp.format_selector_values(data.tables[1]));

            if(isNaN(id)){
                cache = JSON.stringify(anp.comp.forms.get_values(item)[0]);
                return () => set_wait_values(item);
            }else 
                anp.ajax.send("post", "/app/sessions/users/emails/load", {id : id}, data => {
                    if(anp.errors.validate(data.variables.error, [].concat(
                        anp.sessions.get_errors_list(),
                        [
                            "user_email_null",
                            "user_email_not_id",
                            "user_email_not_exists",
                            "user_email_deleted"
                        ]
                    ), "user_email_load_error")){
                        anp.comp.forms.set(item, data.data);
                        cache = JSON.stringify(anp.comp.forms.get_values(item)[0]);
                        return () => set_wait_values(item);
                    };
                });

        };
    });

    this.validate = data => {

        let error = anp.errors.set("", (
            data.id === undefined ? 0 : 
            data.id === null ? 1 << 1 : 
            !anp.is_number(data.id) ? 1 << 2 : 
            !anp.is_integer(data.id) ? 1 << 3 : 
            data.id < 1 ? 1 << 4 : 
        0), 0, 0); 

        error = anp.errors.set(error, (
            data.email === undefined ? 1 << 0 : 
            data.email === null ? 1 << 1 : 
            !anp.is_number(data.email) ? 1 << 2 : 
            !anp.is_integer(data.email) ? 1 << 3 : 
            data.email < 1 ? 1 << 4 : 
        0), 5, 0);

        error = anp.errors.set(error, (
            data.user === undefined ? 1 << 0 : 
            data.user === null ? 1 << 1 : 
            !anp.is_number(data.user) ? 1 << 2 : 
            !anp.is_integer(data.user) ? 1 << 3 : 
            data.user < 1 ? 1 << 4 : 
        0), 10, 0);

        error = anp.errors.set(error, (
            data.belongs === undefined ? 1 << 0 : 
            data.belongs === null ? 1 << 1 : 
        0), 15, 0);

        return error;
    };

    this.save = (item, event) => {

        const [data, form] = anp.comp.forms.get_values(item);

        if(JSON.stringify(data) == cache)
            return;

        const id = Number(anp.get_globals("user_email")),
              key = id ? "edit" : "add";

        id && (data.id = id);  

        if(!anp.errors.validate(form, self.validate(data), "user_email_" + key + "_local_error", [
            "user_email_undefined", 
            "user_email_null", 
            "user_email_not_number", 
            "user_email_not_integer",
            "user_email_not_id" ,
            "email_undefined",
            "email_null",
            "email_not_number",
            "email_not_integer",
            "email_not_id",
            "user_undefined",
            "user_null",
            "user_not_number",
            "user_not_integer",
            "user_not_id",
            "belongs_undefined",
            "belongs_null" 
        ]))
            return;

        anp.confirm("user_email_confirm_changes", () => {
            anp.ajax.send("post", "/app/sessions/users/emails/" + key, data, (response, ok) => {
                if(anp.errors.validate(response.variables.error, "user_email_" + key + "_error", [].concat(
                    anp.sessions.get_errors_list(), 
                    id ? [
                        "user_email_null",
                        "user_email_not_id",
                        "user_email_not_exists",
                        "user_email_deleted"
                    ] : [],
                    [,
                        "email_null",
                        "email_not_id",
                        "email_not_exist",
                        "email_deleted",
                        "user_null",
                        "user_not_id",
                        "user_not_exist",
                        "user_deleted",
                        "belongs_null"
                    ]
                ), "user_email_" + key + "_ok")){
    
                    const i18n_button = form.querySelector("button[data-i18n=i18n_texts]");
    
                    if(i18n_button && i18n_button.hasAttribute("disabled")){
                        response.variables.id && 
                        (window.location = window.location.hash.replace(/\/add$/, "/" + response.variables.id + "/edit"));
                    }else 
                        anp.confirm("user_email_exit_edit", anp.back_edit);
                    
                };
            });
        });

    };

    this.cancel = (item, event) => {
        if(has_changes(item))
            anp.confirm("user_email_has_changes", anp.back_edit, null);
        else 
            anp.back_edit();
    };

    this.refresh_deleted = (item, event) => anp.comp.tables.fill(
        item, 
        "/app/sessions/users/emails/deleted", 
        {}, 
        null, // callback
        "users_emails_refresh_deleted_error", 
        anp.sessions.get_errors_list().concat([])
    );

    this.undelete = (item, event) => anp.confirm("user_email_undelete_confirm", () => {
        anp.ajax.send("post", "/app/sessions/users/emails/undelete", {
            id : anp.comp.tables.get_id(item)
        }, (response, ok) => {
            anp.errors.validate(response.variables.error, "user_email_undelete_error", [].concat(
                anp.sessions.get_errors_list(), [
                    "user_email_null",
                    "user_email_not_id",
                    "user_email_not_exists",
                    "user_email_not_deleted"
                ]
            ), "user_email_undelete_ok") && 
            self.refresh_deleted(item, event);
        });
    });

    this.refresh_history = (item, event) => anp.comp.tables.fill(
        item, 
        "/app/sessions/users/emails/history", 
        {id : Number(anp.get_globals("user_email"))}, 
        null, // callback
        "{error_message}", 
        anp.sessions.get_errors_list().concat([
            anp.sessions.get_errors_list(), [
                "user_email_null",
                "user_email_not_id",
                "user_email_not_exists",
                "user_email_deleted"
            ]
        ])
    );

    this.restore = (item, event) => anp.confirm("user_email_restore_confirm", () => {
        anp.ajax.send("post", "/app/sessions/users/emails/restore", {
            id : anp.comp.tables.get_row_field(item, "plain_id")
        }, (response, ok) => {
            anp.errors.validate(response.variables.error, "user_email_restore_error", [].concat(
                anp.sessions.get_errors_list(), [
                    "user_email_null",
                    "user_email_not_id",
                    "user_email_not_exists",
                    "user_email_not_deleted"
                ]
            ), "user_email_restore_ok") && 
            self.refresh_history(item, event);
        });
    });

    construct();

};