AnPTests = function(input, object){

    const self = this,
          default_settings = {
              nulls : false,
              default_value : null,
              autostart : true,
              position : "body",
              preload_timeout : 2000,
              ajax_timeout : 2000,
              default_settings_files : "/tests/json/AnPTests.settings.json",
              default_i18n_files : [
                  "/tests/json/AnPTests.i18n.english.json",
                  "/tests/json/AnPTests.i18n.espanol.json",
                  "/tests/json/AnPTests.i18n.galego.json"
              ],
              settings_overwrite : false,
              i18n_overwrite : false,
              preload_timeout : 2000,
              default_text : "",
              position : "body",
              show_preload_exception : false,
              hash_alphabet : "123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz",
              hash_length : 13,
              default_language : "english",
              application : "AnPTests",
              url : "https://anp.k3y.pw/tests/",
              object_name : "anp_tests"
          },
          custom = {},
          sentences = {},
          hashes = [],
          attributes_without_value = ["selected"],
          screen = {x : 0, y : 0},
          threads = [];
    let started = false,
        language_selected = null,
        default_language = null,
        parent = null,
        thread = null;

    let object_name = this.object_name;
    let item_self = this.item_self = document;
    let hash_self = this.hash_self;

    const default_value = this.default_value = (_default, nulls) => _default !== undefined && ((typeof nulls == "boolean" ? nulls : settings("nulls", null, false, false)) || _default !== null) ? _default : settings(["default", "default_value"], null, null, true);

    const settings = this.settings = (names, inputs, _default, nulls) => {
        if(!names)
            return default_value(_default, null);

        const l = (names.push ? names : names = [names]).length,
              m = (inputs = (inputs ? inputs.push ? inputs : [inputs] : []).concat([input, custom, default_settings])).length;

        typeof nulls != "boolean" && (nulls = settings("nulls", null, false, false));

        for(let j = 0; j < m; j ++)
            if(typeof inputs[j] == "object")
                for(let i = 0; i < l; i ++)
                    if(names[i] && inputs[j][names[i]] !== undefined && (nulls || inputs[j][names[i]] !== null))
                        return inputs[j][names[i]];
        return default_value(_default, null);
    };

    const load_file = this.load_file = (url, callback) => {

        let ended = false;
        const ajax = new XMLHttpRequest(),
              date = Date.now(),
              end = message => {
                  if(ended)
                      return;
                  (ended = true) && typeof callback == "function" && callback(ajax.responseText, ajax.status, ajax.readyState, message == "OK", message);
              },
              timeout = settings(["ajax_timeout", "timeout"]);

        ajax.open("get", url, true);
        ajax.timeout = timeout;
        ajax.onreadystatechange = () => {
            if(ended)
                return;
            if(ajax.readyState == 4)
                end((ajax.status >= 200 && ajax.status < 300) || [301, 302, 304].includes(ajax.status) ? "OK" : "HTTP_ERROR");
            else if(Date.now() - date > timeout)
                end("FORCED_TIMEOUT");
        };
        ajax.send(null);

        ajax.onerror = () => end("ERROR");
        ajax.onabort = () => end("ABORTED");
        ajax.ontimeout = () => end("TIMEOUT");

        return ajax;
    };

    const settings_load_block = (block, overwrite, callback, i) => {

        if(i >= block.length){
            typeof callback == "function" && callback();
            return;
        };

        const end = () => settings_load_block(block, overwrite, callback, i + 1);

        if(block[i]){
            if(typeof block[i] == "string"){

                let json;

                try{
                    "{[".includes(block[i][0]) && (json = JSON.parse(block[i]));
                }catch(exception){};
                if(!json){
                    load_file(block[i], response => {
                        try{
                            if("{[".includes(response[0]) && (json = JSON.parse(response))){
                                settings_load_block([json], overwrite, end, 0);
                                return;
                            };
                        }catch(exception){};
                        end();
                    });
                    return;
                };

            };
            if(typeof block[i] == "object"){
                if(block[i].push){
                    settings_load_block(block[i], overwrite, end, 0);
                    return;
                };
                for(const key in block[i])
                    (overwrite || custom[key] === undefined) && (custom[key] = block[i][key]);
            };
        };

        end();

    };

    const settings_add = this.settings_add = (items, overwrite, callback) => settings_load_block(items && items.push ? items : [items], typeof overwrite == "boolean" ? overwrite : settings(["settings_overwrite", "overwrite"]), callback, 0);

    const i18n_load_block = (block, overwrite, callback, i) => {

        if(i >= block.length){
            typeof callback == "function" && callback();
            return;
        };

        const end = () => i18n_load_block(block, overwrite, callback, i + 1);

        if(block[i]){
            if(typeof block[i] == "string"){

                let json;

                try{
                    "[{".includes(block[i][0]) && (json = JSON.parse(block[i]));
                }catch(exception){};
                if(!json){
                    load_file(block[i], response => {
                        try{
                            if("{[".includes(response[0]) && (json = JSON.parse(response))){
                                i18n_load_block([json], overwrite, end, 0);
                                return;
                            };
                        }catch(exception){};
                        end();
                    });
                    return;
                };

            };
            if(typeof block[i] == "object"){
                if(block[i].push){
                    i18n_load_block(block[i], overwrite, end, 0);
                    return;
                };
                for(const language in block[i]){
                    !sentences[language] && (sentences[language] = {});
                    for(const key in block[i][language])
                        (overwrite || sentences[language][key] === undefined) && (sentences[language][key] = block[i][language][key]);
                };
            };
        };

        end();

    };

    const i18n_add = this.i18n_add = (items, overwrite, callback) => i18n_load_block(items && items.push ? items : [items], typeof overwrite == "boolean" ? overwrite : settings(["i18n_overwrite", "overwrite"]), callback, 0);

    const is_html_item = this.is_html_item = item => !!(item.tagName || item.nodeName);

    const preload = this.preload = (selector, callback) => {
        if(typeof callback != "function")
            return;

        if(!selector){
            callback(null, false, "NO_ITEM");
            return;
        };
        if(is_html_item(selector)){
            callback(selector, false, "OK");
            return;
        };
        if(typeof selector != "string"){
            callback(null, false, "NO_SELECTOR");
            return;
        };

        let item;

        try{
            if(item = item_self.querySelector(selector)){
                callback(item, false, "OK");
                return;
            };
        }catch(exception){
            settings("show_preload_exception") && console.error(exception);
            callback(null, false, "BAD_SELECTOR");
            return;
        };

        const date = Date.now(),
              timeout = settings(["preload_timeout", "timeout"]),
              preload = setInterval(() => {
                  if(item = item_self.querySelector(selector)){
                      clearInterval(preload);
                      callback(item, true, "OK");
                  }else if(Date.now() - date > timeout){
                      clearInterval(preload);
                      callback(null, true, "TIMEOUT");
                  };
              }, 1000 / settings(["frames_per_second", "fps"]));

    };

    const default_text = this.default_text = _default => _default !== undefined ? _default : settings("default_text");

    const get_i18n = (names, _default) => {
        if(!names)
            return default_text(_default);

        const l = (names.push ? names : names = [names]).length,
              languages = [language_selected, default_language].concat(Object.keys(sentences)),
              m = languages.length;

        for(let j = 0; j < m; j ++)
            if(languages[j] && sentences[languages[j]])
                for(let i = 0; i < l; i ++)
                    if(names[i] && sentences[languages[j]][names[i]] !== undefined)
                        return sentences[languages[j]][names[i]];
        for(let i = 0; i < l; i ++)
            if(names[i] !== undefined)
                return names[i];
        return default_text(_default);
    };

    const string_variables = this.string_variables = (string, variables, _default) => {

        const l = (variables = variables ? variables.push ? variables : [variables] : []).length;

        return ("" + string).replace(/\{([^\{\}]+)\}/g, (...arguments) => {
            if(arguments[1])
                for(let i = 0; i < l; i ++)
                    if(typeof variables[i] == "object" && variables[i][arguments[1]] !== undefined)
                        return variables[i][arguments[1]];
            return arguments[0];
        });
    };

    const i18n = this.i18n = (names, variables, _default) => {

        const text = get_i18n(names, _default);

        return string_variables(typeof text == "object" && text.push ? text.join(" ") : "" + text, variables);
    };

    const hash = this.hash = () => {

        let hash;
        const alphabet = settings(["hash_alphabet", "alphabet"]),
              length = settings(["hash_length", "length"]),
              l = alphabet.length;

        do{
            hash = "";
            while((hash += alphabet[Math.random() * l >> 0]).length < length);
        }while(
            hashes.includes(hash) ||
            /^\d/.test(hash) ||
            document.querySelector("#" + hash + ",." + hash + ",[name=" + hash + "]")
        );
        hashes.push(hash);

        return hash;
    };

    this.init = callback => {

        if(started)
            return;
        started = true;

        object && self.extends(object);

        settings_add(settings("default_settings_files"), true, () => {
            settings_add(settings("settings_files"), true, () => {

                object_name = self.object_name = object.object_name = settings("object_name");

                console.log(custom);

                i18n_add(settings("default_i18n_files"), true, () => {
                    i18n_add(settings("i18n_files"), true, () => {

                        const selector = settings("position");

                        !sentences[language_selected = default_language = settings(["default_language", "language"])] && (language_selected = default_language = Object.keys(sentences)[0]);

                        preload(selector, position => {
                            if(!position){
                                console.error(i18n("anptest_position_error", {selector : selector}));
                                return;
                            };

                            typeof self.build == "function" && position.appendChild(self.build());
                            typeof callback == "function" && callback();
                            ["start", "init", "inititate"].some(key => self[key] && (self[key]() || true));

                        });
                    });
                });

            });
        });

    };

    const construct = () => {

        settings("autostart") && self.init();

    };

    this.extends = object => {
        if(!object)
            return null;

        typeof object == "function" && (object = new object(input, self));

        parent = object;

        for(const key in self)
            !object[key] && (object[key] = self[key]);
        ["start", "init", "inititate", "build"].forEach(key => typeof object[key] == "function" && (self[key] = object[key]));

        return object;
    };

    const thread_method = () => threads.forEach(thread => thread && thread());

    this.threads_start = () => thread === null && (thread = setInterval(thread_method, 1000 / settings(["frames_per_second", "fps"])));

    this.threads_stop = () => {

        if(thread === null)
            return;

        clearInterval(thread);
        thread = null;

    };

    this.threads_add = method => {
        if(typeof method != "function")
            return null;

        let i = 0;
        const l = threads.length;

        for(; i < l; i ++)
            if(!threads[i])
                break;

        threads[i] = method;

        return i;
    };

    this.threads_remove = i => !isNaN(i) && threads[i] && (threads[i] = null);

    this.resize = () => {

        const minimum = Number(item_self.getAttribute("data-minimum-size")) || 0,
              size = screen[screen.x < screen.y ? "x" : "y"] / Number(item_self.getAttribute("data-cells"));

        item_self.style.fontSize = (minimum > size ? minimum : size) + "px";

    };

    const screen_resize = () => {

        if(!item_self)
            return;

        if(screen.x == item_self.offsetWidth && screen.y == item_self.offsetHeight)
            return;

        screen.x = item_self.offsetWidth;
        screen.y = item_self.offsetHeight;

        self.item_self.setAttribute("data-direction", screen.x > screen.y ? "horizontal" : "vertical");

        item_self.getAttribute("data-autosize") == "true" && self.resize();

    };

    this.base = (input, callback) => {

        const preloader = hash();

        if(!input)
            input = {};
        else if(typeof input == "string")
            input = {html : input};
        else if(is_html_item(input))
            input = {position : input};

        item_self = self.item_self = parent.item_self = document.createElement("div");

        const attributes = {
                  id : hash_self = self.hash_self = hash(),
                  class : ("anptest anp-test at " + hash_self + " " + (settings("class", input) || "")).trim(),
                  data_hash : hash_self,
                  data_application : settings("application", input),
                  data_url : settings("url", input),
                  data_autosize : settings("autosize", input),
                  data_cells : settings("cells", input),
                  data_minimum_size : settings("minimum_size", input)
              };

        for(const key in attributes)
            item_self.setAttribute(key.replace(/_/g, "-"), attributes[key]);

        self.threads_start();
        self.threads_add(screen_resize);

        preload("[data-preloader=" + preloader + "]", item => {
            typeof callback == "function" && callback(item.parentNode);
            item.remove();
        });

        item_self.innerHTML = (`
            <header></header>
            <main>` + settings("html", input) + `</main>
            <footer></footer>
            <div data-preloader="` + preloader + `"></div>
        `);

        return item_self;
    };

    const set_input = input => typeof input == "object" ? input : !input ? {} : typeof input == "string" ? {name : input} : {};

    const join_array_dictionaries = array => array ? array.push ? Object.assign.apply(null, [{}].concat(array.filter(item => item && typeof item == "object"))) : array : {};

    const set_attributes = this.set_attributes = (input, exception, only) => {

        let attributes = ``;

        exception = exception ? exception.push ? exception : [exception] : [];
        input = join_array_dictionaries(input);

        (only ? only.push ? only : [only] : Object.keys(input)).forEach(key => !exception.includes(key) && input[key] !== undefined && (attributes += attributes_without_value.includes(key) ? (input[key] ? ` ` + key.replace(/_/g, "-") : ``) : ` ` + key.replace(/_/g, "-") + `="` + input[key] + `"`));

        return attributes;
    };

    const build_input = input => `<input` + set_attributes([input = join_array_dictionaries(input), {
        data_i18n : input.name,
        data_i18n_without : true,
        placeholder : i18n(input.name, input.text) + "..."
    }]) + ` />`;

    this.text = input => build_input([{type : "text"}, input]);

    this.number = input => build_input([{type : "number"}, input]);

    this.selector = input => {

        let options = ``;

        ((input = join_array_dictionaries(input)).options || []).forEach(option => options += `<option` + set_attributes({
            value : option,
            data_i18n : option,
            selected : input.selected && input.selected == option
        }) + `>` + i18n(option) + `</option>`);

        return `<select` + set_attributes(input, "options") + `>` + options + `</select>`;
    };

    this.button = (name, action) => {

        const text = i18n(name);

        return (`
            <button` + set_attributes({
                type : "button",
                data_i18n : name,
                data_i18n_without : true,
                title : text,
                onclick : action
            }) + `>
                <span data-icon="` + name + `"></span>
                <span data-i18n="` + name + `">` + text + `</span>
            </button>
        `);
    };

    this.field = input => {

        !(input = set_input(input)).id && (input.id = hash());

        return (`
            <div class="field">
                <label for="` + input.id + `">
                    <span data-i18n="` + (input = set_input(input)).name + `">` + i18n(input.name) + `</span>
                    <span data-i18n="` + (input = set_input(input)).name + `_description">` + i18n(input.name + "_description") + `</span>
                </label>
                <span class="input" data-i18n="` + input.name + `" data-i18n-without="true" title="` + i18n(input.name, input.text) + `">` + (typeof self[input.type] == "function" ? self[input.type](input) : input.html || ``) + `</span>
            </div>
        `);
    };

    const get_form = this.get_form = form => {

        if(form)
            while((!(form.tagName && form.tagName.toLowerCase() == "form") && !(form.classList && form.classList.contains("form-block"))) && (form = form.parentNode));

        return form || null;
    };

    this.get_form_values = form => {
        if(!(form = get_form(form)))
            return [null, []];

        const values = {};

        form.querySelectorAll("[name]").forEach(item => {

            const type = item.hasAttribute("type") ? item.getAttribute("type").toLowerCase() : "string";

            values[item.getAttribute("name")] = (
                ["number", "numeric", "decimal", "float", "double", "int", "integer", "tinyint", "bigint", "smallint", "mediumint"].includes(type) ? Number(item.value) :
                item.value
            );

        });

        return [form, values];
    };

    construct();

};
