JSReports = function(input){
    // Require html2canvas.min.js, purify.min.js & jspdf.umd.min.js for PDF files.

    const self = this,
          default_settings = {
              nulls : false,
              default_value : null,
              timeout : 2000,
              cache_box : null
          };
    let started = false,
        cache_box = document;

    const base64_to_blob = this.base64_to_blob = (uri, type) => {

        const array = atob(uri.split(",")[1]),
              l = array.length,
              buffer = new ArrayBuffer(l),
              integers = new Uint8Array(buffer);

        for(let i = 0; i < l; i ++)
            buffer[i] = array.charCodeAt(i);

        return new Blob([buffer], {type : type});
    };

    const css_to_html = this.css_to_html = (html, css, callback) => {

        const html_item = cache_box.appendChild(document.createElement("div")),
              cache = cache_box.appendChild(document.createElement("div"));
        let preloader,
            preload = setInterval(() => {
                if(!(preloader = html_item.querySelector(".preload")))
                    return;
                preloader.remove();

                let loaded = 0;
                const images = html_item.querySelectorAll("img"),
                      l = images.length,
                      end = (item, image) => {

                          if(image){

                              const canvas = cache.appendChild(document.createElement("canvas")),
                                    context = canvas.getContext("2d");

                              canvas.setAttribute("width", image.width);
                              canvas.setAttribute("height", image.height);

                              context.drawImage(image, 0, 0, image.width, image.height);
                              item.setAttribute("src", canvas.toDataURL("image/png", 0.9));

                              canvas.remove();

                          };

                          if(++ loaded != l)
                              return;

                          cache.remove();
                          html = html_item.innerHTML;
                          console.log(html.substring(html.length - 2000, html.length));
                          html_item.remove();
                          callback(html);

                      };

                clearInterval(preload);

                css.replace(/\/\*(([^\*]+|[\r\n]+|\*[^\/])*)(\*\/)?|(([^\{]+|[\r\n]+)*)\{(([^\}]+|[\r\n]+)*)\}/g, (...arguments) => {
                    if(arguments[1])
                        return;
                    html_item.querySelectorAll(arguments[4].trim()).forEach(item => item.setAttribute("style", (item.getAttribute("style") || "") + arguments[6].trim().replace(/([\r\n]+\s*)+/g, ";")));
                });

                images.forEach(item => {

                    let image = new Image();

                    image.src = item.getAttribute("src");
                    image.crossOrigin = "anonymous";
                    image.onload = () => end(item, image);
                    image.onerror = () => end(item, null);

                });

            }, 1000 / 24);

        cache.style.position = html_item.style.position = "absolute";
        cache.style.left = html_item.style.left = "100%";
        html_item.innerHTML = html + `<div class="preload"></div>`;

    };

    this.start = () => {

        if(started)
            return;
        started = true;

        const selector = settings("cache_box") || "body";

        if(selector.tagName || selector.nodeName){
            cache_box = selector;
            return;
        };

        let item;

        let preload = setInterval(() => {
            
        })

    };

    const construct = () => {};

};
