<?php

    include __DIR__ . "/../../PHP/include.php";

    class ErrorsTests{

        private $anp;
        private $input;

        public function default_test($codes = [
            [23, 43],
            ["a3", 54],
            [[54, 1], 645],
            [0, 3],
            ['', 5],
            [null, 1]
        ]){

            $bitwise = 0;
            $length = 0;
            $methods = [
                "array",
                "integer",
                "string"
            ];

            foreach($codes as $error){

                $results = [$error[0], $this->anp->errors->set($error[0], $error[1], $bitwise, $length)];
                $array = [];
                $integer = [];
                $string = [];
                $messages = [];
                $has = [];

                foreach($results as $code){
                    $messages[] = [$code, $this->anp->errors->get($code)];
                    $has[] = [$code, $this->anp->errors->has($code)];
                    foreach($methods as $method){
                        $function = "to_" . $method;
                        $result = $this->anp->errors->$function($code);
                        foreach($methods as $submethod){
                            $subfunction = "to_" . $submethod;
                            !isset($$method[$submethod]) && ($$method[$submethod] = []);
                            $$method[$submethod][] = $this->anp->errors->$subfunction($result);
                        };
                    };
                };

                print_r([
                    "results" => $results,
                    "array" => $array,
                    "integer" => $integer,
                    "string" => $string,
                    "messages" => $messages,
                    "has" => $has
                ]);

            };

        }

        private function get_key($names){
            if(!$names)
                return $this->anp->settings->get("default_value");

            !is_array($names) && ($names = [$names]);

            foreach([$_POST, $_GET, $_COOKIE, $this->input] as $set)
                if(is_array($set))
                    foreach($names as $name)
                        if(isset($set[$name]))
                            return $set[$name];
            return $this->anp->settings->get("default_value");
        }

        public function __construct($input = []){
            global $default_test;

            $this->input = $input;
            $this->anp = new AnP(array_merge([], $input));

            if($action = $this->get_key("action")){
                switch($action){
                    case "default":
                    case "default_test":
                        $this->default_test();
                    break;
                };
                exit(0);
            };

        }

    };

    $errors_tests = new ErrorsTests();

    exit(0);

?><!DOCTYPE html>
<html lang="es" dir="ltr">
    <head>
        <title data-i18n="anp_errors_title">Errores - AnP Tests</title>
        <meta http-equiv="content-type" content="text/html; charset=utf-8" />
        <meta charset="utf-8" />
        <meta name="viewport" content="width=device-width,initial-scale=1.0" />
        <link rel="icon" href="/images/AnP-32.png" sizes="32x32" />
        <link rel="icon" href="/images/AnP-192.png" sizes="192x192" />
        <link rel="icon" href="/images/AnP-512.png" sizes="512x512" />
        <link rel="apple-touch-icon-precomposed" href="/images/AnP-180.png" />
        <meta name="msapplication-TileImage" content="/images/AnP-270.png" />

        <meta name="licence:text" content="© 2020-2021 CopyLeft. GPLv3" />
        <meta name="licence:link" content="https://www.gnu.org/licenses/gpl-3.0.txt" />
        <meta name="licence:icon" content="https://www.gnu.org/graphics/gplv3-88x31.png" />

        <meta name="xdoc:link" content="https://anp.k3y.pw/tests/errors.test.php" />
        <meta name="xdoc:author" content="KyMAN" />
        <meta name="xdoc:since" content="20220218" />
        <meta name="xdoc:version" content="20220218" />
        <meta name="xdoc:access" content="public" />

        <meta name="description" data-i18n="anp_errors_description" content="Aplicación de prueba de gestión de errores." />
        <meta name="keywords" data-i18n="anp_errors_keywords" content="anp,attach,play,attach&play,errors,test" />
        <meta name="author" content="KyMAN" />
        <meta name="copyright" content="© 2020-2021 CopyLeft" />
        <meta name="robots" content="index,follow" />
        <meta name="googlebot" content="index,follow,max-snippet:-1,max-image-preview:large,max-video-preview:-1" />
        <meta name="bingbot" content="index,follow,max-snippet:-1,max-image-preview:large,max-video-preview:-1" />
        <!--<meta http-equiv="refresh" content="30" />-->
        <!--<meta http-equiv="cache-control" content="no-cache" />-->
        <!--<meta http-equiv="expires" content="0" />-->
        <link rel="canonical" href="https://anp.k3y.pw/tests/errors.test.php" />
        <link rel="alternate" href="https://anp.k3y.pw/tests/errors.test.php" hreflang="es" />
        <meta property="og:locale:alternate" content="es_ES" />
        <meta name="referrer" content="origin" />
        <meta name="fragment" content="!" /><!-- Para uso AJAX -->
        <meta name="language" content="es" />
        <meta name="revisit-after" content="7 days" /><!-- Regreso de las arañas. Información Crawl. -->
        <meta name="rating" content="general" /><!-- Tipo de contenido: general, mature, restricted, adult, 14 years, safe for kids. -->
        <meta name="author" content="KyMAN" />
        <meta name="owner" content="KyMAN" />

        <meta property="og:locale" content="es_ES" />
        <meta property="og:type" content="website" />
        <meta property="og:title" data-i18n="anp_errors_title" content="Errores - AnP Tests" />
        <meta property="og:description" data-i18n="anp_errors_description" content="Aplicación de prueba de gestión de errores." />
        <meta property="og:url" content="https://anp.k3y.pw/tests/errors.test.php" />
        <meta property="og:site_name" content="AnP" />
        <meta property="og:image" content="https://anp.k3y.pw/images/anp.png" />
        <!--<meta property="fb:admins" content="FB-AppID" />-->
        <meta name="twitter:card" content="summary" />
        <meta name="twitter:description" data-i18n="anp_errors_description" content="Aplicación de prueba de gestión de errores." />
        <meta name="twitter:title" data-i18n="anp_errors_title" content="Errores - AnP Tests" />
        <!--<meta name="twitter:site" content="@AnP" />-->
        <!--<meta name="twitter:creator" content="@AnP" />-->

        <meta name="SKYPE_TOOLBAR" content="SKYPE_TOOLBAR_PARSER_COMPATIBLE" />
        <!--<meta name="google-site-verification" content="123456789" />--><!-- Verificación en el Google Search Console. -->
        <meta name="google" content="nositelinkssearchbox" />
        <link rel="dns-prefetch" href="https://anp.k3y.pw/tests/errors.test.php" />
        <!--<link rel="amphtml" href="https://anp.k3y.pw/tests/errors.test.amp.php" />--><!-- Indica si tiene página para móviles. Tecnología AMP. -->

        <link type="text/css" rel="stylesheet" data-language="CSS3" href="https://cdn.k3y.pw/css/fonts/local/Roboto.css" data-crossorigin="anonymous" charset="utf-8" />
        <link type="text/css" rel="stylesheet" data-language="CSS3" href="https://cdn.k3y.pw/css/fonts/local/RobotoMono.css" data-crossorigin="anonymous" charset="utf-8" />
        <link type="text/css" rel="stylesheet" data-language="CSS3" href="https://cdn.k3y.pw/css/fonts/local/FontAwesome5Free.css" data-crossorigin="anonymous" charset="utf-8" />

        <link type="text/css" rel="stylesheet" data-language="SASS/CSS3" href="/tests/scss/AnPTests.css" data-scss="/tests/scss/AnPTests.scss" data-css-map="/tests/scss/AnPTests.css.map" data-crossorigin="anonymous" charset="utf-8" />
        <link type="text/css" rel="stylesheet" data-language="CSS3" href="/tests/css/AnPTests.icons.css" data-crossorigin="anonymous" charset="utf-8" />

        <style data-type="text/css" data-rel="stylesheet" data-language="CSS3" charset="utf-8">

            html,body{
                height : 100%;
                margin : 0px;
            }

        </style>

        <script data-type="text/javascript" data-language="ECMAScript 2015" src="/tests/ecma/AnPTests.ecma.js" data-crossorigin="anonymous" charset="utf-8"></script>
        <script data-type="text/javascript" data-language="ECMAScript 2015" src="/tests/ecma/Errors.ecma.js" data-crossorigin="anonymous" charset="utf-8"></script>

        <script data-type="text/javascript" data-language="ECMAScript 2015" charset="utf-8">

            errors = new Errors({
                show_preload_exception : true,
                settings_files : "/tests/json/Errors.settings.json",
                i18n_files : [
                    "/tests/json/Errors.i18n.english.json",
                    "/tests/json/Errors.i18n.espanol.json",
                    "/tests/json/Errors.i18n.galego.json"
                ],
                object_name : "errors"
            });

        </script>

    </head>
    <body></body>
</html>
