#!/usr/bin/env python
# -*- coding: utf-8 -*-

from math import ceil

class Anonymous:

    anp = None
    __connections = None

    def __init__(self, anp, input = [], connections = []):
        self.anp = anp
        self.__connections = []

    def __update_field(self, key, table, name, _type, not_null, default_value, foreign = None, snake_name = None):
        if key not in self.__connections:
            return

        tuple = self.__connections[key].query("select * from pragma_table_info(\"" + table + "\") where name = {name} limit 1;", {
            "name" : name
        })["data"][0]["table"]

        if len(tuple):
            tuple = tuple[0]
            if tuple["type"] != _type or (tuple["notnull"] == "1") != not_null or tuple["dflt_value"] != default_value:
                self.__connections[key].query("alter table \"" + table + "\" alter column \"" + name + "\" " + _type + (" not null" if not_null else "") + (" default " + default_value if default_value != None else ""))
        else:
            self.__connections[key].query("alter table \"" + table + "\" add column \"" + name + "\" " + _type + (" not null" if not_null else "") + (" default " + default_value if default_value != None else ""))
            foreign != None and self.__connections[key].query("alter table \"" + table + "\" add constraint " + snake_name + "_" + name + " foreign key(\"" + name + "\") references \"" + foreign + "\"(id);")

    def __session_validate(self, session):
        return 0

    def __has_permissions(self, session, permissions):
        return 0

    def __exception(self, session, database, procedure, parameters, error):
        pass

    def __log(self, session, database, procedure, parameters, error):
        pass

    def set_error(self, error, code, bit = 0, length = 0):
        return self.anp.errors.set(error, code, bit, length)

    def has_error(self, error):
        return self.anp.errors.has(error)

    def set_errors(self, error, code, bit = 0, length = 0):
        return self.set_error(error, code, bit, length)

    def has_errors(self, error, code):
        return self.has_error(error, code)

    def set_where(self, where):
        return ""

    def set_order_by(self, order_by):
        return ""

    def __list(self, session, database, procedure, key, parameters, permissions, error, view, page, items_per_page, where, order_by):

        data = []
        items = 0
        pages = 0

        try:

            error = self.set_error(error, self.__session_validate(session), 1)
            error = self.set_error(error, self.__has_permissions(session, permissions), 9)
            error = self.set_error(error, (
                1 << 0 if page == None else 
                1 << 1 if page < 1 else 
                0
            ) | (
                1 << 2 if items_per_page == None else 
                1 << 3 if items_per_page < 1 else 
                0
            ), 10)

            if not self.has_error(error):
                where = self.set_where(where)
                order_by = self.set_order_by(order_by)

                items = len(self.__connections[key].query(
                    "select count(1) as rows from \"" + view + "\" \"table\"" + 
                    (" where " + where if where else "") + ";"
                )["data"][0]["tables"])
                pages = ceil(items / items_per_page * 1.0)

                data = self.__connections[key].query(
                    "select row_number() over(order by " + (order_by if order_by else "id asc") + ") as i, * from \"" + view + "\" \"table\"" + 
                    (" where " + where if where else "") + 
                    (" order by " + order_by if order_by else "") + 
                    " limit " + page + ", " + ((page * items_per_page) + items_per_page) + ";"
                )["data"][0]["tables"]
        
        except:
            error = self.set_error(error, 1, 0)
            self.__exception(session, database, procedure, parameters, error)

        return {
            "error" : error,
            "data" : data,
            "items" : items,
            "pages" : pages,
            "results" : len(data)
        }

    def __settings_get(self, name, default):
        return default

    def __get_procedure(self, database, procedure):
        return 1

if "AnP" not in globals():
    class AnP:
        pass
if not hasattr(AnP, "Abstracts"):
    class Abstracts:
        pass
    AnP.Abstracts = Abstracts
    del globals()["Abstracts"]
AnP.Abstracts.SQLite = Anonymous
del globals()["Anonymous"]