#!/usr/bin/env python
# -*- coding: utf-8 -*-

class Anonymous:

    anp = None
    __callbacks = []
    __l = 0
    __default_callbacks = []

    def add(self, callback, parameters = None):

        if AnP.is_dictionary(callback):
            if AnP.is_dictionary(parameters):
                parameters += callback
            else:
                parameters = callback
            if "callback" not in parameters:
                return None

        if not AnP.is_function(callback):
            if "callback" not in parameters:
                return None
            callback = parameters["callback"]
        elif parameters and AnP.is_dictionary(parameters) and "callback" not in parameters:
            parameters["callback"] = callback

        i = 0
        data = {
            "callback" : callback,
            "parameters" : parameters
        }

        while i < self.__l and self.__callbacks[i]:
            i += 1

        if i != self.__l:
            self.__callbacks[i] = data
        else:
            self.__callbacks.append(data)
            self.__l = len(self.__callbacks)

        return i

    def __init__(self, anp, callbacks = None):
        self.anp = anp

        if callbacks:
            for callback in callbacks if AnP.is_array(callbacks) else [callbacks]:
                self.__default_callbacks.append(self.add(callback))

    def execute(self, data = None):
        for callback in self.__callbacks:
            if callback:
                callback["callback"](data, callback["parameters"])

    def remove(self, i):
        if AnP.is_integer(i) and i >= 0 and i < self.__l and self.__callbacks[i]:
            self.__callbacks[i] = None

    def remove_default_callbacks(self):
        for i in self.__default_callbacks:
            self.remove(i)
        self.__default_callbacks = []

    def get_default_callbacks(self):
        return self.__default_callbacks[0:] if len(self.__default_callbacks) != 0 else []

if "AnP" not in globals():
    class AnP:
        pass
AnP.Callbacks = Anonymous
del globals()["Anonymous"]
