#!/usr/bin/env python
# -*- coding: utf-8 -*-

from re import compile as re_compile

class Anonymous: # AnP.Errors

    anp = None
    __base64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"

    __re_email = re_compile(r'^[^\@]+\@[^\.]+(\.[^\.]+)*?$')

    def __init__(self, anp, input = []):
        self.anp = anp

        self.anp._print("ok", "errors_module_built")

    @staticmethod
    def null_or_empty(value, length = None):
        return "001" if value == None else "010" if value == "" else "100" if length != None and len(value) > length else "000"
    @classmethod
    def empty(self, value, length = None):
        return self.null_or_empty(value, length)
    @classmethod
    def email(self, address):

        error = self.null_or_empty(address)

        if error != "000":
            return error
        return 0 if self.__re_email.match(address) else "100"

    @classmethod
    def integer(self, value):

        error = self.null_or_empty(value)

        return error if error != "000" else "000" if AnP.is_integer(value) else "100"

    @classmethod
    def number(self, value):

        error = self.null_or_empty(value)

        return error if error != "000" else"000" if AnP.is_number(value) else "100"

    @classmethod
    def id(self, value):

        error = self.integer(value)

        return "0" + error if error != "000" else "0000" if value > 0 else "1000"

    @staticmethod
    def bool(value):
        return "01" if value == None else "00" if AnP.is_bool(value) else "10"

    @classmethod
    def base64(self, error, length = None):
        if isinstance(error, (list, tuple)):

            code = ""

            for suberror in error:
                code += self.base64(suberror, length)

            return code

        if AnP.is_string(error):

            i = 0
            code = ""
            l = length or len(error)
            error = error [::-1]

            while i < l:
                code += self.__base64[int((error[i:i + 6] + "000000")[0:6][::-1], 2)]
                i += 6

            return code

        if isinstance(error, int):

            i = 0
            code = ""

            while (length and i < length) or error >> i:
                code += self.__base64[(error >> i) & ((1 << 6) - 1)]
                i += 6

            return code

    @classmethod
    def binary(self, error, length = None):
        if isinstance(error, int):

            l = 

    def process(self, error, messages, variables = None):

        ok = True

        if self.anp.is_string(error):

            i = 0
            l = len(messages)

            for i in error:

                code = self.__base64.find(i)

                if code:
                    for j in range(6):
                        if code & (1 << j):
                            ok = False
                            self.anp._print("warn", messages[i + j], variables)

        elif error:

            ended = False

            for j, code in enumerate(error if isinstance(error, (list, tuple)) else [error]):

                x = j * 24

                for k in range(24):

                    y = 1 << (k + x)

                    if error <= y:
                        ended = True
                        break
                    if error & y:
                        ok = False
                        self.anp._print("warn", messages[y], variables)

                if ended:
                    break

        return ok

if "AnP" not in globals():
    class AnP:
        pass
AnP.Errors = Anonymous
del globals()["Anonymous"]
