#!/usr/bin/env python
# -*- coding: utf-8 -*-

class Anonymous: # AnP.Logs

    __logs = []
    __started = False
    __thread = None

    def __init__(self, anp, input = None):
        self.anp = anp

        self.anp._print("ok", "The Logs module was built.")

    def update(self):
        if not self.anp.procedure_exists("logs") or len(self.__logs) == 0:
            return

        logs = self.__logs.copy()

        self.anp.procedure_get("logs").to_print(logs)
        self.__logs = self.__logs[len(logs):]

    def __thread_method(self, data, i):
        self.update()

    def start(self):
        if not hasattr(self.anp, "threads") or not self.anp.threads:
            return

        self.anp._print("info", "logs_starting")

        if self.__thread != None:
            self.anp._print("info", "logs_already_started")
            return

        self.__thread = self.anp.threads.add(self.__thread_method, 1000.0 / self.anp.settings.get("logs_save_time"))

        self.anp._print("ok", "logs_started")

    def stop(self):

        self.anp._print("info", "logs_stopping")

        if self.__thread == None:
            self.anp._print("info", "logs_already_stopped")
            return

        self.anp.threads.remove(self.__thread)
        self.__thread = None

        self.anp._print("ok", "logs_stopped")

    def add(self, type, date, text, variables, trace):
        if self.anp.logs_in_stream():
            if not self.anp.is_closing():
                self.anp.procedure_get("logs").to_print({
                    "type" : type,
                    "date" : date,
                    "text" : text,
                    "variables" : variables,
                    "trace" : trace
                })
        else:
            self.__logs.append({
                "type" : type,
                "date" : date,
                "text" : text,
                "variables" : variables,
                "trace" : trace
            })

if "AnP" not in globals():
    class AnP:
        pass
if not hasattr(AnP, "Logs"):
    AnP.Logs = Anonymous
del globals()["Anonymous"]
