#!/usr/bin/env python
# -*- coding: utf-8 -*-

from os.path import dirname as directory_name
from os.path import abspath as path_absolute
from os.path import exists as path_exists

if "root" not in globals():
    root = directory_name(path_absolute(__file__)) + "/"
if "libraries" not in globals():
    libraries_allowed = None

limit_libraries = isinstance(libraries_allowed, (list, tuple))

for file in libraries if "libraries" in globals() else [
    "AnP.Common", "AnP", "AnP.Settings", "AnP.I18N", "Drivers/AnP.Drivers.SQLite",

    "Procedures/AnP.Procedures.Users", "Procedures/AnP.Procedures.Logs",
    "Procedures/AnP.Procedures.Groups", "Procedures/AnP.Procedures.Permissions",

    "AnP.Callbacks", "AnP.Threads", "AnP.Terminals", "AnP.Logs", "AnP.Files", "AnP.Controller",
    "AnP.Controllers", "AnP.Errors", "AnP.Routes", "AnP.WebServers",

    "Controllers/AnP.Controllers.Users"
]:
    if limit_libraries and file not in libraries_allowed:
        print(["un", file])
        continue
    path = root + file + ".py"
    if path_exists(path):
        print(["ok", path])
        with open(path, "rb") as data:
            exec(compile(data.read(), file, "exec"), globals())
    else:
        print(["no", path])
