#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Script que testea la implementación de la parte estática de AnP.

from os.path import dirname as directory_name
from os.path import abspath as path_absolute
from os.path import exists as path_exists

root = directory_name(path_absolute(__file__)) + "/../../Python/"
path = root + "include.py"

if path_exists(path):
    with open(path) as data:
        exec(compile(data.read(), "include", "exec"), globals())

class Proyecto(AnP):

    __web_servers = {}

    def __init__(self, input = None):
        super().__init__(input)

        if AnP.is_dictionary(input):
            if "web_servers" in input:
                for web_server in input["web_servers"] if AnP.is_array(input["web_servers"]) else [input["web_servers"]]:
                    self.__web_servers[web_server["name"]] = AnP.WebServers(self, web_server)

proyecto = Proyecto({
    "secrets_files" : directory_name(path_absolute(__file__)) + "/../../../Secrets/AnP.secrets.json",
    "web_servers" : [{
        "name" : "AnP",
        "port" : 49343,
        "hosts" : "localhost",
        "simultaneous_connections" : 100
    }]
})

print("Sí" if Proyecto.python3() else "No")
