#!/usr/bin/env python
# -*- coding: utf-8 -*-

from os.path import dirname as directory_name
from os.path import abspath as path_absolute
from os.path import exists as path_exists

root = directory_name(path_absolute(__file__)) + "/../../Python/"
path = root + "include.py"

if path_exists(path):
    with open(path) as data:
        exec(compile(data.read(), "include", "exec"), globals())

anp_root = "D:\\git\\AnP"

anp = AnP({
	"roots" : [anp_root],
	"settings_files" : anp_root + "/JSON/AnP.py.settings.json",
	"secrets_files" : anp_root + "/JSON/AnP.py.secrets.json"
})

results = anp.errors.tests(1 << 1)
formatted = ""

# length = {
#     "integer" : 10,
#     "string" : 7,
#     "array" : 22
# }
#
# for i, result in enumerate(results["types"]):
#     formatted += "\n\ni => " + str(i)
#     for method, level in result.items():
#         formatted += "\n" + ("     " + method)[-8:] + ": "
#         for _type, value in level.items():
#             formatted += ("                        " + str(value))[-length[_type]:]
# formatted += "\n\n"

print(results)
