@echo off

set "transact_sql_host=127.0.0.1"
set "transact_sql_port=1433"
set "transact_sql_user=sa"
set "transact_sql_password="

if exist Secrets.cmd (
    call Secrets.cmd
)

where sqlcmd > NUL
if %errorlevel% neq 0 (
    echo "Please, install 'sqlcmd' for use the Scripts via CMD."
) else (
    for %%f in (10.common 11.initial_data 12.errors 13.initial_sessions) do (
        echo %cd%\..\TransactSQL\AnP.1.%%f.transact.sql
        sqlcmd -S %transact_sql_host%,%transact_sql_port% -U %transact_sql_user% -P %transact_sql_password% -i %cd%\..\TransactSQL\AnP.1.%%f.transact.sql
    )
    for %%f in (20.base) do (
        echo %cd%\..\TransactSQL\AnP.4.%%f.transact.sql
        sqlcmd -S %transact_sql_host%,%transact_sql_port% -U %transact_sql_user% -P %transact_sql_password% -i %cd%\..\TransactSQL\AnP.4.%%f.transact.sql
    )
    for /D %%d in (%cd%\..\TransactSQL\AnP.5.*) do (
        for %%f in (%%d\*.sql) do (
            echo %%f
            sqlcmd -S %transact_sql_host%,%transact_sql_port% -U %transact_sql_user% -P %transact_sql_password% -i %%f
        )
    )
    for %%f in (30.full 31.sessions) do (
        echo %cd%\..\TransactSQL\AnP.6.%%f.transact.sql
        sqlcmd -S %transact_sql_host%,%transact_sql_port% -U %transact_sql_user% -P %transact_sql_password% -i %cd%\..\TransactSQL\AnP.6.%%f.transact.sql
    )
)