#!/bin/bash

directory=`dirname $(readlink -f "$0")`

if command -v sqlcmd &> /dev/null; then

	transact_sql_host="127.0.0.1"
	transact_sql_port="1433"
	transact_sql_user="sa"
	transact_sql_password=""

	[[ -f Secrets.sh ]] && source Secrets.sh

	for i in $(find $directory/../TransactSQL -type f|grep .sql|sort|cat); do
		echo $i
        sqlcmd -S $transact_sql_host,$transact_sql_port -U $transact_sql_user -P $transact_sql_password -i $i -C
    done

else
	echo "Please, install 'sqlcmd'."
fi
