if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.common_tables_delete', N'P') is not null drop procedure dbo.common_tables_delete
go
create procedure dbo.common_tables_delete 
	@session integer
as begin 

	set nocount on

	-- Level 3.
	if object_id(N'dbo._Users', N'U') is not null drop table dbo._Users
	if object_id(N'dbo._Ips', N'U') is not null drop table dbo._Ips
	if object_id(N'dbo._SettingsTypes', N'U') is not null drop table dbo._SettingsTypes
	if object_id(N'dbo._Settings', N'U') is not null drop table dbo._Settings
	if object_id(N'dbo._SessionsIps', N'U') is not null drop table dbo._SessionsIps
	if object_id(N'dbo._SessionsUsersAgents', N'U') is not null drop table dbo._SessionsUsersAgents

	-- Level 2.
	if object_id(N'dbo.UsersData', N'U') is not null drop table dbo.UsersData
	if object_id(N'dbo.IpsData', N'U') is not null drop table dbo.IpsData
	if object_id(N'dbo.SettingsTypesData', N'U') is not null drop table dbo.SettingsTypesData
	if object_id(N'dbo.SettingsData', N'U') is not null drop table dbo.SettingsData
	if object_id(N'dbo.Logs', N'U') is not null drop table dbo.Logs
	if object_id(N'dbo.Exceptions', N'U') is not null drop table dbo.Exceptions
	if object_id(N'dbo.Traces', N'U') is not null drop table dbo.Traces
	if object_id(N'dbo.SessionsIpsData', N'U') is not null drop table dbo.SessionsIpsData
	if object_id(N'dbo.SessionsUsersAgentsData', N'U') is not null drop table dbo.SessionsUsersAgentsData
	if object_id(N'dbo.LoginsTries', N'U') is not null drop table dbo.LoginsTries
	if object_id(N'dbo.Terminal', N'U') is not null drop table dbo.Terminal

	-- Level 1.
	if object_id(N'dbo.[Procedures]', N'U') is not null drop table dbo.[Procedures]
	if object_id(N'dbo.[Sessions]', N'U') is not null drop table dbo.[Sessions]
	if object_id(N'dbo.ErrorsMessages', N'U') is not null drop table dbo.ErrorsMessages

	-- Level 0.
	if object_id(N'dbo.[Databases]', N'U') is not null drop table dbo.[Databases]
	if object_id(N'dbo.Users', N'U') is not null drop table dbo.Users
	if object_id(N'dbo.Ips', N'U') is not null drop table dbo.Ips
	if object_id(N'dbo.SettingsTypes', N'U') is not null drop table dbo.SettingsTypes
	if object_id(N'dbo.Errors', N'U') is not null drop table dbo.Errors
	if object_id(N'dbo.[Parameters]', N'U') is not null drop table dbo.[Parameters]
	if object_id(N'dbo.[Messages]', N'U') is not null drop table dbo.[Messages]
	if object_id(N'dbo.Projects', N'U') is not null drop table dbo.Projects
	if object_id(N'dbo.TracesFiles', N'U') is not null drop table dbo.TracesFiles
	if object_id(N'dbo.Lines', N'U') is not null drop table dbo.Lines
	if object_id(N'dbo.Settings', N'U') is not null drop table dbo.Settings
	if object_id(N'dbo.UsersAgents', N'U') is not null drop table dbo.UsersAgents
	if object_id(N'dbo.SessionsIps', N'U') is not null drop table dbo.SessionsIps
	if object_id(N'dbo.SessionsUsersAgents', N'U') is not null drop table dbo.SessionsUsersAgents
	if object_id(N'dbo.ErrorsMessagesGroups', N'U') is not null drop table dbo.ErrorsMessagesGroups
	if object_id(N'dbo.ErrorsTemporaryGroups', N'U') is not null drop table dbo.ErrorsTemporaryGroups
	if object_id(N'dbo.ErrorsTemporaryMessages', N'U') is not null drop table dbo.ErrorsTemporaryMessages
	if object_id(N'dbo.TerminalData', N'U') is not null drop table dbo.TerminalData

end
go

if object_id(N'dbo.common_tables_create', N'P') is not null drop procedure dbo.common_tables_create
go
create procedure dbo.common_tables_create 
	@session integer
as begin 

	set nocount on

	-- Level 0.
	if object_id(N'dbo.[Databases]', N'U') is null create table dbo.[Databases](
		id integer not null identity(1, 1),
		[name] varchar(64) not null,
		date_in datetime not null constraint databases_date_in default getdate(),
		date_out datetime,
		constraint databases_id primary key(id)
	)
	
	if object_id(N'dbo.Users', N'U') is null create table dbo.Users(
		id integer not null identity(1, 1),
		date_in datetime not null constraint users_date_in default getdate(),
		date_out datetime,
		constraint users_id primary key(id)
	)
	
	if object_id(N'dbo.Ips', N'U') is null create table dbo.Ips(
		id integer not null identity(1, 1),
		date_in datetime not null constraint ips_date_in default getdate(),
		date_out datetime,
		constraint ips_id primary key(id)
	)
	
	if object_id(N'dbo.SettingsTypes', N'U') is null create table dbo.SettingsTypes(
		id integer not null identity(1, 1),
		date_in datetime not null constraint settings_types_date_in default getdate(),
		date_out datetime,
		constraint settings_types_id primary key(id)
	)
	
	if object_id(N'dbo.Errors', N'U') is null create table dbo.Errors(
		id integer not null identity(1, 1),
		code varchar(512) not null,
		[description] varchar(512),
		date_in datetime not null constraint errors_date_in default getdate(),
		date_out datetime,
		constraint errors_id primary key(id)
	)
	
	if object_id(N'dbo.[Parameters]', N'U') is null create table dbo.[Parameters](
		id integer not null identity(1, 1),
		[json] varchar(max) not null,
		[description] varchar(512),
		date_in datetime not null constraint parameters_date_in default getdate(),
		date_out datetime,
		constraint parameters_id primary key(id)
	)
	
	if object_id(N'dbo.[Messages]', N'U') is null create table dbo.[Messages](
		id integer not null identity(1, 1),
		[text] varchar(max) not null,
		[description] varchar(512),
		date_in datetime not null constraint messages_date_in default getdate(),
		date_out datetime,
		constraint messages_id primary key(id)
	)
	
	if object_id(N'dbo.Projects', N'U') is null create table dbo.Projects(
		id integer not null identity(1, 1),
		[name] varchar(64) not null,
		[description] varchar(512),
		date_in datetime not null constraint projects_date_in default getdate(),
		date_out datetime,
		constraint projects_id primary key(id)
	)
	
	if object_id(N'dbo.TracesFiles', N'U') is null create table dbo.TracesFiles(
		id integer not null identity(1, 1),
		[path] varchar(512) not null,
		[description] varchar(512),
		date_in datetime not null constraint traces_files_date_in default getdate(),
		date_out datetime,
		constraint traces_files_id primary key(id)
	)
	
	if object_id(N'dbo.Lines', N'U') is null create table dbo.Lines(
		id integer not null identity(1, 1),
		trace varchar(max) not null,
		[description] varchar(512),
		date_in datetime not null constraint lines_date_in default getdate(),
		date_out datetime,
		constraint lines_id primary key(id)
	)
	
	if object_id(N'dbo.Settings', N'U') is null create table dbo.Settings(
		id integer not null identity(1, 1),
		date_in datetime not null constraint settings_date_in default getdate(),
		date_out datetime,
		constraint settings_id primary key(id)
	)
	
	if object_id(N'dbo.UsersAgents', N'U') is null create table dbo.UsersAgents(
		id integer not null identity(1, 1),
		[data] varchar(max) not null,
		date_in datetime not null constraint users_agents_date_in default getdate(),
		date_out datetime,
		constraint users_agents_id primary key(id)
	)
	
	if object_id(N'dbo.ErrorsMessagesGroups', N'U') is null create table dbo.ErrorsMessagesGroups(
		id integer not null identity(1, 1),
		[name] varchar(64) not null,
		[description] varchar(512),
		date_in datetime not null constraint errors_messages_groups_date_in default getdate(),
		date_out datetime,
		constraint errors_messages_groups_id primary key(id)
	)

	if object_id(N'dbo.SessionsIps', N'U') is null create table dbo.SessionsIps(
		id integer not null identity(1, 1),
		date_in datetime not null constraint sessions_ips_date_in default getdate(),
		date_out datetime,
		constraint sessions_ips_id primary key(id)
	)

	if object_id(N'dbo.SessionsUsersAgents', N'U') is null create table dbo.SessionsUsersAgents(
		id integer not null identity(1, 1),
		date_in datetime not null constraint sessions_users_agents_date_in default getdate(),
		date_out datetime,
		constraint sessions_users_agents_id primary key(id)
	)

	if object_id(N'dbo.ErrorsTemporaryGroups', N'U') is null create table dbo.ErrorsTemporaryGroups(
		id integer not null identity(1, 1),
		i integer not null,
		[name] varchar(64) not null,
		date_in datetime not null constraint errors_temporary_groups_date_in default getdate(),
		date_out datetime,
		constraint errors_temporary_groups_id primary key(id)
	)

	if object_id(N'dbo.ErrorsTemporaryMessages', N'U') is null create table dbo.ErrorsTemporaryMessages(
		id integer not null identity(1, 1),
		[group] integer not null,
		i smallint,
		[message] varchar(64),
		date_in datetime not null constraint errors_temporary_messages_date_in default getdate(),
		date_out datetime,
		constraint errors_temporary_messages_id primary key(id)
	)

	if object_id(N'dbo.ErrorsTemporaryMessages', N'U') is null create table dbo.ErrorsTemporaryMessages(
		id integer not null identity(1, 1),
		[group] integer not null,
		i smallint,
		[message] varchar(64),
		date_in datetime not null constraint errors_temporary_messages_date_in default getdate(),
		date_out datetime,
		constraint errors_temporary_messages_id primary key(id)
	)

	if object_id(N'dbo.TerminalData', N'U') is null create table dbo.TerminalData(
		id integer not null identity(1, 1),
		[data] varchar(max),
		date_in datetime not null constraint terminal_data_date_in default getdate(),
		date_out datetime,
		constraint terminal_data_id primary key(id)
	)

	-- Level 1.
	if object_id(N'dbo.[Procedures]', N'U') is null create table dbo.[Procedures](
		id integer not null identity(1, 1),
		[database] integer not null,
		[name] varchar(64) not null,
		deleted datetime,
		date_in datetime not null constraint procedures_date_in default getdate(),
		date_out datetime,
		constraint procedures_id primary key(id),
		constraint procedures_database foreign key([database]) references dbo.[Databases](id)
	)
	
	if object_id(N'dbo.[Sessions]', N'U') is null create table dbo.[Sessions](
		id integer not null identity(1, 1),
		[user] integer not null,
		date_last datetime not null constraint sessions_date_last default getdate(),
		date_in datetime not null constraint sessions_date_in default getdate(),
		date_out datetime,
		constraint sessions_id primary key(id),
		constraint sessions_user foreign key([user]) references dbo.Users(id)
	)
	
	if object_id(N'dbo.ErrorsMessages', N'U') is null create table dbo.ErrorsMessages(
		id integer not null identity(1, 1),
		[group] integer not null,
		i integer not null,
		[name] varchar(64) not null,
		date_in datetime not null constraint errors_messages_date_in default getdate(),
		date_out datetime,
		constraint errors_messages_id primary key(id),
		constraint errors_messages_group foreign key([group]) references dbo.ErrorsMessagesGroups(id)
	)

	-- Level 2.
	if object_id(N'dbo.LoginsTries', N'U') is null create table dbo.LoginsTries(
		id integer not null identity(1, 1),
		[session] integer not null,
		[user] integer not null,
		[ip] integer not null,
		i integer not null constraint logins_tries_i default 0,
		date_in datetime not null constraint logins_tries_date_in default getdate(),
		date_out datetime,
		constraint logins_tries_id primary key(id),
		constraint logins_tries_session foreign key([session]) references dbo.[Sessions](id),
		constraint logins_tries_user foreign key([user]) references dbo.Users(id),
		constraint logins_tries_ip foreign key([ip]) references dbo.Ips(id)
	)

	if object_id(N'dbo.UsersData', N'U') is null create table dbo.UsersData(
		id integer not null identity(1, 1),
		[procedure] integer not null,
		[session] integer not null,
		entity integer not null,
		nick varchar(32) not null,
		[password] varchar(256) not null,
		accessible bit not null constraint users_accessible_data default 0,
		deleted datetime,
		date_in datetime not null constraint users_data_date_in default getdate(),
		date_out datetime,
		constraint users_data_id primary key(id),
		constraint users_data_procedure foreign key([procedure]) references dbo.[Procedures](id),
		constraint users_data_session foreign key([session]) references dbo.[Sessions](id),
		constraint users_data_entity foreign key(entity) references dbo.Users(id)
	)
	
	if object_id(N'dbo.IpsData', N'U') is null create table dbo.IpsData(
		id integer not null identity(1, 1),
		[procedure] integer not null,
		[session] integer not null,
		entity integer not null,
		[address] varchar(39) not null,
		accessible bit not null constraint ips_accessible_data default 1,
		deleted datetime,
		date_in datetime not null constraint ips_data_date_in default getdate(),
		date_out datetime,
		constraint ips_data_id primary key(id),
		constraint ips_data_procedure foreign key([procedure]) references dbo.[Procedures](id),
		constraint ips_data_session foreign key([session]) references dbo.[Sessions](id),
		constraint ips_data_entity foreign key(entity) references dbo.Ips(id)
	)
	
	if object_id(N'dbo.SettingsTypesData', N'U') is null create table dbo.SettingsTypesData(
		id integer not null identity(1, 1),
		[procedure] integer not null,
		[session] integer not null,
		entity integer not null,
		[name] varchar(64) not null,
		[description] varchar(max),
		deleted datetime,
		date_in datetime not null constraint settings_types_data_date_in default getdate(),
		date_out datetime,
		constraint settings_types_data_id primary key(id),
		constraint settings_types_data_procedure foreign key([procedure]) references dbo.[Procedures](id),
		constraint settings_types_data_session foreign key([session]) references dbo.[Sessions](id),
		constraint settings_types_data_entity foreign key(entity) references dbo.SettingsTypes(id)
	)
	
	if object_id(N'dbo.SettingsData', N'U') is null create table dbo.SettingsData(
		id integer not null identity(1, 1),
		[procedure] integer not null,
		[session] integer not null,
		entity integer not null,
		[type] integer not null,
		[name] varchar(64) not null,
		[range] integer not null constraint settings_range_data default 1,
		[value] varchar(max),
		[description] varchar(max),
		deleted datetime,
		date_in datetime not null constraint settings_data_date_in default getdate(),
		date_out datetime,
		constraint settings_data_id primary key(id),
		constraint settings_data_procedure foreign key([procedure]) references dbo.[Procedures](id),
		constraint settings_data_session foreign key([session]) references dbo.[Sessions](id),
		constraint settings_data_entity foreign key(entity) references dbo.Settings(id),
		constraint settings_data_type foreign key([type]) references dbo.SettingsTypes(id)
	)
	
	if object_id(N'dbo.Logs', N'U') is null create table dbo.Logs(
		id integer not null identity(1, 1),
		[procedure] integer not null,
		[session] integer not null,
		[ip] integer,
		user_agent integer,
		own_error integer not null,
		own_parameters integer not null,
		deleted datetime,
		date_in datetime not null constraint logs_date_in default getdate(),
		date_out datetime,
		constraint logs_id primary key(id),
		constraint logs_procedure foreign key([procedure]) references dbo.[Procedures](id),
		constraint logs_session foreign key([session]) references dbo.[Sessions](id),
		constraint logs_ip foreign key([ip]) references dbo.Ips(id),
		constraint logs_user_agent foreign key(user_agent) references dbo.UsersAgents(id),
		constraint logs_own_error foreign key(own_error) references dbo.Errors(id),
		constraint logs_own_parameters foreign key(own_parameters) references dbo.[Parameters](id)
	)
	
	if object_id(N'dbo.Exceptions', N'U') is null create table dbo.Exceptions(
		id integer not null identity(1, 1),
		[procedure] integer not null,
		[session] integer not null,
		[ip] integer,
		user_agent integer,
		own_error integer not null,
		own_parameters integer not null,
		[message] integer not null,
		[status] varchar(16) not null,
		code integer not null,
		deleted datetime,
		date_in datetime not null constraint exceptions_date_in default getdate(),
		date_out datetime,
		constraint exceptions_id primary key(id),
		constraint exceptions_procedure foreign key([procedure]) references dbo.[Procedures](id),
		constraint exceptions_session foreign key([session]) references dbo.[Sessions](id),
		constraint exceptions_ip foreign key([ip]) references dbo.Ips(id),
		constraint exceptions_user_agent foreign key(user_agent) references dbo.UsersAgents(id),
		constraint exceptions_own_error foreign key(own_error) references dbo.Errors(id),
		constraint exceptions_own_parameters foreign key(own_parameters) references dbo.[Parameters](id),
		constraint exceptions_message foreign key([message]) references dbo.[Messages](id)
	)

	if object_id(N'dbo.Traces', N'U') is null create table dbo.[Traces](
		id integer not null identity(1, 1),
		[session] integer,
		[ip] integer, 
		user_agent integer,
		project integer not null,
		[file] integer not null,
		own_error integer not null,
		own_parameters integer not null,
		trace integer not null,
		[message] integer not null,
		line integer not null,
		deleted datetime,
		date_in datetime not null constraint traces_date_in default getdate(),
		date_out datetime,
		constraint traces_id primary key(id), 
		constraint traces_session foreign key([session]) references dbo.[Sessions](id),
		constraint traces_ip foreign key([ip]) references dbo.Ips(id),
		constraint traces_user_agent foreign key(user_agent) references dbo.UsersAgents(id),
		constraint traces_project foreign key(project) references dbo.Projects(id),
		constraint traces_file foreign key([file]) references dbo.TracesFiles(id),
		constraint traces_own_error foreign key(own_error) references dbo.Errors(id),
		constraint traces_own_parameters foreign key(own_parameters) references dbo.[Parameters](id),
		constraint traces_trace foreign key(trace) references dbo.Lines(id), 
		constraint traces_message foreign key([message]) references dbo.[Messages](id)
	)
	
	if object_id(N'dbo.SessionsIpsData', N'U') is null create table dbo.SessionsIpsData(
		id integer not null identity(1, 1),
		entity integer not null,
		[session] integer not null,
		[ip] integer not null,
		ok bit not null,
		deleted datetime,
		date_in datetime not null constraint sessions_ips_data_date_in default getdate(),
		date_out datetime,
		constraint sessions_ips_data_id primary key(id),
		constraint sessions_ips_data_entity foreign key(entity) references dbo.SessionsIps(id),
		constraint sessions_ips_data_session foreign key([session]) references dbo.[Sessions](id),
		constraint sessions_ips_data_ip foreign key([ip]) references dbo.Ips(id)
	)
	
	if object_id(N'dbo.SessionsUsersAgentsData', N'U') is null create table dbo.SessionsUsersAgentsData(
		id integer not null identity(1, 1),
		entity integer not null,
		[session] integer not null,
		user_agent integer not null,
		ok bit not null,
		deleted datetime,
		date_in datetime not null constraint sessions_users_agents_data_date_in default getdate(),
		date_out datetime,
		constraint sessions_users_agents_data_id primary key(id),
		constraint sessions_users_agents_data_entity foreign key(entity) references dbo.SessionsUsersAgents(id),
		constraint sessions_users_agents_data_session foreign key([session]) references dbo.[Sessions](id),
		constraint sessions_users_agents_data_user_agent foreign key(user_agent) references dbo.UsersAgents(id)
	)
	
	if object_id(N'dbo.Terminal', N'U') is null create table dbo.Terminal(
		id integer not null identity(1, 1),
		[session] integer not null,
		[procedure] integer not null,
		[data] integer not null,
		deleted datetime,
		date_in datetime not null constraint terminal_date_in default getdate(),
		date_out datetime,
		constraint terminal_id primary key(id),
		constraint terminal_session foreign key([session]) references dbo.[Sessions](id),
		constraint terminal_procedure foreign key([procedure]) references dbo.[Procedures](id),
		constraint terminal_data foreign key([data]) references dbo.TerminalData(id)
	)

	-- Level 3.
	if object_id(N'dbo._Users', N'U') is null create table dbo._Users(
		id integer not null identity(1, 1),
		[procedure] integer not null,
		[session] integer not null,
		entity integer not null, 
		[data] integer not null,
		nick varchar(32) not null,
		[password] varchar(256) not null,
		accessible bit not null constraint _users_accessible default 0,
		deleted datetime,
		date_in datetime not null,
		date_created datetime not null,
		constraint _users_id primary key(id),
		constraint _users_procedure foreign key([procedure]) references dbo.[Procedures](id),
		constraint _users_session foreign key([session]) references dbo.[Sessions](id),
		constraint _users_entity foreign key(entity) references dbo.Users(id)
	)
	
	if object_id(N'dbo._Ips', N'U') is null create table dbo._Ips(
		id integer not null identity(1, 1),
		[procedure] integer not null,
		[session] integer not null,
		entity integer not null, 
		[data] integer not null,
		[address] varchar(39) not null,
		accessible bit not null constraint _ips_accessible default 1,
		deleted datetime,
		date_in datetime not null,
		date_created datetime not null,
		constraint _ips_id primary key(id),
		constraint _ips_procedure foreign key([procedure]) references dbo.[Procedures](id),
		constraint _ips_session foreign key([session]) references dbo.[Sessions](id),
		constraint _ips_entity foreign key(entity) references dbo.Ips(id)
	)
	
	if object_id(N'dbo._SettingsTypes', N'U') is null create table dbo._SettingsTypes(
		id integer not null identity(1, 1),
		[procedure] integer not null,
		[session] integer not null,
		entity integer not null, 
		[data] integer not null,
		[name] varchar(64) not null,
		[description] varchar(max),
		deleted datetime,
		date_in datetime not null,
		date_created datetime not null,
		constraint _settings_types_id primary key(id),
		constraint _settings_types_procedure foreign key([procedure]) references dbo.[Procedures](id),
		constraint _settings_types_session foreign key([session]) references dbo.[Sessions](id),
		constraint _settings_types_entity foreign key(entity) references dbo.SettingsTypes(id)
	)
	
	if object_id(N'dbo._Settings', N'U') is null create table dbo._Settings(
		id integer not null identity(1, 1),
		[procedure] integer not null,
		[session] integer not null,
		entity integer not null, 
		[data] integer not null,
		[type] integer not null,
		[name] varchar(64) not null,
		[range] integer not null constraint _settings_range default 1,
		[value] varchar(max),
		[description] varchar(max),
		deleted datetime,
		date_in datetime not null,
		date_created datetime not null,
		constraint _settings_id primary key(id),
		constraint _settings_procedure foreign key([procedure]) references dbo.[Procedures](id),
		constraint _settings_session foreign key([session]) references dbo.[Sessions](id),
		constraint _settings_entity foreign key(entity) references dbo.Settings(id),
		constraint _settings_type foreign key([type]) references dbo.SettingsTypes(id)
	)
	
	if object_id(N'dbo._SessionsIps', N'U') is null create table dbo._SessionsIps(
		id integer not null identity(1, 1),
		entity integer not null, 
		[data] integer not null,
		[session] integer not null,
		[ip] integer not null,
		ok bit not null,
		deleted datetime,
		date_in datetime not null,
		date_created datetime not null,
		constraint _sessions_ips_id primary key(id),
		constraint _sessions_ips_entity foreign key(entity) references dbo.SessionsIps(id),
		constraint _sessions_ips_session foreign key([session]) references dbo.[Sessions](id),
		constraint _sessions_ips_ip foreign key([ip]) references dbo.Ips(id)
	)
	
	if object_id(N'dbo._SessionsUsersAgents', N'U') is null create table dbo._SessionsUsersAgents(
		id integer not null identity(1, 1),
		entity integer not null, 
		[data] integer not null,
		[session] integer not null,
		user_agent integer not null,
		ok bit not null,
		deleted datetime,
		date_in datetime not null,
		date_created datetime not null,
		constraint _sessions_users_agents_id primary key(id),
		constraint _sessions_users_agents_entity foreign key(entity) references dbo.SessionsUsersAgents(id),
		constraint _sessions_users_agents_session foreign key([session]) references dbo.[Sessions](id),
		constraint _sessions_users_agents_user_agent foreign key(user_agent) references dbo.UsersAgents(id)
	)

end
go

if object_id(N'dbo.common_tables_update', N'P') is not null drop procedure dbo.common_tables_update
go
create procedure dbo.common_tables_update 
	@session integer
as begin 

	declare @database varchar(64) = 'AnP'

	set nocount on

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Databases' and column_name = 'name') is null 
		alter table dbo.[Databases] add [name] varchar(64) not null

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'UsersData' and column_name = 'nick') is null begin 
		alter table dbo.UsersData add nick varchar(32) not null
		alter table dbo._Users add nick varchar(32) not null
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'UsersData' and column_name = 'password') is null begin 
		alter table dbo.UsersData add [password] varchar(256) not null
		alter table dbo._Users add [password] varchar(256) not null
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'UsersData' and column_name = 'accessible') is null begin 
		alter table dbo.UsersData add accessible bit not null constraint users_data_accessible default 0
		alter table dbo._Users add accessible bit not null constraint _users_accessible default 0
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'IpsData' and column_name = 'address') is null begin 
		alter table dbo.IpsData add [address] varchar(39) not null
		alter table dbo._Ips add [address] varchar(39) not null
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'IpsData' and column_name = 'accessible') is null begin 
		alter table dbo.IpsData add accessible bit not null constraint ips_data_accessible default 1
		alter table dbo._Ips add accessible bit not null constraint _ips_accessible default 1
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'SettingsTypesData' and column_name = 'name') is null begin 
		alter table dbo.SettingsTypesData add [name] varchar(64) not null
		alter table dbo._SettingsTypes add [name] varchar(64) not null
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'SettingsTypesData' and column_name = 'description') is null begin 
		alter table dbo.SettingsTypesData add [description] varchar(max)
		alter table dbo._SettingsTypes add [description] varchar(max)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Errors' and column_name = 'code') is null 
		alter table dbo.Errors add code varchar(512) not null

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Errors' and column_name = 'description') is null 
		alter table dbo.Errors add [description] varchar(512)

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Parameters' and column_name = 'json') is null 
		alter table dbo.[Parameters] add json varchar(max) not null

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Parameters' and column_name = 'description') is null 
		alter table dbo.[Parameters] add [description] varchar(512)

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Messages' and column_name = 'text') is null 
		alter table dbo.[Messages] add [text] varchar(max) not null

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Messages' and column_name = 'description') is null 
		alter table dbo.[Messages] add [description] varchar(512)

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Projects' and column_name = 'name') is null 
		alter table dbo.Projects add [name] varchar(64) not null

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Projects' and column_name = 'description') is null 
		alter table dbo.Projects add [description] varchar(512)

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'TracesFiles' and column_name = 'path') is null 
		alter table dbo.TracesFiles add [path] varchar(512) not null

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'TracesFiles' and column_name = 'description') is null 
		alter table dbo.TracesFiles add [description] varchar(512)

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Lines' and column_name = 'trace') is null 
		alter table dbo.Lines add trace varchar(max) not null

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Lines' and column_name = 'description') is null 
		alter table dbo.Lines add [description] varchar(512)

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'ErrorsMessagesGroups' and column_name = 'name') is null 
		alter table dbo.ErrorsMessagesGroups add [name] varchar(64) not null

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'ErrorsMessagesGroups' and column_name = 'description') is null 
		alter table dbo.ErrorsMessagesGroups add [description] varchar(512)

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'ErrorsTemporaryGroups' and column_name = 'i') is null 
		alter table dbo.ErrorsTemporaryGroups add i integer not null

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'ErrorsTemporaryGroups' and column_name = 'name') is null 
		alter table dbo.ErrorsTemporaryGroups add [name] varchar(64) not null

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'ErrorsTemporaryMessages' and column_name = 'group') is null 
		alter table dbo.ErrorsTemporaryMessages add [group] integer not null

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'ErrorsTemporaryMessages' and column_name = 'i') is null 
		alter table dbo.ErrorsTemporaryMessages add i integer

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'ErrorsTemporaryMessages' and column_name = 'message') is null 
		alter table dbo.ErrorsTemporaryMessages add [message] varchar(64)

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'UsersAgents' and column_name = 'data') is null 
		alter table dbo.UsersAgents add [data] varchar(max) not null

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Procedures' and column_name = 'database') is null begin 
		alter table dbo.[Procedures] add [database] integer not null
		alter table dbo.[Procedures] add constraint procedures_database foreign key([database]) references dbo.[Databases](id)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Procedures' and column_name = 'name') is null 
		alter table dbo.[Procedures] add [name] varchar(64) not null

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Sessions' and column_name = 'user') is null begin 
		alter table dbo.[Sessions] add [user] integer not null
		alter table dbo.[Sessions] add constraint sessions_user foreign key([user]) references dbo.Users(id)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Sessions' and column_name = 'date_last') is null 
		alter table dbo.[Sessions] add date_last datetime not null constraint sessions_date_last default getdate()

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'LoginsTries' and column_name = 'session') is null begin 
		alter table dbo.LoginsTries add [session] integer not null
		alter table dbo.LoginsTries add constraint logins_tries_session foreign key([session]) references dbo.[Sessions](id)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'LoginsTries' and column_name = 'user') is null begin 
		alter table dbo.LoginsTries add [user] integer not null
		alter table dbo.LoginsTries add constraint logins_tries_user foreign key([user]) references dbo.Users(id)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'LoginsTries' and column_name = 'ip') is null begin 
		alter table dbo.LoginsTries add [ip] integer not null
		alter table dbo.LoginsTries add constraint logins_tries_ip foreign key([ip]) references dbo.Ips(id)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'LoginsTries' and column_name = 'i') is null 
		alter table dbo.LoginsTries add i integer not null constraint logins_tries_i default 0

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'SettingsData' and column_name = 'type') is null begin 
		alter table dbo.SettingsData add [type] integer not null
		alter table dbo.SettingsData add constraint settings_data_type foreign key([type]) references dbo.SettingsTypes(id)
		alter table dbo._Settings add [type] integer not null
		alter table dbo._Settings add constraint _settings_type foreign key([type]) references dbo.SettingsTypes(id)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'SettingsData' and column_name = 'name') is null begin 
		alter table dbo.SettingsData add [name] varchar(64) not null
		alter table dbo._Settings add [name] varchar(64) not null
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'SettingsData' and column_name = 'range') is null begin 
		alter table dbo.SettingsData add [range] integer not null constraint settings_data_range default 1
		alter table dbo._Settings add [range] integer not null constraint _settings_range default 1
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'SettingsData' and column_name = 'value') is null begin 
		alter table dbo.SettingsData add [value] varchar(max)
		alter table dbo._Settings add [value] varchar(max)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'SettingsData' and column_name = 'description') is null begin 
		alter table dbo.SettingsData add [description] varchar(max)
		alter table dbo._Settings add [description] varchar(max)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Logs' and column_name = 'ip') is null begin 
		alter table dbo.Logs add [ip] integer
		alter table dbo.Logs add constraint logs_ip foreign key([ip]) references dbo.Ips(id)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Logs' and column_name = 'user_agent') is null begin 
		alter table dbo.Logs add user_agent integer
		alter table dbo.Logs add constraint logs_user_agent foreign key(user_agent) references dbo.UsersAgents(id)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Logs' and column_name = 'own_error') is null begin 
		alter table dbo.Logs add own_error integer not null
		alter table dbo.Logs add constraint logs_own_error foreign key(own_error) references dbo.Errors(id)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Logs' and column_name = 'own_parameters') is null begin 
		alter table dbo.Logs add own_parameters integer not null
		alter table dbo.Logs add constraint logs_own_parameters foreign key(own_parameters) references dbo.[Parameters](id)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Exceptions' and column_name = 'ip') is null begin 
		alter table dbo.Exceptions add [ip] integer
		alter table dbo.Exceptions add constraint exceptions_ip foreign key([ip]) references dbo.Ips(id)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Exceptions' and column_name = 'user_agent') is null begin 
		alter table dbo.Exceptions add user_agent integer
		alter table dbo.Exceptions add constraint exceptions_user_agent foreign key(user_agent) references dbo.UsersAgents(id)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Exceptions' and column_name = 'own_error') is null begin 
		alter table dbo.Exceptions add own_error integer not null
		alter table dbo.Exceptions add constraint exceptions_own_error foreign key(own_error) references dbo.Errors(id)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Exceptions' and column_name = 'own_parameters') is null begin 
		alter table dbo.Exceptions add own_parameters integer not null
		alter table dbo.Exceptions add constraint exceptions_own_parameters foreign key(own_parameters) references dbo.[Parameters](id)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Exceptions' and column_name = 'message') is null begin 
		alter table dbo.Exceptions add [message] integer not null
		alter table dbo.Exceptions add constraint exceptions_message foreign key([message]) references dbo.[Messages](id)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Exceptions' and column_name = 'status') is null 
		alter table dbo.Exceptions add [status] varchar(16) not null

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Exceptions' and column_name = 'code') is null 
		alter table dbo.Exceptions add code integer not null

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Traces' and column_name = 'ip') is null begin 
		alter table dbo.[Traces] add [ip] integer
		alter table dbo.[Traces] add constraint traces_ip foreign key([ip]) references dbo.Ips(id)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Traces' and column_name = 'user_agent') is null begin 
		alter table dbo.[Traces] add user_agent integer
		alter table dbo.[Traces] add constraint traces_user_agent foreign key(user_agent) references dbo.UsersAgents(id)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Traces' and column_name = 'project') is null begin 
		alter table dbo.[Traces] add project integer not null
		alter table dbo.[Traces] add constraint traces_user_agent foreign key(user_agent) references dbo.UsersAgents(id)
	end
	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Traces' and column_name = 'file') is null begin 
		alter table dbo.[Traces] add [file] integer not null
		alter table dbo.[Traces] add constraint traces_file foreign key([file]) references dbo.TracesFiles(id)
	end
	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Traces' and column_name = 'own_error') is null begin 
		alter table dbo.[Traces] add own_error integer not null
		alter table dbo.[Traces] add constraint traces_own_error foreign key(own_error) references dbo.Errors(id)
	end
	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Traces' and column_name = 'own_parameters') is null begin 
		alter table dbo.[Traces] add own_parameters integer not null
		alter table dbo.[Traces] add constraint traces_own_parameters foreign key(own_parameters) references dbo.[Parameters](id)
	end
	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Traces' and column_name = 'trace') is null begin 
		alter table dbo.[Traces] add trace integer not null
		alter table dbo.[Traces] add constraint traces_trace foreign key(trace) references dbo.Lines(id)
	end
	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Traces' and column_name = 'message') is null begin 
		alter table dbo.[Traces] add [message] integer not null
		alter table dbo.[Traces] add constraint traces_message foreign key([message]) references dbo.[Messages](id)
	end
	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Traces' and column_name = 'line') is null 
		alter table dbo.[Traces] add line integer not null

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'ErrorsMessages' and column_name = 'group') is null begin 
		alter table dbo.ErrorsMessages add [group] integer not null
		alter table dbo.ErrorsMessages add constraint errors_messages_group foreign key([group]) references dbo.ErrorsMessagesGroups(id)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'ErrorsMessages' and column_name = 'i') is null 
		alter table dbo.ErrorsMessages add i integer not null

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'ErrorsMessages' and column_name = 'name') is null 
		alter table dbo.ErrorsMessages add [name] varchar(64) not null

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'SessionsIpsData' and column_name = 'session') is null begin 
		alter table dbo.SessionsIpsData add [session] integer not null
		alter table dbo.SessionsIpsData add constraint sessions_ips_data_session foreign key([session]) references dbo.[Sessions](id)
		alter table dbo._SessionsIps add [session] integer not null
		alter table dbo._SessionsIps add constraint _sessions_ips_session foreign key([session]) references dbo.[Sessions](id)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'SessionsIpsData' and column_name = 'ip') is null begin 
		alter table dbo.SessionsIpsData add [ip] integer not null
		alter table dbo.SessionsIpsData add constraint sessions_ips_data_ip foreign key([ip]) references dbo.Ips(id)
		alter table dbo._SessionsIps add [ip] integer not null
		alter table dbo._SessionsIps add constraint _sessions_ips_ip foreign key([ip]) references dbo.Ips(id)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'SessionsIpsData' and column_name = 'ok') is null begin 
		alter table dbo.SessionsIpsData add ok bit not null
		alter table dbo._SessionsIps add ok bit not null
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'SessionsUsersAgentsData' and column_name = 'session') is null begin 
		alter table dbo.SessionsUsersAgentsData add [session] integer not null
		alter table dbo.SessionsUsersAgentsData add constraint sessions_users_agents_data_session foreign key([session]) references dbo.[Sessions](id)
		alter table dbo._SessionsUsersAgents add [session] integer not null
		alter table dbo._SessionsUsersAgents add constraint _sessions_users_agents_session foreign key([session]) references dbo.[Sessions](id)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'SessionsUsersAgentsData' and column_name = 'user_agent') is null begin 
		alter table dbo.SessionsUsersAgentsData add user_agent integer not null
		alter table dbo.SessionsUsersAgentsData add constraint sessions_users_agents_data_user_agent foreign key(user_agent) references dbo.UsersAgents(id)
		alter table dbo._SessionsUsersAgents add user_agent integer not null
		alter table dbo._SessionsUsersAgents add constraint _sessions_users_agents_user_agent foreign key(user_agent) references dbo.UsersAgents(id)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'SessionsUsersAgentsData' and column_name = 'ok') is null begin 
		alter table dbo.SessionsUsersAgentsData add ok bit not null
		alter table dbo._SessionsUsersAgents add ok bit not null
	end

end
go

-- execute dbo.common_tables_delete null
execute dbo.common_tables_create null
execute dbo.common_tables_update null

if object_id(N'dbo.users_data_update', N'P') is not null drop procedure dbo.users_data_update
go
create procedure dbo.users_data_update 
	@entity integer
as begin 
	
	set nocount on

	if (
		(select top 1 1 from dbo.Users where id = @entity and date_out is null) is null or 
		(select top 1 1 from dbo.UsersData where entity = @entity and date_out is null) is null
	) 
		delete from dbo._Users where entity = @entity
	else begin 
		if (select top 1 1 from dbo._Users where entity = @entity) is null 
			insert into dbo._Users([procedure], [session], entity, [data], nick, [password], accessible, deleted, date_in, date_created) 
				select [procedure], [session], entity, id, nick, [password], accessible, deleted, date_in, (
					select top 1 date_in from dbo.Users where id = @entity
				) from dbo.UsersData where id = (
					select top 1 max(id) from dbo.UsersData where date_out is null group by entity having entity = @entity
				)
		else 
			update plain set 
				plain.[procedure] = [data].[procedure],
				plain.[session] = [data].[session],
				plain.[data] = [data].id,
				plain.nick = [data].nick,
				plain.[password] = [data].[password],
				plain.accessible = [data].accessible,
				plain.deleted = [data].deleted,
				plain.date_in = [data].date_in
			from dbo._Users plain 
			join (select [procedure], [session], entity, id, nick, [password], accessible, deleted, date_in from dbo.UsersData where id = (
				select top 1 max(id) from dbo.UsersData where date_out is null group by entity having entity = @entity
			)) [data] on plain.entity = [data].entity
			where plain.entity = @entity
	end

end
go

if object_id(N'dbo.users_full_update', N'P') is not null drop procedure dbo.users_full_update
go
create procedure dbo.users_full_update 
	@procedure integer,
	@session integer,
	@entity integer,
	@data integer,
	@nick varchar(32),
	@password varchar(256),
	@accessible bit,
	@deleted datetime,
	@date_in datetime,
	@date_out datetime
as begin 
	
	set nocount on

	if (select top 1 1 from dbo.Users where id = @entity and date_out is null) is null 
		delete from dbo._Users where entity = @entity
	else begin 
		if @date_out is not null 
			execute dbo.users_data_update @entity
		else if (select top 1 1 from dbo._Users where entity = @entity) is null 
			insert into _Users([procedure], [session], entity, [data], nick, [password], accessible, deleted, date_in, date_created) values
				(@procedure, @session, @entity, @data, @nick, @password, @accessible, @deleted, @date_in, (
					select top 1 date_in from dbo.Users where id = @entity
				))
		else 
			update dbo._Users set 
				[procedure] = @procedure,
				[session] = @session,
				[data] = @data,
				nick = @nick,
				[password] = @password,
				accessible = @accessible,
				deleted = @deleted,
				date_in = @date_in
			where entity = @entity
	end

end
go

if object_id(N'dbo.users_trigger_update_entity', N'TR') is not null drop trigger dbo.users_trigger_update_entity
go
create trigger dbo.users_trigger_update_entity on dbo.Users after update as begin 

	declare @id integer
	declare update_cursor cursor local for select id from inserted

	set nocount on

	open update_cursor
	while 1 = 1 begin 
		fetch next from update_cursor into @id
		if @@fetch_status != 0
			break
		execute dbo.users_data_update @id
	end
	close update_cursor
	deallocate update_cursor

end 
go

if object_id(N'dbo.users_trigger_update_data', N'TR') is not null drop trigger dbo.users_trigger_update_data
go
create trigger dbo.users_trigger_update_data on dbo.UsersData after insert, update, delete as begin 

	declare @procedure integer
	declare @session integer
	declare @entity integer
	declare @data integer
	declare @nick varchar(32)
	declare @password varchar(256)
	declare @accessible bit
	declare @deleted datetime
	declare @date_in datetime
	declare @date_out datetime
	declare @id integer
	declare inserted_cursor cursor local for select [procedure], [session], entity, id, nick, [password], accessible, deleted, date_in, date_out from inserted
	declare deleted_cursor cursor local for select entity from deleted where id not in (select id from inserted)

	set nocount on
	
	open deleted_cursor
	while 1 = 1 begin 
		fetch next from deleted_cursor into @id
		if @@fetch_status != 0
			break
		execute dbo.users_data_update @id
	end
	close deleted_cursor
	deallocate deleted_cursor
	
	open inserted_cursor
	while 1 = 1 begin 
		fetch next from inserted_cursor into @procedure, @session, @entity, @id, @nick, @password, @accessible, @deleted, @date_in, @date_out
		if @@fetch_status != 0
			break
		execute dbo.users_full_update @procedure, @session, @entity, @id, @nick, @password, @accessible, @deleted, @date_in, @date_out
	end
	close inserted_cursor
	deallocate inserted_cursor

end 
go

if object_id(N'dbo.ips_data_update', N'P') is not null drop procedure dbo.ips_data_update
go
create procedure dbo.ips_data_update 
	@entity integer
as begin 
	
	set nocount on

	if (
		(select top 1 1 from dbo.Ips where id = @entity and date_out is null) is null or 
		(select top 1 1 from dbo.IpsData where entity = @entity and date_out is null) is null
	) 
		delete from dbo._Ips where entity = @entity
	else begin 
		if (select top 1 1 from dbo._Ips where entity = @entity) is null 
			insert into dbo._Ips([procedure], [session], entity, [data], [address], accessible, deleted, date_in, date_created) 
				select [procedure], [session], entity, id, [address], accessible, deleted, date_in, (
					select top 1 date_in from dbo.Ips where id = @entity
				) from dbo.IpsData where id = (
					select top 1 max(id) from dbo.IpsData where date_out is null group by entity having entity = @entity
				)
		else 
			update plain set 
				plain.[procedure] = [data].[procedure],
				plain.[session] = [data].[session],
				plain.[data] = [data].id,
				plain.[address] = [data].[address],
				plain.accessible = [data].accessible,
				plain.deleted = [data].deleted,
				plain.date_in = [data].date_in
			from dbo._Ips plain 
			join (select [procedure], [session], entity, id, [address], accessible, deleted, date_in from dbo.IpsData where id = (
				select top 1 max(id) from dbo.IpsData where date_out is null group by entity having entity = @entity
			)) [data] on plain.entity = [data].entity
			where plain.entity = @entity
	end

end
go

if object_id(N'dbo.ips_full_update', N'P') is not null drop procedure dbo.ips_full_update
go
create procedure dbo.ips_full_update 
	@procedure integer,
	@session integer,
	@entity integer,
	@data integer,
	@address varchar(39),
	@accessible bit,
	@deleted datetime,
	@date_in datetime,
	@date_out datetime
as begin 
	
	set nocount on

	if (select top 1 1 from dbo.Ips where id = @entity and date_out is null) is null 
		delete from dbo._Ips where entity = @entity
	else begin 
		if @date_out is not null 
			execute dbo.ips_data_update @entity
		else if (select top 1 1 from dbo._Ips where entity = @entity) is null 
			insert into _Ips([procedure], [session], entity, [data], [address], accessible, deleted, date_in, date_created) values
				(@procedure, @session, @entity, @data, @address, @accessible, @deleted, @date_in, (
					select top 1 date_in from dbo.Ips where id = @entity
				))
		else 
			update dbo._Ips set 
				[procedure] = @procedure,
				[session] = @session,
				[data] = @data,
				[address] = @address,
				accessible = @accessible,
				deleted = @deleted,
				date_in = @date_in
			where entity = @entity
	end

end
go

if object_id(N'dbo.ips_trigger_update_entity', N'TR') is not null drop trigger dbo.ips_trigger_update_entity
go
create trigger dbo.ips_trigger_update_entity on dbo.Ips after update as begin 

	declare @id integer
	declare update_cursor cursor local for select id from inserted

	set nocount on

	open update_cursor
	while 1 = 1 begin 
		fetch next from update_cursor into @id
		if @@fetch_status != 0
			break
		execute dbo.ips_data_update @id
	end
	close update_cursor
	deallocate update_cursor

end 
go

if object_id(N'dbo.ips_trigger_update_data', N'TR') is not null drop trigger dbo.ips_trigger_update_data
go
create trigger dbo.ips_trigger_update_data on dbo.IpsData after insert, update, delete as begin 

	declare @procedure integer
	declare @session integer
	declare @entity integer
	declare @data integer
	declare @address varchar(39)
	declare @accessible bit
	declare @deleted datetime
	declare @date_in datetime
	declare @date_out datetime
	declare @id integer
	declare inserted_cursor cursor local for select [procedure], [session], entity, id, [address], accessible, deleted, date_in, date_out from inserted
	declare deleted_cursor cursor local for select entity from deleted where id not in (select id from inserted)

	set nocount on
	
	open deleted_cursor
	while 1 = 1 begin 
		fetch next from deleted_cursor into @id
		if @@fetch_status != 0
			break
		execute dbo.ips_data_update @id
	end
	close deleted_cursor
	deallocate deleted_cursor
	
	open inserted_cursor
	while 1 = 1 begin 
		fetch next from inserted_cursor into @procedure, @session, @entity, @id, @address, @accessible, @deleted, @date_in, @date_out
		if @@fetch_status != 0
			break
		execute dbo.ips_full_update @procedure, @session, @entity, @id, @address, @accessible, @deleted, @date_in, @date_out
	end
	close inserted_cursor
	deallocate inserted_cursor

end 
go

if object_id(N'dbo.settings_types_data_update', N'P') is not null drop procedure dbo.settings_types_data_update
go
create procedure dbo.settings_types_data_update 
	@entity integer
as begin 
	
	set nocount on

	if (
		(select top 1 1 from dbo.SettingsTypes where id = @entity and date_out is null) is null or 
		(select top 1 1 from dbo.SettingsTypesData where entity = @entity and date_out is null) is null
	) 
		delete from dbo._SettingsTypes where entity = @entity
	else begin 
		if (select top 1 1 from dbo._SettingsTypes where entity = @entity) is null 
			insert into dbo._SettingsTypes([procedure], [session], entity, [data], [name], [description], deleted, date_in, date_created) 
				select [procedure], [session], entity, id, [name], [description], deleted, date_in, (
					select top 1 date_in from dbo.SettingsTypes where id = @entity
				) from dbo.SettingsTypesData where id = (
					select top 1 max(id) from dbo.SettingsTypesData where date_out is null group by entity having entity = @entity
				)
		else 
			update plain set 
				plain.[procedure] = [data].[procedure],
				plain.[session] = [data].[session],
				plain.[data] = [data].id,
				plain.[name] = [data].[name],
				plain.[description] = [data].[description],
				plain.deleted = [data].deleted,
				plain.date_in = [data].date_in
			from dbo._SettingsTypes plain 
			join (select [procedure], [session], entity, id, [name], [description], deleted, date_in from dbo.SettingsTypesData where id = (
				select top 1 max(id) from dbo.SettingsTypesData where date_out is null group by entity having entity = @entity
			)) [data] on plain.entity = [data].entity
			where plain.entity = @entity
	end

end
go

if object_id(N'dbo.settings_types_full_update', N'P') is not null drop procedure dbo.settings_types_full_update
go
create procedure dbo.settings_types_full_update 
	@procedure integer,
	@session integer,
	@entity integer,
	@data integer,
	@name varchar(64),
	@description varchar(max),
	@deleted datetime,
	@date_in datetime,
	@date_out datetime
as begin 
	
	set nocount on

	if (select top 1 1 from dbo.SettingsTypes where id = @entity and date_out is null) is null 
		delete from dbo._SettingsTypes where entity = @entity
	else begin 
		if @date_out is not null 
			execute dbo.settings_types_data_update @entity
		else if (select top 1 1 from dbo._SettingsTypes where entity = @entity) is null 
			insert into _SettingsTypes([procedure], [session], entity, [data], [name], [description], deleted, date_in, date_created) values
				(@procedure, @session, @entity, @data, @name, @description, @deleted, @date_in, (
					select top 1 date_in from dbo.SettingsTypes where id = @entity
				))
		else 
			update dbo._SettingsTypes set 
				[procedure] = @procedure,
				[session] = @session,
				[data] = @data,
				[name] = @name,
				[description] = @description,
				deleted = @deleted,
				date_in = @date_in
			where entity = @entity
	end

end
go

if object_id(N'dbo.settings_types_trigger_update_entity', N'TR') is not null drop trigger dbo.settings_types_trigger_update_entity
go
create trigger dbo.settings_types_trigger_update_entity on dbo.SettingsTypes after update as begin 

	declare @id integer
	declare update_cursor cursor local for select id from inserted

	set nocount on

	open update_cursor
	while 1 = 1 begin 
		fetch next from update_cursor into @id
		if @@fetch_status != 0
			break
		execute dbo.settings_types_data_update @id
	end
	close update_cursor
	deallocate update_cursor

end 
go

if object_id(N'dbo.settings_types_trigger_update_data', N'TR') is not null drop trigger dbo.settings_types_trigger_update_data
go
create trigger dbo.settings_types_trigger_update_data on dbo.SettingsTypesData after insert, update, delete as begin 

	declare @procedure integer
	declare @session integer
	declare @entity integer
	declare @data integer
	declare @name varchar(64)
	declare @description varchar(max)
	declare @deleted datetime
	declare @date_in datetime
	declare @date_out datetime
	declare @id integer
	declare inserted_cursor cursor local for select [procedure], [session], entity, id, [name], [description], deleted, date_in, date_out from inserted
	declare deleted_cursor cursor local for select entity from deleted where id not in (select id from inserted)

	set nocount on
	
	open deleted_cursor
	while 1 = 1 begin 
		fetch next from deleted_cursor into @id
		if @@fetch_status != 0
			break
		execute dbo.settings_types_data_update @id
	end
	close deleted_cursor
	deallocate deleted_cursor
	
	open inserted_cursor
	while 1 = 1 begin 
		fetch next from inserted_cursor into @procedure, @session, @entity, @id, @name, @description, @deleted, @date_in, @date_out
		if @@fetch_status != 0
			break
		execute dbo.settings_types_full_update @procedure, @session, @entity, @id, @name, @description, @deleted, @date_in, @date_out
	end
	close inserted_cursor
	deallocate inserted_cursor

end 
go

if object_id(N'dbo.settings_data_update', N'P') is not null drop procedure dbo.settings_data_update
go
create procedure dbo.settings_data_update 
	@entity integer
as begin 
	
	set nocount on

	if (
		(select top 1 1 from dbo.Settings where id = @entity and date_out is null) is null or 
		(select top 1 1 from dbo.SettingsData where entity = @entity and date_out is null) is null
	) 
		delete from dbo._Settings where entity = @entity
	else begin 
		if (select top 1 1 from dbo._Settings where entity = @entity) is null 
			insert into dbo._Settings([procedure], [session], entity, [data], [type], [name], [range], [value], [description], deleted, date_in, date_created) 
				select [procedure], [session], entity, id, [type], [name], [range], [value], [description], deleted, date_in, (
					select top 1 date_in from dbo.Settings where id = @entity
				) from dbo.SettingsData where id = (
					select top 1 max(id) from dbo.SettingsData where date_out is null group by entity having entity = @entity
				)
		else 
			update plain set 
				plain.[procedure] = [data].[procedure],
				plain.[session] = [data].[session],
				plain.[data] = [data].id,
				plain.[type] = [data].[type],
				plain.[name] = [data].[name],
				plain.[range] = [data].[range],
				plain.[value] = [data].[value],
				plain.[description] = [data].[description],
				plain.deleted = [data].deleted,
				plain.date_in = [data].date_in
			from dbo._Settings plain 
			join (select [procedure], [session], entity, id, [type], [name], [range], [value], [description], deleted, date_in from dbo.SettingsData where id = (
				select top 1 max(id) from dbo.SettingsData where date_out is null group by entity having entity = @entity
			)) [data] on plain.entity = [data].entity
			where plain.entity = @entity
	end

end
go

if object_id(N'dbo.settings_full_update', N'P') is not null drop procedure dbo.settings_full_update
go
create procedure dbo.settings_full_update 
	@procedure integer,
	@session integer,
	@entity integer,
	@data integer,
	@type integer,
	@name varchar(64),
	@range integer,
	@value varchar(max),
	@description varchar(max),
	@deleted datetime,
	@date_in datetime,
	@date_out datetime
as begin 
	
	set nocount on

	if (select top 1 1 from dbo.Settings where id = @entity and date_out is null) is null 
		delete from dbo._Settings where entity = @entity
	else begin 
		if @date_out is not null 
			execute dbo.settings_data_update @entity
		else if (select top 1 1 from dbo._Settings where entity = @entity) is null 
			insert into _Settings([procedure], [session], entity, [data], [type], [name], [range], [value], [description], deleted, date_in, date_created) values
				(@procedure, @session, @entity, @data, @type, @name, @range, @value, @description, @deleted, @date_in, (
					select top 1 date_in from dbo.Settings where id = @entity
				))
		else 
			update dbo._Settings set 
				[procedure] = @procedure,
				[session] = @session,
				[data] = @data,
				[type] = @type,
				[name] = @name,
				[range] = @range,
				[value] = @value,
				[description] = @description,
				deleted = @deleted,
				date_in = @date_in
			where entity = @entity
	end

end
go

if object_id(N'dbo.settings_trigger_update_entity', N'TR') is not null drop trigger dbo.settings_trigger_update_entity
go
create trigger dbo.settings_trigger_update_entity on dbo.Settings after update as begin 

	declare @id integer
	declare update_cursor cursor local for select id from inserted

	set nocount on

	open update_cursor
	while 1 = 1 begin 
		fetch next from update_cursor into @id
		if @@fetch_status != 0
			break
		execute dbo.settings_data_update @id
	end
	close update_cursor
	deallocate update_cursor

end 
go

if object_id(N'dbo.settings_trigger_update_data', N'TR') is not null drop trigger dbo.settings_trigger_update_data
go
create trigger dbo.settings_trigger_update_data on dbo.SettingsData after insert, update, delete as begin 

	declare @procedure integer
	declare @session integer
	declare @entity integer
	declare @data integer
	declare @type integer
	declare @name varchar(64)
	declare @range integer
	declare @value varchar(max)
	declare @description varchar(max)
	declare @deleted datetime
	declare @date_in datetime
	declare @date_out datetime
	declare @id integer
	declare inserted_cursor cursor local for select [procedure], [session], entity, id, [type], [name], [range], [value], [description], deleted, date_in, date_out from inserted
	declare deleted_cursor cursor local for select entity from deleted where id not in (select id from inserted)

	set nocount on
	
	open deleted_cursor
	while 1 = 1 begin 
		fetch next from deleted_cursor into @id
		if @@fetch_status != 0
			break
		execute dbo.settings_data_update @id
	end
	close deleted_cursor
	deallocate deleted_cursor
	
	open inserted_cursor
	while 1 = 1 begin 
		fetch next from inserted_cursor into @procedure, @session, @entity, @id, @type, @name, @range, @value, @description, @deleted, @date_in, @date_out
		if @@fetch_status != 0
			break
		execute dbo.settings_full_update @procedure, @session, @entity, @id, @type, @name, @range, @value, @description, @deleted, @date_in, @date_out
	end
	close inserted_cursor
	deallocate inserted_cursor

end 
go

if object_id(N'dbo.sessions_ips_data_update', N'P') is not null drop procedure dbo.sessions_ips_data_update
go
create procedure dbo.sessions_ips_data_update 
	@entity integer
as begin 
	
	set nocount on

	if (
		(select top 1 1 from dbo.SessionsIps where id = @entity and date_out is null) is null or 
		(select top 1 1 from dbo.SessionsIpsData where entity = @entity and date_out is null) is null
	) 
		delete from dbo._SessionsIps where entity = @entity
	else begin 
		if (select top 1 1 from dbo._SessionsIps where entity = @entity) is null 
			insert into dbo._SessionsIps(entity, [data], [session], [ip], ok, deleted, date_in, date_created) 
				select entity, id, [session], [ip], ok, deleted, date_in, (
					select top 1 date_in from dbo.SessionsIps where id = @entity
				) from dbo.SessionsIpsData where id = (
					select top 1 max(id) from dbo.SessionsIpsData where date_out is null group by entity having entity = @entity
				)
		else 
			update plain set 
				plain.[data] = [data].id,
				plain.[session] = [data].[session],
				plain.[ip] = [data].[ip],
				plain.ok = [data].ok,
				plain.deleted = [data].deleted,
				plain.date_in = [data].date_in
			from dbo._SessionsIps plain 
			join (select entity, id, [session], [ip], ok, deleted, date_in from dbo.SessionsIpsData where id = (
				select top 1 max(id) from dbo.SessionsIpsData where date_out is null group by entity having entity = @entity
			)) [data] on plain.entity = [data].entity
			where plain.entity = @entity
	end

end
go

if object_id(N'dbo.sessions_ips_full_update', N'P') is not null drop procedure dbo.sessions_ips_full_update
go
create procedure dbo.sessions_ips_full_update 
	@entity integer,
	@data integer,
	@session integer,
	@ip integer,
	@ok bit,
	@deleted datetime,
	@date_in datetime,
	@date_out datetime
as begin 
	
	set nocount on

	if (select top 1 1 from dbo.SessionsIps where id = @entity and date_out is null) is null 
		delete from dbo._SessionsIps where entity = @entity
	else begin 
		if @date_out is not null 
			execute dbo.sessions_ips_data_update @entity
		else if (select top 1 1 from dbo._SessionsIps where entity = @entity) is null 
			insert into _SessionsIps(entity, [data], [session], [ip], ok, deleted, date_in, date_created) values
				(@entity, @data, @session, @ip, @ok, @deleted, @date_in, (
					select top 1 date_in from dbo.SessionsIps where id = @entity
				))
		else 
			update dbo._SessionsIps set 
				[data] = @data,
				[session] = @session,
				[ip] = @ip,
				ok = @ok,
				deleted = @deleted,
				date_in = @date_in
			where entity = @entity
	end

end
go

if object_id(N'dbo.sessions_ips_trigger_update_entity', N'TR') is not null drop trigger dbo.sessions_ips_trigger_update_entity
go
create trigger dbo.sessions_ips_trigger_update_entity on dbo.SessionsIps after update as begin 

	declare @id integer
	declare update_cursor cursor local for select id from inserted

	set nocount on

	open update_cursor
	while 1 = 1 begin 
		fetch next from update_cursor into @id
		if @@fetch_status != 0
			break
		execute dbo.sessions_ips_data_update @id
	end
	close update_cursor
	deallocate update_cursor

end 
go

if object_id(N'dbo.sessions_ips_trigger_update_data', N'TR') is not null drop trigger dbo.sessions_ips_trigger_update_data
go
create trigger dbo.sessions_ips_trigger_update_data on dbo.SessionsIpsData after insert, update, delete as begin 

	declare @entity integer
	declare @data integer
	declare @session integer
	declare @ip integer
	declare @ok bit
	declare @deleted datetime
	declare @date_in datetime
	declare @date_out datetime
	declare @id integer
	declare inserted_cursor cursor local for select entity, id, [session], [ip], ok, deleted, date_in, date_out from inserted
	declare deleted_cursor cursor local for select entity from deleted where id not in (select id from inserted)

	set nocount on
	
	open deleted_cursor
	while 1 = 1 begin 
		fetch next from deleted_cursor into @id
		if @@fetch_status != 0
			break
		execute dbo.sessions_ips_data_update @id
	end
	close deleted_cursor
	deallocate deleted_cursor
	
	open inserted_cursor
	while 1 = 1 begin 
		fetch next from inserted_cursor into @entity, @id, @session, @ip, @ok, @deleted, @date_in, @date_out
		if @@fetch_status != 0
			break
		execute dbo.sessions_ips_full_update @entity, @id, @session, @ip, @ok, @deleted, @date_in, @date_out
	end
	close inserted_cursor
	deallocate inserted_cursor

end 
go

if object_id(N'dbo.sessions_users_agents_data_update', N'P') is not null drop procedure dbo.sessions_users_agents_data_update
go
create procedure dbo.sessions_users_agents_data_update 
	@entity integer
as begin 
	
	set nocount on

	if (
		(select top 1 1 from dbo.SessionsUsersAgents where id = @entity and date_out is null) is null or 
		(select top 1 1 from dbo.SessionsUsersAgentsData where entity = @entity and date_out is null) is null
	) 
		delete from dbo._SessionsUsersAgents where entity = @entity
	else begin 
		if (select top 1 1 from dbo._SessionsUsersAgents where entity = @entity) is null 
			insert into dbo._SessionsUsersAgents(entity, [data], [session], user_agent, ok, deleted, date_in, date_created) 
				select entity, id, [session], user_agent, ok, deleted, date_in, (
					select top 1 date_in from dbo.SessionsUsersAgents where id = @entity
				) from dbo.SessionsUsersAgentsData where id = (
					select top 1 max(id) from dbo.SessionsUsersAgentsData where date_out is null group by entity having entity = @entity
				)
		else 
			update plain set 
				plain.[data] = [data].id,
				plain.[session] = [data].[session],
				plain.user_agent = [data].user_agent,
				plain.ok = [data].ok,
				plain.deleted = [data].deleted,
				plain.date_in = [data].date_in
			from dbo._SessionsUsersAgents plain 
			join (select entity, id, [session], user_agent, ok, deleted, date_in from dbo.SessionsUsersAgentsData where id = (
				select top 1 max(id) from dbo.SessionsUsersAgentsData where date_out is null group by entity having entity = @entity
			)) [data] on plain.entity = [data].entity
			where plain.entity = @entity
	end

end
go

if object_id(N'dbo.sessions_users_agents_full_update', N'P') is not null drop procedure dbo.sessions_users_agents_full_update
go
create procedure dbo.sessions_users_agents_full_update 
	@entity integer,
	@data integer,
	@session integer,
	@user_agent integer,
	@ok bit,
	@deleted datetime,
	@date_in datetime,
	@date_out datetime
as begin 
	
	set nocount on

	if (select top 1 1 from dbo.SessionsUsersAgents where id = @entity and date_out is null) is null 
		delete from dbo._SessionsUsersAgents where entity = @entity
	else begin 
		if @date_out is not null 
			execute dbo.sessions_users_agents_data_update @entity
		else if (select top 1 1 from dbo._SessionsUsersAgents where entity = @entity) is null 
			insert into _SessionsUsersAgents(entity, [data], [session], user_agent, ok, deleted, date_in, date_created) values
				(@entity, @data, @session, @user_agent, @ok, @deleted, @date_in, (
					select top 1 date_in from dbo.SessionsUsersAgents where id = @entity
				))
		else 
			update dbo._SessionsUsersAgents set 
				[data] = @data,
				[session] = @session,
				user_agent = @user_agent,
				ok = @ok,
				deleted = @deleted,
				date_in = @date_in
			where entity = @entity
	end

end
go

if object_id(N'dbo.sessions_users_agents_trigger_update_entity', N'TR') is not null drop trigger dbo.sessions_users_agents_trigger_update_entity
go
create trigger dbo.sessions_users_agents_trigger_update_entity on dbo.SessionsUsersAgents after update as begin 

	declare @id integer
	declare update_cursor cursor local for select id from inserted

	set nocount on

	open update_cursor
	while 1 = 1 begin 
		fetch next from update_cursor into @id
		if @@fetch_status != 0
			break
		execute dbo.sessions_users_agents_data_update @id
	end
	close update_cursor
	deallocate update_cursor

end 
go

if object_id(N'dbo.sessions_users_agents_trigger_update_data', N'TR') is not null drop trigger dbo.sessions_users_agents_trigger_update_data
go
create trigger dbo.sessions_users_agents_trigger_update_data on dbo.SessionsUsersAgentsData after insert, update, delete as begin 

	declare @entity integer
	declare @data integer
	declare @session integer
	declare @user_agent integer
	declare @ok bit
	declare @deleted datetime
	declare @date_in datetime
	declare @date_out datetime
	declare @id integer
	declare inserted_cursor cursor local for select entity, id, [session], user_agent, ok, deleted, date_in, date_out from inserted
	declare deleted_cursor cursor local for select entity from deleted where id not in (select id from inserted)

	set nocount on
	
	open deleted_cursor
	while 1 = 1 begin 
		fetch next from deleted_cursor into @id
		if @@fetch_status != 0
			break
		execute dbo.sessions_users_agents_data_update @id
	end
	close deleted_cursor
	deallocate deleted_cursor
	
	open inserted_cursor
	while 1 = 1 begin 
		fetch next from inserted_cursor into @entity, @id, @session, @user_agent, @ok, @deleted, @date_in, @date_out
		if @@fetch_status != 0
			break
		execute dbo.sessions_users_agents_full_update @entity, @id, @session, @user_agent, @ok, @deleted, @date_in, @date_out
	end
	close inserted_cursor
	deallocate inserted_cursor

end 
go