if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.anp_base_set', N'P') is not null drop procedure dbo.anp_base_set
go
create procedure dbo.anp_base_set 
	@session varchar(max)
as begin 
		
	declare @database varchar(64) = dbo.settings_get('database_anp2', 0)
	declare @procedure varchar(64) = 'anp_base_set'
	declare @procedure_id integer
	declare @id integer
	declare @has_database bit = (case when @database is null then 0 else 1 end)
	declare @session_id integer = dbo.sessions_get_id(@session)
	declare @ip_id integer
	declare @user_agent_id integer
	
	if @session_id is null 
		set @session_id = dbo.sessions_get_machine()

	select top 1 
		@ip_id = ip_id,
		@user_agent_id = user_agent_id
	from dbo.SessionsFullView where id = @session_id

	if @database is null 
		set @database = 'AnP'

	execute dbo.procedures_get @database, @procedure, @procedure_id output
	
	if @has_database = 0 begin 
		insert into dbo.Settings default values
		set @id = scope_identity()
		insert into dbo.SettingsData([procedure], [session], entity, [type], [name], [range], [value]) values 
			(@procedure_id, @session_id, @id, 1, 'database_anp2', 1, @database)
	end
	
	execute dbo.logs_set @session_id, @database, @procedure, @ip_id, @user_agent_id, 0, '{}', 2
		
end
go
	
execute dbo.anp_base_set null