if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.UsersView', N'V') is not null drop view dbo.UsersView
go
create view dbo.UsersView as select 
	users.id as plain_id, 
	users.entity as id, 
	users.[data] as [data], 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	users.nick as user_nick, 
	users.[password] as [password], 
	users.accessible as accessible, 
	users.deleted as deleted, 
	users.date_in as date_in, 
	users.date_created as date_created
from dbo._Users users
join dbo.SessionsFullView [sessions] on users.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on users.[procedure] = [procedures].id
go

if object_id(N'dbo.UsersSelectView', N'V') is not null drop view dbo.UsersSelectView
go
create view UsersSelectView as select 
	users.entity as id, 
	users.nick as nick
from dbo._Users users

go

if object_id(N'dbo.UsersHistoryView', N'V') is not null drop view dbo.UsersHistoryView
go
create view dbo.UsersHistoryView as select 
	users.id as plain_id, 
	users.entity as id, 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	users.nick as user_nick, 
	users.[password] as [password], 
	users.accessible as accessible, 
	users.deleted as deleted, 
	users.date_in as date_in
from dbo.UsersData users
join dbo.SessionsFullView [sessions] on users.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on users.[procedure] = [procedures].id
where 
	users.date_out is null
go

if object_id(N'dbo.UsersLoadView', N'V') is not null drop view dbo.UsersLoadView
go
create view dbo.UsersLoadView as select 
	users.entity as id,
	users.nick as nick,
	users.[password] as [password],
	users.accessible as accessible
from dbo._Users users
where 
	users.deleted is null
go