if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.users_reset_password', N'P') is not null drop procedure dbo.users_reset_password
go
create procedure dbo.users_reset_password 
	@session varchar(max), 
	@entity integer, 
	@error varchar(512) output
as begin 
	
	declare @database varchar(64) = dbo.settings_get('database_anp2', 0)
	declare @procedure varchar(64) = 'users_reset_password'
	declare @procedure_id integer
	declare @parameters varchar(max) = '{"entity":null,"id":null}'
	declare @session_id integer
	declare @ip_id integer
	declare @user_agent_id integer

	set @parameters = json_modify(@parameters, 'strict $.entity', @entity)
	set @parameters = json_modify(@parameters, 'strict $.id', 0)

	begin try

		execute dbo.sessions_validate_full @session, '["administrator"]', @error output, @session_id output, @ip_id output, @user_agent_id output
		set @error = dbo.errors_set(@error, dbo.users_validate(@entity, 1), 30, 0)

		if dbo.errors_has(@error) = 0 begin 

			set @error = dbo.errors_set(@error, (case when isnull((
				select top 1 [password] from dbo._Users where entity = @entity
			), '') = '' then dbo.bw(1, 0) else 0 end), 34, 0)

			if dbo.errors_has(@error) = 0 begin 

				declare @nick varchar(32)
				declare @accessible bit
				declare @deleted datetime
				
				execute dbo.procedures_get @database, @procedure, @procedure_id output

				select top 1 
					@nick = nick, 
					@accessible = accessible, 
					@deleted = deleted 
				from dbo._Users where entity = @entity

				insert into dbo.UsersData([procedure], [session], entity, nick, [password], [accessible], deleted) values 
					(@procedure_id, @session_id, @entity, @nick, '', @accessible, @deleted)

				set @parameters = json_modify(@parameters, 'strict $.id', scope_identity())

			end

		end

	end try
	begin catch
		set @error = @error | dbo.bw(1, 0)
		execute dbo.exceptions_set @session_id, @database, @procedure, @ip_id, @user_agent_id, @error, @parameters
	end catch

	execute dbo.logs_set @session_id, @database, @procedure, @ip_id, @user_agent_id, @error, @parameters, 0

end
go