if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.GroupsView', N'V') is not null drop view dbo.GroupsView
go
create view dbo.GroupsView as select 
	groups.id as plain_id, 
	groups.entity as id, 
	groups.[data] as [data], 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	groups.[name] as [name], 
	groups.[default] as [default], 
	groups.is_entity as is_entity, 
	groups.[description] as [description], 
	groups.deleted as deleted, 
	groups.date_in as date_in, 
	groups.date_created as date_created
from dbo._Groups groups
join dbo.SessionsFullView [sessions] on groups.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on groups.[procedure] = [procedures].id
go

if object_id(N'dbo.GroupsSelectView', N'V') is not null drop view dbo.GroupsSelectView
go
create view GroupsSelectView as select 
	groups.entity as id, 
	groups.[name] as [name]
from dbo._Groups groups

go

if object_id(N'dbo.GroupsHistoryView', N'V') is not null drop view dbo.GroupsHistoryView
go
create view dbo.GroupsHistoryView as select 
	groups.id as plain_id, 
	groups.entity as id, 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	groups.[name] as [name], 
	groups.[default] as [default], 
	groups.is_entity as is_entity, 
	groups.[description] as [description], 
	groups.deleted as deleted, 
	groups.date_in as date_in
from dbo.GroupsData groups
join dbo.SessionsFullView [sessions] on groups.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on groups.[procedure] = [procedures].id
where 
	groups.date_out is null
go

if object_id(N'dbo.GroupsLoadView', N'V') is not null drop view dbo.GroupsLoadView
go
create view dbo.GroupsLoadView as select 
	groups.entity as id,
	groups.[name] as [name],
	groups.[default] as [default],
	groups.is_entity as is_entity,
	groups.[description] as [description]
from dbo._Groups groups
where 
	groups.deleted is null
go