if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.emails_tables_delete', N'P') is not null drop procedure dbo.emails_tables_delete
go
create procedure dbo.emails_tables_delete
	@session varchar(max)
as begin
		
	if object_id(N'dbo.Emails', N'U') is not null drop table dbo.Emails
		
end
go

if object_id(N'dbo.emails_tables_create', N'P') is not null drop procedure dbo.emails_tables_create
go
create procedure dbo.emails_tables_create
	@session varchar(max)
as begin 
		
	if object_id(N'dbo.Emails', N'U') is null create table dbo.Emails(
		id integer not null identity(1, 1),
		[procedure] integer not null,
		[session] integer not null,
		[address] varchar(256) not null,
		deleted datetime,
		date_in datetime not null constraint emails_date_in default getdate(),
		date_out datetime,
		constraint emails_id primary key(id), 
		constraint emails_procedure foreign key([procedure]) references dbo.[Procedures](id), 
		constraint emails_session foreign key([session]) references dbo.[Sessions](id)
	)
		
end
go

if object_id(N'dbo.emails_tables_update', N'P') is not null drop procedure dbo.emails_tables_update
go
create procedure dbo.emails_tables_update
	@session varchar(max)
as begin 
		
	declare @database varchar(64) = dbo.settings_get('database_anp2', 0)
	declare @procedure varchar(64) = 'emails_tables_update'
	declare @session_id integer = isnull(dbo.sessions_get_id(@session), dbo.sessions_get_machine())
	declare @ip_id integer
	declare @user_agent_id integer

	select top 1 
		@ip_id = ip_id,
		@user_agent_id = user_agent_id
	from dbo.SessionsFullView where id = @session_id

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Emails' and column_name = 'address') is null begin 
		alter table Emails add [address] varchar(256) not null
	end
	
	execute dbo.logs_set @session_id, @database, @procedure, @ip_id, @user_agent_id, 0, '{}', 2
	
end
go
	
-- execute dbo.emails_tables_delete null
execute dbo.emails_tables_create null
execute dbo.emails_tables_update null
	
