if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.EmailsView', N'V') is not null drop view dbo.EmailsView
go
create view dbo.EmailsView as select 
	emails.id as id, 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	emails.[address] as [address], 
	emails.deleted as deleted, 
	emails.date_in as date_in
from dbo.Emails emails
join dbo.SessionsFullView [sessions] on emails.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on emails.[procedure] = [procedures].id
where 
	emails.date_out is null
go

if object_id(N'dbo.EmailsSelectView', N'V') is not null drop view dbo.EmailsSelectView
go
create view EmailsSelectView as select 
	emails.id as id, 
	emails.[address] as [address]
from dbo.Emails emails

go