if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.IpsView', N'V') is not null drop view dbo.IpsView
go
create view dbo.IpsView as select 
	ips.id as plain_id, 
	ips.entity as id, 
	ips.[data] as [data], 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	ips.[address] as [address], 
	ips.accessible as accessible, 
	ips.deleted as deleted, 
	ips.date_in as date_in, 
	ips.date_created as date_created
from dbo._Ips ips
join dbo.SessionsFullView [sessions] on ips.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on ips.[procedure] = [procedures].id
go

if object_id(N'dbo.IpsSelectView', N'V') is not null drop view dbo.IpsSelectView
go
create view IpsSelectView as select 
	ips.entity as id, 
	ips.[address] as [address]
from dbo._Ips ips

go