if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.PermissionsView', N'V') is not null drop view dbo.PermissionsView
go
create view dbo.PermissionsView as select 
	permissions.id as plain_id, 
	permissions.entity as id, 
	permissions.[data] as [data], 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	permissions.[name] as [name], 
	permissions.[description] as [description], 
	permissions.deleted as deleted, 
	permissions.date_in as date_in, 
	permissions.date_created as date_created
from dbo._Permissions permissions
join dbo.SessionsFullView [sessions] on permissions.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on permissions.[procedure] = [procedures].id
go

if object_id(N'dbo.PermissionsSelectView', N'V') is not null drop view dbo.PermissionsSelectView
go
create view PermissionsSelectView as select 
	permissions.entity as id, 
	permissions.[name] as [name]
from dbo._Permissions permissions

go

if object_id(N'dbo.PermissionsHistoryView', N'V') is not null drop view dbo.PermissionsHistoryView
go
create view dbo.PermissionsHistoryView as select 
	permissions.id as plain_id, 
	permissions.entity as id, 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	permissions.[name] as [name], 
	permissions.[description] as [description], 
	permissions.deleted as deleted, 
	permissions.date_in as date_in
from dbo.PermissionsData permissions
join dbo.SessionsFullView [sessions] on permissions.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on permissions.[procedure] = [procedures].id
where 
	permissions.date_out is null
go

if object_id(N'dbo.PermissionsLoadView', N'V') is not null drop view dbo.PermissionsLoadView
go
create view dbo.PermissionsLoadView as select 
	permissions.entity as id,
	permissions.[name] as [name],
	permissions.[description] as [description]
from dbo._Permissions permissions
where 
	permissions.deleted is null
go