if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.SettingsTypesView', N'V') is not null drop view dbo.SettingsTypesView
go
create view dbo.SettingsTypesView as select 
	settings_types.id as plain_id, 
	settings_types.entity as id, 
	settings_types.[data] as [data], 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	settings_types.[name] as [name], 
	settings_types.[description] as [description], 
	settings_types.deleted as deleted, 
	settings_types.date_in as date_in, 
	settings_types.date_created as date_created
from dbo._SettingsTypes settings_types
join dbo.SessionsFullView [sessions] on settings_types.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on settings_types.[procedure] = [procedures].id
go

if object_id(N'dbo.SettingsTypesSelectView', N'V') is not null drop view dbo.SettingsTypesSelectView
go
create view SettingsTypesSelectView as select 
	settings_types.entity as id, 
	settings_types.[name] as [name]
from dbo._SettingsTypes settings_types

go

if object_id(N'dbo.SettingsTypesHistoryView', N'V') is not null drop view dbo.SettingsTypesHistoryView
go
create view dbo.SettingsTypesHistoryView as select 
	settings_types.id as plain_id, 
	settings_types.entity as id, 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	settings_types.[name] as [name], 
	settings_types.[description] as [description], 
	settings_types.deleted as deleted, 
	settings_types.date_in as date_in
from dbo.SettingsTypesData settings_types
join dbo.SessionsFullView [sessions] on settings_types.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on settings_types.[procedure] = [procedures].id
where 
	settings_types.date_out is null
go

if object_id(N'dbo.SettingsTypesLoadView', N'V') is not null drop view dbo.SettingsTypesLoadView
go
create view dbo.SettingsTypesLoadView as select 
	settings_types.entity as id,
	settings_types.[name] as [name],
	settings_types.[description] as [description]
from dbo._SettingsTypes settings_types
where 
	settings_types.deleted is null
go