if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.hashes_tables_delete', N'P') is not null drop procedure dbo.hashes_tables_delete
go
create procedure dbo.hashes_tables_delete
	@session varchar(max)
as begin
		
	if object_id(N'dbo.Hashes', N'U') is not null drop table dbo.Hashes
		
end
go

if object_id(N'dbo.hashes_tables_create', N'P') is not null drop procedure dbo.hashes_tables_create
go
create procedure dbo.hashes_tables_create
	@session varchar(max)
as begin 
		
	if object_id(N'dbo.Hashes', N'U') is null create table dbo.Hashes(
		id integer not null identity(1, 1),
		[procedure] integer not null,
		[session] integer not null,
		[name] varchar(16) not null,
		[description] varchar(512),
		deleted datetime,
		date_in datetime not null constraint hashes_date_in default getdate(),
		date_out datetime,
		constraint hashes_id primary key(id), 
		constraint hashes_procedure foreign key([procedure]) references dbo.[Procedures](id), 
		constraint hashes_session foreign key([session]) references dbo.[Sessions](id)
	)
		
end
go

if object_id(N'dbo.hashes_tables_update', N'P') is not null drop procedure dbo.hashes_tables_update
go
create procedure dbo.hashes_tables_update
	@session varchar(max)
as begin 
		
	declare @database varchar(64) = dbo.settings_get('database_anp2', 0)
	declare @procedure varchar(64) = 'hashes_tables_update'
	declare @session_id integer = isnull(dbo.sessions_get_id(@session), dbo.sessions_get_machine())
	declare @ip_id integer
	declare @user_agent_id integer

	select top 1 
		@ip_id = ip_id,
		@user_agent_id = user_agent_id
	from dbo.SessionsFullView where id = @session_id

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Hashes' and column_name = 'name') is null begin 
		alter table Hashes add [name] varchar(16) not null
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Hashes' and column_name = 'description') is null begin 
		alter table Hashes add [description] varchar(512)
	end
	
	execute dbo.logs_set @session_id, @database, @procedure, @ip_id, @user_agent_id, 0, '{}', 2
	
end
go
	
-- execute dbo.hashes_tables_delete null
execute dbo.hashes_tables_create null
execute dbo.hashes_tables_update null
	
