if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.HashesView', N'V') is not null drop view dbo.HashesView
go
create view dbo.HashesView as select 
	hashes.id as id, 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	hashes.[name] as [name], 
	hashes.[description] as [description], 
	hashes.deleted as deleted, 
	hashes.date_in as date_in
from dbo.Hashes hashes
join dbo.SessionsFullView [sessions] on hashes.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on hashes.[procedure] = [procedures].id
where 
	hashes.date_out is null
go

if object_id(N'dbo.HashesSelectView', N'V') is not null drop view dbo.HashesSelectView
go
create view HashesSelectView as select 
	hashes.id as id, 
	hashes.[name] as [name]
from dbo.Hashes hashes

go