if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.FilesTypesView', N'V') is not null drop view dbo.FilesTypesView
go
create view dbo.FilesTypesView as select 
	files_types.id as id, 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	files_types.mime as mime, 
	files_types.[description] as [description], 
	files_types.deleted as deleted, 
	files_types.date_in as date_in
from dbo.FilesTypes files_types
join dbo.SessionsFullView [sessions] on files_types.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on files_types.[procedure] = [procedures].id
where 
	files_types.date_out is null
go

if object_id(N'dbo.FilesTypesSelectView', N'V') is not null drop view dbo.FilesTypesSelectView
go
create view FilesTypesSelectView as select 
	files_types.id as id, 
	files_types.mime as mime
from dbo.FilesTypes files_types

go