if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.FilesGroupsView', N'V') is not null drop view dbo.FilesGroupsView
go
create view dbo.FilesGroupsView as select 
	files_groups.id as id, 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	files_groups.[name] as [name], 
	files_groups.[description] as [description], 
	files_groups.deleted as deleted, 
	files_groups.date_in as date_in
from dbo.FilesGroups files_groups
join dbo.SessionsFullView [sessions] on files_groups.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on files_groups.[procedure] = [procedures].id
where 
	files_groups.date_out is null
go

if object_id(N'dbo.FilesGroupsSelectView', N'V') is not null drop view dbo.FilesGroupsSelectView
go
create view FilesGroupsSelectView as select 
	files_groups.id as id, 
	files_groups.[name] as [name]
from dbo.FilesGroups files_groups

go