if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.LocatesGroupsView', N'V') is not null drop view dbo.LocatesGroupsView
go
create view dbo.LocatesGroupsView as select 
	locates_groups.id as id, 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	locates_groups.[name] as [name], 
	locates_groups.[description] as [description], 
	locates_groups.deleted as deleted, 
	locates_groups.date_in as date_in
from dbo.LocatesGroups locates_groups
join dbo.SessionsFullView [sessions] on locates_groups.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on locates_groups.[procedure] = [procedures].id
where 
	locates_groups.date_out is null
go

if object_id(N'dbo.LocatesGroupsSelectView', N'V') is not null drop view dbo.LocatesGroupsSelectView
go
create view LocatesGroupsSelectView as select 
	locates_groups.id as id, 
	locates_groups.[name] as [name]
from dbo.LocatesGroups locates_groups

go