if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.users_agents_tables_delete', N'P') is not null drop procedure dbo.users_agents_tables_delete
go
create procedure dbo.users_agents_tables_delete
	@session varchar(max)
as begin
	
	if object_id(N'dbo._UsersAgents', N'U') is not null drop table dbo._UsersAgents
	if object_id(N'dbo.UsersAgentsData', N'U') is not null drop table dbo.UsersAgentsData
	if object_id(N'dbo.UsersAgents', N'U') is not null drop table dbo.UsersAgents
		
end
go

if object_id(N'dbo.users_agents_tables_create', N'P') is not null drop procedure dbo.users_agents_tables_create
go
create procedure dbo.users_agents_tables_create
	@session varchar(max)
as begin 
	
	if object_id(N'dbo.UsersAgents', N'U') is null create table dbo.UsersAgents(
		id integer not null identity(1, 1),
		date_in datetime not null constraint users_agents_date_in default getdate(),
		date_out datetime,
		constraint users_agents_id primary key(id)
	)
	
	if object_id(N'dbo.UsersAgentsData', N'U') is null create table dbo.UsersAgentsData(
		id integer not null identity(1, 1),
		[procedure] integer not null,
		[session] integer not null,
		entity integer not null,
		[data] varchar(max) not null,
		deleted datetime,
		date_in datetime not null constraint users_agents_data_date_in default getdate(),
		date_out datetime,
		constraint users_agents_data_id primary key(id),
		constraint users_agents_data_entity foreign key(entity) references dbo.UsersAgents(id), 
		constraint users_agents_data_procedure foreign key([procedure]) references dbo.[Procedures](id), 
		constraint users_agents_data_session foreign key([session]) references dbo.[Sessions](id)
	)
	
	if object_id(N'dbo._UsersAgents', N'U') is null create table dbo._UsersAgents(
		id integer not null identity(1, 1),
		[procedure] integer not null,
		[session] integer not null,
		entity integer not null, 
		[data] integer not null,
		[data] varchar(max) not null,
		deleted datetime,
		date_in datetime not null,
		date_created datetime not null,
		constraint _users_agents_id primary key(id),
		constraint _users_agents_entity foreign key(entity) references dbo.UsersAgents(id), 
		constraint _users_agents_procedure foreign key([procedure]) references dbo.[Procedures](id), 
		constraint _users_agents_session foreign key([session]) references dbo.[Sessions](id)
	)
		
end
go

if object_id(N'dbo.users_agents_tables_update', N'P') is not null drop procedure dbo.users_agents_tables_update
go
create procedure dbo.users_agents_tables_update
	@session varchar(max)
as begin 
	
	declare @database varchar(64) = dbo.settings_get('database_anp2', 0)
	declare @procedure varchar(64) = 'users_agents_tables_update'
	declare @session_id integer = isnull(dbo.sessions_get_id(@session), dbo.sessions_get_machine())
	declare @ip_id integer
	declare @user_agent_id integer

	select top 1 
		@ip_id = ip_id,
		@user_agent_id = user_agent_id
	from dbo.SessionsFullView where id = @session_id

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'UsersAgentsData' and column_name = 'data') is null begin 
		alter table dbo.UsersAgentsData add [data] varchar(max) not null
		alter table dbo._UsersAgents add [data] varchar(max) not null
	end
	
	execute dbo.logs_set @session_id, @database, @procedure, @ip_id, @user_agent_id, 0, '{}', 2
	
end
go
	
-- execute dbo.users_agents_tables_delete null
execute dbo.users_agents_tables_create null
execute dbo.users_agents_tables_update null
	
