if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.UsersAgentsView', N'V') is not null drop view dbo.UsersAgentsView
go
create view dbo.UsersAgentsView as select 
	users_agents.id as plain_id, 
	users_agents.entity as id, 
	users_agents.[data] as [data], 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	users_agents.[data] as user_agent_data, 
	users_agents.deleted as deleted, 
	users_agents.date_in as date_in, 
	users_agents.date_created as date_created
from dbo._UsersAgents users_agents
join dbo.SessionsFullView [sessions] on users_agents.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on users_agents.[procedure] = [procedures].id
go

if object_id(N'dbo.UsersAgentsSelectView', N'V') is not null drop view dbo.UsersAgentsSelectView
go
create view UsersAgentsSelectView as select 
	users_agents.entity as id
from dbo._UsersAgents users_agents

go