if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.UsersGroupsView', N'V') is not null drop view dbo.UsersGroupsView
go
create view dbo.UsersGroupsView as select 
	users_groups.id as plain_id, 
	users_groups.entity as id, 
	users_groups.[data] as [data], 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	groups.entity as group_id, 
	groups.[name] as [name], 
	users.entity as users_user_id, 
	users.nick as user_nick, 
	users_groups.belongs as belongs, 
	users_groups.date_in as date_in, 
	users_groups.date_created as date_created
from dbo._UsersGroups users_groups
join dbo.SessionsFullView [sessions] on users_groups.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on users_groups.[procedure] = [procedures].id
join dbo._Groups groups on users_groups.[group] = groups.entity
join dbo._Users users on users_groups.[user] = users.entity
where 
	groups.deleted is null and 
	users.deleted is null
go

if object_id(N'dbo.UsersGroupsHistoryView', N'V') is not null drop view dbo.UsersGroupsHistoryView
go
create view dbo.UsersGroupsHistoryView as select 
	users_groups.id as plain_id, 
	users_groups.entity as id, 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	groups.entity as group_id, 
	groups.[name] as [name], 
	users.entity as users_user_id, 
	users.nick as user_nick, 
	users_groups.belongs as belongs, 
	users_groups.date_in as date_in
from dbo.UsersGroupsData users_groups
join dbo.SessionsFullView [sessions] on users_groups.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on users_groups.[procedure] = [procedures].id
join dbo._Groups groups on users_groups.[group] = groups.entity
join dbo._Users users on users_groups.[user] = users.entity
where 
	users_groups.date_out is null and 
	groups.deleted is null and 
	users.deleted is null
go