if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.IpsGroupsView', N'V') is not null drop view dbo.IpsGroupsView
go
create view dbo.IpsGroupsView as select 
	ips_groups.id as plain_id, 
	ips_groups.entity as id, 
	ips_groups.[data] as [data], 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	groups.entity as group_id, 
	groups.[name] as [name], 
	ips.entity as ips_ip_id, 
	ips.[address] as [address], 
	ips_groups.belongs as belongs, 
	ips_groups.date_in as date_in, 
	ips_groups.date_created as date_created
from dbo._IpsGroups ips_groups
join dbo.SessionsFullView [sessions] on ips_groups.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on ips_groups.[procedure] = [procedures].id
join dbo._Groups groups on ips_groups.[group] = groups.entity
join dbo._Ips ips on ips_groups.[ip] = ips.entity
where 
	groups.deleted is null and 
	ips.deleted is null
go

if object_id(N'dbo.IpsGroupsHistoryView', N'V') is not null drop view dbo.IpsGroupsHistoryView
go
create view dbo.IpsGroupsHistoryView as select 
	ips_groups.id as plain_id, 
	ips_groups.entity as id, 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	groups.entity as group_id, 
	groups.[name] as [name], 
	ips.entity as ips_ip_id, 
	ips.[address] as [address], 
	ips_groups.belongs as belongs, 
	ips_groups.date_in as date_in
from dbo.IpsGroupsData ips_groups
join dbo.SessionsFullView [sessions] on ips_groups.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on ips_groups.[procedure] = [procedures].id
join dbo._Groups groups on ips_groups.[group] = groups.entity
join dbo._Ips ips on ips_groups.[ip] = ips.entity
where 
	ips_groups.date_out is null and 
	groups.deleted is null and 
	ips.deleted is null
go