if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.PermissionsGroupsView', N'V') is not null drop view dbo.PermissionsGroupsView
go
create view dbo.PermissionsGroupsView as select 
	permissions_groups.id as plain_id, 
	permissions_groups.entity as id, 
	permissions_groups.[data] as [data], 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	groups.entity as group_id, 
	groups.[name] as [name], 
	permissions.entity as permission_id, 
	permissions.[name] as permission_name, 
	permissions_groups.belongs as belongs, 
	permissions_groups.date_in as date_in, 
	permissions_groups.date_created as date_created
from dbo._PermissionsGroups permissions_groups
join dbo.SessionsFullView [sessions] on permissions_groups.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on permissions_groups.[procedure] = [procedures].id
join dbo._Groups groups on permissions_groups.[group] = groups.entity
join dbo._Permissions permissions on permissions_groups.permission = permissions.entity
where 
	groups.deleted is null and 
	permissions.deleted is null
go

if object_id(N'dbo.PermissionsGroupsHistoryView', N'V') is not null drop view dbo.PermissionsGroupsHistoryView
go
create view dbo.PermissionsGroupsHistoryView as select 
	permissions_groups.id as plain_id, 
	permissions_groups.entity as id, 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	groups.entity as group_id, 
	groups.[name] as [name], 
	permissions.entity as permission_id, 
	permissions.[name] as permission_name, 
	permissions_groups.belongs as belongs, 
	permissions_groups.date_in as date_in
from dbo.PermissionsGroupsData permissions_groups
join dbo.SessionsFullView [sessions] on permissions_groups.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on permissions_groups.[procedure] = [procedures].id
join dbo._Groups groups on permissions_groups.[group] = groups.entity
join dbo._Permissions permissions on permissions_groups.permission = permissions.entity
where 
	permissions_groups.date_out is null and 
	groups.deleted is null and 
	permissions.deleted is null
go