if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.SettingsView', N'V') is not null drop view dbo.SettingsView
go
create view dbo.SettingsView as select 
	settings.id as plain_id, 
	settings.entity as id, 
	settings.[data] as [data], 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	settings_types.entity as type_id, 
	settings_types.[name] as [name], 
	settings.[name] as settings_name, 
	settings.[range] as [range], 
	settings.[value] as [value], 
	settings.[description] as [description], 
	settings.deleted as deleted, 
	settings.date_in as date_in, 
	settings.date_created as date_created
from dbo._Settings settings
join dbo.SessionsFullView [sessions] on settings.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on settings.[procedure] = [procedures].id
join dbo._SettingsTypes settings_types on settings.[type] = settings_types.entity
where 
	settings_types.deleted is null
go

if object_id(N'dbo.SettingsSelectView', N'V') is not null drop view dbo.SettingsSelectView
go
create view SettingsSelectView as select 
	settings.entity as id, 
	settings_types.entity as type_id, 
	settings_types.[name] as [name], 
	settings.[name] as settings_name
from dbo._Settings settings
join dbo._SettingsTypes settings_types on settings.[type] = settings_types.entity
where 
settings_types.deleted is null
go

if object_id(N'dbo.SettingsHistoryView', N'V') is not null drop view dbo.SettingsHistoryView
go
create view dbo.SettingsHistoryView as select 
	settings.id as plain_id, 
	settings.entity as id, 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	settings_types.entity as type_id, 
	settings_types.[name] as [name], 
	settings.[name] as settings_name, 
	settings.[range] as [range], 
	settings.[value] as [value], 
	settings.[description] as [description], 
	settings.deleted as deleted, 
	settings.date_in as date_in
from dbo.SettingsData settings
join dbo.SessionsFullView [sessions] on settings.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on settings.[procedure] = [procedures].id
join dbo._SettingsTypes settings_types on settings.[type] = settings_types.entity
where 
	settings.date_out is null and 
	settings_types.deleted is null
go

if object_id(N'dbo.SettingsLoadView', N'V') is not null drop view dbo.SettingsLoadView
go
create view dbo.SettingsLoadView as select 
	settings.entity as id,
	settings.[type] as [type],
	settings.[name] as [name],
	settings.[range] as [range],
	settings.[value] as [value],
	settings.[description] as [description]
from dbo._Settings settings
where 
	settings.deleted is null
go