if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP
	
if object_id(N'dbo.settings_load', N'P') is not null drop procedure dbo.settings_load
go
create procedure dbo.settings_load 
	@session varchar(max),
	@id integer,
	@error varchar(512) output
as begin 
		
	declare @database varchar(64) = dbo.settings_get('database_anp2', 0)
	declare @procedure varchar(64) = 'settings_load'
	declare @parameters varchar(max) = '{"id":null}'
	declare @has_errors bit
	declare @session_id integer
	declare @ip_id integer
	declare @user_agent_id integer
	
	set @error = ''
	set @parameters = json_modify(@parameters, 'strict $.id', @id)

	begin try
	
		execute dbo.sessions_validate_full @session, '["administrator"]', @error output, @session_id output, @ip_id output, @user_agent_id output
		set @error = dbo.errors_set(@error, dbo.settings_validate(@id, 1), 30, 0)
		set @has_errors = dbo.errors_has(@error)
	
		select top 1 * from dbo.SettingsLoadView where @has_errors = 0 and id = @id

	end try
	begin catch
		set @error = dbo.errors_set(@error, dbo.bw(1, 0), 0, 0)
		execute dbo.exceptions_set @session_id, @database, @procedure, @ip_id, @user_agent_id, @error, @parameters
	end catch
	
	execute dbo.logs_set @session_id, @database, @procedure, @ip_id, @user_agent_id, @error, @parameters, 2
		
end
go