if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.files_tables_delete', N'P') is not null drop procedure dbo.files_tables_delete
go
create procedure dbo.files_tables_delete
	@session varchar(max)
as begin
		
	if object_id(N'dbo.Files', N'U') is not null drop table dbo.Files
		
end
go

if object_id(N'dbo.files_tables_create', N'P') is not null drop procedure dbo.files_tables_create
go
create procedure dbo.files_tables_create
	@session varchar(max)
as begin 
		
	if object_id(N'dbo.Files', N'U') is null create table dbo.Files(
		id integer not null identity(1, 1),
		[procedure] integer not null,
		[session] integer not null,
		[group] integer not null,
		[type] integer not null,
		[name] varchar(256) not null,
		[path] varchar(512) not null,
		[weight] integer not null,
		date_modified bigint not null,
		[description] varchar(512),
		deleted datetime,
		date_in datetime not null constraint files_date_in default getdate(),
		date_out datetime,
		constraint files_id primary key(id), 
		constraint files_procedure foreign key([procedure]) references dbo.[Procedures](id), 
		constraint files_session foreign key([session]) references dbo.[Sessions](id)
	)
		
end
go

if object_id(N'dbo.files_tables_update', N'P') is not null drop procedure dbo.files_tables_update
go
create procedure dbo.files_tables_update
	@session varchar(max)
as begin 
		
	declare @database varchar(64) = dbo.settings_get('database_anp2', 0)
	declare @procedure varchar(64) = 'files_tables_update'
	declare @session_id integer = isnull(dbo.sessions_get_id(@session), dbo.sessions_get_machine())
	declare @ip_id integer
	declare @user_agent_id integer

	select top 1 
		@ip_id = ip_id,
		@user_agent_id = user_agent_id
	from dbo.SessionsFullView where id = @session_id

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Files' and column_name = 'group') is null begin 
		alter table Files add [group] integer not null
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Files' and column_name = 'type') is null begin 
		alter table Files add [type] integer not null
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Files' and column_name = 'name') is null begin 
		alter table Files add [name] varchar(256) not null
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Files' and column_name = 'path') is null begin 
		alter table Files add [path] varchar(512) not null
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Files' and column_name = 'weight') is null begin 
		alter table Files add [weight] integer not null
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Files' and column_name = 'date_modified') is null begin 
		alter table Files add date_modified bigint not null
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Files' and column_name = 'description') is null begin 
		alter table Files add [description] varchar(512)
	end
	
	execute dbo.logs_set @session_id, @database, @procedure, @ip_id, @user_agent_id, 0, '{}', 2
	
end
go
	
-- execute dbo.files_tables_delete null
execute dbo.files_tables_create null
execute dbo.files_tables_update null
	
