if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.FilesView', N'V') is not null drop view dbo.FilesView
go
create view dbo.FilesView as select 
	files.id as id, 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	files_groups.id as group_id, 
	files_groups.[name] as [name], 
	files_types.id as type_id, 
	files_types.mime as mime, 
	files.[name] as file_name, 
	files.[path] as [path], 
	files.[weight] as [weight], 
	files.date_modified as date_modified, 
	files.[description] as [description], 
	files.deleted as deleted, 
	files.date_in as date_in
from dbo.Files files
join dbo.SessionsFullView [sessions] on files.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on files.[procedure] = [procedures].id
join dbo.FilesGroups files_groups on files.[group] = files_groups.id
join dbo.FilesTypes files_types on files.[type] = files_types.id
where 
	files.date_out is null and 
	files_groups.date_out is null and 
	files_types.date_out is null
go

if object_id(N'dbo.FilesSelectView', N'V') is not null drop view dbo.FilesSelectView
go
create view FilesSelectView as select 
	files.id as id, 
	files.[name] as [name]
from dbo.Files files

go