if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.locates_tables_delete', N'P') is not null drop procedure dbo.locates_tables_delete
go
create procedure dbo.locates_tables_delete
	@session varchar(max)
as begin
		
	if object_id(N'dbo.Locates', N'U') is not null drop table dbo.Locates
		
end
go

if object_id(N'dbo.locates_tables_create', N'P') is not null drop procedure dbo.locates_tables_create
go
create procedure dbo.locates_tables_create
	@session varchar(max)
as begin 
		
	if object_id(N'dbo.Locates', N'U') is null create table dbo.Locates(
		id integer not null identity(1, 1),
		[procedure] integer not null,
		[session] integer not null,
		[group] integer not null,
		[name] varchar(256),
		latitude float not null,
		longitude float not null,
		altitude float not null,
		[description] varchar(512),
		deleted datetime,
		date_in datetime not null constraint locates_date_in default getdate(),
		date_out datetime,
		constraint locates_id primary key(id), 
		constraint locates_procedure foreign key([procedure]) references dbo.[Procedures](id), 
		constraint locates_session foreign key([session]) references dbo.[Sessions](id)
	)
		
end
go

if object_id(N'dbo.locates_tables_update', N'P') is not null drop procedure dbo.locates_tables_update
go
create procedure dbo.locates_tables_update
	@session varchar(max)
as begin 
		
	declare @database varchar(64) = dbo.settings_get('database_anp2', 0)
	declare @procedure varchar(64) = 'locates_tables_update'
	declare @session_id integer = isnull(dbo.sessions_get_id(@session), dbo.sessions_get_machine())
	declare @ip_id integer
	declare @user_agent_id integer

	select top 1 
		@ip_id = ip_id,
		@user_agent_id = user_agent_id
	from dbo.SessionsFullView where id = @session_id

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Locates' and column_name = 'group') is null begin 
		alter table Locates add [group] integer not null
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Locates' and column_name = 'name') is null begin 
		alter table Locates add [name] varchar(256)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Locates' and column_name = 'latitude') is null begin 
		alter table Locates add latitude float not null
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Locates' and column_name = 'longitude') is null begin 
		alter table Locates add longitude float not null
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Locates' and column_name = 'altitude') is null begin 
		alter table Locates add altitude float not null
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'Locates' and column_name = 'description') is null begin 
		alter table Locates add [description] varchar(512)
	end
	
	execute dbo.logs_set @session_id, @database, @procedure, @ip_id, @user_agent_id, 0, '{}', 2
	
end
go
	
-- execute dbo.locates_tables_delete null
execute dbo.locates_tables_create null
execute dbo.locates_tables_update null
	
