if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.LocatesView', N'V') is not null drop view dbo.LocatesView
go
create view dbo.LocatesView as select 
	locates.id as id, 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	locates_groups.id as group_id, 
	locates_groups.[name] as [name], 
	locates.[name] as locate_name, 
	locates.latitude as latitude, 
	locates.longitude as longitude, 
	locates.altitude as altitude, 
	locates.[description] as [description], 
	locates.deleted as deleted, 
	locates.date_in as date_in
from dbo.Locates locates
join dbo.SessionsFullView [sessions] on locates.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on locates.[procedure] = [procedures].id
join dbo.LocatesGroups locates_groups on locates.[group] = locates_groups.id
where 
	locates.date_out is null and 
	locates_groups.date_out is null
go

if object_id(N'dbo.LocatesSelectView', N'V') is not null drop view dbo.LocatesSelectView
go
create view LocatesSelectView as select 
	locates.id as id, 
	locates.[name] as [name]
from dbo.Locates locates

go