if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.users_emails_tables_delete', N'P') is not null drop procedure dbo.users_emails_tables_delete
go
create procedure dbo.users_emails_tables_delete
	@session varchar(max)
as begin
	
	if object_id(N'dbo._UsersEmails', N'U') is not null drop table dbo._UsersEmails
	if object_id(N'dbo.UsersEmailsData', N'U') is not null drop table dbo.UsersEmailsData
	if object_id(N'dbo.UsersEmails', N'U') is not null drop table dbo.UsersEmails
		
end
go

if object_id(N'dbo.users_emails_tables_create', N'P') is not null drop procedure dbo.users_emails_tables_create
go
create procedure dbo.users_emails_tables_create
	@session varchar(max)
as begin 
	
	if object_id(N'dbo.UsersEmails', N'U') is null create table dbo.UsersEmails(
		id integer not null identity(1, 1),
		date_in datetime not null constraint users_emails_date_in default getdate(),
		date_out datetime,
		constraint users_emails_id primary key(id)
	)
	
	if object_id(N'dbo.UsersEmailsData', N'U') is null create table dbo.UsersEmailsData(
		id integer not null identity(1, 1),
		[procedure] integer not null,
		[session] integer not null,
		entity integer not null,
		email integer not null,
		[user] integer not null,
		belongs bit not null,
		date_in datetime not null constraint users_emails_data_date_in default getdate(),
		date_out datetime,
		constraint users_emails_data_id primary key(id),
		constraint users_emails_data_entity foreign key(entity) references dbo.UsersEmails(id), 
		constraint users_emails_data_procedure foreign key([procedure]) references dbo.[Procedures](id), 
		constraint users_emails_data_session foreign key([session]) references dbo.[Sessions](id),
		constraint users_emails_data_email foreign key(email) references dbo.Emails(id),
		constraint users_emails_data_user foreign key([user]) references dbo.Users(id)
	)
	
	if object_id(N'dbo._UsersEmails', N'U') is null create table dbo._UsersEmails(
		id integer not null identity(1, 1),
		[procedure] integer not null,
		[session] integer not null,
		entity integer not null, 
		[data] integer not null,
		email integer not null,
		[user] integer not null,
		belongs bit not null,
		date_in datetime not null,
		date_created datetime not null,
		constraint _users_emails_id primary key(id),
		constraint _users_emails_entity foreign key(entity) references dbo.UsersEmails(id), 
		constraint _users_emails_procedure foreign key([procedure]) references dbo.[Procedures](id), 
		constraint _users_emails_session foreign key([session]) references dbo.[Sessions](id),
		constraint _users_emails_email foreign key(email) references dbo.Emails(id),
		constraint _users_emails_user foreign key([user]) references dbo.Users(id)
	)
		
end
go

if object_id(N'dbo.users_emails_tables_update', N'P') is not null drop procedure dbo.users_emails_tables_update
go
create procedure dbo.users_emails_tables_update
	@session varchar(max)
as begin 
	
	declare @database varchar(64) = dbo.settings_get('database_anp2', 0)
	declare @procedure varchar(64) = 'users_emails_tables_update'
	declare @session_id integer = isnull(dbo.sessions_get_id(@session), dbo.sessions_get_machine())
	declare @ip_id integer
	declare @user_agent_id integer

	select top 1 
		@ip_id = ip_id,
		@user_agent_id = user_agent_id
	from dbo.SessionsFullView where id = @session_id

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'UsersEmailsData' and column_name = 'email') is null begin 
		alter table dbo.UsersEmailsData add email integer not null
		alter table dbo.UsersEmailsData add constraint users_emails_data_email foreign key(email) references dbo.Emails(id)
		alter table dbo._UsersEmails add email integer not null
		alter table dbo._UsersEmails add constraint _users_emails_email foreign key(email) references dbo.Emails(id)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'UsersEmailsData' and column_name = 'user') is null begin 
		alter table dbo.UsersEmailsData add [user] integer not null
		alter table dbo.UsersEmailsData add constraint users_emails_data_user foreign key([user]) references dbo.Users(id)
		alter table dbo._UsersEmails add [user] integer not null
		alter table dbo._UsersEmails add constraint _users_emails_user foreign key([user]) references dbo.Users(id)
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'UsersEmailsData' and column_name = 'belongs') is null begin 
		alter table dbo.UsersEmailsData add belongs bit not null
		alter table dbo._UsersEmails add belongs bit not null
	end
	
	execute dbo.logs_set @session_id, @database, @procedure, @ip_id, @user_agent_id, 0, '{}', 2
	
end
go
	
-- execute dbo.users_emails_tables_delete null
execute dbo.users_emails_tables_create null
execute dbo.users_emails_tables_update null
	
