if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.UsersEmailsView', N'V') is not null drop view dbo.UsersEmailsView
go
create view dbo.UsersEmailsView as select 
	users_emails.id as plain_id, 
	users_emails.entity as id, 
	users_emails.[data] as [data], 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	emails.id as email_id, 
	emails.[address] as [address], 
	users.entity as users_user_id, 
	users.nick as user_nick, 
	users_emails.belongs as belongs, 
	users_emails.date_in as date_in, 
	users_emails.date_created as date_created
from dbo._UsersEmails users_emails
join dbo.SessionsFullView [sessions] on users_emails.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on users_emails.[procedure] = [procedures].id
join dbo.Emails emails on users_emails.email = emails.id
join dbo._Users users on users_emails.[user] = users.entity
where 
	emails.date_out is null and 
	users.deleted is null
go

if object_id(N'dbo.UsersEmailsHistoryView', N'V') is not null drop view dbo.UsersEmailsHistoryView
go
create view dbo.UsersEmailsHistoryView as select 
	users_emails.id as plain_id, 
	users_emails.entity as id, 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	emails.id as email_id, 
	emails.[address] as [address], 
	users.entity as users_user_id, 
	users.nick as user_nick, 
	users_emails.belongs as belongs, 
	users_emails.date_in as date_in
from dbo.UsersEmailsData users_emails
join dbo.SessionsFullView [sessions] on users_emails.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on users_emails.[procedure] = [procedures].id
join dbo.Emails emails on users_emails.email = emails.id
join dbo._Users users on users_emails.[user] = users.entity
where 
	users_emails.date_out is null and 
	emails.date_out is null and 
	users.deleted is null
go