if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.users_emails_get_basics', N'P') is not null drop procedure dbo.users_emails_get_basics
go
create procedure dbo.users_emails_get_basics 
    @session varchar(max),
    @error varchar(512) output
as begin 

	declare @database varchar(64) = dbo.settings_get('database_anp2', 0)
	declare @procedure varchar(64) = 'users_emails_get_basics'
    declare @has_errors bit
    declare @session_id integer
    declare @ip_id integer
    declare @user_agent_id integer

    set nocount on

	begin try
		
		execute dbo.sessions_validate_full @session, '["administrator"]', @error output, @session_id output, @ip_id output, @user_agent_id output
		set @has_errors = dbo.errors_has(@error)

		select * from dbo.EmailsSelectView where @has_errors = 0
		select * from dbo.UsersSelectView where @has_errors = 0

	end try
	begin catch
		set @error = dbo.errors_set(@error, dbo.bw(1, 0), 0, 0)
		execute dbo.exceptions_set @session_id, @database, @procedure, @ip_id, @user_agent_id, @error, '{}'
	end catch
	
	execute dbo.logs_set @session_id, @database, @procedure, @ip_id, @user_agent_id, @error, '{}', 2

end
go