if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.files_hashes_tables_delete', N'P') is not null drop procedure dbo.files_hashes_tables_delete
go
create procedure dbo.files_hashes_tables_delete
	@session varchar(max)
as begin
		
	if object_id(N'dbo.FilesHashes', N'U') is not null drop table dbo.FilesHashes
		
end
go

if object_id(N'dbo.files_hashes_tables_create', N'P') is not null drop procedure dbo.files_hashes_tables_create
go
create procedure dbo.files_hashes_tables_create
	@session varchar(max)
as begin 
		
	if object_id(N'dbo.FilesHashes', N'U') is null create table dbo.FilesHashes(
		id integer not null identity(1, 1),
		[procedure] integer not null,
		[session] integer not null,
		[file] integer not null,
		[algorithm] integer not null,
		[hash] varchar(256) not null,
		deleted datetime,
		date_in datetime not null constraint files_hashes_date_in default getdate(),
		date_out datetime,
		constraint files_hashes_id primary key(id), 
		constraint files_hashes_procedure foreign key([procedure]) references dbo.[Procedures](id), 
		constraint files_hashes_session foreign key([session]) references dbo.[Sessions](id)
	)
		
end
go

if object_id(N'dbo.files_hashes_tables_update', N'P') is not null drop procedure dbo.files_hashes_tables_update
go
create procedure dbo.files_hashes_tables_update
	@session varchar(max)
as begin 
		
	declare @database varchar(64) = dbo.settings_get('database_anp2', 0)
	declare @procedure varchar(64) = 'files_hashes_tables_update'
	declare @session_id integer = isnull(dbo.sessions_get_id(@session), dbo.sessions_get_machine())
	declare @ip_id integer
	declare @user_agent_id integer

	select top 1 
		@ip_id = ip_id,
		@user_agent_id = user_agent_id
	from dbo.SessionsFullView where id = @session_id

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'FilesHashes' and column_name = 'file') is null begin 
		alter table FilesHashes add [file] integer not null
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'FilesHashes' and column_name = 'algorithm') is null begin 
		alter table FilesHashes add [algorithm] integer not null
	end

	if (select top 1 1 from information_schema.columns where table_catalog = @database and table_name = 'FilesHashes' and column_name = 'hash') is null begin 
		alter table FilesHashes add [hash] varchar(256) not null
	end
	
	execute dbo.logs_set @session_id, @database, @procedure, @ip_id, @user_agent_id, 0, '{}', 2
	
end
go
	
-- execute dbo.files_hashes_tables_delete null
execute dbo.files_hashes_tables_create null
execute dbo.files_hashes_tables_update null
	
