if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.FilesHashesView', N'V') is not null drop view dbo.FilesHashesView
go
create view dbo.FilesHashesView as select 
	files_hashes.id as id, 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	files.id as file_id, 
	files.[name] as [name], 
	hashes.id as algorithm_id, 
	hashes.[name] as algorithm_name, 
	files_hashes.[hash] as [hash], 
	files_hashes.deleted as deleted, 
	files_hashes.date_in as date_in
from dbo.FilesHashes files_hashes
join dbo.SessionsFullView [sessions] on files_hashes.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on files_hashes.[procedure] = [procedures].id
join dbo.Files files on files_hashes.[file] = files.id
join dbo.Hashes hashes on files_hashes.[algorithm] = hashes.id
where 
	files_hashes.date_out is null and 
	files.date_out is null and 
	hashes.date_out is null
go