if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.CountriesView', N'V') is not null drop view dbo.CountriesView
go
create view dbo.CountriesView as select 
	countries.id as plain_id, 
	countries.entity as id, 
	countries.[data] as [data], 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	countries.[name] as [name], 
	countries.[key] as [key], 
	countries.code as code, 
	countries_flag.id as flag_id, 
	countries_flag.group_id as flag_group_id, 
	countries_flag.[group] as flag_group, 
	countries_flag.[name] as flag_name, 
	countries_flag.type_id as flag_type_id, 
	countries_flag.mime as flag_mime, 
	countries_flag.[size] as flag_size, 
	countries_flag.last_modified as flag_last_modified, 
	concat('/app/countries/flag/', countries_flag.id, '/', countries_flag.[name]) as flag_url, 
	countries.[description] as [description], 
	countries.deleted as deleted, 
	countries.date_in as date_in, 
	countries.date_created as date_created
from dbo._Countries countries
join dbo.SessionsFullView [sessions] on countries.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on countries.[procedure] = [procedures].id
left join dbo.FilesLoadItemView countries_flag on countries_flag.id = countries.flag
go

if object_id(N'dbo.CountriesSelectView', N'V') is not null drop view dbo.CountriesSelectView
go
create view CountriesSelectView as select 
	countries.entity as id, 
	countries.[name] as [name], 
	countries.code as code
from dbo._Countries countries

go

if object_id(N'dbo.CountriesHistoryView', N'V') is not null drop view dbo.CountriesHistoryView
go
create view dbo.CountriesHistoryView as select 
	countries.id as plain_id, 
	countries.entity as id, 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	countries.[name] as [name], 
	countries.[key] as [key], 
	countries.code as code, 
	countries_flag.id as flag_id, 
	countries_flag.group_id as flag_group_id, 
	countries_flag.[group] as flag_group, 
	countries_flag.[name] as flag_name, 
	countries_flag.type_id as flag_type_id, 
	countries_flag.mime as flag_mime, 
	countries_flag.[size] as flag_size, 
	countries_flag.last_modified as flag_last_modified, 
	concat('/app/countries/flag/', countries_flag.id, '/', countries_flag.[name]) as flag_url, 
	countries.[description] as [description], 
	countries.deleted as deleted, 
	countries.date_in as date_in
from dbo.CountriesData countries
join dbo.SessionsFullView [sessions] on countries.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on countries.[procedure] = [procedures].id
left join dbo.FilesLoadItemView countries_flag on countries_flag.id = countries.flag
where 
	countries.date_out is null
go

if object_id(N'dbo.CountriesLoadView', N'V') is not null drop view dbo.CountriesLoadView
go
create view dbo.CountriesLoadView as select 
	countries.entity as id,
	countries.[name] as [name],
	countries.[key] as [key],
	countries.code as code,
	files_flag.id as flag_id,
	files_flag.[name] as flag_name,
	files_flag.mime as flag_mime,
	files_flag.size as flag_size,
	files_flag.last_modified as flag_last_modified,
	files_flag.[path] as flag_path,
	concat('/app/countries/flag/', files_flag.id, '/', files_flag.[name]) as flag_url,
	countries.[description] as [description]
from dbo._Countries countries
left join dbo.FilesLoadItemView files_flag on countries.flag = files_flag.id
where 
	countries.deleted is null
go