if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.countries_delete', N'P') is not null drop procedure dbo.countries_delete
go
create procedure dbo.countries_delete
	@session varchar(max),
	@entity integer,
	@error varchar(512) output
as begin 
		
	declare @database varchar(64) = dbo.settings_get('database_anp2', 0)
	declare @procedure varchar(64) = 'countries_delete'
	declare @procedure_id integer
	declare @data_id integer
	declare @parameters varchar(max) = '{"entity":null,"id":null}'
	declare @session_id integer
	declare @ip_id integer
	declare @user_agent_id integer
	
	set @error = ''
	set @parameters = json_modify(@parameters, 'strict $.entity', @entity)
	set @parameters = json_modify(@parameters, 'strict $.id', 0)
	
	begin transaction

	begin try
	
		execute dbo.sessions_validate_full @session, '["administrador"]', @error output, @session_id output, @ip_id output, @user_agent_id output
		set @error = dbo.errors_set(@error, dbo.countries_validate(@entity, 1), 30, 0)
	
		if dbo.errors_has(@error) = 0 begin 
			
			execute dbo.procedures_get @database, @procedure, @procedure_id output
			set @data_id = (select top 1 [data] from dbo._Countries where entity = @entity)
		
			insert into dbo.CountriesData([procedure], [session], entity, [name], [key], code, flag, [description], deleted) 
				select top 1 @procedure_id, @session_id, entity, [name], [key], code, flag, [description], getdate() from dbo.CountriesData where id = @data_id
			
			set @parameters = json_modify(@parameters, 'strict $.id', scope_identity())
		
		end
	
		commit

	end try
	begin catch
		rollback
		set @error = dbo.errors_set(@error, dbo.bw(1, 0), 0, 0)
		execute dbo.exceptions_set @session_id, @database, @procedure, @ip_id, @user_agent_id, @error, @parameters
	end catch
	
	execute dbo.logs_set @session_id, @database, @procedure, @ip_id, @user_agent_id, @error, @parameters, 0
		
end
go

