if (select top 1 1 from sys.databases where name = 'AnP') is null create database AnP
go
use AnP

if object_id(N'dbo.SettingsGroupsView', N'V') is not null drop view dbo.SettingsGroupsView
go
create view dbo.SettingsGroupsView as select 
	settings_groups.id as plain_id, 
	settings_groups.entity as id, 
	settings_groups.[data] as [data], 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	groups.entity as group_id, 
	groups.[name] as [name], 
	settings.entity as settings_id, 
	settings_types.entity as type_id, 
	settings_types.[name] as type_name, 
	settings.[name] as settings_name, 
	settings_groups.[value] as [value], 
	settings_groups.belongs as belongs, 
	settings_groups.date_in as date_in, 
	settings_groups.date_created as date_created
from dbo._SettingsGroups settings_groups
join dbo.SessionsFullView [sessions] on settings_groups.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on settings_groups.[procedure] = [procedures].id
join dbo._Groups groups on settings_groups.[group] = groups.entity
join dbo._Settings settings on settings_groups.settings = settings.entity
join dbo._SettingsTypes settings_types on settings.[type] = settings_types.entity
where 
	groups.deleted is null and 
	settings.deleted is null and 
	settings_types.deleted is null
go

if object_id(N'dbo.SettingsGroupsHistoryView', N'V') is not null drop view dbo.SettingsGroupsHistoryView
go
create view dbo.SettingsGroupsHistoryView as select 
	settings_groups.id as plain_id, 
	settings_groups.entity as id, 
	[procedures].database_id as database_id, 
	[procedures].id as procedure_id, 
	[procedures].[database] as [database], 
	[procedures].[procedure] as [procedure], 
	[sessions].id as session_id, 
	[sessions].[user_id] as [user_id], 
	[sessions].nick as nick, 
	[sessions].ip_id as ip_id, 
	[sessions].[ip] as [ip], 
	groups.entity as group_id, 
	groups.[name] as [name], 
	settings.entity as settings_id, 
	settings_types.entity as type_id, 
	settings_types.[name] as type_name, 
	settings.[name] as settings_name, 
	settings_groups.[value] as [value], 
	settings_groups.belongs as belongs, 
	settings_groups.date_in as date_in
from dbo.SettingsGroupsData settings_groups
join dbo.SessionsFullView [sessions] on settings_groups.[session] = [sessions].id
join dbo.ProceduresFullView [procedures] on settings_groups.[procedure] = [procedures].id
join dbo._Groups groups on settings_groups.[group] = groups.entity
join dbo._Settings settings on settings_groups.settings = settings.entity
join dbo._SettingsTypes settings_types on settings.[type] = settings_types.entity
where 
	settings_groups.date_out is null and 
	groups.deleted is null and 
	settings.deleted is null and 
	settings_types.deleted is null
go

if object_id(N'dbo.SettingsGroupsLoadView', N'V') is not null drop view dbo.SettingsGroupsLoadView
go
create view dbo.SettingsGroupsLoadView as select 
	settings_groups.entity as id,
	settings_groups.[group] as [group],
	settings_groups.settings as settings,
	settings_groups.[value] as [value],
	settings_groups.belongs as belongs
from dbo._SettingsGroups settings_groups
go