﻿use AnP

if object_id(N'dbo.kyman_language_set', N'P') is not null drop procedure dbo.kyman_language_set
go
create procedure dbo.kyman_language_set 
	@country_name varchar(64),
	@country_key varchar(64),
	@country_code varchar(4),
	@language_name varchar(64),
	@language_key varchar(64),
	@language_code varchar(4)
as begin
	
	declare @session_id integer = dbo.sessions_get_machine()
	declare @database varchar(64) = dbo.settings_get('database_anp', 0)
	declare @procedure varchar(64) = 'kyman_language_set'
	declare @procedure_id integer
	declare @country_id integer = (select top 1 id from dbo._Countries where [key] = @country_key)
	
	execute procedures_get @procedure, @database, @procedure_id output
	
	if @country_id is null begin 
		insert into dbo.Countries default values
		set @country_id = scope_identity()
		insert dbo.CountriesData([procedure], [session], entity, [name], [key], code) values 
			(@procedure_id, @session_id, @country_id, @country_name, @country_key, @country_code);
	end
	
	if (select top 1 1 from dbo._Languages where country = @country_id and [key] = @language_key) is null begin 
		insert into dbo.Languages default values
		insert dbo.LanguagesData([procedure], [session], entity, country, name, [key], code) values 
			(@procedure_id, @session_id, scope_identity(), @country_id, @language_name, @language_key, @language_code);
	end
	
end
go

execute dbo.kyman_language_set 'España', 'espana', 'es', 'Español', 'espanol', 'es'
execute dbo.kyman_language_set 'España', 'espana', 'es', 'Galego', 'galego', 'gal'
execute dbo.kyman_language_set 'United Kingdom', 'united_kingdom', 'uk', 'English', 'english', 'en'
execute dbo.kyman_language_set 'Россия', 'Rossiya', 'ru', 'Русский', 'russkiy', 'ru'
execute dbo.kyman_language_set '日本', 'nihon', 'jp', '日本語', 'nihongo', 'jp'

drop procedure dbo.kyman_language_set