[[post_data {
    "author" : "KyMAN",
    "since" : 20211223,
    "version" : 20211223
}]]
# AnP.Sessions.ecma.js

```txt
/Public/ecma/AnP.Sessions.ecma.js
```

## [[plain AnP.Sessions.construct]]

[[wdoc
Método object.
@name       AnP.Sessions.construct
@lang       ECMAScript
@author     KyMAN
@since      20211223
@version    20211223
@access     private
@hash       e5a6f191432eb8ff69dcdcb69daa6876
]]

## [[plain AnP.Sessions.set_permissions_views]]

[[wdoc
Método object.
@name       AnP.Sessions.set_permissions_views
@see	
@lang       ECMAScript
@author     KyMAN
@since      20211223
@version	20220507
@access	public
@hash	51c14b5898486210b5de26393b1278bb
#return	- - Retorno.
]]

## [[plain AnP.Sessions.refresh]]

[[wdoc
Método object.
@name       AnP.Sessions.refresh
@see	AnP.cookie_set
@see	AnP.settings_get
@see	AnP.Sessions.set_permissions_views
@see	AnP.is_function
@see	AnP.go
@see	AnP.Sessions.refresh
@lang       ECMAScript
@author     KyMAN
@since      20211223
@version	20220425
@access	private
@hash	eb39d5e316ce6169aff1d752b8c8aae7
#callback	- optional Parámetro callback
#return	- - Retorno.
]]

## [[plain AnP.Sessions.thread_method]]

[[wdoc
Método object.
@name       AnP.Sessions.thread_method
@see        AnP.Sessions.refresh
@lang       ECMAScript
@author     KyMAN
@since      20211223
@version    20211223
@access     private
@hash       70868bb90acce1e3afc2859b2816a068
]]

## [[plain AnP.Sessions.get_guest]]

[[wdoc
Método object.
@name       AnP.Sessions.get_guest
@see	AnP.cookie_set
@see	AnP.settings_get
@see	AnP.Sessions.set_permissions_views
@see	AnP.is_function
@lang       ECMAScript
@author     KyMAN
@since      20211223
@version	20220425
@access	private
@hash	c269f805649d849b1032495f4d3c70a5
#callback	- optional Parámetro callback
#return	- - Retorno.
]]

## [[plain AnP.Sessions.start]]

[[wdoc
Método object.
@name       AnP.Sessions.start
@see        AnP.settings_get
@see        AnP.cookie_get
@see        AnP.Sessions.refresh
@see        AnP.Sessions.get_guest
@see        AnP.Sessions.thread_method
@lang       ECMAScript
@author     KyMAN
@since      20211223
@version    20211223
@access     public
@hash       71a8276b2fd110e63bc21b4cf244c18d
#callback	- optional Parámetro callback
]]

## [[plain AnP.Sessions.field]]

[[wdoc
Método object.
@name       AnP.Sessions.field
@lang       ECMAScript
@author     KyMAN
@since      20211223
@version    20211223
@access     private
@hash       95c5044d50e452b8a3aac5826e3dc4ef
#key	- optional Parámetro key
#value	- optional Parámetro value
#return	- - Retorno.
]]

## [[plain AnP.Sessions.create]]

[[wdoc
Método object.
@name       AnP.Sessions.create
@see        AnP.settings_get
@see        AnP.Sessions.field
@see        AnP.Sessions.create
@lang       ECMAScript
@author     KyMAN
@since      20211223
@version    20211223
@access     public
@hash       fe7aa6b059b5f0466711a4e061106acb
#input	- optional Parámetro input
]]

## [[plain AnP.Sessions.get]]

[[wdoc
Método object.
@name       AnP.Sessions.get
@lang       ECMAScript
@author     KyMAN
@since      20211223
@version    20211223
@access     public
@hash       3bded52573813c2dee56f504ca07818c
#return	- - Retorno.
]]

## [[plain AnP.Sessions.register]]

[[wdoc
Método object.
@name       AnP.Sessions.register
@lang       ECMAScript
@author     KyMAN
@since      20211223
@version    20211223
@access     public
@hash       e6a2b3a10e99e9b5e4860d2c55a91908
#item	- optional Parámetro item
#event	- optional Parámetro event
]]

## [[plain AnP.Sessions.close]]

[[wdoc
Método object.
@name       AnP.Sessions.close
@see	AnP.settings_get
@see	AnP.is_function
@see	AnP.Sessions.field
@lang       ECMAScript
@author     KyMAN
@since      20211223
@version	20220425
@access	private
@hash	c8986056a125878c53e272a64275bf12
#callback	- optional Parámetro callback
#return	- - Retorno.
]]

## [[plain AnP.Sessions.login]]

[[wdoc
Método object.
@name       AnP.Sessions.login
@see	AnP.Sessions.close
@lang       ECMAScript
@author     KyMAN
@since      20211223
@version	20220425
@access	public
@hash	e7a5b1199622f8f72ed4301b8c2add62
#item	- optional Parámetro item
#event	- optional Parámetro event
]]

## [[plain AnP.Sessions.execute_result]]

[[wdoc
Método object.
@name       AnP.Sessions.execute_result
@see        AnP.is_function
@see        AnP.is_string
@see        AnP.go
@lang       ECMAScript
@author     KyMAN
@since      20211223
@version    20211223
@access     private
@hash       3a1d769351a015a36263cfb1351b1432
#element	- optional Parámetro element
]]

## [[plain AnP.Sessions.has_permissions]]

[[wdoc
Método object.
@name       AnP.Sessions.has_permissions
@see	AnP.is_array
@see	AnP.Sessions.execute_result
@see	AnP.toast
@see	AnP.go
@lang       ECMAScript
@author     KyMAN
@since      20211223
@version	20220425
@access	public
@hash	da1560240152c8547a31cdc3fb66c43d
#check	- optional Parámetro check
#reject	- optional Parámetro reject
#ok	- optional Parámetro ok
#return	- - Retorno.
]]

## [[plain AnP.Sessions.logout]]

[[wdoc
Método object.
@name       AnP.Sessions.logout
@see	
@lang       ECMAScript
@author     KyMAN
@since      20211223
@version	20220507
@access	public
@hash	32b3204cfcf916c1114eb3713fbc865c
#item	- optional Parámetro item
#event	- optional Parámetro event
#return	- - Retorno.
]]

[[html_data {
    "title" : "AnP.Sessions.ecma.js - AnP",
    "url" : "https://anp.k3y.pw//Public/ecma/AnP.Sessions.ecma.js.html",
    "author" : "KyMAN",
    "since" : 20211223,
    "version" : 20211223,
    "key_words" : "anp,attach and play,framework,libraries,librerías,documentación,developt,desarrollo,programación,sessions,ecma",
    "description" : "AnP.Sessions.ecma.js del AnP.",
    "project" : "AnP",
    "logo" : "/images/AnP.png",
    "language" : "es"
}]]
